; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; EVOLUTION RADICALE DE LA ROM ALICE 32                                 +
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
; ATTENTION : ALWAYS WIP !! TOUJOURS EN CONSTRUCTION
;
; ATTENTION :
; - le résultat de la compilation de ce source nécessite un
; émulateur acceptant de charger une rom au lieu de l'originale et
; corrigeant un bug dans le moteur émulant l'EF9345 (la gestion de
; l'incrément du pointeur X de EF9345 n'était pas correcte) ainsi que la correction
; de la gestion du bit V du registre d'état de certaines instructions du mc6803.
:
; ==> Version émulateur conseillée : toute version dont la date à disposition est
; inférieure au 01/04/2022
;
;
; STATUT DU DEVELOPPEMENT : WORK IN PROGRESS
;
;
; BUGS :
; 1 - si numéro de ligne = 0 il n'y a pas d'affichage du 0 par la commande LIST !!
; 2 - SGN(entier) ne retourne pas un entier mais un float !
; 3 - plein d'autres ...
;
;
; DIRECTIVE DE COMPILATION
; ========================
; compilation via dasm : .\dasm rom_ALICE32_V3.48_CLEAN_ALL_WIP_V1.asm -f3 -o"res.bin" -v2 -ssymbol
;   res.bin étant le fichier résultant de la compilation
;   symbol étant le nom du fichier symbolique
; powershell : Get-FileHash nom_du_fichier
; comparaison de deux fichiers binaires sous powershell : comp
;
; NOTE : http://gmvhdl.com/hc11core.html
;
; NOTE 1 : numéro de ligne maximal est 63999
;
; NOTE 2 : CTRL-0  : mode 32/40 colonnes : changement de la couleur du curseur
;          SHIFT-0 : mode 80/81 colonnes : minuscule/majuscule
;                    mode 32/40 colonnes : mode inverse video
;          CTRL-A : effacer la ligne
;          CTRL-Q : backspace
;          CTRL-Z : caractère ^
;
;          Mode édition :
;          ==============
;          CTRL-ESPACE : AUTOREPEAT ON (mode édition)
;          SHIFT-ESPACE : AUTOREPEAT OFF (mode édition)
;          CTRL-Z : curseur haut   (mode édition)
;          CTRL-Q : curseur gauche (mode édition)
;          CTRL-S : curseur droit  (mode édition)
;          CTRL-W : curseur bas    (mode édition)
;          SHIFT-0: mode inverse video

;
;
; +-------------------------------------------------------------------- +
;  V0.10 2020/01/04 : Première version                                  +
;  V0.20 2020/03/01 : Version compilable avec DASM                      +
;                     Corrections des explications,                     +
;                     poursuites normalisation des labels et variables  +
;  V0.30 2020/03/03 : Poursuites normalisation des labels et variables  +
;                     Correction diverses                               +
;                     Transformation des constantes numériques en       +
;                     constantes symboliques préfixe cXXX_YYY_ZZZZ      +
;  V0.40 2020/03/30 : Poursuite transformation des constantes numériques+
;                     en constantes symboliques préfixe cXXX_YYY_ZZZZ   +
;                     Correction des erreurs d'interprétations          +
;  V0.50 2020/04/22 : Poursuite des améliorations des commentaires      +
;                     Version définitive avant modification pour        +
;                     amélioration                                      +
;  V0.60 2020/05/01 : Modification des commentaires                     +
;                     Correction fautes d'orthographe                   +
;  V0.70 2020/05/14 : MAJ suite remarques après mise à disposition sur  +
;                     le site system-cfg.com                            +
;                     Corrections diverses de commentaires ou de codes
;                     Report de certaines modifications des versions    +
;                     0.9X :                                            +
;                     + Correction d'un bug d'une valeur chargée en     +
;                       mode direct au lieu du mode immediat            +
;                       ldaa #cBAS_QUESTION_MARK est correct            +
;        2020/10/13 : Corrections commentaires                          +
;        2021/05/18 : Report 0.9X harmonisation des noms des constantes +
;=======================================================================+
;  V0.90 2020/05/05 : + Premières optimisations  :                      +
;                       Les optimisations sont repérables par O+chiffres+
;                   O01 - jsr+rts --> jmp                               +
;                   O02 - Remplacement de l'appel jsrjsrPRINT_EF9345    +
;                         par vectorOS_PRINT                            +
;                   O03 - Optim. de OS_printCHARAtCurrentPos            +
;                   O04 - Optim. des appels longs CHRGET et CHRGOT      +
;                   O05 - Optim. sur les acces longs sur INDEX          +
;                   O06 - Optim. sur les acces longs sur DEVNU          +
;                   O07 - Optim. sur les acces longs sur CURLIN         +
;                   O08 - Optim. sur les acces longs sur LINUM          +
;                   O09 - Optim. sur les acces longs sur TXTPTR         +
;                   O10 - Optim. sur jmpCHRGOT_0                        +
;                   O11 - Optim. de l'appel indirect                    +
;                         j_OS_printCHARByDevice                        +
;                   O12 - Optim. utilisation des appels à OS_PRINT      +
;                         au lieu de vectorOS_PRINT                     +
;                     + Mise en place d'un test de performance          +
;                                                                       +
;  Résultat TEST T1 : affichage de I;SIN(I) avec I=[1-1000]             +
;  SANS OPTIM : 66 / AVEC OPTIM : 62 s ==> Gain 4 secondes / 6%         +
;                                                                       +
;  V0.91 2020/05/11 : + Premières optimisations  :                      +
;                  O14 - récupération des nop introduits en V0.9        +
;                  suite aux optimisations : 72 octets                  +
;                  O15 - récupération de l'espace pris par l'easter egg +
;                  liée au co-auteur CHAMBERLIN : 10 octets             +
;                  O16 - récupération de l'espace pris par la table     +
;                  de sauts en $FFDC-$FFEF : 20 octets                  +
;                  O17 - récupération de l'espace pris par des routines +
;                  inutilisées : 175 octets                             +
;                  O18 - récupération de l'espace pris par l'easter egg +
;                  du nom de MICROSOFT : 1O octets                      +
;                  O19 - remplacement de l'appel vectorSCROLLUP par     +
;                  GR_scrollUp                                          +
;                  O20 - remlacement de l'appel à GR_clearLine par      +
;                  GR_clearLine_LORES dans le cas où nous sommes déjà   +
;                  dans ce mode                                         +
;                                                                       +
;  V0.92 2020/05/20 : + 1ere version qui va diverger de la version      +
;                       originelle du BASIC                             +
;                  O21 : récupération de tous les octers gagnés suite   +
;                        aux différentes optimisations de O01 à 020     +
;                  O22 : récupération de tous les octers disponibles    +
;                        dans la rom + fusion avec ceux de O21          +
;                  O23 : optimisation pour l'appel de printChar1        +
;                  O24 : optimisation dans la gestion du retour chariot +
;                  O25 : suppression du dernier appel indirect à        +
;                        j_printCHAR                                    +
;                  O26 : optimisation commande ASC                      +
;                  O27 : optimisation routine SUBSTRING_SETUP           +
;                  O28 : optimisation pour imprimer des chaines         +
;                        constantes en interne (message d'erreur, etc.) +
;                  O29 : optimisation pour imprimer un entier (LIPTR)   +
;                  O30 : récupération espace inutilisé                  +
;                  O31 : nettoyage du code de la commande basic CLS     +
;                                                                       +
;  V0.93 2020/06/12 : + Poursuite de l'optimisation                     +
;                  O32 : suppression des certains hook                  +
;                  O33 : ajout des nouvells commandes BASIC : HIRES,    +
;                        TEXT,LORES,PAPER,INK,COLOR,ASS,CURSET,CURMOV   +
;                        DRAW,FILL,PLOT,CARG,EDIT,RESUME : en cours     +
;                        ou bien juste la déclaration de la commande    +
;                  O34 : suppression de certains nop                    +
;                                                                       +
;  V0.94 2020/07/27 : + Finalisation des développements introduits      +
;   V2.0                dans les versios V0.92                          +
;                     + Suppression des commandes CARG et DRAW suite au +
;                       développement de la commande FILL               +
;                     + GETA$ remplace INKEY$ (conflit de décodage avec +
;                       INK)                                            +
;                     + Poursuite de l'uniformisation des noms des      +
;                       procédures ou fonctions                         *
;                     + Rationalisation du code de GR_clearLine :       *
;                       le code a été concentré en un seul endroit      *
;                     + Poursuite de l'optimisation                     +
;                     + L'émulateur DCALICE a été corrigé suite à une   +
;                       remontée d'un bug de la gestion du registre MP  +
;                       de l'EF9345 dans le mode increment de pointeur  +
;                       MP                                              +
;                     + La commande BASIC CLS continue à gérer les      +
;                       anciens appels du type CLS n                    +
;                     + Correction d'un bug d'une valeur chargée en     +
;                       mode direct au lieu du mode immediat            +
;                       ldaa #cBAS_QUESTION_MARK est correct            +
;                  O35 : RESET (X,Y) devient RESET X,Y                  +
;                        SET (X,Y,C) devient SET X,Y,C                  +
;                                                                       +
;  V0.95 2020/10/05 :                                                   +
;   V2.00             + Ajout de la commande BOX                        +
;                     + Correction l'intervalle (X,Y) possible de la    +
;                       commande basic PLOT                             +
;                     + Ajout de la commande CARG b,n, ...              +
;                     + Début de la réorganisation des variables        +
;                       définies à partir de l'adresse $3000            +
;                  040 : Suppression des HOOKS + réorganisation du code +
;                  041 : Récupération espace mémoire                    +
;                     + Correction de l'inversion des variables         +
;                       CURX_PRT et XMAX_PRT                            +
;                                                                       +
;=======================================================================+
;  V0.96 2020/10/15 : VERSION 3.0 DU BASIC                              +
;   V3.00             + Evolution majeure : la partie assembleur        +
;                       est supprimée pour faire place aux nouvelles    +
;                       commandes du BASIC                              +
;                     + Remplacement de tous les SKIP2 par bra XXX      +
;                     + Optimisation dans la fonction romMULT qui       +
;                       stockait le résultat dans TMPFLT1 n'était pas   +
;                       utilisé ! 20 octets récupèrés                   +
;                       En fait, cette variable était utilisée pour     +
;                       du sel à la fonction RND                        +
;                                                                       +
;=======================================================================+
;  V0.97 2021/05/04 : VERSION 3.10 DU BASIC                             +
;   V3.10             + Réorganisation du code !                        +
;                       - déplacement du noyau de la fin au début de la +
;                         rom                                           +
;                       - regroupement des constantes mathématiques     +
;                       - harmonisation des noms des constantes         +
;                       - regroupement du code par famille :            +
;                           - calcul mathématique                       +
;                           - manipulation de chaîne                    +
;                           - routine spécifique (OS_XXXX)              +
;                       - Le découpage de la rom est le suivant :       +
;                         - BASIC                                       +
;                         - EDITION                                     +
;                         - I/O : CLAVIER/GRAPHISMES/K7/SON             +
;                         - ZONE LIBRE                                  +
;                         - ZONE VECTEURS CPU                           +
;                     + Suppression de ASS / RESUME                     +
;                     + Report V0.95 de la correction de l'inversion des+
;                       variables CURX_PRT et XMAX_PRT                  +
;                     + Correction de CRT_TEMPO en TEMPO_PRT            +
;                     + Correction de la fonction QUICK_INT qui faisait +
;                       référence à ACC1 codé en dur au lieu de son     +
;                       nom (ldx #$00C9 ==> ldx #ACC1)                  +
;                     + Nettoyage des variables (changement de nom, d'  +
;                       utilisation, déplacement en mémoire vive, etc.) +
;                       pour des soucis de rationalisation et de clarté +
;                     + Optimisation de la commande BASIC SGN           +
;                       gain de temps estimé 10%                        +
;                     + Développement de repeat until                   +
;                     + Développement de while wend                     +
;                     + romRND : remplacement de bsr j_romINT_RomRND par+
;                       jsr romINT                                      +
;                     + Ajout des commandes de DEBUG TRON et TROFF      +
;                     + La commande BASIC RESTORE peut prendre un       +
;                       nouveau paramètre ligne                         +
;                     + Ajout de la commande ELSE                       +
;                     + Ajout de la commande BASIC TRUE et FALSE        +
;                     + Ajout de INC / DEC / SWAP                       +
;                     + Ajout de DEF FN                                 +
;                                                                       +
;=======================================================================+
;  V3.10 2021/08/27 : + Changement de numérotation du nom du fichier    +
;                       source : V0.97 devient V3.10                    +
;                     + Les commandes TRUE et FALSE deviennent enfin des+
;                       constantes                                      +
;                     + Ajout de la constante TWOPI = 2 * PI            +
;                     + Ajout du calcul de la borne du numéro maximal de+
;                       ligne + maj commentaire lié à LINGET            +
;                     + 042 : Optimisation légère sur cmdRESTORE        +
;                     + O43 : Optim. bsr jmpFMULT_SubMapApproximxation  +
;                       en jsr FMULT (optim. en vitesse pas en place !) +
;                     + Déplacement des données liées à MATHTBL         +
;                     + Déplacement d'un jmp setError0x02_SYNTAXERROR   +
;                     + 044 : suppression de pshx/pulx dans la fonction +
;                       GR_readScreenAtHOME                             +
;                     + Suppression de la fonction OS_convUnderscore    +
;                       et GR_storeAToR1_EF9345                         +
;                     + La séquence de touche CTRL+L ne génère plus     +
;                       le mot clé PEEK mais effectue un CLS            +
;                     + Simplification de la commande BASIC CLS et      +
;                       suppression GR_getParamCLS                      +
;                     + Optimisation des commandes basic TEXT et        +
;                       LORES                                           +
;                     + Ajout des commandes BASIC AUTO et DEL           +
;                     + Optimisation du code pour la commande FILL      +
;                       et la fonction setMaskColor : Gain 2 cyles      +
;                     + Simplification des constantes cOS_DEV_*         +
;                     + Personnalisation de l'étiquette loc_E362 en     +
;                       next3IsUnknownTokenBasic                        +
;                     + Correction du contenu des constantes d'erreur   +
;                       changement de nom et de contenu                 +
;                     + Dans romCLEAR, remplacement de la constante     +
;                       numérique $3A par cBAS_OFS_STK                  +
;                     + Correction d'un commentaire sur cBAS_OFS_STK    +
;                     + Correction commentaire FREFAC                   +
;                     + Dans isEndRelFRMEVL, remplac. de la constante   +
;                       numérique $07 par cBAS_TOKEN_sup-cBAS_TOKEN_PLUS+
;                     + Nettoyage de commentaires inutiles              +
;                     + Remplacement des constantes numériques liées    +
;                       à la précédence des opérations mathématiques par+
;                       des constantes alpha (cBAS_PREC_xxx)            +
;                                                                       +
;=======================================================================+
;  V3.20 2021/12/13 : + Poursuite des remplacements de constantes       +
;                       numériques en constantes alpha                  +
;                     + Poursuite de l'uniformisation des noms des      +
;                       étiquettes                                      +
;                     + l'étiquette ASS_isNumberEVAL devient            +
;                       isNumberEVAL                                    +
;                     + Possibilité de prendre une expression comme     +
;                       numéro de ligne pour les fonctions GOTO/GOSUB   +
;                     + Ajout de la fonction AT : permet de fixer       +
;                       la position du curseur texte. Peut-être utilisé +
;                       seul ou combiné avcc la commande PRINT          +
;                     + Optimisation des nouvelles fonctions : WHILE    +
;                     + Optimisation de la commande BASIC LIST          +
;                     + Mise à jour commentaire de CHKVAL               +
;                     + Correction des commentaires sur les bugs des    +
;                       commandes VAL, IF, ASC, SGN, etc. liés à la     +
;                       version de l'émulateur utilisée. Ces bugs des   +
;                       commandes n'existent pas dans le BASIC.         +
;                                                                       +
;=======================================================================+
;  V3.30 2022/04/01 : + Reorganisation des constantes                   +
;                     + Prise en compte des nombres hexadécimaux        +
;                       sous la forme #XXXX avec XXXX=[0000;FFFF]       +
;                     + Prise en compte des nombres entiers signés sous +
;                       la forme A% et intervalle = [-32768,32767]      +
;                     + Optimisation de la procédure FIN : l'appel à    +
;                       ADDACC qui permet d'ajouter un nombre entre 0 à +
;                       9 à ACC1 a été remplacé par l'utilisation d'un  +
;                       tableau de constante de type float contenant les+
;                       chiffres de 0 à 9 au lieu de l'utilisation d'une+
;                       fonction de conversion entier vers flottant     +
;                       Suite à cela, ADDACC a été intégrée dans la     +
;                       fonction LOG.                                   +
;                       gain (à confirmer) : 15 à 50 % de temps gagné ! +
;                     + Uniformisation des noms des constantes pointant +
;                       sur les paramètres polynomiaux d'approximation  +
;                       des fonctions sin,log,exp                       +
;                     + Optimisation de MKINT : nous ne faisons plus    +
;                       deux fois le CHKNUM lors de la conversion       +
;                     + Suppression de commentaire inadéquat dans la    +
;                       partie nextDoCLOADM                             +
;                     + Changement de nom de variable TMPKBD en CTRLKBD +
;                     + Suprression de commentaires concernant la rom   +
;                       V1.xx et V2.xx                                  +
;                     + Correction et évolutions de la commande PLOT.   +
;                       Elle permet d'afficher des caractères en mode   +
;                       bichrome ou quadrichorme  via PLOTB et PLOTQ    +
;                     + Ajout de la commande BLK pour choisir le bloc   +
;                       mémoire contenant la redéfinition des caractères+
;                       quadrichrome                                    +
;                     + Ajout de la commande PAL pour définir la palette+
;                       de couleur pour les caractères quadrichorùes    +
;                     + Poursuite des optimisations de code             +
;                     + Poursuite de l'harmonisation des noms des       +
;                       fonctions                                       +
;                                                                       +
;=======================================================================+
;  V3.4x 2022/06/21 : + Poursuite de la mise en place du type int       +
;                       l'addition et la soustraction fonctionne        +
;                       La multiplication fonctionne avec les entiers   +
;                       positifs                                        +
;                       La division d'entier est à implémneter          +
;                     + Formattage du code                              +
;                     + Regroupement de code partie conversion entier   +
;                       en signé et non signé                           +
;                     + Correction bug de la commande SWAP : transfert  +
;                       de 5 octets au lieu de 4 comme auparavant       +
;                     + Le code GR_resetPixelHiRes a été optimisé   et  +
;                       stocké directement dans la commande BASIC RESET +
;                     + Le code GR_setPixelWithMask a été stocké dans la+
;                       commande BASIC SET et optimisé subtilement      +
;                     + l'étiquette isNumberEVAL devient doNumberEVAL   +
;                     + Passage en UTF8 du fichier source               +
;                     + Ajout du code pour la commande basic LINE       +
;                     + Correction bcdConvert                           +
;  V3.45 2023/01/05 : + Correction commande BASIC LINE                  +
;  V3.46 2023/01/12 : + Correction régression sur les calculs des       +
;                       entiers et la comparaison                       +
;                     + Correction régression commande BASIC FOR        +
;                     + Correction régression sur l'opération *         +
;                     + Correction régression : dans certains cas, la   +
;                       commande LIST affiche les numéros de lignes avec+
;                       un '-' avant (ex: -10 PRINT I)                  +
;  V3.47 2023/01/16 : + Correction régression sur la multiplication     +
;                       partie FMULT  et sur la partie romPLUS          +
;                       PRINT SIN(PI/2) donne le bon résultat           +
;                     + Harmonisation : FDIV_ACC1_BY_MEM devient FDIV   +
;                       à l'image de FADD, FSUB, FMULT                  +
;                     + CONUPK : le code ldab ACC1 a été sorti de la    +
;                       fonction. Il n'y a pas de lien direct avec sa   +
;                       fonctionnalité première.                        +
;                     + LEN retourne dorénavant un entier               +
;                     + ASC retourne dorénavant un entier               +
;                     + INT traite aussi les entiers en paramètre et    +
;                       retourne un entier dans ce cas                  +
;                     + Ajout de la fonction FLOAT : conversion d'un    +
;                       entier en float                                 +
;                     + Le code FPWRT a été optimisé légèrement afin    +
;                       d'utiliser les constantes pour n^0 = 1 ou 0^n=0 +
;                       Il faut passer des float car la gestion des int +
;                       comme paramètre n'a pas été effectuée           +
;                     + Diverses corrections pour passer le pointeur X  +
;                       aux fonctions ZEROFAC1 et ZEROFAC2              +
;                     + Correction d'une régression lors de la          +
;                       comparaison (IF A$="TITI" ...)                  +
;                     + Correction du code de recherche de variable     +
;                       confondant A et A$                              +
;                     + Correction régression sur la multiplication ... +
;                       suite à une régression sur le type des variables+
;                       retourné lors d'une comparaison                 +
;  V3.48 2023/04/11 : + Nettoyage de certains TODO                      +
;                     + FOR : déplacement du test de la numéricité de   +
;                       la valeur de départ au plus près de l'action au +
;                       de le faire avant le TO                         +
;                     + Suppression de la constante cK7_TYP_PRG_ASS_SRC +
;                     + Gestion des formats d'un nombre et du type :    +
;                       NOTE : intervalle des entiers [-65535;65535]    +
;                       nombre = . => type : float et égal à 0          +
;                       nombre = 0 => type : entier                     +
;                       nombre = 0. => type : float                     +
;                       nombre = 10000 => type : entier                 +
;                       nombre = 10000. => type : float                 +
;                       nombre = 100000 => type : float car dépassement +
;                       de capacité d'un entier                         +
;                     + Correction d'une régression dans la commande    +
;                       INPUT dans le cas d'une attente d'une saisie    +
;                       d'une chaîne de caractère                       +
;                     + Ajout d'une commande RECT qui dessine ... un    +
;                       rectangle de couleur c                          +
;                     + la gestion des float dans FOR ... TO ... est    +
;                       encore cassée                                   +
;                     + la comparaison ne vérifie pas la comptabilité   +
;                       des types numériques des éléments comparés      +
;                                                                       +
;=======================================================================+
; +-------------------------------------------------------------------- +
;  Origine de la ROM : MICROSOFT 8ko + modifications MATRA              +
;  La version BASIC n'est pas encore déterminée par rapport aux versions+
;  des processeurs 6502 ou Z80.                                         +
;                                                                       +
; ----------------------------------------------------------------------+
; DEVELOPPEMENT EN COURS :                                              +
; ----------------------------------------------------------------------+
;   HIRES              : remplace CLS 80 de la rom V1 d'ALICE 32        +
;   TEXT               : remplace CLS 40 de la rom V1 d'ALICE 32        +
;   LORES              : remplace CLS 32 de la rom V1 d'ALICE 32        +
;   INK c              : change la couleur de l'encre 1 ou encre 2      +
;   PAPER c            : change la couleur du fond d'écran              +
;   CURSET X,Y,c       : remplace SET(X,Y,c)                            +
;   CURMOV X,Y,c       : positionne le curseur relativement à la pos.   +
;                        courante de celui-ci                           +
;   FILL X,Y,dX,dY,c   : remplit une zone rectangulaire de l'écran à    +
;                        partir de la position X,Y à X+dX,Y+dY avec la  +
;                        couleur c                                      +
;   BOX X,Y,dX,dY,c    : remplit une zone rectangulaire de l'écran à    +
;                        partir de la position (X mod 2,Y mod 5)        +
;                        à (X mod 2)+dX,(Y mod 5)+dY avec la couleur c  +
;                        Le remplissage s'effectue par bloc de 2 col x  +
;                        5 lignes                                       +
;                        dX = nombre de blocs selon l'axe X             +
;                        dY = nombre de blocs selon l'axe Y             +
;   PLOT[B,Q] X,Y,str  : imprime une chaîne de caractère à la position  +
;                        (X,Y) avec (X,Y)=[0,0] à [79,24] en mode HIRES +
;                        PLOTB permet d'imprimer des carctères bichromes+
;                        PLOTQ imprime des caractères quadrichromes     +
;   EDIT n             : pour éditer une ligne au lieu de taper * n     +
;   CARG z,c,xxyyzzww  : pour stocker une redéfinition de caractère     +
;   INC  X             : incrémente de 1 la variable X                  +
;   DEC  X             : décrémente de 1 la variable X                  +
;   SWAP A,B           : échange le contenu des variables A et B        +
;   WORD               : pour lister les commandes BASIC connues        +
;   TRUE               : retourne la valeur -1                          +
;   FALSE              : retourne la valeur 0                           +
;   REPEAT ... UNTIL   : boucle de type ... REPEAT ... UNTIL cond       +
;   WHILE ... WEND     : boucle de type ... WHILE cond ... WEND         +
;   DEF FN             : définition d'une fonction                      +
;   TRON               : active le mode trace (debug)                   +
;   TROFF              : désactive le mode trace (debug)                +
;   ELSE               : le ELSE de l'instruction IF ... THEN ... ELSE  +
;   AUTO               : numérote automatiquement les lignes à la saisie+
;   DEL                : supprime des lignes de programme               +
;   RENUM              : renumérotation de ligne de programme           +
;   GOTO N/GOSUB N     : possibilité d'utiliser une expression pour la  +
;                        ligne de saut                                  +
;   RESTORE N          : possibilité d'utiliser une expression pour la  +
;                        ligne de données à lire                        +
;   [PRINT] AT X,Y     : permet de positionner le curseur texte         +
;                        utilisable seule ou avec print                 +
;   PAL(#D2)           : permet de fixer la palette des caractères      +
;                        quadrichromes.                                 +
;   BLK(x)             : permet de fixer le bloc du caractère quadri-   +
;                        chrome affiché par PLOTQ                       +
;   LINE X,Y,X1,Y1,c   : pour tracer ... une ligne de couleur c         +
;   RECT X,Y,X1,Y1,c   : pour tracer ... un rectangle de couleur c      +
; ----------------------------------------------------------------------+
; DEVELOPPEMENT EN ATTENTE :                                            +
; ----------------------------------------------------------------------+
;   ! MYPROC           : pour appeler une procédure définie par ]MYPROC +
;   ] MYPROC           : pour définir une procédure MYPROC              +
;   LOG                : log décimal (base 10). Cela implique que       +
;                        l'ancienne commande LOG soit renommée en LN    +
;   SQR                : optimisation du temps d'exécution de SQR       +
;                                                                       +
; ----------------------------------------------------------------------+
; ----------------------------------------------------------------------+
;  La norme dans les labels des procédures dans le listing est la       +
;  suivante : préfixe origine +  '_' + verbe + complement               +
;  sauf pour le noyau du basic et les routines commande BASIC romXXX    +
;  exemple : GR_getPixel :                                              +
;  Les préfixes  sont :                                                 +
;  GR  : routine graphique                                              +
;  K7  : routine magnétophone                                           +
;  OS  : routine spécifique type BIOS                                   +
; + ------------------------------------------------------------------- +
; Zone mémoire : TODO : à revoir 16/05/2022
;
;  $0000-$007F : 128 octets   : reserved MC6803 : gestion clavier, timer, K7, RS232
;  $0080-$00FF : 128 octets   : variables basic
;  $0100-$2FFF : 12031 octets : ram optionnelle
;  $3000-$4FFF : 8Ko          : variable basic, assembleur, i/o +
;                               graphisme + programme +
;                               tableaux + variables
;    $3043-$3093 : sert de tampon d'édition d'une ligne assemleur
;                  mais aussi d'une zone temporaire pour :
;                  -- stockage temporaire pour les variables locales lors
;                     de la sauvegarde K7 de la partie assembleur
;                  -- stockage temporaire pour la conversion word -> ASCII
;
;    $3346 : début du programme basic
;    $4F94 : début pile système
;  $5000-$B000 : 24576 octets : ram optionelle
;  $B000-$BFFF :  4096 octets : I/O : EF9345, SON, clavier
;     $BF20-$BF2F   : EF9345
;     $BFFF         : clavier
;  $C000-$FFFF : 16 Ko        : rom
;   $C000-$D268 : assembleur
;   $D269-$D26F : libre
;   $D270-$DFFF : routine graphique, K7, éditeur mode ligne
;       $D27C-$D3FC : libre : 385 octets
;       $D432-$D43F : libre :  14 octets
;       $D691-$D69F : libre :  15 octets
;       $DACB-$DADF : libre :   5 octets
;       $DD93-$DF8F : libre : 509 octets
;       $DF90-$DFF2 : routine lecture/écriture K7 non utilisée
;       $DFF3-$DFFF : libre :  13 octets
;   $E000-$FFD1 : BASIC MICROSOFT : environ 8ko
;       $E000-$E02F : Table des commandes BASIC
;       $E030-$E044 : Table des sauts des opérateurs mathématiques + prédécence associée
;       $E045-$E0E0 : Table des commandes BASIC suite
;       $E0E1-$E0ED : Table des opérateurs mathématiques
;       $E0EE-$E147 : Table des fonctions BASIC
;       $E048-$E189 : Table des sauts des commandes et fonctions BASIC
;       $E18A-$EAAF : Table des messages d'erreurs
;       $F9BE-$F9C5 : libre :  8 octets
;       $F724-$F72D : Easter EGG : 9 octets : Microsoft
;   $FFD2-$FFDB : ANOTHER EASTER EGG nilrebmahC (Chamberlin) : co-auteur de la rom chez M$
;   $FFDC-$FFEF : Table de sauts systèmes : à quoi ça sert car ce n'est pas une vraie table de sauts systèmes ?
;   $FFF0-$FFFF : table des vecteurs : SCI,TIMER,IRQ,SWI,NMI et RESET
;
; ==> Quel gachis ! Tant de mémoire perdue ...
; ===========================================================================
; TODO :
; 1 -
; ===========================================================================
            PROCESSOR 6803

;--------------- MACRO
        MAC SKIP1
                dc.b $21
        ENDM
        MAC SKIP2
                dc.b $8C
        ENDM
        MAC SKIP2_ASM
                dc.b $BC
        ENDM
        MAC SKIP_BYTE
                dc.b $86
        ENDM

;-- Définition des token de type commande, fonction et opérateur mathématique
cBAS_OFS_CMD                     EQU $80

;-- Définition des token BASIC de type commande
cBAS_TOKEN_FOR                   EQU cBAS_OFS_CMD                         ; $80 : OPCODE DE LA COMMANDE BASIC FOR
cBAS_TOKEN_GOTO                  EQU cBAS_TOKEN_FOR         + 1           ; $81 : OPCODE DE LA COMMANDE BASIC GOTO
cBAS_TOKEN_GOSUB                 EQU cBAS_TOKEN_GOTO        + 1           ; $82 : OPCODE DE LA COMMANDE BASIC GOSUB
cBAS_TOKEN_REM                   EQU cBAS_TOKEN_GOSUB       + 1           ; $83 : OPCODE DE LA COMMANDE BASIC REM
cBAS_TOKEN_IF                    EQU cBAS_TOKEN_REM         + 1           ; $84 : OPCODE DE LA COMMANDE BASIC IF
cBAS_TOKEN_DATA                  EQU cBAS_TOKEN_IF          + 1           ; $85 : OPCODE DE LA COMMANDE BASIC DATA
cBAS_TOKEN_PRINT                 EQU cBAS_TOKEN_DATA        + 1           ; $86 ; OPCODE DE LA COMMANDE BASIC PRINT
cBAS_TOKEN_ON                    EQU cBAS_TOKEN_PRINT       + 1           ; $87 ; OPCODE DE LA COMMANDE BASIC ON
cBAS_TOKEN_INPUT                 EQU cBAS_TOKEN_ON          + 1           ; $88 : OPCODE DE LA COMMANDE BASIC INPUT
cBAS_TOKEN_END                   EQU cBAS_TOKEN_INPUT       + 1           ; $89 ; OPCODE DE LA COMMANDE BASIC END
cBAS_TOKEN_NEXT                  EQU cBAS_TOKEN_END         + 1           ; $8A : OPCODE DE LA COMMANDE BASIC NEXT
cBAS_TOKEN_DIM                   EQU cBAS_TOKEN_NEXT        + 1           ; $8B : OPCODE DE LA COMMANDE BASIC DIM
cBAS_TOKEN_READ                  EQU cBAS_TOKEN_DIM         + 1           ; $8C : OPCODE DE LA COMMANDE BASIC READ
cBAS_TOKEN_LET                   EQU cBAS_TOKEN_READ        + 1           ; $8D : OPCODE DE LA COMMANDE BASIC LET
cBAS_TOKEN_RUN                   EQU cBAS_TOKEN_LET         + 1           ; $8E : OPCODE DE LA COMMANDE BASIC RUN
cBAS_TOKEN_RESTORE               EQU cBAS_TOKEN_RUN         + 1           ; $8F : OPCODE DE LA COMMANDE BASIC RESTORE
cBAS_TOKEN_RETURN                EQU cBAS_TOKEN_RESTORE     + 1           ; $90 : OPCODE DE LA COMMANDE BASIC RETURN
cBAS_TOKEN_STOP                  EQU cBAS_TOKEN_RETURN      + 1           ; $91 ; OPCODE DE LA COMMANDE BASIC STOP
cBAS_TOKEN_POKE                  EQU cBAS_TOKEN_STOP        + 1           ; $92 ; OPCODE DE LA COMMANDE BASIC POKE
cBAS_TOKEN_CONT                  EQU cBAS_TOKEN_POKE        + 1           ; $93 : OPCODE DE LA COMMANDE BASIC CONT
cBAS_TOKEN_LIST                  EQU cBAS_TOKEN_CONT        + 1           ; $94 ; OPCODE DE LA COMMANDE BASIC LIST
cBAS_TOKEN_CLEAR                 EQU cBAS_TOKEN_LIST        + 1           ; $95 ; OPCODE DE LA COMMANDE BASIC CLEAR
cBAS_TOKEN_NEW                   EQU cBAS_TOKEN_CLEAR       + 1           ; $96 ; OPCODE DE LA COMMANDE BASIC NEW
cBAS_TOKEN_CLOAD                 EQU cBAS_TOKEN_NEW         + 1           ; $97 ; OPCODE DE LA COMMANDE BASIC CLOAD
cBAS_TOKEN_CSAVE                 EQU cBAS_TOKEN_CLOAD       + 1           ; $98 ; OPCODE DE LA COMMANDE BASIC CSAVE
cBAS_TOKEN_LLIST                 EQU cBAS_TOKEN_CSAVE       + 1           ; $99 ; OPCODE DE LA COMMANDE BASIC LLIST
cBAS_TOKEN_LPRINT                EQU cBAS_TOKEN_LLIST       + 1           ; $9A ; OPCODE DE LA COMMANDE BASIC LPRINT
cBAS_TOKEN_SET                   EQU cBAS_TOKEN_LPRINT      + 1           ; $9B : OPCODE DE LA COMMANDE BASIC SET
cBAS_TOKEN_RESET                 EQU cBAS_TOKEN_SET         + 1           ; $9C : OPCODE DE LA COMMANDE BASIC RESET
cBAS_TOKEN_CLS                   EQU cBAS_TOKEN_RESET       + 1           ; $9D ; OPCODE DE LA COMMANDE BASIC CLS
; -- Ajouts pour BASIC V2.x, V3.x : DEBUT
cBAS_TOKEN_HIRES                 EQU cBAS_TOKEN_CLS         + 1           ; $9E ; OPCODE DE LA COMMANDE BASIC HIRES
cBAS_TOKEN_TEXT                  EQU cBAS_TOKEN_HIRES       + 1           ; $9F ; OPCODE DE LA COMMANDE BASIC TEXT
cBAS_TOKEN_LORES                 EQU cBAS_TOKEN_TEXT        + 1           ; $A0 ; OPCODE DE LA COMMANDE BASIC LORES
cBAS_TOKEN_PAPER                 EQU cBAS_TOKEN_LORES       + 1           ; $A1 ; OPCODE DE LA COMMANDE BASIC PAPER
cBAS_TOKEN_INK                   EQU cBAS_TOKEN_PAPER       + 1           ; $A2 ; OPCODE DE LA COMMANDE BASIC INK
cBAS_TOKEN_BOX                   EQU cBAS_TOKEN_INK         + 1           ; $A3 ; OPCODE DE LA COMMANDE BASIC BOX
cBAS_TOKEN_RECT                  EQU cBAS_TOKEN_BOX         + 1           ; $A4 ; OPCODE DE LA COMMANDE BASIC RECT
cBAS_TOKEN_CURSET                EQU cBAS_TOKEN_RECT        + 1           ; $A5 ; OPCODE DE LA COMMANDE BASIC CURSET
cBAS_TOKEN_CURMOV                EQU cBAS_TOKEN_CURSET      + 1           ; $A6 ; OPCODE DE LA COMMANDE BASIC CURMOV
cBAS_TOKEN_FILL                  EQU cBAS_TOKEN_CURMOV      + 1           ; $A7 ; OPCODE DE LA COMMANDE BASIC FILL
cBAS_TOKEN_PLOT                  EQU cBAS_TOKEN_FILL        + 1           ; $A8 ; OPCODE DE LA COMMANDE BASIC PLOT
cBAS_TOKEN_PAL                   EQU cBAS_TOKEN_PLOT        + 1           ; $A9 : OPCODE DE LA COMMANDE BASIC PAL
cBAS_TOKEN_BLK                   EQU cBAS_TOKEN_PAL         + 1           ; $AA : OPCODE DE LA COMMANDE BASIC BLK
cBAS_TOKEN_AT                    EQU cBAS_TOKEN_BLK         + 1           ; $AB ; OPCODE DE LA COMMANDE BASIC AT
cBAS_TOKEN_LINE                  EQU cBAS_TOKEN_AT          + 1           ; $AC ; OPCODE DE LA COMMANDE BASIC LINE
cBAS_TOKEN_EDIT                  EQU cBAS_TOKEN_LINE        + 1           ; $AD : OPCODE DE LA COMMANDE BASIC EDIT
cBAS_TOKEN_CARG                  EQU cBAS_TOKEN_EDIT        + 1           ; $AE : OPCODE DE LA COMMANDE BASIC CARG
cBAS_TOKEN_WORD                  EQU cBAS_TOKEN_CARG        + 1           ; $AF : OPCODE DE LA COMMANDE BASIC WORD
cBAS_TOKEN_INC                   EQU cBAS_TOKEN_WORD        + 1           ; $B0 : OPCODE DE LA COMMANDE BASIC INC
cBAS_TOKEN_DEC                   EQU cBAS_TOKEN_INC         + 1           ; $B1 : OPCODE DE LA COMMANDE BASIC DEC
cBAS_TOKEN_SWAP                  EQU cBAS_TOKEN_DEC         + 1           ; $B2 : OPCODE DE LA COMMANDE BASIC SWAP
cBAS_TOKEN_REPEAT                EQU cBAS_TOKEN_SWAP        + 1           ; $B3 : OPCODE DE LA COMMANDE BASIC REPEAT
cBAS_TOKEN_UNTIL                 EQU cBAS_TOKEN_REPEAT      + 1           ; $B4 : OPCODE DE LA COMMANDE BASIC UNTIL
cBAS_TOKEN_WHILE                 EQU cBAS_TOKEN_UNTIL       + 1           ; $B5 : OPCODE DE LA COMMANDE BASIC WHILE
cBAS_TOKEN_WEND                  EQU cBAS_TOKEN_WHILE       + 1           ; $B6 : OPCODE DE LA COMMANDE BASIC WHEND
cBAS_TOKEN_DEF                   EQU cBAS_TOKEN_WEND        + 1           ; $B7 : OPCODE DE LA COMMANDE BASIC DEF
cBAS_TOKEN_FN                    EQU cBAS_TOKEN_DEF         + 1           ; $B8 : OPCODE DE LA COMMANDE BASIC FN
cBAS_TOKEN_TRON                  EQU cBAS_TOKEN_FN          + 1           ; $B9 : OPCODE DE LA COMMANDE BASIC TRON
cBAS_TOKEN_TROFF                 EQU cBAS_TOKEN_TRON        + 1           ; $BA : OPCODE DE LA COMMANDE BASIC TROFF
cBAS_TOKEN_ELSE                  EQU cBAS_TOKEN_TROFF       + 1           ; $BB : OPCODE DE LA COMMANDE BASIC ELSE
cBAS_TOKEN_AUTO                  EQU cBAS_TOKEN_ELSE        + 1           ; $BC : OPCODE DE LA COMMANDE BASIC AUTO
cBAS_TOKEN_RENUM                 EQU cBAS_TOKEN_AUTO        + 1           ; $BD : OPCODE DE LA COMMANDE BASIC RENUM
cBAS_TOKEN_DEL                   EQU cBAS_TOKEN_RENUM       + 1           ; $BE : OPCODE DE LA COMMANDE BASIC DEL
; -- Ajouts pour BASIC V2.x, V3.x : FIN
cBAS_TOKEN_SOUND                 EQU cBAS_TOKEN_DEL         + 1           ; $BF : OPCODE DE LA COMMANDE BASIC SOUND
cBAS_TOKEN_EXEC                  EQU cBAS_TOKEN_SOUND       + 1           ; $C0 : OPCODE DE LA COMMANDE BASIC EXEC
cBAS_TOKEN_SKIPF                 EQU cBAS_TOKEN_EXEC        + 1           ; $C1 ; OPCODE DE LA COMMANDE BASIC SKIPF

; -- Définition des fonctions/commandes spécifiques, opérateurs mathématiques, fonctions à 1 seul paramètre,
;    fonction à n paramètres, fonction à aucun paramètre (MEM)

; -- fonctions ou commandes spécifiques
cBAS_TOKEN_TAB                   EQU cBAS_TOKEN_SKIPF       + 1           ; $C2 : Opcode DE LA FONCTION BASIC TAB
cBAS_TOKEN_TO                    EQU cBAS_TOKEN_TAB         + 1           ; $C3 : Opcode DE LA FONCTION BASIC TO
cBAS_TOKEN_THEN                  EQU cBAS_TOKEN_TO          + 1           ; $C4 : Opcode DE LA FONCTION BASIC THEN
cBAS_TOKEN_NOT                   EQU cBAS_TOKEN_THEN        + 1           ; $C5 : Opcode DE LA FONCTION BASIC NOT
cBAS_TOKEN_STEP                  EQU cBAS_TOKEN_NOT         + 1           ; $C6 : Opcode DE LA FONCTION BASIC STEP
cBAS_TOKEN_OFF                   EQU cBAS_TOKEN_STEP        + 1           ; $C7 : Opcode DE LA FONCTION BASIC OFF

;-- opérateur mathématique
cBAS_TOKEN_PLUS                  EQU cBAS_TOKEN_OFF         + 1           ; $C8 : Opcode DE LA FONCTION BASIC +
cBAS_TOKEN_MINUS                 EQU cBAS_TOKEN_PLUS        + 1           ; $C9 : Opcode DE LA FONCTION BASIC -
cBAS_TOKEN_mult:                 EQU cBAS_TOKEN_MINUS       + 1           ; $CA : Opcode DE LA FONCTION BASIC *
cBAS_TOKEN_div:                  EQU cBAS_TOKEN_mult        + 1           ; $CB : Opcode DE LA FONCTION BASIC /
cBAS_TOKEN_power:                EQU cBAS_TOKEN_div         + 1           ; $CC : Opcode DE LA FONCTION BASIC ^
cBAS_TOKEN_AND:                  EQU cBAS_TOKEN_power       + 1           ; $CD : Opcode DE LA FONCTION BASIC AND
cBAS_TOKEN_OR:                   EQU cBAS_TOKEN_AND         + 1           ; $CE : Opcode DE LA FONCTION BASIC OR

; -- Opérateur de comparaison
cBAS_TOKEN_sup                   EQU cBAS_TOKEN_OR          + 1           ; $CF : OPCODE DE L'OPERATEUR BASIC >
cBAS_TOKEN_egal                  EQU cBAS_TOKEN_sup         + 1           ; $D0 : OPCODE DE L'OPERATEUR BASIC =
cBAS_TOKEN_inf                   EQU cBAS_TOKEN_egal        + 1           ; $D1 : OPCODE DE L'OPERATEUR BASIC <

;-- Définition des token BASIC de type FONCTION à 1 seul paramètre, fonction n paramètres et fonction à aucun paramètre
; ---- function with one parameter
cBAS_TOKEN_SGN                   EQU cBAS_TOKEN_inf         + 1           ; $D2 : OPCODE DE LA FONCTION BASIC SGN
cBAS_TOKEN_INT                   EQU cBAS_TOKEN_SGN         + 1           ; $D3 : OPCODE DE LA FONCTION BASIC INT
cBAS_TOKEN_ABS                   EQU cBAS_TOKEN_INT         + 1           ; $D4 : OPCODE DE LA FONCTION BASIC ABS
cBAS_TOKEN_USR                   EQU cBAS_TOKEN_ABS         + 1           ; $D5 : OPCODE DE LA FONCTION BASIC USR
cBAS_TOKEN_RND                   EQU cBAS_TOKEN_USR         + 1           ; $D6 : OPCODE DE LA FONCTION BASIC RND
cBAS_TOKEN_SQR                   EQU cBAS_TOKEN_RND         + 1           ; $D7 : OPCODE DE LA FONCTION BASIC SQR
cBAS_TOKEN_LOG                   EQU cBAS_TOKEN_SQR         + 1           ; $D8 : OPCODE DE LA FONCTION BASIC LOG
cBAS_TOKEN_EXP                   EQU cBAS_TOKEN_LOG         + 1           ; $D9 : OPCODE DE LA FONCTION BASIC EXP
cBAS_TOKEN_SIN                   EQU cBAS_TOKEN_EXP         + 1           ; $DA : OPCODE DE LA FONCTION BASIC SIN
cBAS_TOKEN_COS                   EQU cBAS_TOKEN_SIN         + 1           ; $DB : OPCODE DE LA FONCTION BASIC COS
cBAS_TOKEN_TAN                   EQU cBAS_TOKEN_COS         + 1           ; $DC : OPCODE DE LA FONCTION BASIC TAN
cBAS_TOKEN_PEEK                  EQU cBAS_TOKEN_TAN         + 1           ; $DD : OPCODE DE LA FONCTION BASIC PEEK
cBAS_TOKEN_LEN                   EQU cBAS_TOKEN_PEEK        + 1           ; $DE : OPCODE DE LA FONCTION BASIC LEN
cBAS_TOKEN_STRdollar             EQU cBAS_TOKEN_LEN         + 1           ; $DF : OPCODE DE LA FONCTION BASIC STR$
cBAS_TOKEN_VAL                   EQU cBAS_TOKEN_STRdollar   + 1           ; $E0 : OPCODE DE LA FONCTION BASIC VAL
cBAS_TOKEN_ASC                   EQU cBAS_TOKEN_VAL         + 1           ; $E1 : OPCODE DE LA FONCTION BASIC ASC
cBAS_TOKEN_CHRdollar             EQU cBAS_TOKEN_ASC         + 1           ; $E2 : OPCODE DE LA FONCTION BASIC CHR$
; -- Ajouts pour BASIC V3.x : DEBUT
cBAS_TOKEN_FLOAT                 EQU cBAS_TOKEN_CHRdollar   + 1           ; $E3 : OPCODE DE LA COMMANDE BASIC FLOAT
; -- Ajouts pour BASIC V3.x : FIN
; ---- function with multiple parameter
cBAS_TOKEN_LEFTdollar            EQU cBAS_TOKEN_FLOAT       + 1           ; $E4 : OPCODE DE LA FONCTION BASIC LEFT$
cBAS_TOKEN_RIGHTdollar           EQU cBAS_TOKEN_LEFTdollar  + 1           ; $E5 : OPCODE DE LA FONCTION BASIC RIGHT$
cBAS_TOKEN_MIDdollar             EQU cBAS_TOKEN_RIGHTdollar + 1           ; $E6 : OPCODE DE LA FONCTION BASIC MID$
cBAS_TOKEN_POINT                 EQU cBAS_TOKEN_MIDdollar   + 1           ; $E7 : OPCODE DE LA FONCTION BASIC POINT
cBAS_TOKEN_VARPTR                EQU cBAS_TOKEN_POINT       + 1           ; $E8 : OPCODE DE LA FONCTION BASIC VARPTR
cBAS_TOKEN_GETAdollar            EQU cBAS_TOKEN_VARPTR      + 1           ; $E9 : OPCODE DE LA FONCTION BASIC GETA$ (remplace INKEY$)
; ---- function with no parameter
; -- Ajouts pour BASIC V3.x : DEBUT
cBAS_TOKEN_PI                    EQU cBAS_TOKEN_GETAdollar  + 1           ; $EA : OPCODE DE LA FONCTION BASIC PI
cBAS_TOKEN_TWOPI                 EQU cBAS_TOKEN_PI          + 1           ; $EB : OPCODE DE LA FONCTION BASIC TWOPI
cBAS_TOKEN_FALSE                 EQU cBAS_TOKEN_TWOPI       + 1           ; $EC : OPCODE DE LA COMMANDE BASIC FALSE
cBAS_TOKEN_TRUE                  EQU cBAS_TOKEN_FALSE       + 1           ; $ED : OPCODE DE LA COMMANDE BASIC TRUE
; -- Ajouts pour BASIC V3.x : FIN
cBAS_TOKEN_MEM                   EQU cBAS_TOKEN_TRUE        + 1           ; $EE : OPCODE DE LA FONCTION BASIC MEM

;--
cBAS_TOKEN_CMD_MAX               EQU cBAS_TOKEN_SKIPF                     ; Numéro maximal des commandes BASIC                     : TODO : $C0
cBAS_OFS_FCT                     EQU cBAS_TOKEN_SGN                       ; Début de token de type fonction avec ou sans paramètre : TODO : $D1
cBAS_TOKEN_ALL_MAX               EQU cBAS_TOKEN_MEM                       ; Numéro maximal de tous les opcodes BASIC               : TODO : $ED
cBAS_NB_OP_CMP                   EQU (cBAS_TOKEN_inf-cBAS_TOKEN_sup) + 1  ; Nombre d'opérateur de comparaison                      : TODO : $03

;--
sBAS_ERR_NOFOR                   EQU "NF" ; $00 (00) : NF Next without FOR
sBAS_ERR_SYNTAX                  EQU "SN" ; $02 (02) : SN SyNtax error
sBAS_ERR_NOGOSUB                 EQU "RG" ; $04 (04) : RG Return without GOSUB
sBAS_ERR_NODATA                  EQU "OD" ; $06 (06) : OD Overflow Data
sBAS_ERR_ILLQTY                  EQU "FC" ; $08 (08) : FC function incorrecte
sBAS_ERR_OVERFLOW                EQU "OV" ; $0A (10) : OV OVerflow capacity
sBAS_ERR_MEMFULL                 EQU "OM" ; $0C (12) : OM Out of Memory
sBAS_ERR_UNDEFLINE               EQU "UL" ; $0E (14) : UL Undefined Line
sBAS_ERR_BADSUBS                 EQU "BS" ; $10 (16) : BS Bad Subscript
sBAS_ERR_REDIMD                  EQU "DD" ; $12 (18) : DD Erreur avec un tableau
sBAS_ERR_ZERODIV                 EQU "/0" ; $14 (20) : /0 divide by 0
sBAS_ERR_ILLDIR                  EQU "ID" ; $16 (22) : ID Illegal Direct
sBAS_ERR_TYPEMISM                EQU "TM" ; $18 (24) : TM Type Mismatch
sBAS_ERR_STRFULL                 EQU "OS" ; $1A (26) : OS Out of String
sBAS_ERR_STRLONG                 EQU "LS" ; $1C (28) : LS Lenght String
sBAS_ERR_FRMCPX                  EQU "ST" ; $1E (30) : ST STatement
sBAS_ERR_CANTCONT                EQU "CN" ; $20 (32) : CN CaN't continue
sBAS_ERR_IO                      EQU "IO" ; $22 (34) : IO Error Input/output
sBAS_ERR_K7                      EQU "FM" ; $24 (38) : FM File Mismatch
; DEBUT BASIC 3.x
sBAS_ERR_NOREPEAT                EQU "NR" ; $26 (40) : NR UNTIL without REPEAT
sBAS_ERR_NOWHILE                 EQU "NW" ; $28 (40) : NW WEND without WHILE
; FIN BASIC 3.x

cBAS_ERR_NOFOR                   EQU $00  ; (00) : NF Next without FOR
cBAS_ERR_SYNTAX                  EQU $02  ; (02) : SN SyNtax error
cBAS_ERR_NOGOSUB                 EQU $04  ; (04) : RG Return without GOSUB
cBAS_ERR_NODATA                  EQU $06  ; (06) : OD Overflow Data
cBAS_ERR_ILLQTY                  EQU $08  ; (08) : FC fonction incorrecte
cBAS_ERR_OVERFLOW                EQU $0A  ; (10) : OV OVerflow capcity
cBAS_ERR_MEMFULL                 EQU $0C  ; (12) : OM Out of Memory
cBAS_ERR_UNDEFLINE               EQU $0E  ; (14) : UL Undefined Line
cBAS_ERR_BADSUBS                 EQU $10  ; (16) : BS Bad Subscript
cBAS_ERR_REDIMD                  EQU $12  ; (18) : DD Erreur avec un tableau
cBAS_ERR_ZERODIV                 EQU $14  ; (20) : /0 divide by 0
cBAS_ERR_ILLDIR                  EQU $16  ; (22) : ID Illegal Direct
cBAS_ERR_TYPEMISM                EQU $18  ; (24) : TM Type Mismatch
cBAS_ERR_STRFULL                 EQU $1A  ; (26) : OS Out of String
cBAS_ERR_STRLONG                 EQU $1C  ; (28) : LS Length String
cBAS_ERR_FRMCPX                  EQU $1E  ; (30) : ST STatement
cBAS_ERR_CANTCONT                EQU $20  ; (32) : CN CaN't continue
cBAS_ERR_IO                      EQU $22  ; (34) : IO Error Input/output
cBAS_ERR_K7                      EQU $24  ; (38) : FM File Mismatch
; DEBUT BASIC 3.x
cBAS_ERR_NOREPEAT                EQU $26  ; (40) : NR Until without REPEAT
cBAS_ERR_NOWHILE                 EQU $28  ; (42) : NW WEND without WHILE
; FIN BASIC 3.x

;--------------- CONSTANTES GLOBALES
cBEGIN_RAM                       EQU $3000                                ; DEBUT DE LA RAM

;--------------- CONSTANTES PARTIE BASIC
cBAS_NUMLEV                      EQU 21                                   ; Nombre de niveau d'imbrication
cBAS_ADDPRC                      EQU 01                                   ; Précision d'un type float
cBAS_BYTES_PER_VARIABLE          EQU $05                                  ; Nombre d'octets pour stocker une variable
cBAS_LG_VAR                      EQU $02                                  ; Longueur maximale du nom d'une variable
cBAS_AREA_STR_DEFAULT            EQU $64                                  ; Nb octets par défaut pour la zone des chaines de caractère
cBAS_BYTES_PER_FOR               EQU $14                                  ; Nb octets pour coder un for dans la pile (le type du numerique est codé)
cBAS_LG_FILENAME                 EQU $08                                   ; Longueur maximale d'un nom de fichier
cBAS_LEN_VAR_FLOAT               EQU cBAS_BYTES_PER_VARIABLE+cBAS_LG_VAR  ; $07
cBAS_ARY_DIM_DEFAULT             EQU $0A                                  ; Taille d'un tableau par défaut.
cBAS_OFS_STK                     EQU ((2*cBAS_NUMLEV)+(3*cBAS_ADDPRC)+13) ; =$3A

cBAS_PREC_OP_REL                 EQU $64                                  ; "Précédence" d'un opérateur relationel
cBAS_PREC_NOT                    EQU $5A                                  ; "Précédence" de l'opérateur NOT
cBAS_PREC_MINUS                  EQU $7D                                  ; "Précédence" de l'opérateur -

; -- BASIC
cBAS_SEP_STR                     EQU $22                                  ; '"' ; -- $22
cBAS_SEP_ARG                     EQU $2C                                  ; ',' ; -- $2C
cBAS_SEP                         EQU $3A                                  ; ':' ; -- $3A
cBAS_SEP_VAR                     EQU $3B                                  ; ';' ; -- $3B
;--
cBAS_ID_HEX                      EQU $23                                  ; '#'
cBAS_ID_STR                      EQU $24                                  ; '$'
cBAS_ID_INT                      EQU $25                                  ; '%'
;--
cBAS_FCT_OPEN                    EQU $28                                  ; '('
cBAS_FCT_CLOSE                   EQU $29                                  ; ')'
;--
cBAS_EQUAL                       EQU $3D                                  ; '='
cBAS_QUESTION_MARK               EQU $3F                                  ; '?'

; -- BASIC partie divers
cNbMaxLigne                      EQU 63999                               ; $F9FF
cHI_NbMaxLigne                   EQU >(cNbMaxLigne/10)                   ; $18

; -- BASIC partie mathématique
cMATH_PLUS                       EQU $2B ; '-'
cMATH_MINUS                      EQU $2D ; '+'
cMATH_SEP_FLT                    EQU $2E ; '.'
; --
cTYPFLGACC1                      EQU $7F ; Indique que le type de numérique dans ACC1 est un float
cTYPFLGACC2                      EQU $81 ; Indique que le type de numérique dans ACC2 est un float

;---------------- KEYBOARD
cKB_NULL                         EQU $00
cKB_BREAK                        EQU $03
cKB_ENTER                        EQU $0D
cKB_ESPACE                       EQU $20
cKB_CTRL                         EQU $00
cKB_SHIFT                        EQU $00
;---
cKB_LEFT                         EQU $08
cKB_RIGHT                        EQU $09
cKB_DOWN                         EQU $0A
cKB_UP                           EQU $0B
; -- clavier normal

cKB_ARROBASE                     EQU $40 ; '@'
cKB_Q                            EQU $51 ; 'Q'
cKB_B                            EQU $42 ; 'B'
cKB_C                            EQU $43 ; 'C'
cKB_D                            EQU $44 ; 'D'
cKB_E                            EQU $45 ; 'E'
cKB_F                            EQU $46 ; 'F'

cKB_G                            EQU $47 ; 'G'
cKB_H                            EQU $48 ; 'H'
cKB_I                            EQU $49 ; 'I'
cKB_J                            EQU $4A ; 'J'
cKB_K                            EQU $4B ; 'K'
cKB_L                            EQU $4C ; 'L'
cKB_DIVIDE                       EQU $2F ; '/'
cKB_N                            EQU $4E ; 'N'

cKB_O                            EQU $4F ; 'O'
cKB_P                            EQU $50 ; 'P'
cKB_A                            EQU $41 ; 'A'
cKB_R                            EQU $52 ; 'R'
cKB_S                            EQU $53 ; 'S'
cKB_T                            EQU $54 ; 'T'
cKB_U                            EQU $55 ; 'U'
cKB_V                            EQU $56 ; 'V'

cKB_Z                            EQU $5A ; 'Z'
cKB_X                            EQU $58 ; 'X'
cKB_Y                            EQU $59 ; 'Y'
cKB_W                            EQU $57 ; 'W'

cKB_0                            EQU $30 ; '0'
cKB_1                            EQU $31 ; '1'
cKB_2                            EQU $32 ; '2'
cKB_3                            EQU $33 ; '3'
cKB_4                            EQU $34 ; '4'
cKB_5                            EQU $35 ; '5'
cKB_6                            EQU $36 ; '6'

cKB_7                            EQU $37 ; '7'
cKB_8                            EQU $38 ; '8'
cKB_9                            EQU $39 ; '9'
cKB_2POINT                       EQU $3A ; ':'
cKB_M                            EQU $4D ; 'M'
cKB_comma                        EQU $2C ; ','
cKB_minus                        EQU $2D ; '-'
cKB_dot                          EQU $2E ; '.'

cKB_SEMICOLON                    EQU $3B ; ';'

; -- CTRL
cKB_CTRL_ARROBASE                EQU cBAS_TOKEN_INPUT       ; $88 ; OPCODE DE LA COMMANDE BASIC INPUT
cKB_CTRL_Q                       EQU cKB_LEFT               ; $08 ; Flèche gauche
cKB_CTRL_B                       EQU cBAS_TOKEN_ABS         ; $C1 ; OPCODE DE LA COMMANDE BASIC ABS
cKB_CTRL_C                       EQU cBAS_TOKEN_INT         ; $C0 ; OPCODE DE LA COMMANDE BASIC INT
cKB_CTRL_D                       EQU cBAS_TOKEN_GOSUB       ; $82 ; OPCODE DE LA COMMANDE BASIC GOSUB
cKB_CTRL_E                       EQU cBAS_TOKEN_SET         ; $9B ; OPCODE DE LA COMMANDE BASIC SET
cKB_CTRL_F                       EQU cBAS_TOKEN_RETURN      ; $90 ; OPCODE DE LA COMMANDE BASIC RETURN

cKB_CTRL_G                       EQU cBAS_TOKEN_IF          ; $84 ; OPCODE DE LA COMMANDE BASIC IF
cKB_CTRL_H                       EQU cBAS_TOKEN_THEN        ; $B1 ; OPCODE DE LA COMMANDE BASIC THEN (n'existe pas !)
cKB_CTRL_I                       EQU cBAS_TOKEN_NEXT        ; $8A ; OPCODE DE LA COMMANDE BASIC NEXT
cKB_CTRL_J                       EQU cBAS_TOKEN_GOTO        ; $81 ; OPCODE DE LA COMMANDE BASIC GOTO
cKB_CTRL_K                       EQU cBAS_TOKEN_SOUND       ; $AC ; OPCODE DE LA COMMANDE BASIC SOUND
cKB_CTRL_L                       EQU $0C                    ; $0C ; CODE ASCII DE L'EFFACEMENT DE L'ECRAN (FORM FEED)
cKB_CTRL_DIVIDE                  EQU cBAS_TOKEN_COS         ; $C8 ; OPCODE DE LA COMMANDE BASIC COS
cKB_CTRL_N                       EQU cBAS_TOKEN_SIN         ; $C7 ; OPCODE DE LA COMMANDE BASIC SIN

cKB_CTRL_O                       EQU cBAS_TOKEN_STEP        ; $B3 ; OPCODE DE LA COMMANDE BASIC STEP
cKB_CTRL_P                       EQU cBAS_TOKEN_GETAdollar  ; $E1 ; OPCODE DE LA COMMANDE BASIC GETA$ (remplace INKEY$)
cKB_CTRL_A                       EQU $15                    ; $15 ; CLEAR LINE
cKB_CTRL_R                       EQU cBAS_TOKEN_RESET       ; $9C ; OPCODE DE LA COMMANDE BASIC RESET
cKB_CTRL_S                       EQU cKB_RIGHT
cKB_CTRL_T                       EQU cBAS_TOKEN_READ        ; $8C ; OPCODE DE LA COMMANDE BASIC READ
cKB_CTRL_U                       EQU cBAS_TOKEN_FOR         ; $80 ; OPCODE DE LA COMMANDE BASIC FOR
cKB_CTRL_V                       EQU cBAS_TOKEN_RND         ; $C3 ; OPCODE DE LA COMMANDE BASIC RND

cKB_CTRL_Z                       EQU $5E                    ; 'Z'
cKB_CTRL_X                       EQU cBAS_TOKEN_SGN         ; $D1 ; OPCODE DE LA COMMANDE BASIC SGN
cKB_CTRL_Y                       EQU cBAS_TOKEN_RESTORE     ; $8F ; OPCODE DE LA COMMANDE BASIC RESTORE
cKB_CTRL_W                       EQU cKB_DOWN               ; $0A ; flèche bas
cKB_CTRL_ENTER                   EQU cKB_ENTER              ; $0D ; enter
cKB_CTRL_ESPACE                  EQU $07                    ; $07 : AUTOREPEAT OFF

cKB_CTRL_0                       EQU $30                    ; '0'
cKB_CTRL_1                       EQU cBAS_TOKEN_RUN         ; $8E ; OPCODE DE LA COMMANDE BASIC RUN
cKB_CTRL_2                       EQU cBAS_TOKEN_CONT        ; $93 ; OPCODE DE LA COMMANDE BASIC CONT
cKB_CTRL_3                       EQU cBAS_TOKEN_CSAVE       ; $98 ; OPCODE DE LA COMMANDE BASIC CSAVE
cKB_CTRL_4                       EQU cBAS_TOKEN_CLOAD       ; $97 ; OPCODE DE LA COMMANDE BASIC CLOAD
cKB_CTRL_5                       EQU cBAS_TOKEN_NEW         ; $96 ; OPCODE DE LA COMMANDE BASIC NEW
cKB_CTRL_6                       EQU cBAS_TOKEN_LIST        ; $94 ; OPCODE DE LA COMMANDE BASIC LIST

cKB_CTRL_7                       EQU cBAS_TOKEN_CLEAR       ; $95 ; OPCODE DE LA COMMANDE BASIC CLEAR
cKB_CTRL_8                       EQU cBAS_TOKEN_CLS         ; $9D ; OPCODE DE LA COMMANDE BASIC CLS
cKB_CTRL_9                       EQU cBAS_TOKEN_PRINT       ; $86 ; OPCODE DE LA COMMANDE BASIC PRINT
cKB_CTRL_2POINT                  EQU cBAS_TOKEN_END         ; $89 ; OPCODE DE LA COMMANDE BASIC END
cKB_CTRL_M                       EQU cBAS_TOKEN_POKE        ; $92 ; OPCODE DE LA COMMANDE BASIC POKE
cKB_CTRL_comma                   EQU cBAS_TOKEN_TAN         ; $C8 ; OPCODE DE LA COMMANDE TAN
cKB_CTRL_minus                   EQU cBAS_TOKEN_STOP        ; $91 ; OPCODE DE LA COMMANDE BASIC STOP
cKB_CTRL_dot                     EQU cBAS_TOKEN_LOG         ; $C5 ; OPCODE DE LA COMMANDE LOG

cKB_CTRL_SEMICOLON               EQU cBAS_TOKEN_SQR         ; $C4 ; OPCODE DE LA COMMANDE SQR
cKB_CTRL_BREAK                   EQU cKB_BREAK
cKB_CTRL_LEFT                    EQU cKB_LEFT
cKB_CTRL_RIGHT                   EQU cKB_RIGHT
cKB_CTRL_DOWN                    EQU cKB_DOWN
cKB_CTRL_UP                      EQU cKB_UP

;-- SHIFT
cKB_SHIFT_ARROBASE               EQU $13       ;
cKB_SHIFT_Q                      EQU $8F       ; CARACTERE PLEIN
cKB_SHIFT_B                      EQU $80       ; CARACTERE VIDE
cKB_SHIFT_C                      EQU $82       ; CARACTERE No 2
cKB_SHIFT_D                      EQU $87       ; CARACTERE No 7
cKB_SHIFT_E                      EQU $8D       ; CARACTERE No 13
cKB_SHIFT_F                      EQU $86       ; CARACTERE No 6

cKB_SHIFT_G                      EQU $85       ; CARACTERE No 5
cKB_SHIFT_H                      EQU $48       ; 'H'
cKB_SHIFT_I                      EQU $49       ; 'I'
cKB_SHIFT_J                      EQU $4A       ; 'J'
cKB_SHIFT_K                      EQU $4B       ; 'K'
cKB_SHIFT_L                      EQU $4C       ; 'L'
cKB_SHIFT_DIVIDE                 EQU $3F       ; '?'
cKB_SHIFT_N                      EQU $4E       ; 'N'

cKB_SHIFT_O                      EQU $4F       ; 'O'
cKB_SHIFT_P                      EQU $50       ; 'P'
cKB_SHIFT_A                      EQU $89       ; CARACTERE No 9
cKB_SHIFT_R                      EQU $8C       ; CARACTERE No 12
cKB_SHIFT_S                      EQU $88       ; CARACTERE No 8
cKB_SHIFT_T                      EQU $8B       ; CARACTERE No 11
cKB_SHIFT_U                      EQU $8F       ; CARACTERE No 15
cKB_SHIFT_V                      EQU $81       ; CARACTERE No 1

cKB_SHIFT_Z                      EQU $84       ; CARACTERE No 4
cKB_SHIFT_X                      EQU $83       ; CARACTERE No 3
cKB_SHIFT_Y                      EQU $8A       ; CARACTERE No 10
cKB_SHIFT_W                      EQU $8E       ; CARACTERE No 14
cKB_SHIFT_ENTER                  EQU cKB_ENTER ;

cKB_SHIFT_ESPACE                 EQU $06       ; AUTOREPEAT ON
cKB_SHIFT_0                      EQU $30       ; '0'
cKB_SHIFT_1                      EQU $21       ; '!'
cKB_SHIFT_2                      EQU $22       ; '"'
cKB_SHIFT_3                      EQU $23       ; '#'
cKB_SHIFT_4                      EQU $24       ; '$'
cKB_SHIFT_5                      EQU $25       ; '%'
cKB_SHIFT_6                      EQU $26       ; '&'

cKB_SHIFT_7                      EQU $27       ; '''
cKB_SHIFT_8                      EQU $28       ; '('
cKB_SHIFT_9                      EQU $29       ; ')'
cKB_SHIFT_2POINT                 EQU $2A       ; '*'
cKB_SHIFT_M                      EQU $4D       ; 'M'
cKB_SHIFT_inf                    EQU $3C       ; '<'
cKB_SHIFT_egal                   EQU $3D       ; '='
cKB_SHIFT_sup                    EQU $3E       ; '>'

cKB_SHIFT_SEMICOLON              EQU $2B       ; '+'
cKB_SHIFT_BREAK                  EQU cKB_BREAK ; BREAK
cKB_SHIFT_LEFT                   EQU cKB_LEFT  ; Flèche gauche
cKB_SHIFT_DOWN                   EQU cKB_DOWN  ; Flèche droite
cKB_SHIFT_RIGHT                  EQU cKB_RIGHT ; Flèche bas
cKB_SHIFT_UP                     EQU cKB_UP    ; Flèche haut

;---------------- K7
cK7_TYP_PRG_BASIC                EQU $00
cK7_TYP_PRG_0x01                 EQU $01
cK7_TYP_PRG_ASS                  EQU $02
cK7_TYP_PRG_ARRAY                EQU $04
;--
cK7_TYP_BLK_FILENAME             EQU $00
cK7_TYP_BLK_DATA                 EQU $01
cK7_TYP_BLK_END                  EQU $FF
cK7_DURATE_BIT_LOW               EQU $23
cK7_DURATE_BIT_HIGH              EQU $46
;--
cK7_SYNCHRO                      EQU $55
cK7_SYNCHRO_02                   EQU $3C

;---------------- OS
cOS_NULL                         EQU $00
;----------------
cOS_DEV_SCREEN                   EQU $00
cOS_DEV_BUFFER                   EQU $01
cOS_DEV_PRINTER                  EQU $FF
; --
cOS_CLS_MODE_LORES               EQU $20 ; Mode 32 colonnes
cOS_CLS_MODE_TEXTE               EQU $28 ; Mode 40 colonnes
cOS_CLS_MODE_HIRES               EQU $50 ; Mode 80 colonnes
;--
cOS_WARN                         EQU $55
cOS_SPACE                        EQU $20
cOS_BS                           EQU $08 ; Back Space
cOS_CR                           EQU $0D ; Carriage Return
cOS_PLEIN_INVERSE                EQU $80 ; Caractère plein inversée
cOS_PLEIN                        EQU $7F ; Code du caractère plein dans le charset de EF9345 pour le mode 80 colonnes

;---------------- EDITEUR MODE LIGNE
cEDT_UNKNOWN                     EQU $21 ; '!' - Token inconnu

;---------------- CPU
cCPU_BEGIN_RAM                   EQU $80
cCPU_END_RAM                     EQU $FF

;---------------- VDP
cVDP_MODE_80x25                  EQU $00
cVDP_MODE_40x25                  EQU $01
cVDP_MODE_32x16                  EQU $02
;--
cVDP_PLEIN_LO                    EQU $0F ; Caractère plein en basse résolution
;--
cVDP_CMD_IND                     EQU $80
cVDP_CMD_KRF                     EQU $00
cVDP_CMD_KRG                     EQU $02
cVDP_CMD_KRC                     EQU $40
cVDP_CMD_KRL                     EQU $50
cVDP_CMD_EXP                     EQU 96
cVDP_CMD_CMP                     EQU 64+32+16
cVDP_CMD_KRE                     EQU 16
cVDP_CMD_OCT                     EQU 32+16
cVDP_CMD_MVB                     EQU 128+64+16
cVDP_CMD_MVD                     EQU 128+64+32
cVDP_CMD_MVT                     EQU 128+64+32+16
cVDP_CMD_CLF                     EQU $05
cVDP_CMD_CLG                     EQU $07
cVDP_CMD_VSM                     EQU 128+16+8+1
cVDP_CMD_VRM                     EQU 128+16+4+1
cVDP_CMD_INY                     EQU 128+32+16
cVDP_CMD_NOP                     EQU 128+16+1
cVDP_RD                          EQU $08
cVDP_WR                          EQU $00
cVDP_NO_INC                      EQU $00
cVDP_INC                         EQU $01
cVDP_COPY_MVP_TO_AP              EQU $04
cVDP_COPY_AP_TO_MVP              EQU $08
cVDP_STOP_EOB                    EQU $01
cVDP_STOP_NO                     EQU $02
cVDP_USE_AUX                     EQU $04
cVDP_USE_MAIN                    EQU $00
cVDP_REG_ROM                     EQU $00
cVDP_REG_TGS                     EQU $01
cVDP_REG_MAT                     EQU $02
cVDP_REG_PAT                     EQU $03
cVDP_REG_DOR                     EQU $04
cVDP_REG_ROR                     EQU $07
; -- VARIABLE POUR LE REGISTRE TGS
cVDP_TGS_625                     EQU $00    ; Résolution 625 lignes
cVDP_TGS_525                     EQU $01    ; Résolution 525 lignes
cVDP_TGS_NO_INTERLACE            EQU $00    ; Mode non entrelacé
cVDP_TGS_INTERLACE               EQU $02    ; Mode entrelacé
cVDP_TGS_NO_HOR_RESYNC           EQU $00
cVDP_TGS_HOR_RESYNC              EQU $04
cVDP_TGS_NO_VER_RESYNC           EQU $00
cVDP_TGS_VER_RESYNC              EQU $08
cVDP_TGS_SYNC_OUT_COMP           EQU $10
cVDP_TGS_SYNC_OUT_V_H            EQU $00
cVDP_TGS_SERVICE_ROW             EQU $20
cVDP_TGS_NO_SERVICE_ROW          EQU $00
cVDP_TGS_MODE_40_LONG            EQU $00
cVDP_TGS_MODE_40_VAR             EQU $40
cVDP_TGS_MODE_40_SHORT           EQU $00
cVDP_TGS_MODE_80_LONG            EQU $C0
cVDP_TGS_MODE_80_SHORT           EQU $80
; -- VARIABLE POUR LE REGISTRE MAT
cVDP_MAT_DBL_HEIGHT              EQU $80
cVDP_MAT_NO_DBL_HEIGHT           EQU $00
cVDP_MAT_CURSOR_DISP             EQU $40
cVDP_MAT_NO_CURSOR_DISP          EQU $00
cVDP_MAT_MD_CURS_FIX_CPL         EQU $00
cVDP_MAT_MD_CURS_FLS_CPL         EQU $20
cVDP_MAT_MD_CURS_FIX_UND         EQU $10
cVDP_MAT_MD_CURS_FLS_UND         EQU $30
cVDP_MAT_MARG_INS                EQU $08
cVDP_MAT_NO_MARG_INS             EQU $00
; -- VARIABLE POUR LE REGISTRE PAT
cVDP_PAT_SERVICE_ROW_EN          EQU $01
cVDP_PAT_NO_SERVICE_ROW_EN       EQU $00
cVDP_PAT_UP_BULK_EN              EQU $02
cVDP_PAT_NO_DW_BULK_EN           EQU $00
cVDP_PAT_DW_BULK_EN              EQU $04
cVDP_PAT_NO_UP_BULK_EN           EQU $00
cVDP_PAT_CONCEAL_EN              EQU $08
cVDP_PAT_NO_CONCEAL_EN           EQU $00
cVDP_PAT_INS_MODE_INLAY          EQU $00
cVDP_PAT_INS_MODE_BOXING         EQU $10
cVDP_PAT_INS_MODE_CHAR_MARK      EQU $20
cVDP_PAT_INS_MODE_ACT_AREA_MARK  EQU $30
cVDP_PAT_FLASH_EN                EQU $40
cVDP_PAT_NO_FLASH_EN             EQU $00
cVDP_PAT_NO_FLASH_EN             EQU $00
cVDP_PAT_MODE_40_LONG            EQU $00
cVDP_PAT_MODE_40_VAR             EQU $00
cVDP_PAT_MODE_40_SHORT           EQU $80
cVDP_PAT_MODE_80_LONG            EQU $00
cVDP_PAT_MODE_80_SHORT           EQU $00
; -- COULEUR
cVDP_BLACK                       EQU $00
cVDP_RED                         EQU $01
cVDP_GREEN                       EQU $02
cVDP_YELLOW                      EQU $03
cVDP_BLUE                        EQU $04
cVDP_MAGENTA                     EQU $05
cVDP_CYAN                        EQU $06
cVDP_WHITE                       EQU $07
; --- Couleur obtenue par le bit d'inscrustation
cVDP_ORANGE                      EQU $00
; -- ATTRIBUTS
cVDP_NO_INSERT                   EQU $00
cVDP_INSERT                      EQU $01
cVDP_NO_DBL_HEIGHT               EQU $00
cVDP_DBL_HEIGHT                  EQU $02
cVDP_NO_CONCEAL                  EQU $00
cVDP_CONCEAL                     EQU $04
cVDP_NO_DBL_WIDTH                EQU $00
cVDP_WIDTH                       EQU $08
cVDP_G0                          EQU $00
cVDP_GPRIME10                    EQU $0A*16
cVDP_GPRIME11                    EQU $0B*16
cVDP_QX                          EQU $0C*16
cVDP_DOR_HI_INS_HI               EQU $80
cVDP_DOR_HI_INS_LO               EQU $08
; -- ATTRIBUTS MODE 80 colonnes
cVDP_80_AT_D                     EQU $01 ; ATTRIBUT COLOR SET
cVDP_80_AT_NO_D                  EQU $00 ; ATTRIBUT NO_COLOR SET
cVDP_80_AT_U                     EQU $02 ; ATTRIBUT UNDERLINE
cVDP_80_AT_NO_U                  EQU $00 ; ATTRIBUT NO_UNDERLINE
cVDP_80_AT_F                     EQU $04 ; ATTRIBUT FLASH
cVDP_80_AT_NO_F                  EQU $00 ; ATTRIBUT NO FLASH
cVDP_80_AT_N                     EQU $08 ; ATTRIBUT NEGATIVE
cVDP_80_AT_NO_N                  EQU $00 ; ATTRIBUT NO NEGATIVE

        seg.u data
        org $00

;----------------
;--- ORG $0000 - Partie CPU
;----------------
DDR1:                   ds 1            ; $00
DDR2:                   ds 1            ; $01
PORT1:                  ds 1            ; $02
PORT2:                  ds 1            ; $03 : Port I/O soit pour RS232 soit pour K7
                        ds 1            ; $04
                        ds 1            ; $05
                        ds 1            ; $06
                        ds 1            ; $07
CPTHOR_STATUS:          ds 1            ; $08
CPTHOR:                 ds 2            ; $09-$0A : compteur d'horloge
CPTHOR_CMP:             ds 2            ; $0B-$0C : Output Comparator Register
CPTHOR_CAPT:            ds 2            ; $0D-$0E : Input Comparator Register
                        ds 1
;----------------
RCMDSERIAL:             ds 1
RETATSERIAL:            ds 1
RRECEPTIONSERIAL:       ds 1
RTRANSMISERIAL:         ds 1
RCTRLRAM:               ds 1
;----------------
RESERVED:               ds $B           ; 0
                        ds $1E          ; 0
                        ds $30          ; 0
                        ds $12          ; 0
;----------------
;--- ORG $0080 - RAM
;----------------
; ---- CHARAC,ENDCHAR sont ensemble !!
CHARAC:                 ds 1            ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
ENDCHR:                 ds 1            ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
;----
EOLPNTR:                ds 1            ; cela sert à beaucoup de choses : op. binaires, etc.
DIMFLG:                 ds 1            ; ARRAY flag : 0=EVALUATE, 1=DIMENSIONNING
NUMTYP:                 ds 1            ; $00:int, autre valeur : float
STRTYP                  ds 1            ; $00:numeric,  $FF : type string
DATAFLG:                ds 1
SUBFLG:                 ds 1            ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
INPUTFLG:               ds 1            ; =$00:INPUT,=$4F:READ
CPRMASK:                ds 1            ; Masque de comparaison
INDEX:                  ds 2
TMPPTR:                 ds 2
TMPFLT:                 ds 4
SAVREGS:                ds 2
TXTAB:                  ds 2            ; début du programme basic
VARTAB:                 ds 2            ; Fin du programme BASIC / début des variables
ARYTAB:                 ds 2
STREND:                 ds 2
BOTSTK:                 ds 2
FRETOP:                 ds 2
FREESPC:                ds 2
MEMSIZ:                 ds 2            ; Adresse - 1 de la fin de la RAM DISPONIBLE
OLDLIN:                 ds 2
LINUM:                  ds 2
OLDTXT:                 ds 2
TMPTXT:                 ds 2
DATTXT:                 ds 2            ; DATA STATEMENT LINE NUMBER POINTER
DATPTR:                 ds 2            ; DATA STATEMENT ADDRESS POINTER
INPTR:                  ds 2            ; pointeur utilisé par la fonction READ
VARNAM:                 ds 2            ; Temporary storage for a variable name
VARPNT:                 ds 2            ; Pointer used in array building

;  ---- ATTENTION BLOC COMPLET
;----------------------------
FORPNT:                 ds 2            ; sert pour la commande basic FOR, pour stocker un float par la commande basic READ
;----------------------------
LASTOP:                 ds 2
;----------------------------
OPMASK:                 ds 1
;----------------------------
; ---- FIN ATTENTION BLOC COMPLET

FLTTMP1:                ds 5            ; Est utilisé comme sauvegarde de l'argument pour les fonction EXP, TAN, etc.
FLTTMP2:                ds 5            ; Est utilisé comme sauvegarde de l'argument pour appliquer une fonction approximée polynomialement (sin, etc.)
FLTTMP3:                ds 5            ; Est utilisé par la fonction TAN et EXP
;----------------------------
HIGHDS:                 ds 2            ; Cible lors d'une copie de zone mémoire, garbage collector
HIGHTR:                 ds 2            ; Source lors d'une copie de zone mémoire, garbage collector
LOWTR:                  ds 2            ;
;----------------------------
PTRTMP2:                ds 2            ; Utilisation multiple ...
GARBTMP:                ds 2            ; Utilisé uniquement par le garbage collector
;----------------------------
ACC1:                   ds 6            ;  ACC1 : EXPOSANT ACC1+1 ... ACC1+4 : mantisse, ACC1 + 5 : signe (pour rapidité de calcul ?)
ACC1EXT:                ds 1
; --
ACC1TYPFLG              ds 1            ; $7F : float ; =$00 : integer
; -- spécifique conversion string -> float
ACC1SGNFLG:             ds 1            ; ACC1SGNFLG et ACC1JUSTIF sont ensembles car elles sont initialisées dans FIN via une optimisation ...
; --
ACC1JUSTIF              ds 1            ; N'est utilisée que par la fonction QUICK_INT
;----
ACC2:                   ds 6            ; ACC2 : EXPOSANT ACC2+1 ... ACC2+4 : mantisse, ACC2 + 5 : signe (pour rapidité de calcul ?)
ACC2EXT                 ds 1            ; pour stocker le débordement des décalages pour ne pas perdre la précision ...
ACC2TYPFLG              ds 1            ; =$81 : float ; $00 : integer
;----
PRODSIGN:               ds 1            ; Signe de l'opération sur ACC1 et ACC2
;----------------------------
DSCPTR:                 ds 2
STRPTR:                 ds 2
DESCSTR:                ds 3            ; longueur + pointeur sur une chaîne
;----------------------------
STRNG2:                 ds 2            ; divers pointeurs ...
;----------------------------
CURLIN:                 ds 2            ; numéro de ligne courante
;----------------------------
;--------------------------------------
; Routine de lecture entrée utilisateur : TODO : $00F1
;--------------------------------------
CHRGET:                 ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
CHRGOT:                 ds 1
TXTPTR:                 ds 2
                        ds 1
                        ds 1
endCHRGET:
                        ds 1

;----------------
; end of 'RAMPROC'

; ===========================================================================

; Segment type: Regular
;           code ; RAM
        org $3000
;---------------
; VARIABLE POUR LA PARTIE DEMARRAGE
;--------------
fCOLDWARN:              ds 1            ; Indique si il y a un démarrage à froid ou pas
;---------------
; VARIABLES POUR LA PARTIE GRAPHIQUE
;---------------
;----- STRUCTURE DE L'ECRAN - Attention c'est un bloc initialisée de SCR_LGY à SCR_MARGIN !
SCR_LGY:                ds 1            ; Taille max sur Y en mode 32, 40 ou 80 colonnes
SCR_LGX:                ds 1            ; Taille max sur X en mode 32, 40 ou 80 colonnes
SCR_MARGEXY:            ds 2            ; Définition des marges selon les axes X et Y
SCR_OFSY:               ds 1            ; Offset à ajouter pour aller a la ligne suivante pour un même x
SCR_XMAX:               ds 1            ; longueur d'un écran
SCR_YMAX_PIX:           ds 1            ; Taille d'un écran max en pixel pour Y
SCR_XMAX_PIX:           ds 1            ; Taille d'un écran max en pixel pour X
SCR_MARGIN:             ds 2            ; marge gauche: défaut pour 32x16:$10=16:80x25:$10=16
                                        ; marge droite: défaut pour 32x16:$10=16;80x25:$40=64
;----------------
TECRAN:                 ds 1            ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
HOME_YX:                ds 2            ; définit (YX) la position du début de l'écran
CURAD_YX:               ds 2            ; Position du curseur (Y,X)
COLOR_CARGRA:           ds 1            ; Code couleur cyclique pour les caractères graphiques via CTRL+0
ADRMEM_XY:              ds 1            ; Position dans le pavé 2x2 de pixels en LOWRES
POINT_YX_HIRES:         ds 2            ; Position X,Y en écran HIRES / utilisation diverse
ATTRIBUTE_HIRES:        ds 1            ; contient l'attribut du caractère en mode haute résolution
                                        ; Par défaut contient $00 (mode inversion) sinon $88.
                                        ; C'est un nibble donc l'attribut doit être répété 2
                                        ; fois dans l'octet (car colonne paire/impaire !)
                                        ; Sinon cela fait des effets sympas
ColorBG_SCR_LINE:       ds 1            ; Couleur du fond de la ligne insérée suite au scrolling de l'écran
ColorFGBG_CAR:          ds 1            ; Couleur de fond et d'écriture du caractère !
ColorCLS:               ds 1            ; couleur à utiliser par défaut lors d'un CLS
                                        ; + motif (à experimenter) si le code couleur
                                        ; ne correspond pas à un codage prévu de la couleur
;----------------
; PARAMETRAGE SPECIFIQUE POUR LE "DEVICE" EN COURS
;----------------
DEVCUR:                 ds 1            ; CURRENT DEVICE : $00 : SCREEN, $FF : K7
DEVXMARGIN:             ds 2            ; Marge GAUCHE/DROITE pour les tabulations
                                        ; CLS 81  : $10,$40
                                        ; CLS 40  : $10,$10
                                        ; CLS 32  : $10,$10
                                        ; PRINTER : $10,$70
DEVXCURR:               ds 1            ; vaut $00 à l'init
DEVXMAX:                ds 1            ; vaut 32,40 ou 80
DEVNU:                  ds 1            ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
;----------------
REL_HIRES:              ds 1            ; calcul des nouvelles coordonnées soit absolument(0) soit relativement(1)
CUR_POSY:               ds 1            ; position du curseur en mode HIRES axe vertical
CUR_POSX:               ds 1            ; position du curseur en mode HIRES axe horizontal
END_POSX:               ds 1            ;
END_POSY:               ds 1            ;
GRINCX:                 ds 1            ;
GRINCY:                 ds 1            ;
GRERROR:                ds 1            ;
GRERRORINC:             ds 1            ;
GRSLOPE:                ds 1            ;
FILL_DX:                ds 1            ; Utilisée par la commande FILL
FILL_DY:                ds 1            ; Utilisée par la commande FILL
FILL_PARITE_X:          ds 1            ; Utilisée par la commande FILL
FILL_PARITE_DX:         ds 1            ; Utilisée par la commande FILL
FILL_DX_SAV:            ds 1            ; Utilisée par la commande FILL
FILL_COLOR:             ds 1            ; Utilisée par la commande FILL
FILL_MASK_COLOR:        ds 1            ; Utilisée par la commande FILL
fFLASHCAR:              ds 1            ; détermine si c'est le caractère en dessous du curseur qui doit être "flashé" (clignotement)
fFLASHCUR:              ds 1            ; détermine si c'est le curseur qui doit être "flashé" (clignotement)
RDPIX_EF9345:           ds 2            ; Octet lu dans la mémoire à une position X,Y en mode HIRES
                                        ; le format est sm0000A2A1/A0C6C5C4C3C2C1C0 avec :
                                        ; s : =1 : mode HIRES (semi-graphique) : accès type "pixel"
                                        ; m : couleur du pixel : 0 : couleur de l'encre , 1 : couleur de la marge
                                        ; [A2->C0] le pixel à lire à écrire
MSKPIX_EF9345:          ds 2            ; Position du pixel en mode HIRES (semi-graphique)
;-------------------------
QUAD_PAL                ds 1            ; Stocke la palette du caractère quadrichrome
QUAD_BLK                ds 1            ; Stocke le numéro de bloc quadrichrome utilisé : 0 : bloc 6 / 1 : bloc 7
PLOT_MODE               ds 1            ; Mode graphique pour la fonction BASIC PLOT : $FF : HR, $00 : QUADRICHROME / 1 : BICHROME
JMP_PLOT_JMP            ds 1            ; Contient l'opcode JMP
PLOT_JMP                ds 2            ; Contient l'adresse de la routine d'affichage utilisée par la commande PLOT
lgSTR:                  ds 1            ; Utilisé par la commande BASIC PLOT

;-------------------------
; MATHEMATIQUE
;-------------------------
NBLOOP:                 ds 1            ; Nb de lignes contenant des coefficients polynomiaux (sin, cos, ln, log ...)

;---------------
; VARIABLES INITIALISEES PAR LE SYSTEME
; ATTENTION : c'est un bloc complet donc à modifier avec prudence
;---------------

;---------------- VECTEUR
vectSCI:                ds 3
vectTOF:                ds 3
vectOCF:                ds 3
vectICF:                ds 3
vectIRQ1:               ds 3
vectSWI:                ds 3
vectNMI:                ds 3
;----------------
vectUSR:                ds 3
;----------------
ENTROPY:                ds 4         ; L'entropie pour la commande basic RND (RANDOM)
;---------------- CLAVIER
KEYB_INVVIDEO:          ds 1         ; Indicateur pour INVERSE VIDEO pour l'écran et
                                                ; majuscule/minuscule pour imprimante (toggle entre $00 et $FF)
;----------------
memFREE_02              ds 2         ; valeur pour une tempo ? Par défaut la valeur est $045E
;----------------
pEXEC:                  ds 2
pCOLD:                  ds 2
;---------------- IMPRIMANTE
BAUDRATE_PRT:           ds 2         ; Temporisation entre deux envois de caractère à l'imprimante
TEMPO_PRT:              ds 2         ; Temporisation avant de rendre la mai au système
MARGIN_PRT:             ds 2         ; PRINTER : DEFAUT : MARGE GAUCHE : $10 MARGE DROITE : $70
XMAX_PRT:               ds 1         ; WORD :
                                            ; Max X for cursor on PRINTER
CURX_PRT:               ds 1         ; Position X for cursor on PRINTER
;---------------- VIDEO
CURWAITCLIGNOTEMENT:    ds 1
;---------------- K7
CMPMID_K7:              ds 1         ; $18   par défaut ;  Valeur de comparaison pour déterminer si c'est un bit à 1 ou à 0
CMP0_K7:                ds 1         ; $1A   par défaut ;  Limite haute pour un signal à 1200 hz
CMP1_K7:                ds 1         ; $0B   par défaut ;  Limite haute pour une fréquence à 2400 Hz
NBBYTSYNCHRO_K7:        ds 2         ; $0080 par défaut ;  Nombre d'octets à $55 à envoyer sur K7 pour la synchronisation

;---------------
; VARIABLES POUR LA PARTIE K7
;---------------

NBNAM_K7:               ds 1         ; lg du nom du fichier
FILNA_K7:               ds 8         ; nom du fichier
FILTY_K7:               ds 1         ; Type du FICHIER
ASCFL_K7:               ds 1         ; Fichier en ASCII
GAPFL_K7:               ds 1         ; Fichier contigu
ADSTR_K7:               ds 2         ; contient l'adresse d'exécution d'un programme binaire
ADLOA_K7:               ds 2         ; contient l'adresse de chargement lors de la lecture
ADDEB_K7:               ds 2         ; Adresse début de la zone à sauvegarder
ADFIN_K7:               ds 2         ; Adresse fin de la zone à sauvegarder
sTMPBUF_K7:             ds 9         ; stocke :
                                     ;  - la longueur du nom du fichier (maxi 8 caractères)
                                     ;  - le nom du fichier
zTMPFICNM_K7:           ds 8
fFICTYP_K7:             ds 1         ; Type du fichier k7 : $00:BASIC,$01 ou $04 selon la rom ?:ARRAY,$02:LANGAGE MACHINE,$05:FICHIER TEXTE DE L'EDITEUR
UNKNOWN_1_K7:           ds 1
UNKNOWN_2_K7:           ds 1
wOFSLOAD_K7:            ds 2         ; offset de chargement du programme, $0000 par défaut
wSAVEorLOAD_K7:         ds 2         ; Nombre d'octets à sauvegarder ou à lire
pMEMBEGIN_K7:           ds 2
pMEMEND_K7:             ds 2
fSAVEDATA_K7:           ds 1         ; =$00:sauve les données K7 en mémoire sinon ne les sauve pas
DUMMY_K7:               ds 1         ; 0 par défaut : rôle inconnu
BLKTY_K7:               ds 1         ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
LG_BLK_K7:              ds 1         ; Longueur du bloc lu ou écrit
FREE_K7                 ds 1         ; TODO : Vraiment libre ?
pTMP_K7:                ds 2         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
bREALL_K7:              ds 1         ; doit être égal à 0 pour effectuer la lecture
bNB_READ_K7:            ds 1         ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
bNbBitsToRDWR_K7:       ds 1
CPERTM_K7:              ds 1         ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
CBTPHA_K7:              ds 1         ; flag indiquant la phase de lecture du port K7 (quelle transition HI-LO or LO-HI)
;----------------
; VARIABLES POUR LA PARTIE CLAVIER
;----------------
ROLTB:                  ds 8         ; Mémorisation de la dernière touche entrée
NUMRGKBD:               ds 1         ; numéro de ligne en cas de scanning : 0->7
CTRLKBD:                ds 1         ; =$00 : hit normal keyb or hit shift, $FF = hit CTRL,
CHARKBD:                ds 1
fAUTOREPEATKBD:         ds 1         ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                     ; d'1 unité à chaque répétition
TABADKBD:               ds 2         ; pointeur sur les tableaux de conversion KEYB -> ASCII
;----------------
; VARIABLES POUR LA PARTIE BASIC
;----------------
; --- Structure utilisée pour, entre autre, la décomposition en mot-clef de la ligne basic
; struct PARSE
strPARSE_POS:           ds 1
strPARSE_PTR_LINE_NEXT  ds 2
strPARSE_NO_LINE:       ds 2
strPARSE_BUFFER:        ds $80
strPARSE_END_OF_BUFFER  ds 2
;----------------
FTAMPON:                ds $12       ; Tampon pour conversion float -> STRING
TMPPT:                  ds 2
LASTPT:                 ds 2
TMPDESCSTK:             ds 15        ; Pile de description temporaire
ADRENDMEM:              ds 2         ; Adresse de la fin de mémoire
ENDSTT:                 ds 1         ; Indique si la fin du programme a été rencontré
fEDITLINE_SEP:          ds 1         ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM
;----------------
struct_FN:              ds 5
;----------------
fTRACE:                 ds 1         ; flag indiquant si le mode DEBUG est activé =($FF) ou pas =($00)
;----------------
CNTIF:                  ds 1         ; compteur du nombre de if lu (utilisé pour la gestion des else)
;----------------
AUTOINC:                ds 2         ; Pas de l'incrémentation automatique du numéro de ligne. Si=0 pas d'incrémentation automatique
BEGIN_RANGE:            ds 2
END_RANGE:              ds 2
NEW_RANGE:              ds 2
TMP_RENUM:              ds 1
SAVE_RENUM:             ds 2
SAVEX_RENUM:            ds 2
RENUM_START_LINE:       ds 2
RENUM_INTERVAL:         ds 2
RENUM_DEFAULT_START:    ds 2
; NEW RENUM
MSLINE:                 ds 1
LSLINE:                 ds 1
TEMP1:                  ds 2
TEMP2:                  ds 2
TEMP3:                  ds 2
TEMP4:                  ds 2
TEMP5:                  ds 2
ASTM1:                  ds 1
ASTM2:                  ds 1
ASTM3:                  ds 1
ASTM4:                  ds 1
; Pour les nombres hexa
TMP_HEX:                ds 2
; Pour la conversion string -> int
; MEMINT,MENTINT+1 : valeur de la conversion
; MEMINT+2         : si >0 indique un "overflow" (>65535) durant la conversion string->int
; MEMINT+3,+4      : stockage temporaire du chiffre à convertir sur 16 bits
MEMINT:                 ds 5
;---------------------------
flgTYPINC               ds 1                ; Indique le type opération pour les commandes BASIC
                                            ; INC(=$00) et DEC(=$FF)
                                            ; TODO : Optimisation : faire sur 2 caracteres $0001 et $FFFF puis add


;----------------
; Zone libre
;----------------
BAS_FREE_01 ds 496-5-5-1-6+2-2-1-2-6-3-3-10-10-1-2-2-4-4-1-2   ; TODO A REFAIRE LE CALCUL SUITE RENUM et ROMLINE
;----------------
beginPrg:               ds $14BA     ; ADR[beginPRG]=$3346
areaStackByDefault:     ds $800      ; Pour la pile système
; end of 'RAM'

; ===========================================================================
;           PARTIE IO
; ===========================================================================
        org $B000
                        ds $9FC         ; 0
                        ds $524         ; 0
EF9345_R0:              ds 1            ; En lecture : registre des statuts
EF9345_R1:              ds 1
EF9345_R2:              ds 1
EF9345_R3:              ds 1
EF9345_R4:              ds 1
EF9345_R5:              ds 1
EF9345_R6:              ds 1
EF9345_R7:              ds 1
EF9345_EXEC:            ds 1
EF9345_R9:              ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
                        ds 1
EF9345_RF:              ds 1
                        ds $CF
IO_COL_KBD:             ds 1            ; en lecture  : pour une rangée activée du clavier, indique par un 0 la touche du clavier activée
                                        ; en écriture : est utilisée aussi pour le son !
; end of 'IO'

; ===========================================================================
;           PARTIE CODE - ROM
; ===========================================================================
        seg code
        org $C000

; ===========================================================================
; /// BASIC
; ===========================================================================
xxBASIC:

; /// BASIC - vecteur JUMP
xxBASIC_JUMP:

;----------------
jmpFONCTION:
        dc.w romSGN         ; FCT : COMMANDE BASIC SGN : retourne le signe de l'expression
                            ; STX : A=SGN(-12)  : retourne -1
                            ;       B=SGN(0)    : retourne 0
                            ;       C=SGN(14.3) : retourne 1
                            ; OP  : $BF
                            ; BUG : /
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : ACC1 avec le signe de l'expression au format entier si l'expression est typée "entier" sinon au format float
jmpINT:
        dc.w romINT         ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                            ; STX : A=INT(5.25) : retourne 5
                            ; OP  : $C0
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : ACC1 avec la partie entière  de l'expression
                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' ou EXP)
jmpABS:
        dc.w romABS         ; FCT : COMMANDE BASIC ABS(X) : retourne la valeur absolue d'un nombre de type float
                            ; STX : A=ABS(-5.4) retourne 5.4 au format float / A#=ABS(-5) retourne 5 au format entier
                            ; OP  : $C1
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : ACC1=ABS(ACC1) avec le type dépendant du paramètre
jmpUSR:
        dc.w vectUSR
jmpRND:
        dc.w romRND         ; FCT : COMMANDE BASIC RND : retourne une valeur pseudo-aléatoire entre 1 et n
                            ; STX : PRINT RND(15) retourne 5.4
                            ; OP  : $C3
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : ACC1=nombre pseudo-aléatoire  entre 1 et n
jmpSQR:
        dc.w romSQR         ; FCT : COMMANDE BASIC SQR(X) : retourne la racine carrée de X
                            ; STX : A=SQR(4) : retourne 2
                            ; OP  : $C4
                            ; ST  : ACTIF
                            ; IN  : ACC1 = résultat de l'évaluation de l'expression numérique passée en paramètre
                            ; OUT : ACC1=SQR(X)
jmpLOG:
        dc.w romLOG         ; FCT : COMMANDE BASIC LOG(X) : retourne le logarithme NATUREL (ou NEPERIEN) de X
                            ; ALG : LN(F*2^N)=(N+LOG2(F))*LN(2)
                            ;       approximation par polynome sur l'intervalle [0;1]
                            ;       Si N=1/2 alors LN(F*2^N) = LN (F*SQR(2))
                            ;                    = (-0.5+LOG2(F))*LN(2)
                            ; STX : A=LOG(10) : retourne 2.30258509
                            ; OP  : $C5
                            ; ST  : ACTIF
                            ; IN  : ACC1 > 0
                            ; OUT : ACC1=LOG(ACC1)
jmpEXP:
        dc.w romEXP         ; FCT : COMMANDE BASIC EXP(X) : retourne l'exponentiel de X
                            ; ALG : FIRST SAVE THE ORIGINAL ARGUMENT AND MULTIPLY THE FAC BY
                            ;       LOG2(E). THE RESULT IS USED TO DETERMINE IF OVERFLOW
                            ;       WILL OCCUR SINCE EXP(X)=2^(X*LOG2(E)) WHERE
                            ;       LOG2(E)=LOG(E) BASE 2. THEN SAVE THE INTEGER PART OF
                            ;       THIS TO SCALE THE ANSWER AT THE END. SINCE
                            ;       2^Y=2^INT(Y)*2^(Y-INT(Y)) AND 2^INT(Y) IS EASY TO COMPUTE.
                            ;       NOW COMPUTE 2^(X*LOG2(E)-INT(X*LOG2(E)) BY
                            ;       P(LN(2)*(INT(X*LOG2(E))+1)-X) WHERE P IS AN APPROXIMATION
                            ;       POLYNOMIAL. THE RESULT IS THEN SCALED BY THE POWER OF 2
                            ;       PREVIOUSLY SAVED.
                            ; STX : A=EXP(10) : retourne 22026.4658
                            ; OP  : $C6
                            ; ST  : ACTIF
                            ; IN  : ACC1
                            ; OUT : ACC1=EXP(ACC1)
jmpSIN:
        dc.w romSIN         ; FCT : COMMANDE BASIC SIN(X) : retourne le sinus de X
                            ; ALG : approximation
                            ; STX : A=SIN(3.14/2) : retourne 0.999999683
                            ; OP  : $C7
                            ; ST  : ACTIF
                            ; IN  : ACC1
                            ; OUT : ACC1=SIN(ACC1)
jmpCOS:
        dc.w romCOS         ; FCT : COMMANDE BASIC SIN(X) : retourne le sinus de X
                            ; ALG : COS(X)=SIN(X+PI/2)
                            ; STX : A=COS(3.14) : retourne -0.999998732
                            ; OP  : $C8
                            ; ST  : ACTIF
                            ; IN  : ACC1
                            ; OUT : ACC1=COS(ACC1)
jmpTAN:
        dc.w romTAN         ; FCT : COMMANDE BASIC TAN(X) : retourne la tangente de X
                            ; ALG : TAN(X)=SIN(X)/COS(X)
                            ; STX : A=TAN(3.14/3) : retourne 1.72992922
                            ; OP  : $C9
                            ; ST  : ACTIF
                            ; IN  : ACC1
                            ; OUT : ACC1=TAN(ACC1)
jmpPEEK:
        dc.w romPEEK        ; FCT : COMMANDE BASIC PEEK(X) : récupère la valeur de l'octet à l'adresse X
                            ; STX : A=PEEK(12000)
                            ; ALG : /
                            ; OP  : $CA
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : ACC1=la valeur pointée par X
jmpLEN:
        dc.w romLEN         ; FCT : COMMANDE BASIC LEN(A$) : récupère la longueur de la   chaîne A$
                            ; STX : A=LEN(A$)
                            ; BUG : /
                            ; ALG : /
                            ; OP  : $CB
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : ACC1=la longueur de la chaîne A$ > 0 sous forme d'un entier
jmpSTRdollar:
        dc.w romSTRdollar   ; FCT : COMMANDE BASIC STR$(A) : retourne l'équivalent en string de l'expression numérique A
                            ; STX : A$=STR$(100)
                            ; BUG :/
                            ; ALG : /
                            ; OP  : $CC
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : une chaîne de caractères
jmpVAL:
        dc.w romVAL         ; FCT : COMMANDE BASIC VAL("X") : retourne l'équivalent numérique d'une chaîne de caractères contenant des chiffres
                            ; STX : A=VAL("100")
                            ; BUG : /

                            ; ALG : /
                            ; OP  : $CD
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : ACC1 : représentation numérique de l'entrée sous forme d'un float
jmpASC:
        dc.w romASC         ; FCT : COMMANDE BASIC ASC("TEST") : retourne le code ASCII du premier caractère du  paramètre
                            ;       retourne l'erreur FC si chaîne vide
                            ; STX : A=ASC("100") retourne 49 (=ASCII de 1)
                            ; BUG : /
                            ; ALG : /
                            ; OP  : $CE
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : ACC1 : code ASCII du premier caractère sous forme d'un entier
jmpCHRdollar:
        dc.w romCHRdollar   ; FCT : Commande BASIC CHR$(N) : Renvoie le caractère ou
                            ;       la commande correpondant à N
                            ; STX : PRINT CHR$(65)
                            ; BUG : /
                            ; ALG : /
                            ; OP  : $CF
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT:  /
jmpFLOAT:
        dc.w romFLOAT       ; FCT : COMMANDE BASIC FLOAT(X) : retourne la converion de l'expression en float
                            ; STX : A=INT(5) : retourne 5.00
                            ; OP  : $xx
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : ACC1 contient la converion de l'expression en float
jmpLEFTdollar:
        dc.w romLEFTdollar  ; FCT : Extrait les n premiers caractères d'une chaîne de caractères
                            ; STX : A$=LEFT$(B$,3)
                            ; ALG : /
                            ; ST  : ACTIF
                            ; OP  : $D0
                            ; IN  : le flot d'interprétation
                            ; OUT : un descripteur de chaîne de caractères
jmpRIGHTdollar:
        dc.w romRIGHTdollar ; FCT : Extrait les n dernières caractères d'une chaîne
                            ; STX : A$=RIGHT$(B$,3)
                            ; ALG : /
                            ; ST  : ACTIF
                            ; OP  : $D1
                            ; IN  : le flot d'interprétation
                            ; OUT : un descripteur de chaîne de caractères
jmpMIDdollar:
        dc.w romMIDdollar   ; FCT : Extrait de la chaine c,à partir de la position n1, n2 caractères
                            ; STX : A$=MID$(c,N1,N2)
                            ; ALG : /
                            ; ST  : ACTIF
                            ; OP  : $D2
                            ; IN  : le flot d'interprétation
                            ; OUT : un descripteur de chaîne de caractères
jmpPOINT:
        dc.w romPOINT       ; FCT : COMMANDE BASIC POINT(X,Y) : retourne l'état du pixel aux coordonnées (X,Y)
                            ; STX : A=POINT(10,10)
                            ; BUG : /
                            ; ALG : /
                            ; ST  : ACTIF
                            ; OP  : $D3
                            ; IN  : le flot d'interprétation
                            ; OUT : ACC1 : état  du pixel aux coordonnées (X,Y)
                            ;       -1 si il y a un caractère
                            ;       0  si il est éteint
                            ;       Si LORES : 1 à 8 selon la couleur si allumé
                            ;       Si HIRES : 1 à 2 si allumé
jmpVARPTR:
        dc.w romVARPTR      ; FCT : Donne le pointeur sur la variable donnée en paramètre
                            ;       Il faut que la variable existe sinon message d'erreur
                            ; STX : B=VARPTR(A)
                            ; OP  : $D4
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation contenant (A[$])
                            ; OUT : ACC1=Le pointeur sur la mémoire contenant la valeur de la variable
jmpGETAdollar:
        dc.w romGETAdollar  ; FCT : Lit un caractère provenant du clavier
                            ; OP  : $D5
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : Retourne une chaîne de caractère
jmpPI:
        dc.w romPI          ; FCT : renvoie la valeur de PI
                            ; OP  : $D6
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : ACC1=la valeur de PI
jmpTWOPI:
        dc.w romTWOPI       ; FCT : renvoie la valeur de 2*PI
                            ; OP  : $D6
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : ACC1=la valeur de PI
jmpFALSE:
        dc.w romFALSE       ; FCT : Command BASIC FALSE : retourne 0 dans ACC1
                            ; STX : FALSE
                            ; BUG : ?
                            ; ALG : /
                            ; OP  : $XX
                            ; ST  : WIP
                            ; IN  : /
                            ; OUT : /
jmpTRUE:
        dc.w romTRUE        ; FCT : Command BASIC FALSE : retourne -1 dans ACC1
                            ; STX : TRUE
                            ; BUG : ?
                            ; ALG : /
                            ; OP  : $XX
                            ; ST  : WIP
                            ; IN  : /
                            ; OUT : /
jmpMEM:
        dc.w romMEM         ; FCT : Donne la taille mémoire disponible
                            ; OP  : $D7
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : ACC1=taille mémoire  disponible
;----------------
;
; this table contains precedences and dispatchs addresses for arithmetic
; and logical operators - the negation operators do not act on two operands
; so they are not listed in this table. they are treated separately in the
; expression evaluation routine. they are:
; unary negation (-), precedence $7d and logical negation (not), precedence $5A
; the relational operators < > = are also not listed, precedence $64.
; a precedence value of zero indicates end of expression or parentheses
;
aOperator:
        dc.b $79
        dc.w romPLUS        ; FCT : Add ACC2 to ACC1
                            ; STX : /
                            ; ALG : /
                            ; ST  : ACTIF
                            ; IN  : ACC1 and ACC2 set
                            ;       A = ?
                            ;       B = 0 : do move ACC1 to ACC2 / B <> 0 : do operation
                            ; OUT : ACC1=ACC1+ACC2
        dc.b $79
        dc.w romMINUS       ; FCT : Subtract ACC2 to ACC1
                            ; STX : /
                            ; ALG : /
                            ; ST  : ACTIF
                            ; IN  : ACC1 and ACC2 set
                            ;       A=?
                            ;       B = 0 : do move ACC1 to ACC2 / B <> 0 : do operation
                            ; OUT : ACC1=ACC1-ACC2
        dc.b $7B
        dc.w romMULT        ; FCT : multiply ACC1 by ACC2
                            ; ALG : /
                            ; ST  : ACTIF
                            ; IN  : ACC1 qnd ACC2 set
                            ; OUT : ACC1=ACC1*ACC2
        dc.b $7B
        dc.w romDIV         ; FCT : divide ACC1 by ACC2
                            ; STX : /
                            ; ALG : /
                            ; ST  : ACTIF
                            ; IN  : ACC1 and ACC2 set
                            ;       Z=1 si exp(ACC2) = 0 sinon Z=0
                            ;       A=Exposant de ACC1
                            ; OUT : ACC1=ACC1/ACC2
                            ; ERR : $0A : overflow error
                            ;       $14 : divide by 0
        dc.b $7F
        dc.w FPWRT          ; FCT : COMMANDE BASIC ^ : retourne X^Y
                            ; ALG : N.B. 0^0=1
                            ;       FIRST CHECK IF Y=0. IF SO, THE RESULT IS 1.
                            ;       NEXT CHECK IF X=0. IF SO THE RESULT IS 0.
                            ;       THEN CHECK IF X.GT.0. IF NOT CHECK THAT Y IS AN INTEGER.
                            ;       IF SO, NEGATE X, SO THAT LOG DOESN'T GIVE FCERR.
                            ;       IF X IS NEGATIVE AND Y IS ODD, NEGATE THE RESULT
                            ;       RETURNED BY EXP.
                            ;       TO COMPUTE THE RESULT USE X^Y=EXP((Y*LOG(X)).
                            ; STX : A=2^3: retourne 8
                            ; OP  : $B9
                            ; ST  : ACTIF
                            ; IN  : A=exposant de ACC2 (=X)
                            ;       B=exposant de ACC1 (=Y)
                            ;       C=1 ==> Y=0
                            ; OUT : ACC1=ACC2^ACC1
        dc.b $50
        dc.w doOP_AND       ; FCT : do "AND" ACC1 with ACC2
                            ; STX : IF A AND B THEN PRINT "A AND B"
                            ; ALG : /
                            ; OP  : $BA
                            ; ST  : ACTIF
                            ; IN  : ACC1 and ACC2 set
                            ; OUT : ACC1=ACC1 AND ACC2ss
        dc.b $46
        dc.w doOP_OR        ; FCT : do AND ACC1 with ACC2
                            ; STX : IF A OR B THEN PRINT "A OR B"
                            ; ALG : /
                            ; OP  : $BB
                            ; ST  : ACTIF
                            ; IN  : ACC1 and ACC2 set
                            ; OUT : ACC1=ACC1 AND ACC2

; --------------------------------------------------
MATHTBL:
        dc.b cBAS_PREC_OP_REL
        dc.w RELOPS                     ; FCT : PERFORM RELATIONAL OPERATIONS
                                        ; ST  : ACTIF
                                        ; IN  : le flot d'interprétation
                                        ;       C=0 : ? ; C=1 : ?
                                        ; OUT : A,B,X modified
; --------------------------------------------------

; /// BASIC - mots clés
xxBASIC_MOTS_CLES:

aFOR:         dc.b "FO"    ,"R"+$80 ;     : Opcode $80
aGOTO:        dc.b "GOT"   ,"O"+$80
aGOSUB:       dc.b "GOSU"  ,"B"+$80
aREM:         dc.b "RE"    ,"M"+$80 ;     : Opcode $83
aIF:          dc.b "I"     ,"F"+$80
aDATA:        dc.b "DAT"   ,"A"+$80 ;     : Opcode $85
aPRINT:       dc.b "PRIN"  ,"T"+$80 ;     : Opcode $86
aON:          dc.b "O"     ,"N"+$80
aINPUT:       dc.b "INPU"  ,"T"+$80
aEND:         dc.b "EN"    ,"D"+$80
aNEXT:        dc.b "NEX"   ,"T"+$80
aDIM:         dc.b "DI"    ,"M"+$80
aREAD:        dc.b "REA"   ,"D"+$80
aLET:         dc.b "LE"    ,"T"+$80
aRUN:         dc.b "RU"    ,"N"+$80
aRESTORE:     dc.b "RESTOR","E"+$80
aRETURN:      dc.b "RETUR" ,"N"+$80
aSTOP:        dc.b "STO"   ,"P"+$80
aPOKE:        dc.b "POK"   ,"E"+$80
aCONT:        dc.b "CON"   ,"T"+$80
aLIST:        dc.b "LIS"   ,"T"+$80
aCLEAR:       dc.b "CLEA"  ,"R"+$80
aNEW:         dc.b "NE"    ,"W"+$80
aCLOAD:       dc.b "CLOA"  ,"D"+$80
aCSAVE:       dc.b "CSAV"  ,"E"+$80
aLLIST:       dc.b "LLIS"  ,"T"+$80
aLPRINT:      dc.b "LPRIN" ,"T"+$80
aSET:         dc.b "SE"    ,"T"+$80
aRESET:       dc.b "RESE"  ,"T"+$80
aCLS:         dc.b "CL"    ,"S"+$80
aHIRES:       dc.b "HIRE"  ,"S"+$80
aTEXT:        dc.b "TEX"   ,"T"+$80
aLORES:       dc.b "LORE"  ,"S"+$80
aPAPER:       dc.b "PAPE"  ,"R"+$80
aINK:         dc.b "IN"    ,"K"+$80
aBOX:         dc.b "BO"    ,"X"+$80
aREC:         dc.b "REC"   ,"T"+$80
aCURSET:      dc.b "CURSE" ,"T"+$80
aCURMOV:      dc.b "CURMO" ,"V"+$80
aFILL:        dc.b "FIL"   ,"L"+$80
aPLOT:        dc.b "PLO"   ,"T"+$80
aPAL:         dc.b "PAL"   ,"("+$80
aBLK:         dc.b "BLK"   ,"("+$80
aAT:          dc.b "A"     ,"T"+$80
aLINE:        dc.b "LIN"   ,"E"+$80
aEDIT:        dc.b "EDI"   ,"T"+$80
aCARG:        dc.b "CAR"   ,"G"+$80
aWORD:        dc.b "WOR"   ,"D"+$80
aINC:         dc.b "IN"    ,"C"+$80
aDEC:         dc.b "DE"    ,"C"+$80
aSWAP:        dc.b "SWA"   ,"P"+$80
aREPEAT:      dc.b "REPEA" ,"T"+$80
aUNTIL:       dc.b "UNTI"  ,"L"+$80
aWHILE:       dc.b "WHIL"  ,"E"+$80
aWEND:        dc.b "WEN"   ,"D"+$80
aDEF:         dc.b "DE"    ,"F"+$80
aFN:          dc.b "F"     ,"N"+$80
aTRON:        dc.b "TRO"   ,"N"+$80
aTROFF:       dc.b "TROF"  ,"F"+$80
aELSE:        dc.b "ELS"   ,"E"+$80
aAUTO:        dc.b "AUT"   ,"O"+$80
aRENUM:       dc.b "RENU"  ,"M"+$80
aDEL:         dc.b "DE"    ,"L"+$80
aSOUND:       dc.b "SOUN"  ,"D"+$80
aEXEC:        dc.b "EXE"   ,"C"+$80
aSKIPF:       dc.b "SKIP"  ,"F"+$80
aTAB:         dc.b "TAB"   ,"("+$80 ;     : Opcode $AF
aTO:          dc.b "T"     ,"O"+$80 ;     : Opcode $B0
aTHEN:        dc.b "THE"   ,"N"+$80
aNOT:         dc.b "NO"    ,"T"+$80
aSTEP:        dc.b "STE"   ,"P"+$80
aOFF:         dc.b "OF"    ,"F"+$80
;----------------
aplus:        dc.b "+"+$80          ;     : Opcode $B5
aminus:       dc.b "-"+$80          ;     : Opcode $B6
amult:        dc.b "*"+$80          ;     : Opcode $B7
adiv:         dc.b "/"+$80          ;     : Opcode $B8
aexp:         dc.b "^"+$80          ;     : Opcode $B9 ; OBTENU PAR CONTROL+Z
aAND:         dc.b "AN","D"+$80     ;     : Opcode $BA
aOR:          dc.b "O" ,"R"+$80     ;     : Opcode $BB
asup:         dc.b ">"+$80          ;     : Opcode $BC
aegal:        dc.b "="+$80          ;     : Opcode $BD
ainf:         dc.b "<"+$80          ;     : Opcode $BE
;----------------
aSGN:         dc.b "SG"   ,"N"+$80  ;     : Opcode $BF
aINT:         dc.b "IN"   ,"T"+$80
aABS:         dc.b "AB"   ,"S"+$80
aUSR:         dc.b "US"   ,"R"+$80
aRND:         dc.b "RN"   ,"D"+$80
aSQR:         dc.b "SQ"   ,"R"+$80
aLOG:         dc.b "LO"   ,"G"+$80
aEXP:         dc.b "EX"   ,"P"+$80
aSIN:         dc.b "SI"   ,"N"+$80
aCOS:         dc.b "CO"   ,"S"+$80
aTAN:         dc.b "TA"   ,"N"+$80
aPEEK:        dc.b "PEE"  ,"K"+$80
aLEN:         dc.b "LE"   ,"N"+$80
aSTRdollar:   dc.b "STR"  ,"$"+$80
aVAL:         dc.b "VA"   ,"L"+$80
aASC:         dc.b "AS"   ,"C"+$80  ;     : opcode $CE
aCHRdollar:   dc.b "CHR"  ,"$"+$80  ;     : opcode $CF
aFLOAT:       dc.b "FLOA" ,"T"+$80
aLEFTdollar:  dc.b "LEFT" ,"$"+$80
aRIGHTdollar: dc.b "RIGHT","$"+$80
aMIDdollar:   dc.b "MID"  ,"$"+$80
aPOINT:       dc.b "POIN" ,"T"+$80
aVARPTR:      dc.b "VARPT","R"+$80
aGETAdollar:  dc.b "GETA" ,"$"+$80
aPI:          dc.b "P"    ,"I"+$80
aTWOPI:       dc.b "TWOP" ,"I"+$80
aFALSE:       dc.b "FALS" ,"E"+$80
aTRUE:        dc.b "TRU"  ,"E"+$80
aMEM:         dc.b "ME"   ,"M"+$80  ;     : opcode $ED
              dc.b $00
;----------------
jmpINSTRUCTION:
        dc.w romFOR         ; FCT : COMMANDE BASIC FOR
                            ; FOR PUSHES 18 BYTES ON THE STACK:
                            ;  2 -- TXTPTR
                            ;  2 -- LINE NUMBER
                            ;  5 -- INITIAL (CURRENT) FOR VARIABLE VALUE
                            ;  1 -- STEP SIGN
                            ;  5 -- STEP VALUE
                            ;  2 -- ADDRESS OF FOR VARIABLE IN VARTAB
                            ;  1 -- FOR TOKEN ($80)
                            ; IN  : le flot d'interprétation
                            ; OUT : A,B,X modified
jmpGOTO:
        dc.w romGOTO        ; FCT : Effectue un saut à la ligne L
                            ; STX : 10 GOTO 100 ==> OK
                            ;       10 GOTO A   ==> KO
                            ; OP  : $81
                            ; IN  : le flot d'interprétation qui doit contenir un numéro de ligne
                            ; OUT : /
jmpGOSUB:
        dc.w romGOSUB       ; FCT :
                            ;  "GOSUB" STATEMENT
                            ;  LEAVES 5 ou 7 BYTES ON STACK
                            ;  2 -- RETURN ADDRESS (NEWSTT)
                            ;  2 -- TXTPTR
                            ;  2 -- LINE #
                            ;  1 -- GOSUB TOKEN
                            ; OP  : $82
                            ; IN  : /
                            ; OUT : /
jmpREM:
        dc.w romREM         ; FCT : Instruction BASIC pour mettre en commentaire
                            ; STX : REM mon commentaire
                            ; OP  : $83
                            ; IN  : le flot d'interprétation
                            ; OUT : TXTPTR pointe sur la prochaine instruction
jmpIF:
        dc.w romIF          ; FCT : Commande BASIC IF
                            ; STX : IF A THEN 10
                            ;       IF A THEN GOTO 10
                            ; OP  : $84
                            ; BUG : /
                            ; IN  : le flot à interpréter suivant le IF
                            ; OUT : /
jmpDATA:
        dc.w romDATA        ; FCT : Instruction BASIC pour enregistrer des données séquentielles
                            ; OP  : $85
                            ; BUG : /
                            ; IN  : le flot d'interprétation contenant les données séquentielles
                            ; OUT : en mode interprétation ignore la ligne contenant les data
jmpPRINT:
        dc.w romPRINT       ; FCT : Imprime les expressions sur l'écran
                            ; RMQ : Etrangement, en fin de traitement, le "device de sortie" est intialisée à zéro
                            ;       pourquoi ?
                            ; STX : PRINT A;B
                            ; OP  : $86
                            ; ST  : ACTIF
                            ; IN  : le flot à interpreter
                            ; OUT : A,B,X modified
jmpON:
        dc.w romON          ; FCT : Branche vers un numéro de ligne selon la valeur "variable"
                            ; STX : ON variable GOTO n1,n2,...
                            ;       ON variable GOSUB n1,n2,...
                            ; OP  : $87
                            ; BUG : /
                            ; IN  : le flot d'interprétation contenant le reste de l'instruction (variable GOTO n1,...)
                            ; OUT : /
jmpINPUT:
        dc.w romINPUT       ; FCT : CMD BASIC INPUT : permet à l'utilisateur de saisir des données
                            ; STX : 100 INPUT A$
                            ;       110 INPUT B
                            ; OP  : $88
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : /
jmpEND:
        dc.w romEND         ; FCT : CMD BASIC END : arrête le programme
                            ; STX : 100 END
                            ; OP  : $89
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : /
jmpNEXT:
        dc.w romNEXT        ; FCT : CMD BASIC NEXT : Le retour pour le FOR associé
                            ; STX : 100 FOR I=1 TO 10:PRINT I: NEXT I
                            ; OP  : $8A
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : /
jmpDIM:
        dc.w romDIM         ; FCT : CREATION D'UN TABLEAU MULTIDIMENSION DE FLOAT OU DE CHAINE DE CARACTERES
                            ;       Codage d'un tableau en mémoire
                            ;        + WORD   : nom de la variable sur 2 caractères maxi. Le dernier octet du nom
                            ;                   aura le bit de poids le plus fort mis à 1 quand c'est une chaine
                            ;        + WORD   : taille du tableau
                            ;        + BYTE   : nombre de dimension
                            ;        + nxWORD : taille de dimension + 1 pour les n dimensions constituant le tableau
                            ;                   dans l'ordre d'inverse de leur déclaration
                            ;        + stockage des données
                            ;       + si float  : stockage du nombre sur 5 octets
                            ;       + si string : WORD : pointeur sur la chaîne de caractères
                            ; STX : 10 DIM A(4) : DIM B$(5,4)
                            ; OP  : $8B
                            ; IN  : le flot d'interprétration
                            ; OUT : Création d'un tableau
jmpREAD:
        dc.w romREAD        ; FCT : CMD BASIC READ : lit l'entrée pour l'affecter au(x) variable() qui sui(ven)t READ
                            ; STX : READ A[,B[...]]
                            ; OP  : $8C
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : A,B,X modified
jmpLET:
        dc.w romLET         ; FCT : effectue l'affectation d'une expression à une variable
                            ; STX : A=SIN(3.14)
                            ; OP  : $8D
                            ; BUG : /
                            ; IN  : le flot d'interprétation contenant le texte A=expr(B)
                            ; OUT : /
jmpRUN:
        dc.w romRUN         ; FCT : CMD BASIC RUN : permet de lancer un programme au début
                            ;       ou à un numéro de ligne donnée en paramètre
                            ; STX : RUN
                            ;       RUN numéro_de_ligne
                            ; OP  : $8E
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : /
jmpRESTORE:
        dc.w romRESTORE     ; FCT : CMD BASIC RESTORE : permet d'initialiser le
                            ;       pointeur des DATA au début du programme
                            ; STX : 100 RESTORE
                            ; OP  : $8F
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : /
jmpRETURN:
        dc.w romRETURN      ; FCT : COMMANDE BASIC RETURN : Ramène l'exécution du programme à l'instruction qui suit le GOSUB
                            ; STX : RETURN
                            ; OP  : $90
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : A,B,X modified
                            ; ERR : $04 : RETURN sans GOSUB
jmpSTOP:
        dc.w romSTOP        ; FCT : CMD BASIC STOP : permet d'arrêter le programme
                            ; STX : STOP
                            ; OP  : $91
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : /
jmpPOKE:
        dc.w romPOKE        ; FCT : CMD BASIC POKE : initialise l'octet à l'adresse A avec B
                            ; STX : POKE A,B
                            ; OP  : $92
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : A,B,X modified
jmpCONT:
                            ; OUT : /
        dc.w romCONT        ; FCT : CMD BASIC CONT : permet de reprendre le programme après un break
                            ; STX : CONT
                            ; OP  : $93
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : /
jmpLIST:
        dc.w romLIST        ; FCT : Imprime le listing du programme sur l'écran
                            ; STX : LIST ou LIST n-m ou LIST -m ou LIST m-
                            ; OP  : $94
                            ; ST  : ACTIF
                            ; IN  : le flot à interpreter
                            ; OUT : A,B,X modified
jmpCLEAR:
        dc.w romCLEAR       ; FCT : CMD BASIC CLEAR : CLEAR : initialise variable et réserve 100 octets  pour les string
                            ; STX : CLEAR nombre : init var et réserve nombre octets pour les string
                            ;       CLEAR N1,N2 avec N1 < N2 et n1 mémoire basse et n2 mémoire haute
                            ; OP  : $95
                            ; ST  : ACTIF
                            ; BUG : /
                            ; IN  : le flot à interpreter
                            ; OUT : A,B,X modified
jmpNEW:
        dc.w romNEW         ; FCT : CMD BASIC NEW : nouveau programme
                            ; STX : NEW
                            ; OP  : $96
                            ; ST  : ACTIF
                            ; IN  : A=Si <> 0  alors l'appel de NEW avait un argument
                            ;       X=Position de la commande NEW
                            ; OUT : A,B,X modified
jmpCLOAD:
        dc.w romCLOAD       ; FCT : TRAITE A LA FOIS CLOAD,CLOAD* (pour tableau) et CLOADM (programme binaire)
                            ; STX : CLOAD "TITI"
                            ;       CLOAD T,"TITI"
                            ;       CLOADM "TITI",offset
                            ; OP  : $97
                            ; ST  : ACTIF
                            ; IN  : le flot à interpréter
                            ; OUT : A,B,X modified
jmpCSAVE:
        dc.w romCSAVE       ; FCT : TRAITE A LA FOIS CSAVE,CSAVE*
                            ; STX : CSAVE"TITI"
                            ;       CSAVE* T,"TOTO"
                            ; OP  : $98
                            ; ST  : ACTIF
                            ; IN  : A=le prochain caractère (ou  opcode)
                            ;       Le flot à interpréter
                            ; OUT : A,B,X modified
jmpLLIST:
        dc.w romLLIST       ; FCT : Imprime le listing du programme sur l'imprimante
                            ; STX : LLIST ou LLIST n-m ou LLIST -m ou LLIST m-
                            ; OP  : $99
                            ; ST  : ACTIF
                            ; IN  : le flot à interpreter
                            ; OUT : A,B,X modified
jmpLPRINT:
        dc.w romLPRINT      ; FCT : Imprime les expressions sur l'imprimante
                            ; STX : LPRINT A;B
                            ; OP  : $9A
                            ; ST  : ACTIF
                            ; IN  : le flot à interpreter
                            ; OUT : A,B,X modified
jmpSET:
        dc.w romSET         ; FCT : Permet soit d'allumer un point avec une colonne
                            ;       soit de définir les  couleurs de la marge, de la couleur 1 et 2 en HIRES
                            ;       1 - allume un point de couleur C à la position (X,Y)
                            ;       2 - fixe les 3 couleurs en HIRES
                            ;       En mode LORES, l'écran est divisé en 1 pavé
                            ;       de 2x2 qui contient deux couleurs : le noir pour
                            ;       le fond et la couleur de l'avant: Tout changement
                            ;       de couleur d'un des pixels se répercute sur les
                            ;       autres pixels de ce pavé !
                            ; STX : SET (X,Y,C) avec C=couleur de 0 à 8 en LORES avec C=0 : utilisation de la couleur déjà définie dans un pavé de 2x2
                            ;       SET (X,Y,C) avec C=couleur de 0 à 2 en HIRES
                            ;       SET* C0,C1,C2 avec C0:couleur de la marge,C1:Couleur Encre nø1, C2: Couleur Encre nø2
                            ; OP  : $9B
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : /
                            ; RMQ : TODO A optimiser !
jmpRESET:
        dc.w romRESET       ; FCT : éteint un pixel en mode LORES et HIRES
                            ; STX : RESET (X,Y)
                            ; OP  : $9C
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : /
jmpCLS:
        dc.w romCLS         ; ---------------------------------------------------------------------------
                            ; FCT : Efface l'écran avec
                            ;       - soit la couleur courante
                            ;       - soit le code couleur fourni en paramètre [0-8]
                            ; cls 0 : noir
                            ; cls 1 : vert
                            ; cls 2 : jaune
                            ; cls 3 : bleu
                            ; cls 4 : rouge
                            ; cls 5 : blanc
                            ; cls 6 : cyan
                            ; cls 7 : magenta
                            ; cls 8 : orange
                            ; STX : CLS [0-8] avec [0-8] : couleur du fond d'écran
                            ; OP  : $9D
                            ; ST  : ACTIF
                            ; IN  : /
                            ; OUT : A,B,X : modified
jmpHIRES:
        dc.w romHIRES
jmpTEXT:
        dc.w romTEXT
jmpLORES:
        dc.w romLORES
jmpPAPER:
        dc.w romPAPER       ; FCT : commande BASIC PAPER : initialise le fond de l'écran d'un écran haute résolution
                            ;       avec la couleur donnée en paramètre
                            ;       Il est possible de dessiner en HIRES avec deux couleurs.
                            ;       En mode TEXT/LORES : change la couleur de la marge
                            ;       PAPER 0 : noir / PAPER 1 : orange / PAPER 2 : vert / PAPER 3 : jaune
                            ;       PAPER 4 : bleu / PAPER 5 : magenta / PAPER 6 : cyan
                            ; STX : PAPER 4
                            ; ALG : la couleur du fond est stockée dans le registre DOR de l'EF9345 en mode haute résolution
                            ; OP  : $A1
                            ; ST  : ACTIF
                            ; IN  : Le flot d'interprétation
                            ; OUT : /
jmpINK:
        dc.w romINK
jmpBOX:
        dc.w romBOX
jmpRECT:
        dc.w romRECT
jmpCURSET:
        dc.w romCURSET
jmpCURMOV:
        dc.w romCURMOV
jmpFILL:
        dc.w romFILL
jmpPLOT:
        dc.w romPLOT
jmpPAL:
        dc.w romPAL         ; FCT : Command BASIC PAL : fixe la palette du caractère en mode quadrichromie
                            ; STX : PAL(b)
                            ; BUG : ?
                            ; ALG : /
                            ; OP  : $XX
                            ; ST  : WIP
                            ; IN  : /
                            ; OUT : /
jmpBLK:
        dc.w romBLK         ; FCT : Command BASIC BLK : fixe le bloc de définition/de recherche en mode quadrichromie
                            ; STX : BLK(b) avec b=[0;7]
                            ; BUG : ?
                            ; ALG : /
                            ; OP  : $XX
                            ; ST  : WIP
                            ; IN  : /
                            ; OUT : /
jmpAT:
        dc.w romAT          ; FCT : Command BASIC AT X,Y : positionne le curseur à la position X,Y
                            ;       10 AT 10,20
                            ;       20 PRINT AT 10,20
                            ;       40 PRINT AT 10,20,"TITI"
                            ; STX : AT X,Y
                            ; BUG : ?
                            ; ALG : /
                            ; OP  : $XX
                            ; ST  : WIP
                            ; IN  : le flot d'interprétation
                            ; OUT : A,B,X modified

jmpLINE:
        dc.w romLINE
jmpEDIT:
        dc.w romEDIT
jmpCARG:
        dc.w romCARG
jmpWORD:
        dc.w romWORD
jmpINC:
        dc.w romINC
jmpDEC:
        dc.w romDEC
jmpSWAP:
        dc.w romSWAP
jmpREPEAT:
        dc.w romREPEAT
jmpUNTIL:
        dc.w romUNTIL
jmpWHILE:
        dc.w romWHILE
jmpWEND:
        dc.w romWEND
jmpDEF:
        dc.w romDEF
jmpFN:
        dc.w romFN
jmpTRON:
        dc.w romTRON
jmpTROFF:
        dc.w romTROFF
jmpELSE:
        dc.w romREM
jmpAUTO:
        dc.w romAUTO
jmpRENUM:
        dc.w romRENUM
jmpDEL:
        dc.w romDEL
jmpSOUND:
        dc.w romSOUND       ; FCT : Génére un son de hauteur n1 pendant une période n2
                            ;       avec n1=[0..255] et n2=[0..255] : unité 7.5/100e de  seconde
                            ;       rend inutilisable le clavier car utilise la broche de
                            ;       détection d'une touche du clavier pour générer
                            ;       le signal carré
                            ; STX : SOUND 10,55
                            ; OP  : $AC
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : A,B,X modified
jmpEXEC:
        dc.w romEXEC        ; FCT : Execute un sous programme assembleur
                            ; STX : EXEC :exécute de nouveau l'appel au sous-programme assembleur
                            ;       EXEC 25000
                            ;       EXEC exécute le sous programme initialisé préalablement par EXEC XXXX
                            ; OP  : $AD
                            ; ST  : ACTIF
                            ; DBG : NON
                            ; IN  : le flot d'interprétation
                            ;       A=0 si pas d'argument à interpréter
                            ; OUT : /
jmpSKIPF:
        dc.w romSKIPF       ; FCT : K7 : recherche d'un programme sur K7
                            ; STX : SKIPF "FICHIER"
                            ; OP  : $AE
                            ; ST  : ACTIF
                            ; IN  : le flot d'interprétation
                            ; OUT : A,B,X modified
;----------------

; /// BASIC - message d'erreur
xxBASIC_MSG_ERR:

stringMSGERREUR:
        dc.b $4E,$46        ; $00 (00) : NF NEXT without FOR - next sans for
        dc.b $53,$4E        ; $02 (02) : SN syntax error - erreur de syntaxe
        dc.b $52,$47        ; $04 (04) : RG Return without Gosub - return sans gosub
        dc.b $4F,$44        ; $06 (06) : OD Overflow Data -
        dc.b $46,$43        ; $08 (08) : FC function incorrect - fonction incorrecte
        dc.b $4F,$56        ; $0A (10) : OV OVerflow - overflow ...
        dc.b $4F,$4D        ; $0C (12) : OM Out of Memory - Plus de place disponible en mémoire
        dc.b $55,$4C        ; $0E (14) : UL Undefined Line - Ligne indéfnie
        dc.b $42,$53        ; $10 (16) : BS Bad Subscript - Indice incorrect
        dc.b $44,$44        ; $12 (18) : DD Erreur avec un tableau
        dc.b $2F,$30        ; $14 (20) : /0 Division par zéro
        dc.b $49,$44        ; $16 (22) : ID instruction interdite en mode direct
        dc.b $54,$4D        ; $18 (24) : TM Type Mismatch -
        dc.b $4F,$53        ; $1A (26) : OS Out of String -
        dc.b $4C,$53        ; $1C (28) : LS chaîne trop longue
        dc.b $53,$54        ; $1E (30) : ST Expression trop compliquée
        dc.b $43,$4E        ; $20 (32) : CN can't continue
        dc.b $49,$4F        ; $22 (34) : IO Input Output - problème d'entrées/sorties
        dc.b $46,$4D        ; $24 (36) : FM File Mismatch -
        dc.b $4E,$52        ; $26 (38) : NR UNTIL without REPEAT - repeat sans until
        dc.b $4E,$57        ; $28 (40) : NW WHILE without WEND - while sans wend

;----------------
aERROR:     dc.b 8," ERROR",0
aIN:        dc.b 5," IN ",0
aOk:        dc.b 5,$D,">>",$D,0
aBreak:     dc.b 8,$D,"BREAK",0

; /// BASIC - NOYAU
xxBASIC_KERNEL:

; =============== S U B R O U T I N E =======================================
; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
; IN  : /
; OUT : A=0 : Token FOR trouvé
;       A=2 : Token GOSUB trouvé
;       V et C =0
;       Z=1 si A est null
;       N=1 si A est négatif
;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
FNDFOR:
        tsx
        ldab #$04                           ; on enlève l'adresse de retour + rts
        abx
bclFNDFOR:
        ldab #cBAS_BYTES_PER_FOR            ; Il y a 20 octets de données pour coder un FOR :
                                            ; TXTPTR(2)+LINE NUMBER(2)+INITIAL/CURRENT FOR VARIABLE VALUE(6)+STEP SIGN(1)+STEP VALUE(6)+ADDRESS OF FOR VARIABLE IN VARTAB(2)+TOKEN FOR(1)
        stx INDEX                           ; nous stockons l'offset de recherche dans INDEX
        ldaa 0,x
        suba #cBAS_TOKEN_FOR                ; Test si opcode = $80 = FOR
        bne next2GTFORPNT
        ldx 1,x
        stx TMPPTR
        ldx FORPNT
        beq next1GTFORPNT
        cpx TMPPTR
        beq next2GTFORPNT
        bsr addINDEX2TMPPTR                 ; D=INDEX+D puis X=TMPPTR=D
        bra bclFNDFOR
next1GTFORPNT:
        ldx TMPPTR
        stx FORPNT
next2GTFORPNT:
        ldx INDEX                           ; Restitution de la position de la pile des instructions (FOR,GOSUB,REPEAT,WHILE)
        tsta
        rts
; End of function FNDFOR


; =============== S U B R O U T I N E =======================================
; FCT : move block of memory up + vérification si il y a de la place dans la pile
; IN  : HIGHDS (cible), HIGHTR (source min), LOWTR (source max) à jour
; OUT : A,B,X modified
;       PTRTMP2 : contient le pointeur sur le dernier octet copié

BLTU:
        bsr nextCHKMEM
; End of function BLTU


; =============== S U B R O U T I N E =======================================
; FCT : move block of memory up
; IN  : HIGHDS (cible), HIGHTR (source min), LOWTR (source max) à jour
; OUT : A,B,X modified

doBLTU:
        tpa
        psha
        sts SAVREGS
        sei
        lds HIGHDS                          ; Cible lors d'une copie de zone mémoire
        ldx HIGHTR
        inx
bclMoveStrToTop:
        dex
        ldaa 0,x
        psha
        cpx LOWTR
        bne bclMoveStrToTop
        ins
        sts PTRTMP2
        lds SAVREGS
        pula
        tap                                 ; Efface le drapeau interruption (donc pas besoin de cli avec le sei de la fonction)
        rts
; End of function doBLTU


; =============== S U B R O U T I N E =======================================
; FCT : vérifie s'il y a 2*B + $3A octets libres
; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
; OUT : D=pointeur après ajout de 2*B + $3A octets

CHKMEM:
        clra
        aslb
        addd STREND
nextCHKMEM:
        addd #cBAS_OFS_STK                  ; $3A = 2 * NUMLEV + 3*ADDPRC + 13 locs = 23*2 + 3 + 13 = 58
        bcs MEMERR                          ; FCT : Point d'entrée secondaire pour la gestion d'erreur
                                            ;       il correspond à "plus de place disponible en mémoire"
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        sts SAVREGS
        subd SAVREGS
        bcc MEMERR                          ; FCT : Point d'entrée secondaire pour la gestion d'erreur
                                            ;       il correspond à "plus de place disponible en mémoire"
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        addd SAVREGS
        rts
; End of function CHKMEM


; =============== S U B R O U T I N E =======================================
; FCT : INDEX=X et TMPPTR=X+B
; IN  : B=offset sur 8 bits
;       X=pointeur
; OUT : INDEX=X
;       X=D=TMPPTR=X+D
addRegBToTMPPTR:
        clra
; End of function addRegBToTMPPTR


; =============== S U B R O U T I N E =======================================
; FCT : Ajoute l'offset B à X
; IN  : D=offset à ajouter à INDEX
; OUT : INDEX=X
;       X=D=TMPPTR=X+D

addXtoTMPPTR:
        stx INDEX
addINDEX2TMPPTR:
        addd INDEX
        std TMPPTR
        ldx TMPPTR
        rts
; End of function addXtoTMPPTR


; =============== S U B R O U T I N E =======================================
; FCT : Point d'entrée secondaire pour la gestion d'erreur
;       il correspond à "plus de place disponible en mémoire"
; IN  : /
; OUT : A,B,X modified

MEMERR:
        ldab #cBAS_ERR_MEMFULL              ; $0C : erreur : OM Plus de place disponible en mémoire
ERROR:
        jsr endRomCSAVE                     ; Port I/O soit pour RS232 soit pour K7
        ldaa DEVCUR                         ; CURRENT DEVICE : $00 : SCREEN, $FF : K7
        beq nextERROR
        jsr doRomNEW                        ; FCT : Effectue l'action de la commande BASIC NEW
                                            ; IN  : /
                                            ; OUT : X=TXTAB+2=début du programme + 2
nextERROR:
        jsr reInitPointeur                  ; FCT : Initialisation de certains pointeurs, pile et données BASIC
                                            ; IN  : /
                                            ; OUT : S=Initialisé à sa position de départ
                                            ;       A=0
                                            ;       OLDTXT=0, SUBFLG=0,DEVCUR=0 (SCREEN),TMPPT=$3241
                                            ;       Le retour de l'appelant se fait par popx + jmp x
                                            ;       suite à l'initialisation de la pile (S)
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        jsr initParamByMode                 ; FCT : Permet d'initialiser les paramètres de l'écran ou de l'imprimante
                                            ;       selon la variable DEVNU
                                            ; IN  : DEVNU à jour
                                            ; OUT : A,B,X modified
printTypeMsgError:
        jsr OS_printPtInterrogation
        ldx #stringMSGERREUR
        abx
        ldaa 0,x
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        ldaa 1,x
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
printERROR:
        ldx #(aERROR)
        ldab 0,x
        inx

printMsgErrorAndWaitInputFromUser:
        jsr bclOUTTX
        ldx CURLIN
        inx
        beq INTERPRETATION                  ; FCT : INTERPRETATION
                                            ; IN  : /
                                            ; OUT : /
        jsr printIN
; End of function MEMERR


; =============== S U B R O U T I N E =======================================
; FCT : INTERPRETATION
; IN  : /
; OUT : /

INTERPRETATION:
        jsr initParamByMode                 ; FCT : Permet d'initialiser les paramètres de l'écran ou de l'imprimante
                                            ;       selon la variable DEVNU
                                            ; IN  : DEVNU à jour
                                            ; OUT : A,B,X modified

printOK:
        ldx #aOk                            ; "\r>>\r"
        ldab 0,x
        inx
        jsr bclOUTTX

MAIN:
        ldx #$FFFF
        stx CURLIN
        ldab #$01
        ldx #strPARSE_BUFFER
        ldaa AUTOINC
        oraa AUTOINC+1
        beq MAIN1
        ldab strPARSE_POS
        abx
MAIN1:
        jsr entryINKBD                      ; entrée secondaire de :
                                            ; FCT : Attend une saisie utilisateur
                                            ;       gére les touches spécifiques
                                            ;       BREAK  : sort du programme !
                                            ;       CTRL+A : effacement de la saisie en cours
                                            ;       CTRL+Q : effacement d'un caractère
                                            ;       RETURN : fin de la saisie utilisateur
                                            ; IN  : /
                                            ; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur
                                            ;       C=0 : saisie utilisateur
                                            ;       C=1 : saisie d'une touche de contrôle
        bcs MAIN
DEBUGMAIN1:
        stx TXTPTR

INTERPRET:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        beq MAIN

ParseNewLine:
        bcs PARSE_LINE                      ; FCT : Transforme une ligne BASIC saisie par utilisateur
                                            ;       en son équivalent "CRUNCHED" (transformation des
                                            ;       mot-clef BASIC en opcode BASIC) et l'insert
                                            ;       dans le programme BASIC en fonction du numéro de
                                            ;       ligne
                                            ; IN  : le flot d'interprétation sous forme nnn AAAA[:[BBBB]...]
                                            ; OUT : /

; Permet d'interpréter les commandes BASIC tapées directement
isCmdBasic:
        jsr CRUNCH                          ; FCT : CRUNCH - Transforme les mots clefs BASIC en leur équivalent code token
                                            ;       venant du flot à interpréter
                                            ; IN  : le flot à interpréter
                                            ; OUT : X=position de la ligne BASIC convertie
                                            ;       D=Taille de la ligne BASIC convertie
        jmp NEWSTT2

; End of function INTERPRETATION

; =============== S U B R O U T I N E =======================================
; FCT : Transforme une ligne BASIC saisie par utilisateur
;       en son équivalent "CRUNCHED" (transformation des
;       mot-clef BASIC en opcode BASIC) et l'insert
;       dans le programme BASIC en fonction du numéro de
;       ligne
; IN  : le flot d'interprétation sous forme nnn AAAA[:[BBBB]...]
; OUT : /

PARSE_LINE:
        jsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir<
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        ldx LINUM                           ; sauvegarde le numéro de ligne
        stx strPARSE_NO_LINE
        jsr CRUNCH                          ; FCT : CRUNCH - Transforme les mots clefs BASIC en leur équivalent code token
                                            ;       venant du flot à interpréter
                                            ; IN  : le flot à interpréter
                                            ; OUT : X=position de la ligne BASIC convertie
                                            ;       D=Taille de la ligne BASIC convertie
        stab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
                                            ; Sauve la taille de la chaîne convertie
        jsr FNDLIN                          ; FCT : FNDLIN SEARCHES THE PROGRAM TEXT FOR THE LINE
                                            ;       WHOSE NUMBER IS PASSED IN "LINUM".
                                            ;       THERE ARE TWO POSSIBLE RETURNS:
                                            ;       1) CARRY SET.
                                            ;          LOWTR POINTS TO THE LINK FIELD IN THE LINE
                                            ;          WHICH IS THE ONE SEARCHED FOR.
                                            ;
                                            ;       2) CARRY NOT SET.
                                            ;          LINE NOT FOUND. [LOWTR] POINTS TO THE LINE IN THE
                                            ;          PROGRAM GREATER THAN THE ONE SOUGHT AFTER.
                                            ; IN  : /
                                            ; OUT : C=1 : Ligne trouvée
                                            ;       X=Position en mémoire de la ligne trouvée
        bcs next1PARESELINE
        ldd LOWTR
        subd 0,x
        addd VARTAB                         ; Fin du programme BASIC / début des variables
        std VARTAB                          ; Fin du programme BASIC / début des variables
        tpa
        psha
        sts SAVREGS
        sei
        lds 0,x
        des
bclCopy_PARSELINE:
        pula
        staa 0,x
        inx
        cpx VARTAB                          ; Fin du programme BASIC / début des variables
        bne bclCopy_PARSELINE
        lds SAVREGS
        pula
        tap

next1PARESELINE:
        ldaa strPARSE_BUFFER
        beq next3PARESELINE
        ldd VARTAB                          ; Fin du programme BASIC / début des variables
        std HIGHTR
        addb EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        adca #$00
        std HIGHDS                          ; Cible lors d'une copie de zone mémoire
        jsr BLTU                            ; FCT : move block of memory up + vérification si il y a de la place dans la pile
                                            ; IN  : HIGHDS (cible), HIGHTR (source min), LOWTR (source max) à jour
                                            ; OUT : A,B,X modified
                                            ;       PTRTMP2 : contient le pointeur sur le dernier octet copié
        tpa
        psha                                ; Sauvegarde du registre de condition
        sts SAVREGS
        sei
        lds #(strPARSE_PTR_LINE_NEXT-1)

bcl2Copy_PARSELINE:
        pula
        staa 0,x
        inx
        cpx PTRTMP2
        bne bcl2Copy_PARSELINE
        lds SAVREGS
        pula
        tap
        ldx HIGHDS                          ; Cible lors d'une copie de zone mémoire
        stx VARTAB                          ; Fin du programme BASIC / début des variables

next3PARESELINE:
        jsr SETPTRS                         ; FCT : Erase all pointers
                                            ; IN  : /
                                            ; OUT : A,X modified
        bsr CHEAD                           ; FCT : Calcule les liens des lignes BASIC
                                            ; IN  : /
                                            ; OUT : /
modeauto:
        ldd AUTOINC                         ; Si mode auto activé alors affiche le numéro de la ligne suivante
        beq next2MAIN
        addd LINUM
        std ACC1
        jsr bcdConvert                      ; FCT : Convertit un entier stocké dans ACC1 en sa répresentation décimale
                                            ; IN  : ACC1 : le nombre à afficher
                                            ; OPT : oui. A été réécrit pour être plus rapide
                                            ; OUT : B : longueur de la convertion
                                            ;       X : position du premier caractère significatif (padleft)
                                            ;       TAMPON : position du premier caractère non significatif
                                            ;       A and ACC1 modified
        ldab #$01                           ; Initialisation du nombre de caractère dans le tampon
        sei
        sts SAVREGS
        txs
        ldx #strPARSE_BUFFER
bclMAIN:
        pula
        tsta
        beq next1MAIN
        jsr INKBD_echoInput                 ; FCT : vérifie que nous n'avons pas dépassé la taille du tampon clavier ($80)
                                            ;       et stocke le caractère lu dans le tampon et l'imprime sur le device en cours
                                            ; IN  : B=position dans le tampon clavier
                                            ;       A=caractère lu du clavier (ASCII)
                                            ;       X=pointeur sur le tampon clavier
                                            ; OUT : B=B+1
                                            ;       X=X+1
        bra bclMAIN
next1MAIN:
        lds SAVREGS
        cli
        stab strPARSE_POS
        ldaa #$20                           ; ajoute un espace dans le buffer
        jsr INKBD_echoInput                 ; FCT : vérifie que nous n'avons pas dépassé la taille du tampon clavier ($80)
                                            ;       et stocke le caractère lu dans le tampon et l'imprime sur le device en cours
                                            ; IN  : B=position dans le tampon clavier
                                            ;       A=caractère lu du clavier (ASCII)
                                            ;       X=pointeur sur le tampon clavier
                                            ; OUT : B=B+1
                                            ;       X=X+1
next2MAIN:
        jmp MAIN
; End of function PARSE_LINE


; =============== S U B R O U T I N E =======================================
; FCT : Calcule les liens des lignes BASIC
; IN  : /
; OUT : /

CHEAD:
        ldx TXTAB                           ; début du programme basic

bclCHEAD:
        ldd 0,x
        bne next1CHEAD
        rts

next1CHEAD:
        pshx
        ldab #$04
        abx

bcl2CHEAD:
        inx
        ldaa 0,x
        bne bcl2CHEAD
        inx
        pshx
        tsx
        ldd 0,x
        ldx 2,x
        std 0,x
        pulx
        ins
        ins
        bra bclCHEAD
; End of function CHEAD


; =============== S U B R O U T I N E =======================================
; FCT : CRUNCH - Transforme les mots clefs BASIC en leur équivalent code token
;       venant du flot à interpréter
; IN  : le flot à interpréter
; OUT : X=position de la ligne BASIC convertie
;       D=Taille de la ligne BASIC convertie

CRUNCH:
        clr DATAFLG
        ldx TXTPTR                          ; 4/2
        dex                                 ; 3/1
        stx TXTPTR                          ; 4/2 11 cycles / 5 octets
        ldx #strPARSE_BUFFER-1              ;
        stx STRNG2                          ; save begin of buffer to use later
        sts SAVREGS                         ;
        tpa                                 ;
        staa INPUTFLG                       ; =$00:INPUT,=$4F:READ
bclPARSE_INPUT_LINE:
        nop                                 ; pourquoi un nop ?
        sei                                 ; pas d'interruption ... car on va utiliser le registre S
        lds TXTPTR                          ; LDS pointe maintenant sur le flot à interpréter
        pulb                                ; récupération de la donnée avec le pointeur S
isSpace:
        cmpb #cOS_SPACE                     ; ' '
        beq SAVE_B_AND_CONT_PIL             ;
        stab ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
isDoubleGuillemet_0:
        cmpb #cBAS_SEP_STR                  ; '"'
        beq manageString_PIL
        ldaa DATAFLG
        bne SAVE_B_AND_CONT_PIL
isPrintReducted:
        cmpb #cBAS_QUESTION_MARK            ; '?' ; question mark
        bne isNUMeric                       ;
        ldab #cBAS_TOKEN_PRINT              ; set Opcode = PRINT = 0x86
        bra SAVE_B_AND_CONT_PIL
isNUMeric:
        cmpb #$30 ; '0'                     ;
        bcs isTokenBasic                    ;
        cmpb #$3C ; '<'                     ;
        bcs SAVE_B_AND_CONT_PIL             ;
isTokenBasic:
        tstb                                ;
        bmi next3IsUnknownTokenBasic        ;
doSearchToken_PIL:
        ldx #(aFOR-1)                       ; X pointe sur le tableau des commandes BASIC connues
        lds TXTPTR                          ; S pointe sur le flot à interpréter
        clrb
bclIsTokenBasic:
        inx
bcl1IsTokenBasic:
        pula
        cmpa #cOS_SPACE                     ; ' ' ; si c'est un espace lu dans le flot alors on lit le caractère suivant
        beq bcl1IsTokenBasic
        suba 0,x
        beq bclIsTokenBasic                 ; Est-ce que le caractère lu correspond à la commande BASIC  ?
                                            ; Oui alors on continue de lire le flot et à comparer ...
        cmpa #$80
        bne NotFoundTokenBasic_PIL          ; Est-ce la fin du mot-clé basic en cours de recherche ?
        orab #$80
bcl2IsTokenBasic:
        ldx STRNG2
        bra SAVE_B_AND_CONT_PIL
next3IsUnknownTokenBasic:
        ldab #cEDT_UNKNOWN                  ; '!'
SAVE_B_AND_CONT_PIL:
        sts TXTPTR
        lds SAVREGS
        ldaa INPUTFLG                       ; =$00:INPUT,=$4F:READ
        tap
        inx
        stx STRNG2                          ; save position on CRUNCHED LINE
        stab $00,x
        beq endPARSE_INPUT_LINE
        subb #cBAS_SEP                      ; ':' ; est-ce l'opérateur(séparateur) : $3A c'est à dire ':' ?
isSep_PIL:
        beq COLIS_PIL
isTokenDATA_PIL:
        cmpb #(cBAS_TOKEN_DATA-cBAS_SEP)    ; Is it the token DATA=$85=$3A+$4B ?
        bne isTokenREM_PIL
COLIS_PIL:
        stab DATAFLG                        ; setup flag
isTokenREM_PIL:
        subb #(cBAS_TOKEN_REM-cBAS_SEP)     ; Is it the token REM=$83:$3A+$49 ?
        bne bclPARSE_INPUT_LINE
doToken_REM_PIL:
        stab ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        sei                                 ; TODO : ???
        lds TXTPTR
processChar_PIL:
        pulb
        tstb
        beq SAVE_B_AND_CONT_PIL
        cmpb ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        beq SAVE_B_AND_CONT_PIL
manageString_PIL:
        inx
        stab $00,x
        bra processChar_PIL
NotFoundTokenBasic_PIL:
        lds TXTPTR
        incb
EscapeCurrentToken_PIL:
        ldaa 0,x
        inx
        bpl EscapeCurrentToken_PIL
        ldaa 0,x
        bne bcl1IsTokenBasic                ; Est-ce la fin des mots-clés du BASIC ?
                                            ; Si non alors on continue la recherche ...
        sts TXTPTR
        lds SAVREGS
getNextCharFromFlow:
        lds TXTPTR
        pulb                                ; get next char from flow
        bra bcl2IsTokenBasic
endPARSE_INPUT_LINE:
        stab 1,x                            ; to do as end of line  (BASIC LINE)
        stab 2,x
        ldd STRNG2                          ; compute length of crunched line
        subd #(strPARSE_PTR_LINE_NEXT-1)
        ldx #strPARSE_BUFFER-1              ; make TXTPTR point to CRUNCHED LINE
        stx TXTPTR
        rts
; End of function CRUNCH


; =============== S U B R O U T I N E =======================================
; FCT : FNDLIN SEARCHES THE PROGRAM TEXT FOR THE LINE
;   WHOSE NUMBER IS PASSED IN "LINUM".
;   THERE ARE TWO POSSIBLE RETURNS:
;
;   1) CARRY SET.
;      LOWTR POINTS TO THE LINK FIELD IN THE LINE
;      WHICH IS THE ONE SEARCHED FOR.
;
;   2) CARRY NOT SET.
;      LINE NOT FOUND. [LOWTR] POINTS TO THE LINE IN THE
;      PROGRAM GREATER THAN THE ONE SOUGHT AFTER.
; IN  : /
; OUT : C=1 : Ligne trouvée
;       LOWTR=X=Position en mémoire de la ligne trouvée

FNDLIN:
        ldx TXTAB                           ; début du programme basic

bclFNDLIN:
        ldd 0,x
        beq nextFNDLIN_FOUND
        ldd LINUM
        subd 2,x
        bls endFNDLIN
        ldx 0,x
        bra bclFNDLIN

nextFNDLIN_FOUND:
        sec

endFNDLIN:
        stx LOWTR                           ; LOWTR SAVE MATCH LINE NUMBER OR NUMBER OF LINE JUST AFTER
        rts
; End of function FNDLIN


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC NEW : nouveau programme
; STX : NEW
; OP  : $96
; ST  : ACTIF
; IN  : A=Si <> 0  alors l'appel de NEW avait un argument
;       X=Position de la commande NEW
; OUT : A,B,X modified

romNEW:
        bne endFNDLIN
; End of function romNEW


; =============== S U B R O U T I N E =======================================
; FCT : Effectue l'action de la commande BASIC NEW
; IN  : /
; OUT : X=TXTAB+2=début du programme + 2

doRomNEW:
        ldx TXTAB                           ; début du programme basic
        clr 0,x
        inx
        clr 0,x
        inx
        stx VARTAB                          ; Fin du programme BASIC / début des variables
; End of function doRomNEW


; =============== S U B R O U T I N E =======================================
; FCT : Erase all pointers
; IN  : /
; OUT : A,X modified

SETPTRS:
        ldx TXTAB                           ; début du programme basic
        dex
        stx TXTPTR

nextSetPTRS_CLEAR:
        ldx MEMSIZ                          ; Adresse - 1 de la fin de la RAM DISPONIBLE
        stx FRETOP
        ldx TXTAB
        dex
        stx DATPTR
        ldx VARTAB                          ; Fin du programme BASIC / début des variables
        stx ARYTAB
        stx STREND
; End of function SETPTRS


; =============== S U B R O U T I N E =======================================
; FCT : Initialisation de certains pointeurs, pile et données BASIC
; IN  : /
; OUT : S=Initialisé à sa position de départ
;       A=0
;       OLDTXT=0, SUBFLG=0,DEVCUR=0 (SCREEN),TMPPT=$313D - TODO : valeur $313D à revoir
;       Le retour de l'appelant se fait par popx + jmp x
;       suite à l'initialisation de la pile (S)

reInitPointeur:
        ldx #TMPDESCSTK                     ; TODO - $313D
        stx TMPPT
        pulx                                ; nous récupérons l'adresse de retour car ...
        lds BOTSTK                          ; nous reinitialisons le pointeur de pile à sa position initiale
        clra
        psha
        staa OLDTXT
        staa OLDTXT+1
        staa SUBFLG                         ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        staa DEVCUR                         ; CURRENT DEVICE : $00 : SCREEN, $FF : K7
        jmp 0,x                             ; retour à l'appelant via X et non pas rts car nous avons reinitialisé le pointeur de pile
; End of function reInitPointeur


; =============== S U B R O U T I N E =======================================
; FCT : Positionne le device à PRINTER(=$FE)
;       Lit le caractère en cours
; IN  : /
; OUT : A=CHRGOT() & B modified

setDeviceToPrinter:

        ldab #cOS_DEV_PRINTER
        stab DEVNU                          ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        jmp CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
; End of function setDeviceToPrinter


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le listing du programme sur l'imprimante
; STX : LLIST ou LLIST n-m ou LLIST -m ou LLIST m-
; OP  : $99
; ST  : ACTIF
; IN  : le flot à interpreter
; OUT : A,B,X modified

romLLIST:
        bsr setDeviceToPrinter              ; FCT : Positionne le device à PRINTER(=$FE)
                                            ;       Lit le caractère en cours
                                            ; IN  : /
                                            ; OUT : A=CHRGOT() setDeviceToPrinter & B modified
; End of function romLLIST

; =============== S U B R O U T I N E =======================================
; FCT : Imprime le listing du programme sur l'écran
; STX : LIST ou LIST n-m ou LIST -m ou LIST m-
; OP  : $94
; OPT : optimisation effectuée en V3.2 WIP V7 : plus simple ...
; ST  : ACTIF
; IN  : le flot à interpreter
; OUT : A,B,X modified

romLIST:
        tpa                                 ; Subtilité : on sauvegarde l'état du CHRGET précédent
        psha
        jsr CHRGOT                          ; recharge A avec le dernier caractère lu ! si LIST n'a pas de paramètre alors contient #$00
                                            ; dans ce cas LINGET (comme A=$00) alors LINUM=$0000
                                            ; ==> ruse pour obtenir la première ligne = 0 donc la 1ere ligne du programme
        jsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        bsr FNDLIN                          ; FCT : FNDLIN SEARCHES THE PROGRAM TEXT FOR THE LINE
                                            ;       WHOSE NUMBER IS PASSED IN "LINUM".
                                            ;       THERE ARE TWO POSSIBLE RETURNS:
                                            ;
                                            ;       1) CARRY SET.
                                            ;          LOWTR POINTS TO THE LINK FIELD IN THE LINE
                                            ;          WHICH IS THE ONE SEARCHED FOR.
                                            ;
                                            ;       2) CARRY NOT SET.
                                            ;          LINE NOT FOUND. [LOWTR] POINTS TO THE LINE IN THE
                                            ;          PROGRAM GREATER THAN THE ONE SOUGHT AFTER.
                                            ; IN  : /
                                            ; OUT : C=1 : Ligne trouvée
                                            ;       X=Position en mémoire de la ligne trouvée
        pula                                ; permet de savoir si LIST a été lancé avec un paramètre ou pas
        tap
        pshx                                ; Sauvegarde du pointeur de la premuère ligne
        beq nextRomLIST                     ; s'il n'y avait pas de paramère alors on saute à la partie listing
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq next1RomLIST

isTiretRomLIST:
        cmpa #cBAS_TOKEN_MINUS              ; $B6 ; Token MINUS = séparateur entre les deux bornes de recherche
        bne jmpSetError9x02_SYNTAXERROR
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        beq nextRomLIST
        jsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        beq next1RomLIST

jmpSetError9x02_SYNTAXERROR:
        jmp setError0x02_SYNTAXERROR

nextRomLIST:
        ldx #$FFFF
        stx LINUM                           ; fixe la dernière ligne à afficher (le numéro de ligne maximal) quand LIST n'a pas de paramètres

next1RomLIST:
        pulx
        ins
        ins

bcl2RomLIST:                                ;  : le initiParamByMode est intriguant ... remplacer par un retour à ligne tout simplement
        jsr OS_printCR                      ; initParamByMode         ; FCT : Permet d'initialiser les paramètres de l'écran ou de l'imprimante
                                            ;       selon la variable DEVNU
                                            ; IN  : DEVNU à jour
                                            ; OUT : A,B,X modified
        jsr ISCNTC                          ; FCT : Test si touche BREAK ou SHIFT+@(PAUSE) pressée
                                            ;       Sinon écrit A dans le tampon clavier
                                            ; IN  : /
                                            ; OUT : A=code ASCII de la touche pressée
        ldd 0,x
        bne next4RomLIST

bcl3RomLIST:                                ; Retour à l'interprétation car il n'y a plus de liogne à afficher
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        jmp INTERPRETATION                  ; FCT : INTERPRETATION
                                            ; IN  : /
                                            ; OUT : /

next4RomLIST:
        ldd 2,x
        subd LINUM
        bhi bcl3RomLIST
        ldd 2,x
        pshx
printNumberLineRomLIST:
        jsr ULIPTR                          ; FCT : Imprime le nombre non signé contenu dans D
                                            ; IN  : D : le nombre non signé à afficher
                                            ; OPT : oui. A été réécrit pour être plus rapide
                                            ; IN  : D : 0 à 65536 ( entier non relatif )
                                            ; OUT : A,B,X modified
                                            ;       ACC1 détruit
        pulx
        inx                                 ; 3
        inx                                 ; 3
        inx                                 ; 3
        inx                                 ; 3 = 12 cycles
        stx INDEX
printSpaceBeforeStatementRomLIST:
        ldaa #cOS_SPACE                     ; ' '
        bra bcl7RomLIST

bcl5RomLIST:
        ldaa #cEDT_UNKNOWN                  ; '!'

bcl6RomLIST:
        ldx INDEX
        anda #$7F

bcl7RomLIST:

        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        ldaa 0,x
        inx
        tsta
        beq bcl2RomLIST
        cmpa #(cBAS_OFS_CMD-1)
isACharRomList:
        bls  bcl7RomLIST
        cmpa #cBAS_TOKEN_ALL_MAX
isAKnownTokenRomList:
        bhi  bcl5RomLIST
isATokenRomList
        bsr  BAS_searchTextBASIC            ; FCT : Recherche la position du nom de la commande
                                            ;       BASIC associée au code BASIC.
                                            ; IN  : A=code de la fonction BASIC A>= $80
                                            ;       X=position dans le source BASIC
                                            ; OUT : X=position en rom du texte du code BASIC recherché

next8RomLIST:
        ldaa 0,x
        bmi bcl6RomLIST
        inx
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        bra next8RomLIST
; End of function romLIST

; =============== S U B R O U T I N E =======================================
; FCT : Recherche la position du nom de la commande
;       BASIC associée au code BASIC.
; IN  : A=code de la fonction BASIC A>= $80
;       X=position dans le source BASIC
; OUT : X=position en rom du texte du code BASIC recherché

BAS_searchTextBASIC:
        suba #$7F
        stx INDEX
        ldx #aFOR

bclSearchTextBASIC:
        deca
        bne bcl1SearchTextBASIC
        rts

bcl1SearchTextBASIC:
        tst 0,x
        inx
        bpl bcl1SearchTextBASIC
        bra bclSearchTextBASIC
; End of function BAS_searchTextBASIC


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC FOR
; FOR PUSHES 20 BYTES ON THE STACK:
;  2 -- TXTPTR
;  2 -- LINE NUMBER
;  6 -- MAX VALUE for + TYPE OF NUMERIC
;  1 -- STEP SIGN
;  6 -- STEP VALUE + TYPE OF NUMERIC
;  2 -- ADDRESS OF "FOR VARIABLE" IN VARTAB
;  1 -- FOR TOKEN ($80)
; example : FOR I=1 to J : PRINT I,J : NEXT I
; IN  : le flot d'interprétation
; OUT : A,B,X modified

romFOR:
        ldaa #$80
        staa SUBFLG                         ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80: DISABLE SEARCH
getIndiceAndBeginningValue:
        jsr romLET                          ; FCT : effectue l'affectation d'une expression à une variable
                                            ; STX : A=SIN(3.14)
                                            ; OP  : $8D
                                            ; BUG : /
                                            ; IN  : le flot d'interprétation contenant le texte A=expr(B)
                                            ; OUT : /
        jsr CHKNUM                          ; Teste la numéricité de la valeur de départ (un peu tard dans le code, non ?)

isSameIndicRomFOR:                          ; est-ce que nous avons déjà une boucle FOR avec la même variable ?
        jsr FNDFOR                          ; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
                                            ; IN  : /
                                            ; OUT : A=0 : Token FOR trouvé
                                            ;       A=2 : Token GOSUB trouvé
                                            ;       V et C =0
                                            ;       Z=1 si A est null
                                            ;       N=1 si A est négatif
                                            ;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
        pulx                                ; POP RETURN ADRESS
        bne nextRomFOR
deadcodeRomFOR:
        ldx INDEX
        abx
        txs

nextRomFOR:
        ldab #(cBAS_BYTES_PER_FOR/2)        ; Vérifie qu'il y a bien assez de mémoire pour coder un FOR
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        jsr DATAN                           ; FCT : skip to end of statement ":" or null
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of statement ":" or null
                                            ;       A,B, modified
pshTXTPTRRomFOR:
        pshx                                ; Push TXTPTR

pshCURLINRomFOR:
        ldx CURLIN
        pshx                                ; Push CURLIN

isOpcodeTO:
        ldab #cBAS_TOKEN_TO                 ; $A2 ; opcode TO
        jsr SYNCHR                          ; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
                                            ; IN  : B=Opcode ou caractère à comparer
                                            ; OUT : X : not modified
                                            ;       A : le caractère suivant l'opcode ou caractère à comparer
                                            ;           si la comparaison de l'opcode est OK
        jsr FRMNUM                          ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour


testACC1Sign:
        ldab ACC1+5                         ; get ACC1 sign
        orab #$7F
        andb ACC1+1
        stab ACC1+1

isOpcodeSTEP:
        ldx #STEP                           ; Exécution de la fonction STEP !
        jmp FRM_STACK3                      ; sauvegarde ACC1 dans la pile et se débranche sur une routine pointée par X
; End of function romFOR


; =============== S U B R O U T I N E =======================================
; FCT : STEP PHRASE FOR NEXT
;       N'a pas sa propre existence !
; STX : FOR I=D TO F STEP P
; ALG : /
; OP  : $A2
; IN  : Pile initialisée avec un pas codé en float
; OUT : A,B,X modified

STEP:
        tst NUMTYP
        beq nextSTEP
        ldx #cONE
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
        bra next1STEP
nextSTEP:
        ldab #$01
        jsr returnByteIntRomLEN
next1STEP:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        cmpa #cBAS_TOKEN_STEP               ; TODO : $A5 : TOKEN STEP
        bne next2STEP

getValueForSTEP:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        jsr FRMNUM                          ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour


next2STEP:
        jsr subSIGN                         ; FCT : retourne le signe du nombre réel contenu dans ACC1
                                            ; IN  : /
                                            ; OUT : B=$01 si ACC1 > 0
                                            ;       B=$00 si ACC1 = 0
                                            ;       B=$FF si ACC1 < 0
        jsr FRM_STACK2                      ; FCT : Sauvegarde ACC1 dans la pile
                                            ; IN  : B=le signe d'ACC1
                                            ; OUT : B and X modified
                                            ;       A not modified
                                            ;       PILE : ACC1 sauvegardé en pile
        ldx FORPNT                          ; TODO : ???? commentaire ?
        pshx
        ldaa #cBAS_TOKEN_FOR                ; Opcode "FOR" !
        psha
; End of function STEP

; =============== S U B R O U T I N E =======================================
; FCT : perform next statement
; IN  : le flot d'interprétation
; OUT : /

NEWSTT:
        bsr ISCNTC                          ; FCT : Test si touche BREAK ou SHIFT+@(PAUSE) pressée
                                            ;       Sinon écrit A dans le tampon clavier
                                            ; IN  : /
                                            ; OUT : A=code ASCII de la touche pressée
        ldx TXTPTR                          ; look at current character
        stx TMPTXT                          ; SAVE IN CASE OF RESTART BY INPUT

CHKSTT:
        ldaa 0,x
        beq nextNEWSTT

isSEPSTT:
        cmpa #cBAS_SEP                      ; est-ce que nous rencontrons le séparateur d'instruction ':' ?
        beq NEWSTT2

jmpSyntaxError:
        jmp setError0x02_SYNTAXERROR

nextNEWSTT:
        inx
        ldaa 0,x
        inx
        oraa 0,x
        staa ENDSTT                         ; Indique si la fin du programme a été rencontré
        beq next1RomEND                     ; Si oui alors on reinitialise certains pointeurs et nous affichons le prompt
        inx

getLineSTT:
        ldd 0,x
        std CURLIN                          ; met à jour le numéro de ligne suite à une nouvelle instruction
        inx
        stx TXTPTR                          ; met à jour le pointeur de texte à interpreter

doDEBUG:
        ldaa fTRACE                         ; get TRON flag
        beq NEWSTT2                         ; not tracing skip
        ldaa #$5B                           ; print '['
        jsr OS_printCHARByDevice
        ldd CURLIN                          ; get line number
        jsr ULIPTR                          ; FCT : Imprime le nombre non signé contenu dans D
                                            ; IN  : D : le nombre non signé à afficher
                                            ; OPT : oui. A été réécrit pour être plus rapide
                                            ; IN  : D : 0 à 65536 ( entier non relatif )
                                            ; OUT : A,B,X modified
                                            ;       ACC1 détruit
        ldaa #$5D                           ; print closing ']'
        jsr OS_printCHARByDevice
NEWSTT2:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bsr EXECUTE_STATEMENT               ; FCT : exécute a statement
                                            ; IN  : A is first char of statement
                                            ;       C is set
                                            ; OUT : A,B,X modified
        bra NEWSTT                          ; FCT : perform next statement
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /
; End of function NEWSTT

; =============== S U B R O U T I N E =======================================
; FCT : execute a statement
; IN  : A is first char of statement
;       C is set
; OUT : A,B,X modified

EXECUTE_STATEMENT:
        beq saveAndendRomRESTORE

EXEC_STAT1:
        tsta
        bmi doJmpInstruction
        jmp romLET                          ; FCT : effectue l'affectation d'une expression à une variable
                                            ; STX : A=SIN(3.14)
                                            ; OP  : $8D
                                            ; BUG : /
                                            ; IN  : le flot d'interprétation contenant le texte A=expr(B)
                                            ; OUT : /

doJmpInstruction:
        cmpa #cBAS_TOKEN_CMD_MAX            ; $AD ; ' ' ; token SKIPF : nombre maximal de commandes BASIC
        bhi jmpSyntaxError
        asla
        tab
        ldx #jmpINSTRUCTION
        abx
        ldx 0,x
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        jmp 0,x
; End of function EXECUTE_STATEMENT

; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC RESTORE : permet d'initialiser le
;       pointeur des DATA au début du programme ou à une ligne N
; STX : 100 RESTORE
;       110 RESTORE 200
;       120 C=50:RESTORE C
; OP  : $8F
; ST  : ACTIF
; IN  : Z=1 alors parametre
; OUT : /

romRESTORE:
        bne getParamRESTORE
        ldx TXTAB                           ; début du programme basic
decRomRESTORE:
        dex
saveAndendRomRESTORE:
        stx DATPTR                          ; DATA STATEMENT ADDRESS POINTER
endRomRESTORE:
        rts

getParamRESTORE:
        jsr jsrFRMNUMAndMKINT               ; FCT : interprétre une expression de type int et retourne une valeur de type word
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : D=résultat de l'interprétation de l'expression
        std LINUM
        jsr FNDLIN                          ; FCT : FNDLIN SEARCHES THE PROGRAM TEXT FOR THE LINE
                                            ;       WHOSE NUMBER IS PASSED IN "LINUM".
                                            ;       THERE ARE TWO POSSIBLE RETURNS:
                                            ;       1) CARRY SET.
                                            ;          LOWTR POINTS TO THE LINK FIELD IN THE LINE
                                            ;          WHICH IS THE ONE SEARCHED FOR.
                                            ;
                                            ;       2) CARRY NOT SET.
                                            ;          LINE NOT FOUND. [LOWTR] POINTS TO THE LINE IN THE
                                            ;          PROGRAM GREATER THAN THE ONE SOUGHT AFTER.
                                            ; IN  : /
                                            ; OUT : C=1 : Ligne trouvée
                                            ;       X=Position en mémoire de la ligne trouvée
        bcc decRomRESTORE
        ldab #cBAS_ERR_UNDEFLINE
        jmp ERROR
; End of function romRESTORE

; =============== S U B R O U T I N E =======================================
; FCT : Test si touche BREAK ou SHIFT+@(PAUSE) pressée
;       Sinon écrit A dans le tampon clavier
; IN  : /
; OUT : A=code ASCII de la touche pressée

ISCNTC:
        jsr getKeyPressed                   ; FCT : détermine si on a appuyé sur les touches de contrôles
                                            ;       et une autre touche
                                            ; IN  : /
                                            ; OUT : A=0 : CTRL is pressed
                                            ;       A<>0 : other key pressed
        beq endTestKeyPause

isHITKEY_BREAK:
        cmpa #cKB_BREAK
        beq romSTOP                         ; FCT : CMD BASIC STOP : permet d'arrêter le programme
                                            ; STX : STOP
                                            ; OP  : $91
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : /

isHITKEY_SHIFT_ARROBASE:
        cmpa #cKB_SHIFT_ARROBASE
        beq waitHitKeyList
        staa CHARKBD

endTestKeyPause:
        rts

waitHitKeyList:
        jsr OS_POLCA                        ; FCT : polling keyboard
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche actionnée
                                            ;       X,B not modified
        beq waitHitKeyList
        bra isHITKEY_BREAK
; End of function ISCNTC


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC STOP : permet d'arrêter le programme
; STX : STOP
; OP  : $91
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : /

romSTOP:
        sec
; End of function romSTOP


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC END : arrête le programme
; STX : 100 END
; OP  : $89
; ST  : ACTIF
; IN  : /
; OUT : /

romEND:
        bne endRomCont
        ldx TXTPTR
        stx TMPTXT

nextRomEND:
        ror ENDSTT                          ; Indique si la fin du programme a été rencontré
        pulx

next1RomEND:
        ldx CURLIN
        inx
        beq next2RomEND
        dex
        stx OLDLIN
        ldx TMPTXT
        stx OLDTXT

next2RomEND:
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        ldx #(aBreak)                       ; "\rBREAK"
        tst ENDSTT                          ; Indique si la fin du programme a été rencontré
        bpl next3RomEND_restart
        ldab 0,x
        inx
        jmp printMsgErrorAndWaitInputFromUser

next3RomEND_restart:
        jmp INTERPRETATION                  ; FCT : INTERPRETATION
                                            ; IN  : /
                                            ; OUT : /
; End of function romEND

; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC CONT : permet de reprendre le programme après un break
; STX : CONT
; OP  : $93
; ST  : ACTIF
; IN  : /
; OUT : /

romCONT:
        bne endRomCont
        ldab #cBAS_ERR_CANTCONT             ; ' '  ; set error to 0X20 : can't continue
        ldx OLDTXT
        bne nextRomCONT
        jmp ERROR

nextRomCONT:
        stx TXTPTR
        ldx OLDLIN
        stx CURLIN

endRomCont:
        rts
; End of function romCONT


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC CLEAR : CLEAR : initialise variable et réserve 100 octets pour les string
; STX : CLEAR nombre : init var et réserve nombre octets pour les string
;       CLEAR N1,N2 avec N1 < N2 et n1 mémoire basse et n2 mémoire haute
; OP  : $95
; ST  : ACTIF
; BUG : /
; IN  : le flot à interpreter
; OUT : A,B,X modified

romCLEAR:
        beq jmpNextSetPTRS_CLEAR

getFirstPrm_RomCLEAR:
        jsr jsrFRMNUMAndMKINT               ; FCT : interprétre une expression de type int et retourne une valeur de type word
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : D=résultat de l'interprétation de l'expression
        pshb                                ; sauvegarde le premier paramètre
        psha
        ldx MEMSIZ                          ; Adresse - 1 de la fin de la RAM DISPONIBLE
        stx ACC1+3
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq nextCLEAR

getSecondPrm_RomCLEAR:
        jsr CHKCOM
        jsr getArg                          ; FCT : récupère un word dans le flot d'inteprétation
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=WORD from ARGUMENT
                                            ;       ACC1+3 et ACC1+4 contiennent aussi l'expression convertie de type word
        dex
        stx ACC1+3
        ldd ADRENDMEM                       ; Adresse de la fin de mémoire
        subd ACC1+3
        bcs jmpMEMERR

nextCLEAR:
        ldd ACC1+3
        pshb
        psha
        tsx
        subd 2,x
        bcs jmpMEMERR
        std 2,x
        subd #cBAS_OFS_STK
        bcs jmpMEMERR
        subd VARTAB                         ; Fin du programme BASIC / début des variables
        bcs jmpMEMERR
        pulx
        stx MEMSIZ                          ; Adresse - 1 de la fin de la RAM DISPONIBLE
        pulx
        stx BOTSTK

jmpNextSetPTRS_CLEAR:
        jmp nextSetPTRS_CLEAR

jmpMEMERR:
        jmp MEMERR                          ; FCT : Point d'entrée secondaire pour la gestion d'erreur
                                            ;       il correspond à "plus de place disponible en mémoire"
                                            ; IN  : /
                                            ; OUT : A,B,X modified
; End of function romCLEAR

; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC RUN : permet de lancer un programme au début
;       ou à un numéro de ligne donnée en paramètre
; STX : RUN
;       RUN numéro_de_ligne
; OP  : $8E
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : /

romRUN:
        bne nextRomRUN
        jmp SETPTRS                         ; FCT : Erase all pointers
                                            ; IN  : /
                                            ; OUT : A,X modified

nextRomRUN:                                 ; partie RUN XXXX
        jsr nextSetPTRS_CLEAR
        bra nextRomGOSUB
; End of function romRUN


; =============== S U B R O U T I N E =======================================
; FCT :
;  "GOSUB" STATEMENT
;  LEAVES 5 ou 7 BYTES ON STACK
;  2 -- RETURN ADDRESS (NEWSTT)
;  2 -- TXTPTR
;  2 -- LINE #
;  1 -- GOSUB TOKEN
; OP  : $82
; IN  : /
; OUT : /

romGOSUB:
        ldab #$03
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        ldx TXTPTR
        pshx
        ldx CURLIN
        pshx
        ldaa #cBAS_TOKEN_GOSUB              ; $82 ; '‚'     ; opcode GOSUB
        psha

nextRomGOSUB:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        bsr romGOTO                         ; FCT : Effectue un saut à la ligne L
                                            ; STX : 10 GOTO 100 ==> OK
                                            ;       10 GOTO A   ==> KO
                                            ; OP  : $81
                                            ; IN  : le flot d'interprétation qui doit contenir un numéro de ligne
                                            ; OUT : /
        jmp NEWSTT                          ; FCT : perform next statement
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /
; End of function romGOSUB

; =============== S U B R O U T I N E =======================================
; FCT : Effectue un saut à la ligne L
; STX : 10 GOTO 100 ==> OK
;       10 GOTO A   ==> OK
; OP  : $81
; IN  : le flot d'interprétation qui doit contenir un numéro de ligne
; OUT : /

romGOTO:
        jsr jsrFRMNUMAndMKINT               ; FCT : interprétre une expression de type int et retourne une valeur de type word
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : D=résultat de l'interprétation de l'expression
        std LINUM
        bsr REMN                            ; FCT : skip to end of line
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of line
                                            ;       A,B modified
        inx
        ldd LINUM
        subd CURLIN
        bhi nextRomGOTO
        ldx TXTAB                           ; début du programme basic

nextRomGOTO:
        jsr bclFNDLIN
        bcc next1RomGoto
        ldab #cBAS_ERR_UNDEFLINE
        jmp ERROR
next1RomGoto:
        dex
        stx TXTPTR

endRomGOTO:
        rts
; End of function romGOTO

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC RETURN : Ramène l'exécution du programme à l'instruction qui suit le GOSUB
; STX : RETURN
; OP  : $90
; ST  : ACTIF
; IN  : /
; OUT : A,B,X modified
; ERR : $04 : RETURN sans GOSUB
romRETURN:
        bne endRomGOTO                      ; RETURN ne peut-être que par une fin de ligne ou un séparateur d'instruction
        ldaa #$FF
        staa FORPNT
        jsr FNDFOR                          ; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
                                            ; IN  : /
                                            ; OUT : A=0 : Token FOR trouvé
                                            ;       A=2 : Token GOSUB trouvé
                                            ;       V et C =0
                                            ;       Z=1 si A est null
                                            ;       N=1 si A est négatif
                                            ;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
        txs
        cmpa #(cBAS_TOKEN_GOSUB-cBAS_TOKEN_FOR) ; $02 ; A-t-on trouvé l'opcode GOSUB ? (A contient un delta de code de token)
        beq doRETURN                        ; oui alors on revient sur la ligne basic contenant le GOSUB d'appel

jmpERROR_0X04_RETURNWITHOUTGOSUB:
        ldab #cBAS_ERR_NOGOSUB
        jmp ERROR

doRETURN:
        pula                                ; pop opcode
        pulx                                ; pop call line
        stx CURLIN
        pulx                                ; pop next statement on call line
        stx TXTPTR

; =============== S U B R O U T I N E =======================================
; FCT : Instruction BASIC pour enregistrer des données séquentielles
; OP  : $85
; BUG : /
; IN  : le flot d'interprétation contenant les données séquentielles
; OUT : en mode interprétation ignore la ligne contenant les data

romDATA:
        bsr DATAN                           ; FCT : skip to end of statement ":" or null
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of statement ":" or null
                                            ;       A,B, modified
        stx TXTPTR

endRomDATA:
        rts
; End of function romDATA


; =============== S U B R O U T I N E =======================================
; FCT : skip to end of statement ":" or null
; IN  : TXTPTR is set
; OUT : X=pointer on end of statement ":" or null
;       A,B modified
DATAN:
        ldab #cBAS_SEP                      ; ':'
        SKIP_BYTE
; End of function DATAN


; =============== S U B R O U T I N E =======================================
; FCT : skip to end of line
; IN  : TXTPTR is set
; OUT : X=pointer on end of line
;       A,B modified
REMN:
        clrb
entryREMN:
        stab CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        clrb
        ldx TXTPTR

bclREMN:
        tba
        ldab CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire

bcl1REMN:
        ldaa 0,x
        beq endRomDATA
        cba
        beq endRomDATA
        inx
        cmpa #cBAS_SEP_STR                  ; '"'
        beq bclREMN
        cmpa #cBAS_TOKEN_IF
        bne bcl1REMN
        inc CNTIF
        bra bcl1REMN
; End of function REMN


; =============== S U B R O U T I N E =======================================
; FCT : Commande BASIC IF / gère aussi le ELSE !
; STX : IF A THEN 10
;       IF A GOTO 10
;       IF A THEN GOTO 10
;       IF A THEN IF B = 0 THEN PRINT A : ELSE PRINT B : ELSE PRINT A,B
;       La syntaxe du ELSE nécessite le séparateur ':' avant celui-ci !
; OP  : $84
; BUG : /
; IN  : le flot à interpréter suivant le IF
; OUT : /

romIF:
        jsr FRMNUM                          ; FCT : EVALUATE EXPRESSION, MAKE SURE IT IS NUMERIC
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation

isOpcodeGOTO:
        cmpa #cBAS_TOKEN_GOTO               ; $81 ; Opcode GOTO
        beq endRomIF

isOpcodeTHEN:
        ldab #cBAS_TOKEN_THEN               ; Opcode THEN
        jsr SYNCHR                          ; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
                                            ; IN  : B=Opcode ou caractère à comparer
                                            ; OUT : X : not modified
                                            ;       A : le caractère suivant l'opcode ou caractère à comparer
                                            ;           si la comparaison de l'opcode est OK

endRomIF:
        ldaa ACC1
        beq statementRomELSE                ; FCT : gestion spécifique de la séquence suivant le IF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /

statementRomTHEN:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        bcs romGOTO                         ; FCT : Effectue un saut à la ligne L
                                            ; STX : 10 GOTO 100 ==> OK
                                            ;       10 GOTO A   ==> KO
                                            ; OP  : $81
                                            ; IN  : le flot d'interprétation qui doit contenir un numéro de ligne
                                            ; OUT : /
        jmp EXECUTE_STATEMENT               ; FCT : exécute a statement
                                            ; IN  : A is first char of statement
                                            ;       C is set
                                            ; OUT : A,B,X modified

statementRomELSE:
        clr CNTIF

bclStatementRomELSE:
        bsr romDATA ; DATAN                 ; move basic's pointer to end of subline

        tsta                                ; test if end of line or end of subline
        beq endRomDATA                      ; end of line : return
                                            ; get next character
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #cBAS_TOKEN_ELSE               ; is it an ELSE token?
        bne bclStatementRomELSE             ; no : ignore
        dec CNTIF                           ; dec else counter
        bpl bclStatementRomELSE             ; look for next else, if counter <>0
                                            ; get character from basic
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1

endStatementRom_ELSE:
        jmp statementRomTHEN                ; else
; End of function romIF



; =============== S U B R O U T I N E =======================================
; FCT : Instruction BASIC pour mettre en commentaire
; STX : REM mon commentaire
; OP  : $83
; IN  : le flot d'interprétation
; OUT : TXTPTR pointe sur la prochaine instruction

romREM:
        bsr REMN                            ; FCT : skip to end of line
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of line
                                            ;       A,B modified
        stx TXTPTR
        rts
; End of function romREM


; =============== S U B R O U T I N E =======================================
; FCT : Branche vers un numéro de ligne selon la valeur "variable"
; STX : ON variable GOTO n1,n2,...
;       ON variable GOSUB n1,n2,...
; OP  : $87
; BUG : /
; IN  : le flot d'interprétation contenant le reste de l'instruction (variable GOTO n1,...)
; OUT : /

romON:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        psha
        cmpa #cBAS_TOKEN_GOSUB              ; $82 ; TOKEN GOSUB
        beq bcl1NextRomOn
        cmpa #cBAS_TOKEN_GOTO               ; $81 ; TOKEN GOTO

nextRomON:
        beq  bcl1NextRomOn
        jmp setError0x02_SYNTAXERROR

bcl1NextRomOn:

        dec ACC1+4
        bne next2RomON
        pula
        jmp EXEC_STAT1

next2RomON:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        cmpa #cBAS_SEP_ARG                  ; ','
        beq bcl1NextRomOn
        ins

endRomON:
        rts
; End of function romON

; =============== S U B R O U T I N E =======================================
; FCT : Obtient un numéro de ligne dans le flux d'entrée
; IN  : le flot à interpréter via CHRGET
;       A=contient le premier chiffre à convertir
; OUT : LINUM = numéro de ligne obtenu en première position
;       dans le flot à interpréter

LINGET:
        ldx #$0000
        stx LINUM

bclLINGET:
        bcc endRomON
        suba #$30                           ; '0'
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        ldd LINUM
        cmpa #cHI_NbMaxLigne                ; test si on a atteint le numéro maximal de ligne (63999 / 10) = 6399 = $18FF donc $18
        bhi nextRomON
        lsld                                ; D = LINUM * 2
        lsld                                ; D = LINUM * 4
        addd LINUM                          ; D = LINUM * 5
        lsld                                ; D = LINUM * 10
        addb CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        adca #$00
        std LINUM                           ; LINUM = LINUM * 10 + A
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bra bclLINGET
; End of function LINGET

; =============== S U B R O U T I N E =======================================
; FCT : effectue l'affectation d'une expression à une variable
; STX : A=SIN(3.14) ou I%=4+5
; OP  : $8D
; BUG : /
; IN  : le flot d'interprétation contenant le texte A=expr(B)
; OUT : /

romLET:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
                                            ;       Met à jour NUMTYP et STRTYP selon le type de variable
        stx FORPNT                          ; stocke le pointeur sur la variable pour plus tard
        ldab #cBAS_TOKEN_egal               ; $AF : token EQUAL
        jsr SYNCHR                          ; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
                                            ; IN  : B=Opcode ou caractère à comparer
                                            ; OUT : X : not modified
                                            ;       A : le caractère suivant l'opcode ou caractère à comparer
                                            ;           si la comparaison de l'opcode est OK
saveTypeRomLet:
        ldaa NUMTYP                         ; type de la variable en cours : $00:int, $FF:float
        psha
        ldaa STRTYP                         ; type de la variable en cours : $FF:alpha, $00:numeric
        psha
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flux d'entrée
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
        pula                                ; Récupération du type de la variable à mettre à jour
        rora                                ; TODO : A REFAIRE: $00 => $00 & C=0, $01=>$00 & C=1;$FF=>$7F & C=1
        jsr CHKVAL                          ; FCT : Le type de l'interprétation est-il bien attendu celui attendu (C=0 : numérique, C=1 : chaîne de caracteres)  ?
                                            ; ERR : Type incompatible
                                            ; IN  : NUMTYP et  STRTYP à jour & C à jour : si C=1 nous attendons une chaîne, si C=0 nous attendons un type numérique
                                            ; OUT : / - TODO : euh ... cela retourne une valeur ...
        beq saveNumericRomLET
        pula                                ; pop previous numeric type (adjust stack)
entrytRomLET_STRING:                        ; secondary entry (call by READ/INPUT)
        ldx ACC1+3
        ldd BOTSTK
        subd 2,x
        bcc next1RomLET
        ldd VARTAB                          ; Fin du programme BASIC / début des variables
        subd ACC1+3
        bhi next1RomLET

codeMortRomLET_STRING:
        ldab 0,x
        jsr STRINI                          ; FCT : GET SPACE AND MAKE DESCRIPTOR FOR STRING WHOSE ADDRESS IS IN X
                                            ;       AND WHOSE LENGTH IS IN B-REG
                                            ; IN  : X=pointer on string
                                            ;       B=taille de la chaîne à réserver
                                            ; OUT : DESCSTR mise à jour
        ldx DSCPTR
        jsr MOVSTR_IND                      ; FCT : Déplace une zone mémoire dont la source est donnée
                                            ;       indirectement par X et la cible par le pointeur contenu
                                            ;       dans FREESPC
                                            ; IN  : X=source de la zone à copier
                                            ;       B=nombre d'octet à copier
                                            ; OUT : A, X,B modified
        ldx #ACC1

next1RomLET:
        stx DSCPTR
        jsr FRETMS                          ; FCT : RELEASE TEMPORARY DESCRIPTOR IF X = LASTPT
                                            ; IN  : X=pointeur
                                            ; OUT : si X=LASTPT alors
                                            ;         TMPPT=X et LASTP=X-5
                                            ;         A=0
                                            ;       sinon rien
        ldx DSCPTR
        ldaa 0,x
        psha
        ldd 2,x
        ldx FORPNT
        std 2,x
        pula
        staa 0,x
        rts

saveNumericRomLET:
        pula                                ; pop numeric type for variable to let
        anda #$7F                           ; rendre compatible NUMTYP avec ACC1TYPFLG ($FF=$7F / $00=$00)
        ldab ACC1TYPFLG
        cba                                 ; same type (int = int or float = float) ? No then Type Mismatch
        bne errTypMisMatchRomLET
        tstb
        beq saveIntRomLET
        jmp saveACC1byFORPNT
saveIntRomLET:
        jmp beforeMOVIA1toM

errTypMisMatchRomLET:
        ldab #cBAS_ERR_TYPEMISM
        jmp ERROR
; End of function romLET


; =============== S U B R O U T I N E =======================================
; FCT : Imprime les expressions sur l'imprimante
; STX : LPRINT A;B
; OP  : $9A
; ST  : ACTIF
; IN  : le flot à interpreter
; OUT : A,B,X modified

romLPRINT:
        jsr setDeviceToPrinter              ; FCT : Positionne le device à PRINTER(=$FE)
                                            ;       Lit le caractère en cours
                                            ; IN  : /
                                            ; OUT : A=CHRGOT() & B modified
; End of function romLPRINT

; =============== S U B R O U T I N E =======================================
; FCT : Imprime les expressions sur l'écran
; RMQ : Etrangement, en fin de traitement, le "device de sortie" est intialisé à zéro
;       pourquoi ?
; STX : PRINT A;B
; OPT : TODO : supprimer le bsr doRomPRINT ?
; OP  : $86
; ST  : ACTIF
; IN  : le flot à interpreter
; OUT : A,B,X modified

romPRINT:
        bsr doRomPRINT                      ; FCT : COMMANDE BASIC D'AFFICHAGE
                                            ;       PRINT A ; "TITI", 2*A ; @10,TITI
                                            ; IN  : A=le caractère suivant le PRINT
                                            ; OUT : /
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        rts
; End of function romPRINT


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC D'AFFICHAGE
; STX : 10  PRINT A ; "TITI", 2*A ; @10,TITI
;       20 PRINT AT 5,6 "MY TEXT"
; IN  : A=le caractère suivant le PRINT
; OUT : A,B,X modified

doRomPRINT:

        beq OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
isPosPhysRomPRINT:
        cmpa #cKB_ARROBASE                  ; '@' : positionnement physique à l'écran
        bne nextDoRomPRINT

doRomPrint_ARROBASE:
        jsr gepPARAM_ARROBASE               ; FCT : récupère le paramètre numérique suivant le @ de PRINT @
                                            ;       vérifie que le paramètre est bien dans l'intervalle
                                            ;       en nombre de caractères de l'écran.
                                            ;       Et oui ! on ne donne pas X et Y directement !
                                            ; IN  ; /
                                            ; OUT : D=CURAD_YX=nouvelle position imposée par D
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        jsr CHKCOM

nextDoRomPRINT:

        beq endInitParamByMode              ; TODO : un rst plus proche ?

bcl1DoRomPRINT:
        cmpa #cBAS_TOKEN_AT                 ; TODO : $XX : positionnement logique à l'écran
        bne bcl0DoRomPRINT

doATromPRINT:
                                            ; Augmente artificiellement le pointeur sur le flot d'interprétation pour que l'appel romAT se passe bien
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        jsr romAT
        bra bcl1DoRomPRINT

bcl0DoRomPRINT:
        cmpa #cBAS_TOKEN_TAB                ; TODO : $BB
        beq doPRINT_TAB
        cmpa #cBAS_SEP_ARG                  ; ','
        beq doPRINT_COMMA
        cmpa #cBAS_SEP_VAR                  ; ';'
        beq doPRINT_SEMICOMMA

evalRomPRINT:
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flux d'entrée
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
        tst STRTYP                          ; type de la variable en cours : $00:numeric, $FF:alpha
        bmi next2DoRomPRINT
        jsr FOUT                            ; FCT : CONVERT (ACC1) TO STRING
                                            ; IN  : ACC1 à jour
                                            ; OUT : X=Pointeur sur le tampon de conversion Float -> String
        jsr DECXbeforeSTRLIT                ; FCT : DEC X AND BUILD A DESCRIPTOR FOR STRING STARTING AT X
                                            ;       AND TERMINATED BY $00 OR QUOTATION MARK
                                            ;       RETURN WITH DESCRIPTOR IN A TEMPORARY
                                            ;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
                                            ; ST  : ACTIF
                                            ; IN  : X=string to create an descriptor
                                            ; OUT : A,B,X modified

next2DoRomPRINT:                            ; PRINT A STRING VARIABLE
        bsr nextOUTTX
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        cmpa #cBAS_SEP_ARG                  ; ','
        beq doPRINT_COMMA
        bsr OS_printESPACE                  ; Imprime autant d'espace qu'il faut pour le tab

next3DoRomPRINT:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        bne bcl1DoRomPRINT
; End of function doRomPRINT


; =============== S U B R O U T I N E =======================================
; FCT : effectue un retour à la ligne
; IN  : /
; OUT : A modified

OS_printCR:
        ldaa #cOS_CR
        jmp OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
; End of function printCR

; =============== S U B R O U T I N E =======================================:

; FCT : Permet d'initialiser les paramètres de l'écran ou de l'imprimante
;       selon la variable DEVNU
; IN  : DEVNU à jour
; OUT : A,B,X modified
; OPT : TODO : à voir l'utilité de ce code

initParamByMode:
        jsr doinitParamByMode               ; FCT : Initialise le paramétrage des abscisses pour le device (DEVNU=0: écran sinon imprimante)
                                            ; IN  : DEVNU Initialisé : =$00 écran sinon imprimante
                                            ; OUT : A,B,X unmodified
        beq OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        ldaa DEVXCURR                       ; vaut $00 à l'init
        bne OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
endInitParamByMode:
        rts
; End of function initParamByMode

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR doRomPRINT

doPRINT_COMMA:

        jsr doinitParamByMode               ; FCT : Initialise le paramétrage des abscisses pour le device (DEVNU=0: écran sinon imprimante)
                                            ; IN  : DEVNU Initialisé : =$00 écran sinon imprimante
                                            ; OUT : A,B,X unmodified
        beq nextDOPRINT_COMMA
        ldab DEVXCURR                       ; vaut $00 à l'init
        cmpb DEVXMARGIN+1                   ; Marge GAUCHE/DROITE pour les tabulations
                                            ; CLS 81  : $10,$40
                                            ; CLS 40  : $10,$10
                                            ; CLS 32  : $10,$10
                                            ; PRINTER : $10,$70
        bcs bcl1DOPRINT_COMMA
        bsr OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        bra doPRINT_SEMICOMMA

nextDOPRINT_COMMA:
        ldab DEVXCURR                       ; vaut $00 à l'init

bcl1DOPRINT_COMMA:

        subb DEVXMARGIN                     ; Marge GAUCHE/DROITE pour les tabulations
                                            ; CLS 81 : $10,$40
                                            ; CLS 40 : $10,$10
                                            ; CLS 32 : $10,$10
                                            ; PRINTER : $10,$70
        bcc bcl1DOPRINT_COMMA
        negb
        bra bcl1DoPRINT_TAB

doPRINT_TAB:
        jsr GETBYTC                         ; FCT: SCAN TO NEXT CHARACTER AND CONVERT EXPRESSION
                                            ;      TO SINGLE BYTE IN B-REG
                                            ; IN : Le flot d'interprétation
                                            ; OUT: B=byte converted from expression
                                            ;      A=next char after expression
        cmpa #cBAS_FCT_CLOSE                ; ')'
        beq nextDoPRINT_TAB
        jmp setError0x02_SYNTAXERROR

nextDoPRINT_TAB:
        jsr doinitParamByMode               ; FCT : Initialise le paramétrage des abscisses pour le device (DEVNU=0: écran sinon imprimante)
                                            ; IN  : DEVNU Initialisé : =$00 écran sinon imprimante
                                            ; OUT : A,B,X unmodified
        subb DEVXCURR                       ; vaut $00 à l'init
        bls doPRINT_SEMICOMMA

bcl1DoPRINT_TAB:
        bsr OS_printESPACE                  ; Imprime autant d'espace qu'il faut pour le tab
        decb
        bne bcl1DoPRINT_TAB

doPRINT_SEMICOMMA:

        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        jmp nextDoRomPRINT
; END OF FUNCTION CHUNK FOR doRomPRINT

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC AT X,Y : positionne le curseur à la position X,Y
;       peut-être utilisdé autonome ou avec print
;       10 AT 10,20
;       20 PRINT AT 10,20
;       40 PRINT AT 10,20,"TITI"
; STX : AT X,Y
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : le flot d'interprétation
; OUT : A,B,X modified


romAT:

getXRomAT:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        cmpb SCR_LGX                        ; Taille max en pixel pour X
        bcc jmpPrintErrorMSg0x08_FC_03
        stab CURAD_YX+1

getYRomAT:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        cmpb SCR_LGY                        ; Taille max en pixel pour Y
        bcc jmpPrintErrorMSg0x08_FC_03
        stab CURAD_YX
        rts

jmpPrintErrorMSg0x08_FC_03:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT: OUTTX émission d'une chaîne de caractères terminée par 0
; IN : X=pointeur sur une chaîne de caractères terminée par un 0
; OUT: A,B,X modified

OS_OUTTX:
        jsr STRLIT                          ; FCT : BUILD A DESCRIPTOR FOR STRING STARTING AT X
                                            ;       AND TERMINATED BY $00 OR QUOTATION MARK
                                            ;       RETURN WITH DESCRIPTOR IN A TEMPORARY
                                            ;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
                                            ; ST  : ACTIF
                                            ; IN  : X=string to create an descriptor
                                            ; OUT : A,B,X modified

nextOUTTX:
        jsr FREFAC                          ; FCT : Libére la zone réservée par descripteur (chaîne de caractères)
                                            ; IN  : ACC1+3 et ACC1+4 : contient le descripteur
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne
        incb

bclOUTTX:
        decb
        beq endInitParamByMode
        ldaa 0,x
        inx
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
        bra bclOUTTX
; End of function OS_OUTTX


; =============== S U B R O U T I N E =======================================
OS_printESPACE:
        ldaa #cOS_SPACE                     ; ' '
        jmp OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
; End of function OS_printESPACE

; =============== S U B R O U T I N E =======================================
OS_printPtInterrogation:
        ldaa #cBAS_QUESTION_MARK            ; '?'
        jmp OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
; End of function OS_printPtInterrogation

; ---------------------------------------------------------------------------
aptinterrogationREDO:dc.b   7,"?REDO",$D,0

; =============== S U B R O U T I N E =======================================
; FCT : Gestion erreur de la partie READ
; IN  : INPUTFLG
; OUT : /

setErrINPUT_READ:
        ldaa INPUTFLG                       ; =$00:INPUT,=$4F:READ
        beq printMsgError_REDO
        ldx DATTXT                          ; DATA STATEMENT LINE NUMBER POINTER
        stx CURLIN
        jmp setError0x02_SYNTAXERROR

printMsgError_REDO:
        ldx #(aptinterrogationREDO)         ; "?REDO\r"
        ldab 0,x
        inx
        jsr bclOUTTX
        ldx TMPTXT
        stx TXTPTR

endSetErrINPUT_READ:
        rts
; End of function setErrINPUT_READ


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC INPUT : permet à l'utilisateur de saisir des données
; STX : 100 INPUT A$
;       110 INPUT B
; OP  : $88
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : /

romINPUT:
        ldab #cBAS_ERR_ILLDIR               ; set message to $16 : instruction interdite en mode direct
        ldx CURLIN
        inx
        bne isStrRomInput
        jmp ERROR

isStrRomInput:
        cmpa #cBAS_SEP_STR                  ; '"'
        bne next1RomINPUT
        jsr doStringEVAL

waitPtVirg_ROMINPUT:
        ldab #cBAS_SEP_VAR                  ; ';'
        jsr SYNCHR                          ; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
                                            ; IN  : B=Opcode ou caractère à comparer
                                            ; OUT : X : not modified
                                            ;       A : le caractère suivant l'opcode ou caractère à comparer
                                            ;           si la comparaison de l'opcode est OK
        jsr nextOUTTX

next1RomINPUT:
        bsr OUTQUES                         ; FCT : Affiche un point d'interrogation et attend une saise utilisateur
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur
        ldab #cBAS_SEP_ARG                  ; ','
        stab $00,x
        bra nextRomRead
; End of function romINPUT


; =============== S U B R O U T I N E =======================================
; FCT : Affiche un point d'interrogation et attend une saise utilisateur
; ST  : ACTIF
; IN  : /
; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur

OUTQUES:
        jsr OS_printPtInterrogation
        jsr OS_printESPACE                  ; Imprime autant d'espace qu'il faut pour le tab
        jsr INKBD                           ; FCT : Attend une saisie utilisateur
                                            ;       gére les touches spécifiques
                                            ;       BREAK  : sort du programme !
                                            ;       CTRL+A : effacement de la saisie en cours
                                            ;       CTRL+Q : effacement d'un caractère
                                            ;       RETURN : fin de la saisie utilisateur
                                            ; IN  : /
                                            ; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur
                                            ;       C=0 : saisie utilisateur
                                            ;       C=1 : saisie d'une touche de contrôle
        bcc endSetErrINPUT_READ
BUGOUTQUES:
        pulx                                ; pop return address
        jmp nextRomEND
; End of function OUTQUES


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC READ : lit l'entrée pour l'affecter au(x) variable() qui sui(ven)t READ
; STX : READ A[,B[...]]
; OP  : $8C
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : A,B,X modified

romREAD:
        ldx DATPTR                          ; DATA STATEMENT ADDRESS POINTER
        SKIP_BYTE                           ; dc.b $86 : Si le point d'entrée est romRead alors A=$4F
                                            ; car $86 $4F ldaa 0x4F (SKIP_BYTE CLRA)

nextRomRead:
        clra
        staa INPUTFLG                       ; =$00:INPUT,=$4F:READ
        stx INPTR

bcl1RomREAD:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        stx FORPNT
        ldx TXTPTR
        stx LINUM
        ldx INPTR                           ; get pointer on user input
        ldaa 0,x
        bne bcl2RomREAD
        ldaa INPUTFLG                       ; =$00:INPUT,=$4F:READ
        bne bcl7RomREAD
        jsr OS_printPtInterrogation         ; le point d'interrogation est imprimé deux fois !
        bsr OUTQUES                         ; FCT : Affiche un point d'interrogation et attend une saise utilisateur
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur

bcl2RomREAD:
        stx TXTPTR
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        ldab STRTYP                         ; type de la variable en cours : $00:numeric, $FF:alpha
        beq getNumRomREAD

getStringRomRead:
        ldx TXTPTR
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        cmpa #cBAS_SEP_STR                  ; '"'
        beq next3RomREAD
        dex
        ldaa #cBAS_SEP                      ; ':'
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        ldaa #cBAS_SEP_ARG                  ; ','

next3RomREAD:
        staa ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        jsr STRLT2                          ; FCT : BUILD A DESCRIPTOR FOR STRING STARTING AT Y,A
                                            ;       AND TERMINATED BY $00, (CHARAC), OR (ENDCHR)
                                            ;       RETURN WITH DESCRIPTOR IN A TEMPORARY
                                            ;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
        jsr next1RomVAL                     ; COPY STRNG2 INTO TXTPTR
        jsr entrytRomLET_STRING
        bra next5RomREAD

getNumRomREAD:
        jsr FIN                             ; FCT : Float IN : parse a number
                                            ;       NUMBER INPUT IS LEFT IN FAC.
                                            ;       AT ENTRY [TXTPTR] POINTS TO THE FIRST CHARACTER IN A TEXT BUFFER.
                                            ;       THE FIRST CHARACTER IS ALSO IN ACCA. FIN PACKS THE DIGITS
                                            ;       INTO THE FAC AS AN INTEGER AND KEEPS TRACK OF WHERE THE
                                            ;       DECIMAL POINT IS. [DPTFLG] TELL WHETHER A DP HAS BEEN
                                            ;       SEEN. [DECCNT] IS THE NUMBER OF DIGITS AFTER THE DP.
                                            ;       AT THE END [DECCNT] AND THE EXPONENT ARE USED TO
                                            ;       DETERMINE HOW MANY TIMES TO MULTIPLY OR DIVIDE BY TEN
                                            ;       TO GET THE CORRECT NUMBER.
                                            ; IN  : C=1 : The first character is numeric
                                            ;       C=0 : The first character is not numeric
                                            ;       A=premier caractère à convertir
                                            ; OUT : ACC1
        jsr saveACC1byFORPNT                ; SAVE ACC1 into variable by using FORPNT

next5RomREAD:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq next6RomREAD
        cmpa #cBAS_SEP_ARG                  ; ','
        beq next6RomREAD
        jmp setErrINPUT_READ                ; FCT : Gestion erreur de la partie READ
                                            ; IN  : INPUTFLG
                                            ; OUT : /

next6RomREAD:
        ldx TXTPTR
        stx INPTR
        ldx LINUM
        stx TXTPTR
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq next9RomREAD                    ; NO MORE INPUT REQUESTED
        jsr CHKCOM
        bra bcl1RomREAD

bcl7RomREAD:
        stx TXTPTR
        jsr DATAN                           ; FCT : skip to end of statement ":" or null
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of statement ":" or null
                                            ;       A,B, modified
        inx
        tsta
        bne next8RomREAD
        ldab #cBAS_ERR_NODATA               ; set ERROR at OD : Overflow DATA
        ldaa 0,x
        oraa 1,x
        beq braPrintErrorMsg
        ldd 2,x                             ; get BASIC LINE NUMBER AND
        std DATTXT                          ; save it in DATTXT
        ldab #$04
        abx

next8RomREAD:
        ldaa 0,x

isOpcodeDATA:
        cmpa #cBAS_TOKEN_DATA               ; $85
        bne bcl7RomREAD
        bra bcl2RomREAD

next9RomREAD:
        ldx INPTR                           ; NO MORE INPUT REQUESTED
        ldab INPUTFLG                       ; =$00:INPUT,=$4F:READ
        beq next10RomREAD
        jmp saveAndendRomRESTORE

next10RomREAD:
        ldaa 0,x
        beq endRomREAD
        ldx #(aptintextraIgnored)           ; "?EXTRA IGNORED\r"
        ldab 0,x
        inx
        jmp bclOUTTX

endRomREAD:
        rts
; End of function romREAD

aptintextraIgnored: dc.b 16,"?EXTRA IGNORED",$D,0

; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC NEXT : Le retour pour le FOR associé
; STX : 100 FOR I=1 TO 10:PRINT I: NEXT I
;       110 FOR J=J+5 TO 9 : PRINT J : NEXT
; OP  : $8A
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : /

romNEXT:
        bne nextRomNext                     ; Avons-nous défini une variable après le next ?
        ldx #$0000
        bra next2RomNext

nextRomNext:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)

next2RomNext:
        stx FORPNT                          ; pointeur sur la variable du step (=$0000 si n'existe pas)

searchParamForInStack:
        jsr FNDFOR                          ; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
                                            ; IN  : /
                                            ; OUT : A=0 : Token FOR trouvé
                                            ;       A=2 : Token GOSUB trouvé
                                            ;       V et C =0
                                            ;       Z=1 si A est null
                                            ;       N=1 si A est négatif
                                            ;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
        beq next3RomNext

setErrorTo0x00_NextWithoutFor:
        ldab #cBAS_ERR_NOFOR

braPrintErrorMsg:
        bra printErrorMsg

;  2 -- TXTPTR
;  2 -- LINE NUMBER
;  6 -- MAX VALUE for + TYPE OF NUMERIC
;  1 -- STEP SIGN
;  6 -- STEP VALUE + TYPE OF NUMERIC
;  2 -- ADDRESS OF "FOR VARIABLE" IN VARTAB
;  1 -- FOR TOKEN ($80)


next3RomNext:
        txs                                ; S=pointeur sur le paramétrage du token FOR
        inx                                ; cela permet de gérer les appels jsr et le retour correct sur le FOR associé
        inx
        inx

getStepValueRomNEXT:
        tst $05,X                           ; La valeur de STEP est-elle un entier ou un float ? $00:int, autre valeur : float
        beq next31RomNEXT
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
        bra next32RomNEXT
next31RomNEXT:
        jsr MOVIM2A1
next32RomNEXT:
        tsx
getVarForRomNEXT:
        ldx FORPNT                          ; pointeur sur la variable utilisée par la boucle for
addItROMNEXT:
        ldaa $06,X                          ; get type of numeric pointed by X
        beq intAddIntRomNEXT
        jsr CONUPK                          ; FONCTION CONUPK
                                            ; FCT : Recopie le nombre de TYPE FLOAT pointé par X dans ACC2
                                            ; IN  : X: pointeur sur une constante
                                            ; OUT : ACC2 contient la constante pointée par (X)
                                            ;       A = Exposant du nombre pointé par X
        bra nextAddItRomNEXT
intAddIntRomNEXT:
        jsr MOVIM2A2
nextAddItRomNEXT:
        ldab ACC1                           ; Est-ce que le pas du STEP est = 0 ?
        jsr intOrFloatRomPLUS               ; STEP 0 n'est pas censé se produire donc on va directement au calcul de l'addition
        jsr saveCC1byFORPNTByType           ; nous mettons à jour la variable utilisée (de type float ou entier) par la boucle for
        tsx
cmpWithStopValueRomNEXT:
        ldab #$0A
        abx
        jsr IorFCOMP2                       ; FCT : COMPARE A PACKED FLOATING POINT NUMBER POINTED TO BY (X)
                                            ;       TO AN UNPACKED FP NUMBER IN ACC1.
                                            ; IN  : X=Adresse d'un float
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       ACCB = 1   IF ACC1 > (X)
                                            ;       ACCB = $FF IF ACC1 < (X)
        tsx
cmpSignWithStepRomNext
        subb $09,x                          ; Test if fin de boucle
        beq next4RomNext
getCurLinFromStackRomNEXT:
        ldx $10,x                           ; GET LINE NUMBER
        stx CURLIN
        tsx
getTxtPtrFromStackRomNEXT:
        ldx $12,x                           ; get value of TXTPTR
        stx TXTPTR

jmpNewSTT_romNEXT:
        jmp NEWSTT                          ; FCT : perform next statement
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /

                                            ; TRAITE LES MULIBOUCLES de la forme FOR I= ... FOR J= 0 NEXT J,I
next4RomNext:
        ldab #cBAS_BYTES_PER_FOR            ; $12 : un FOR est décrit par 18 octets dans la pile
        abx
        txs
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        cmpa #cBAS_SEP_ARG                  ; ','
        bne jmpNewSTT_romNEXT
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bsr nextRomNext
; End of function romNEXT

; =============== S U B R O U T I N E =======================================
; FCT : EVALUATE EXPRESSION, MAKE SURE IT IS NUMERIC
; IN  : le flot d'interprétation
; OUT : ACC1=result of evaluate expression

FRMNUM:
        bsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flux d'entrée
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
; End of function FRMNUM

; =============== S U B R O U T I N E =======================================
CHKNUM:
        dc.b $6D                            ; opcode : $6D : test si zero ou pas ==> force lde drapeau C à zéro !

; =============== S U B R O U T I N E =======================================
CHKSTR:
        sec
; End of function CHKSTR


; =============== S U B R O U T I N E =======================================
; FCT : Le type de l'interprétation est-il bien attendu celui attendu (C=0 : numérique, C=1 : chaîne de caracteres)  ?
; ERR : Type incompatible
; IN  : STRTYP à jour
;       C à jour : si C=1 nous attendons une chaîne, si C=0 nous attendons un type numérique
; OUT : /
; STRTYP   C   | RESULTAT
; 0        0   | OK         ROR STR ==> $00 : OK
; 0        1   | KO         ROR STR ==> $01 : KO
; FF       0   | KO         ROR STR ==> $7F : KO
; FF       1   | OK         ROR STR ==> $FF : OK

CHKVAL:
        ror STRTYP                          ; $FF : type string, autre valeur : numérique
        bvc endRTS

setErrorTo0x18TypeIncompatible:
        ldab #cBAS_ERR_TYPEMISM
printErrorMsg:
        jmp ERROR
; End of function CHKVAL

endRTS:
        rts

; =============== S U B R O U T I N E =======================================
; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
; ALG : Utilise une pile pour stocker les calculs intermédiaires
;       X est le pointeur sur l'expression à interpréter
;       A et B contiennent les priorités des expressions en cours de traitement
; IN  : TXTPTR : pointe sur l'expression à évaluer
; OUT : ACC1=result of expression (pointeur if string or value if numeric)
;       NUMTYP et STRTYP à jour

FRMEVL:
        ldx TXTPTR
        dex
        stx TXTPTR
        clra                                ; dog keeper for stack ...
        dc.b $C6                            ; $C6 = SIMULE B=$37 : TODO =SKIP à remplacer par bra ...

; =============== S U B R O U T I N E =======================================
; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1
; IN  : A=precedence of previous operator
;       B=precedence of current operator
; OUT : /

LPOPER_FRMEVL:
        pshb                                ; save low precedence

entryLPOPER_FRMEVL:
        psha                                ; save high precedence
        ldab #$01
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        jsr EVAL                            ; FCT : GET ELEMENT IN EXPRESSION
                                            ;       GET VALUE OF VARIABLE OR NUMBER OR NOT OR FUNCTION OR PARENTHESIS
                                            ;       AT TXTPTR, OR POINT TO STRING DESCRIPTOR IF A STRING, AND PUT IN ACC1.
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=resultat
                                            ;       STRTYP et NUMTYP à jour
        clr OPMASK                          ; none conditional operator

testOpFRMEVL:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation

loopOpRelFRMEVL:
        suba #(cBAS_TOKEN_sup)              ; TODO : =$C8 ; current character is a relation ?
        bcs isEndRelFRMEVL
        cmpa #cBAS_NB_OP_CMP                ; $03 ; Le nombre d'opérateur de comparaison est 3 (<,=,>)
        bcc isEndRelFRMEVL
        cmpa #$01
        rola
        eora OPMASK
        cmpa OPMASK
        bcc nextloopOpRelFRMEVL             ; if same operator (>>, ==, <<) then syntax error
        jmp setError0x02_SYNTAXERROR

nextloopOpRelFRMEVL:
        staa OPMASK                         ; save current relation
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bra loopOpRelFRMEVL

isEndRelFRMEVL:
        ldab OPMASK
        bne doFinRelFRMEVL
        bcc QOP
        adda #(cBAS_TOKEN_sup - cBAS_TOKEN_PLUS) ; =#$07
        bcc QOP                             ; l'opcode est-il un opérateur mathématique ?
        adca STRTYP                         ; Ajoute 1 car C=1
        bne doOpFRMEVL

doStringFunctionFRMEVL:
        jmp CAT                             ; only IF A=0 AND STRTYP <> 0 (a string)

doOpFRMEVL:
        adca #$FF                           ; get back original value
        tab
        asla                                ; opcode=opcode*2
        aba                                 ; opcode=opcode*3
        tab                                 ; B=A*3 : index dans le tableau de saut des op
        ldx #aOperator
        abx

QPrecFRMEVL:
        pula                                ; get previous precedence
        cmpa $00,x                          ; is OLD PRECEDENCE GREATER OR EQUAL ?
        bcc QCHNUM
        bsr CHKNUM

                                            ; OPERATION BEING PROCESSED IS OF HIGHER PRECEDENCE THAN THE PREVIOUS OPERATION.
doPrecFRMEVL:
        psha                                ; save old PRECEDENCE
        bsr DOPRE1_FRMEVL                   ; FCT : PUSH OPERATOR ROUTINE ADDRESS AND ACC1  ONTO STACK
                                            ; IN  : X=pointer on adresse of operator routine
                                            ; OUT : B=value of OPMASK
        ldx LASTOP                          ; ?
        pula                                ; ?
        bne QPrec1FRMEVL                    ; Récupére le bit c de DOPRE1_FRMEVL
        tsta
        beq beforeEndQOP                    ; oui alors retourne l'exposant de ACC1 avant de sortir (utile pour les opérateurs mathématiques)
        bra PULSTK                          ; TODO : ?? Récupére la dernière opération et la valeur de l'argument

doFinRelFRMEVL:
        asl STRTYP                          ; type de la variable en cours : $00:numeric, $FF:alpha
        rolb                                ; asl+rolb permet de différencier une comparaison d'un numerique de celle d'une chaîne !
        ldx TXTPTR
        dex
        stx TXTPTR
        ldx #MATHTBL
        stab OPMASK
        bra QPrecFRMEVL

QPrec1FRMEVL:
        cmpa $00,x
        bcc PULSTK
        bra doPrecFRMEVL
; End of function LPOPER_FRMEVL

; =============== S U B R O U T I N E =======================================
; FCT : PUSH OPERATOR ROUTINE ADDRESS AND ACC1 ONTO STACK
; IN  : X=pointer on adresse of operator routine
; OUT : B=value of OPMASK

DOPRE1_FRMEVL:
        ldd 1,x                             ; get from X adress of operator routine to apply
        pshb                                ; save it
        psha
        bsr PUSHF1                          ; FCT : Sauvegarde ACC1 dans la pile
                                            ;       Puis exécute l'opérateur indiqué par X
                                            ; IN  : X=adresse vers un tableau contenant precédence + saut
                                            ;       S=adresse vers un tableau contenant precédence + saut
                                            ;         suivant les points d'entrées on utilise ou pas
                                            ; OUT : A=precédence de l'opérateur mathématique courant
                                            ;       B modified
                                            ;       S : ACC1 sauvegardé en pile
        ldab OPMASK                         ; get precedence of operator
        bra LPOPER_FRMEVL                   ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1
                                            ; IN  : A=precedence of previous operator
                                            ;       B=precedence of current operator
                                            ; OUT : /

; End of function DOPRE1_FRMEVL

; =============== S U B R O U T I N E =======================================
; FCT : Sauvegarde ACC1 dans la pile
;       Puis exécute l'opérateur indiqué par X
; IN  : X=adresse vers un tableau contenant precédence + saut
;       S=return address
;       Suivant les points d'entrées on utilise ou pas le pointeur de pile
; OUT : A=précédence de l'opérateur mathématique courant
;       B modified
;       X modified
;       S : ACC1 sauvegardé en pile avec son type (float/integer) dans l'ordre suivant :*
;         - ACC1, ACC1+1,ACC+2, ACC1+3,ACC1+4,ACC1TYPFLG,ACC1+5 (sign of ACC1)

PUSHF1:
        ldab ACC1+5                         ; get ACC1 sign
        ldaa 0,x                            ; get precedence of current operator
FRM_STACK2:
        pulx                                ; get return address
        pshb                                ; push sign of ACC1
FRM_STACK3:
        ldab ACC1TYPFLG                     ; sauvegarde le type de ACC1 (integer/float)
        pshb
        ldab ACC1+4                         ; sauvegarde ACC1 dans la pile et se débranche sur une routine pointée par X
        pshb
        ldab ACC1+3
        pshb
        ldab ACC1+2
        pshb
        ldab ACC1+1
        pshb
        ldab ACC1
        pshb
        jmp 0,x                             ; return to routine call
; End of function PUSHF1

; =============== S U B R O U T I N E =======================================
; FCT : ?? TODO
; IN  : One element from STACK and one value (float or int or string : TODO : string vraiment ??)
; OUT : A=exponent de ACC2
;       B=exponent de ACC1
;       C=1 string non numérique
QOP:
        ldx #$0000                          ; TODO : POURQUOI ?
        pula                                ; Obtient la précédence de la dernière opération
        tsta                                ; test si c'est la fin de l'interprétation
        beq beforeEndQOP                    ; oui alors retourne l'exposant de ACC1 avant de sortir (utile pour les opérateurs mathématiques)

QCHNUM:
        cmpa #cBAS_PREC_OP_REL              ; Est-ce un opérateur de relation ?
        beq UNPSTK
        jsr CHKNUM
UNPSTK:
        stx LASTOP                          ; save ?
PULSTK:
        pulb                                ; TODO get precedence
        cmpa #cBAS_PREC_NOT                 ; Précédence de l'opérateur NOT ?
        beq endQOP
        cmpa #cBAS_PREC_MINUS               ; Précédence de l'opérateur - ?
        beq endQOP
        lsrb                                ; get type of data (C=1 : string, C=0 : numeric)
        stab CPRMASK                        ; Masque de comparaison
        tpa                                 ; save type of data
getNumFromSTK:
        pulx
        stx ACC2
        pulx
        stx ACC2+2
        pulb
        stab ACC2+4
        pulb                                ; get TYPFLG from stack and set ACC2TYPFLG
        tstb
        beq nextPullStack
        ldab #cTYPFLGACC2
nextPullStack:
        stab ACC2TYPFLG
        pulb
        stab ACC2+5
        eorb ACC1+5                         ; set ACC1 sign
        stab PRODSIGN
beforeEndQOP:
        tap                                 ; get type of data in C
        ldaa ACC2                           ; get Exponent of ACC2
        ldab ACC1                           ; get Exponent of ACC1  (for fast operation : +0 / -0 / *0 / /0)
endQOP:
        rts
; END OF FUNCTION CHUNK FOR LPOPER_FRMEVL

; =============== S U B R O U T I N E =======================================
; FCT : GET ELEMENT IN EXPRESSION
;       GET VALUE OF VARIABLE OR NUMBER OR NOT OR FUNCTION OR PARENTHESIS
;       AT TXTPTR, OR POINT TO STRING DESCRIPTOR IF A STRING, AND PUT IN ACC1.
; IN  : le flot d'interprétation
; OUT : ACC1=resultat
;       STRTYP et NUMTYP à jour
EVAL:
        ldaa #$00
        staa STRTYP                         ; par défaut, le type retourné est numérique et ...
        coma
        staa NUMTYP                         ; ... un float
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1

EVAL2:
        bcc isVariableOrOtherEVAL

doNumberEVAL:
        jmp FIN                             ; FCT : Float IN : parse a number
                                            ;       NUMBER INPUT IS LEFT IN FAC.
                                            ;       AT ENTRY [TXTPTR] POINTS TO THE FIRST CHARACTER IN A TEXT BUFFER.
                                            ;       THE FIRST CHARACTER IS ALSO IN ACCA. FIN PACKS THE DIGITS
                                            ;       INTO THE FAC AS AN INTEGER AND KEEPS TRACK OF WHERE THE
                                            ;       DECIMAL POINT IS. [DPTFLG] TELL WHETHER A DP HAS BEEN
                                            ;       SEEN. [DECCNT] IS THE NUMBER OF DIGITS AFTER THE DP.
                                            ;       AT THE END [DECCNT] AND THE EXPONENT ARE USED TO
                                            ;       DETERMINE HOW MANY TIMES TO MULTIPLY OR DIVIDE BY TEN
                                            ;       TO GET THE CORRECT NUMBER.
                                            ; IN  : C=1 : The first character is numeric
                                            ;       C=0 : The first character is not numeric
                                            ;       A=premier caractère à convertir
                                            ; OUT : ACC1

isVariableOrOtherEVAL:
        jsr ISLETC                          ; FCT : teste si A est une lettre ASCII
                                            ; IN  : A
                                            ; OUT : C=0 si lettre ['A';'Z'] sinon 1
                                            ;       A unmodified
        bcc doVariableFRM

isFloatEVAL:
        cmpa #cMATH_SEP_FLT                 ; '.'
        beq doNumberEVAL

isHexaEVAL:
        cmpa #cBAS_ID_HEX                   ; '#'
        beq doNumberEVAL

isOpMinusEVAL:
        cmpa #cBAS_TOKEN_MINUS              ; TODO $B6  ; compare token MINUS
        beq doMinusEVAL

isOpPlusEVAL:
        cmpa #cBAS_TOKEN_PLUS               ; TODO $B5 ; compare token PLUS
        beq EVAL                            ; FCT : GET ELEMENT IN EXPRESSION
                                            ;       GET VALUE OF VARIABLE OR NUMBER OR NOT OR FUNCTION OR PARENTHESIS
                                            ;       AT TXTPTR, OR POINT TO STRING DESCRIPTOR IF A STRING, AND PUT IN ACC1.
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=resultat
isQuoteEVAL:
        cmpa #cBAS_SEP_STR                  ; '"'
        bne isOpNotEVAL

doStringEVAL:
        ldx TXTPTR
        jsr STRLIT                          ; FCT : BUILD A DESCRIPTOR FOR STRING STARTING AT X
                                            ;       AND TERMINATED BY $00 OR QUOTATION MARK
                                            ;       RETURN WITH DESCRIPTOR IN A TEMPORARY
                                            ;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
                                            ; ST  : ACTIF
                                            ; IN  : X=string to create an descriptor
                                            ; OUT : A,B,X modified
        jmp next1RomVAL                     ; COPY STRNG2 INTO TXTPTR

isOpNotEVAL:
        cmpa #cBAS_TOKEN_NOT                ; TODO : $A4  ; check for "NOT" operator
        bne isFnEVAL

; Peut-on faire plus efficace pour faire le not sur un float ? Ben non ...
doNotEVAL:
        ldaa #cBAS_PREC_NOT                 ; set precedence of NOT
        jsr LPOPER_FRMEVL                   ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1
                                            ; IN  : A=precedence of previous operator
                                            ;       B=precedence of current operator
                                            ; OUT : /
        tst NUMTYP                          ; $00 : integer / $FF : float
        bne doFloatNotEVAL
dointFloatNotEVAL:
        ldd ACC1+3
        coma
        comb
        std ACC1+3                          ; TODO : gestion du signe
        rts

doFloatNotEVAL:
        jsr convACC1toWord                  ; FCT : conversion d'un float (ACC1) en un mot
                                            ;       D=INT(ACC1)
                                            ; ERR : Fonction incorrect
                                            ; IN  : ACC1 set
                                            ; OUT : D=résultat de la conversion float->WORD
        coma                                ; nous effectuons le not ...
        comb
        jmp convUnsignedWordToACC1          ; FCT : Convert Word to Float
                                            ; IN  : D=number to convert
                                            ; OUT : ACC1=float(D)

isFnEVAL:
        cmpa #cBAS_TOKEN_FN
        bne  isOpEVAL
        jmp romFN

isOpEVAL:
        suba #cBAS_OFS_FCT                  ; TODO $D1
        bcc isOneMultiNoParamFctEVAL        ; TODO A=Opcode-$D1
; End of function EVAL


; =============== S U B R O U T I N E =======================================
; FCT : evaluate expression du type (expression)
; IN  : le flot d'interprétation
; OUT : ACC1=resultat de l'évaluation

PARCHK:
        bsr CHKOPN
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
; End of function PARCHK

; =============== S U B R O U T I N E =======================================
; FCT : check close parenthesis and get next char
; IN  : TXTPTR mis à jour
; OUT : X unmodified, A et B modified

CHKCLS:
        ldab #cBAS_FCT_CLOSE                ; ')'
        bra SYNCHR
; End of function CHKCLS

; =============== S U B R O U T I N E =======================================
; FCT : check open parenthesis and get next char
; IN  : TXTPTR mis à jour
; OUT : X unmodified, A et B modified

CHKOPN:
        ldab #cBAS_FCT_OPEN                 ; '('
        bra SYNCHR
; End of function CHKOPN

; =============== S U B R O U T I N E =======================================
; FCT : check token FN and get next char
; IN  : TXTPTR mis à jour
; OUT : X unmodified, A et B modified

CHKFN:
        ldab #cBAS_TOKEN_FN                 ; 'FN'
        bra SYNCHR
; End of function CHKOPN


; =============== S U B R O U T I N E =======================================
; FCT : check comma and get next char
; IN  : TXTPTR mise à jour
; OUT : X unmodified, A et B modified

CHKCOM:
        ldab #cBAS_SEP_ARG                  ; ','
; End of function CHKCOM


; =============== S U B R O U T I N E =======================================
; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
; IN  : B=Opcode ou caractère à comparer
; OUT : X : not modified
;       A : le caractère suivant l'opcode ou caractère à comparer
;           si la comparaison de l'opcode est OK

SYNCHR:
        pshx
        ldx TXTPTR
        cmpb 0,x
        pulx
        bne setError0x02_SYNTAXERROR
        jmp CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
; End of function SYNCHR

; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================
; FCT : TODO : get value of ??
; IN  : le flot d'interprétation
; OUT : ACC1 contenant soit le descripteur de la chaîne, soit la valeur numérique de type float ou entière
;       de la variable recherchée

doVariableFRM:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)

callDoVariableFRM:
        stx ACC1+3
        ldaa STRTYP                         ; $00:numeric, $FF : type string
        bmi endQOP
        tst  NUMTYP
        beq intVariableFRM
        jmp MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
intVariableFRM:
        jmp MOVIM2A1

; End of function  doVariableFRM
; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR EVAL

setError0x02_SYNTAXERROR:
        ldab #cBAS_ERR_SYNTAX
        jmp ERROR
; END OF FUNCTION CHUNK FOR CHKMEM

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR EVAL

doMinusEVAL:
        ldaa #cBAS_PREC_MINUS               ; set precedence of Minus operator
        jsr LPOPER_FRMEVL                   ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1
                                            ; IN  : A=precedence of previous operator
                                            ;       B=precedence of current operator
                                            ; OUT : /
        jmp doNEG                           ; FCT : routine NEG(X) : retourne l'opposé de ACC1
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : ACC1=NEG(ACC1)

; ---------------------------------------------------------------------------

isOneMultiNoParamFctEVAL:
        tab                                 ; A est l'opcode d'une fonction (SGN, ...) - $D1 (opcode de SGN)
        aslb                                ; TODO $D1-$E? -> 0x00 - 0x22 <<
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        pshb                                ; TODO sauvegarde de (opcode - $D1)*2

isInfOpcodeLEFTdollarEVAL:
        cmpb #(cBAS_TOKEN_LEFTdollar-cBAS_OFS_FCT)*2    ; TODO : $22 '"' & pourquoi LEFT dollar ?
        bcs doSimpleFctEVAL

isOpcodeGETAdollarEVAL:
        cmpb #(cBAS_TOKEN_GETAdollar-cBAS_OFS_FCT)*2    ; $2C ; ','
        bcc doNoParamFctEVAL                ; exemple (le seul) de fonction sans param : MEM

doDoubleFctEVAL:                            ; permet de trairer les fonctions à deux paramètres
        bsr CHKOPN
        pulb
        cmpb #$28 ; '('
        bcc getJmpFctEVAL
        pshb
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
        bsr CHKCOM
        jsr CHKSTR
        pula
        ldx ACC1+3
        pshx
        psha
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        pula
        pshb
        tab
        bra getJmpFctEVAL

doSimpleFctEVAL:
        bsr PARCHK                          ; FCT : evaluate expression du type (expression)
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=resultat de l'évaluation

doNoParamFctEVAL:
        pulb                                ; pop index function

getJmpFctEVAL:
        ldx #jmpFONCTION
        abx
        ldx 0,x
        jsr 0,x
        jmp CHKNUM
; END OF FUNCTION CHUNK FOR EVAL
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================
; FCT : do OR ACC1 with ACC2
; STX : IF A OR B THEN PRINT "A OR B"
; ALG : /
; OP  : $AD
; ST  : ACTIF
; IN  : ACC1 and ACC2 set
; OUT : ACC1=ACC1 AND ACC2
doOP_OR:
        SKIP_BYTE                       ; dc.b $86 : équivalent au code "Charge $4F dans A" !

; =============== S U B R O U T I N E =======================================
; FCT : do "AND" ACC1 with ACC2
; STX : IF A AND B THEN PRINT "A AND B"
; ALG : /
; OP  ! $AC
; ST  : ACTIF
; IN  : ACC1 and ACC2 set
; OUT : ACC1=ACC1 AND ACC2
;

doOP_AND:
        clra
        staa EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
; End of function doOP_AND


; =============== S U B R O U T I N E =======================================
; FCT : permet d'effectuer soit le AND soit le OR entre ACC1 et ACC2
; ST  : ACTIF
; IN  : A=0 : AND sinon OR
; OUT : ACC1=ACC1 (and/or) ACC2

entryOpBinary:
        ldaa ACC1TYPFLG
        beq nextOpBinary
        jsr doConvACC1toWord
        std ACC1+3
nextOpBinary:
        ldaa ACC2TYPFLG
        beq doOpBinary
        jsr doConvACC2toWord
        std ACC2+3
doOpBinary:
        ldd ACC1+3
        tst EOLPNTR                         ; cela sert à beaucoup de choses : op. binaires, etc.
        bne nextDoOpBinary
        anda ACC2+3
        andb ACC2+4
        bra endDoOpBinary
nextDoOpBinary:
        oraa ACC2+3
        orab ACC2+4
endDoOpBinary:
        jmp convUnsignedWordToACC1          ; FCT : Convert Word to Float
                                            ; IN  : D=number to convert
                                            ; OUT : ACC1=float(D)
; End of function entryOpBinary

; =============== S U B R O U T I N E =======================================
; FCT : PERFORM RELATIONAL OPERATIONS
; ST  : ACTIF
; IN  : C=0 : numeric ; C=1 : string
;       STRTYP=$00 : numeric, $FF : string
; OUT : A,B,X modified

RELOPS:
        jsr CHKVAL                          ; FCT : Le type de l'interprétation est-il bien attendu celui attendu (C=0 : numérique, C=1 : chaîne de caracteres)  ?
                                            ; ERR : Type incompatible
                                            ; IN  : NUMTYP et  STRTYP à jour & C à jour : si C=1 nous attendons une chaîne, si C=0 nous attendons un type numérique
                                            ; OUT : /
        bne STRCOMP
        ldaa ACC2+5
        oraa #$7F
        anda ACC2+1
        staa ACC2+1
        ldx #ACC2
        jsr IorFCOMP2                       ; FCT : COMPARE A PACKED FLOATING POINT NUMBER POINTED TO BY (X)
                                            ;       TO AN UNPACKED FP NUMBER IN ACC1.
                                            ; IN  : X=Adresse d'un float
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       ACCB = 1   IF ACC1 > (X)
                                            ;       ACCB = $FF IF ACC1 < (X)
        bra NUMCMP

STRCOMP:
        clr STRTYP                          ; type de la variable en cours : $FF:alpha, $00:numeric
        dec OPMASK
        jsr FREFAC                          ; FCT : Libére la zone réservée par descripteur (chaîne de caractères)
                                            ; IN  : ACC1+3 et ACC1+4 : contient le descripteur
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne
        stab DESCSTR
        stx DESCSTR+1
        ldx ACC2+3
        jsr FRETMP                          ; FCT : IF STRING DESCRIPTOR WHOSE ADDRESS IS IN X IS
                                            ;       A TEMPORARY STRING, RELEASE IT.
                                            ; IN  : X=Address of string descriptor
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne de caractères réservée
        ldaa DESCSTR
        sba
        beq nextSTRCMP
        ldaa #$01
        bcc nextSTRCMP
        ldab DESCSTR
        nega

nextSTRCMP:
        staa ACC1+5                         ; set ACC1 sign
        tpa
        psha
        sts SAVREGS
        sei
        txs
        ldx DESCSTR+1
        incb
        dex

bcl1tSTRCMP:
        decb
        bne next2STRCMP
        ldab ACC1+5                         ; get ACC1 sign
        bra next3STRCMP

next2STRCMP:
        pula
        inx
        cmpa $00,x
        beq bcl1tSTRCMP
        ldab #$FF
        bcc next3STRCMP
        negb

next3STRCMP:
        lds SAVREGS
        pula
        tap

NUMCMP:
        addb #$01
        rolb
        andb CPRMASK                        ; Masque de comparaison
        beq jmpconvSignedByteToACC1
        ldab #$FF

jmpconvSignedByteToACC1:
        jmp convSignedByteToACC1            ; CONVERT (B) INTO ACC1, AS SIGNED VALUE -128 TO +127
; End of function RELOPS

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR romDIM

NXDIM:
        jsr CHKCOM
; END OF FUNCTION CHUNK FOR romDIM

; =============== S U B R O U T I N E =======================================
; FCT : CREATION D'UN TABLEAU MULTIDIMENSION DE FLOAT OU DE CHAINE DE CARACTERES
;       Codage d'un tableau en mémoire
;         + WORD   : nom de la variable sur 2 caractères  maxi. Le dernier octet du nom
;                    aura le bit de poids le plus fort mis à 1 quand c'est une chaine
;         + WORD   : taille du tableau
;         + BYTE   : nombre de dimension
;         + nxWORD : taille de dimension + 1 pour les n dimensions constituant le tableau
;                    dans l'ordre d'inverse de leur déclaration
;         + stockage des données
;           + si float  : stockage du nombre sur 5 octets
;           + si string : WORD : pointeur sur la chaîne de caractères
; STX : 10 DIM A(4) : DIM B$(5,4)
; OP  : $8B
; IN  : le flot d'interprétration
;       A=?? TODO
; OUT : Création d'un tableau

romDIM:
        tab
        bsr nextPTRGET
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        bne NXDIM
        rts
; End of function romDIM

; =============== S U B R O U T I N E =======================================
; FCT : Lit un nom de variable à l'aide de CHRGOT
;       et le trouve en mémoire
; IN  : TXTPTR pointe sur le premier caractère du nom
; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
;       (si non trouvé alors création d'une variable simple ou d'un
;       tableau de dimension 10 initialisé à 0)
; OPT : N/A
PTRGET:
        clrb
        jsr CHRGOT                          ; retrieve last character in register A

nextPTRGET:
        stab DIMFLG                         ; =0 variable,<>0 : array
        staa VARNAM                         ; Temporary storage for a variable name
        jsr CHRGOT                          ; get current character
        bsr ISLETC                          ; FCT : teste si A est une lettre ASCII
                                            ; IN  : A
                                            ; OUT : C=0 si lettre ['A';'Z'] sinon 1
                                            ;       A unmodified

        bcc NAMOKnext1PTRGET
        jmp setError0x02_SYNTAXERROR

NAMOKnext1PTRGET:
        clrb                                ; set type to numerical by default
        stab STRTYP                         ; type de la variable en cours : $00:numeric, $FF:alpha
        decb                                ; set type of numeric as float
        stab NUMTYP                         ; type de la variable en cours : $00:int, $FF:float
        incb                                ; sera utilisée pour fixer la valeur par défaut du deuxième caractère
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bcs next2PTRGET
        bsr ISLETC                          ; FCT : teste si A est une lettre ASCII
                                            ; IN  : A
                                            ; OUT : C=0 si lettre ['A';'Z'] sinon 1
                                            ;       A unmodified
        bcs isStringOrIntegerPTRGET         ; Y-a-t-il une seconde lettre (nom avec deux lettres significatifs au maximum) ? non alors saut

next2PTRGET:
        tab                                 ; save second character of variable

bcl3PTRGET:

        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bcs bcl3PTRGET
        bsr ISLETC                          ; FCT : teste si A est une lettre ASCII
                                            ; IN  : A
                                            ; OUT : C=0 si lettre ['A';'Z'] sinon 1
                                            ;       A unmodified
        bcc bcl3PTRGET

isStringOrIntegerPTRGET:
        cmpa #cBAS_ID_STR                   ; '$'
        bne isIntPTRGET
        com STRTYP                          ; type de la variable en cours : $00:numeric, $FF:alpha
                                            ; here set to alpha
        bra next5PTRGET

isIntPTRGET:
        cmpa #cBAS_ID_INT                   ; '%'
        bne  next6PTRGET
        clra
        staa NUMTYP                         ; type de la variable en cours : $00:int,$FF:float
        ldaa VARNAM
        oraa #$80                           ; le codage d'un entier est le bit 7 de la première lettre et éventuellement celui de la deuxième lettre
        staa VARNAM

                                            ; AU FINAL :
                                            ; le codage du nom de variable de type float  est : le bit 7  à 0 de la première lettre et éventuellement celui de la deuxième lettre
                                            ; le codage du nom de variable de type entier est : le bit 7 à 1 de la première lettre et éventuellement celui de la deuxième lettre
                                            ; le codage du nom de variable de type string est : le bit 7 à 0 de la première lettre et bit 7 à 1 celui de la deuxième lettre


next5PTRGET:
        orab  #$80                          ; Turn on MSB of second character
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1

next6PTRGET:
        stab VARNAM+1                       ; Temporary storage for a variable name
        ldab SUBFLG                         ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        decb
        bne next7PTRGET
        jmp nextIsARY

next7PTRGET:
        adda SUBFLG                         ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        suba #$28                           ; Paranthèse ouvrante ?
        bne next8PTRGET
        jmp ISARY                           ; FCT : traite la partie tableau de la recherche d'une variable
                                            ;       et de sa création si il n'existe pas
                                            ; IN  : le flot d'interprétation
                                            ; OUT : Variable à jour

next8PTRGET:
        clr SUBFLG                          ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        ldx VARTAB                          ; Fin du programme BASIC / début des variables

bcl9PTRGET:
        cpx ARYTAB
        beq NAMENOTFOUND                    ; variable inexistante alors création de cette variable !
        ldd VARNAM                          ; Temporary storage for a variable name
        subd 0,x                            ; ajoute la taille du tableau pour trouver la prochaine variable de type tableau
        beq endPTRGET
        ldab #cBAS_LEN_VAR_FLOAT            ; $07 : Taille de la zone de stockage d'une variable de type float
        abx
        bra bcl9PTRGET
; End of function PTRGET

; =============== S U B R O U T I N E =======================================
; FCT : teste si A est une lettre ASCII
; IN  : A = code ascii de la lettre
; OUT : C=0 si lettre ['A';'Z'] sinon 1
;       A unmodified

ISLETC:
        cmpa #$41                           ; 'A'
        bcs F_ISLETC
        suba #$5B                           ; test sur l'intervalle ['A';'Z']
        suba #$A5                           ; par un calcul de modulo ... TODO : exact ?

F_ISLETC:
        rts
; End of function ISLETC

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR PTRGET

NAMENOTFOUND:
        pulx                                ; récupère l'adresse de l'appelant
        pshx
        cpx #callDoVariableFRM
        bne MAKENEWVARIABLE
        ldx #cZERO
        rts

MAKENEWVARIABLE:
        ldd STREND
        std HIGHTR
        addd #cBAS_LEN_VAR_FLOAT            ; $07 : taille d'une cellule de tableau ou de l'entête d'un tableau
        std HIGHDS                          ; Cible lors d'une copie de zone mémoire
        ldx ARYTAB
        stx LOWTR
        jsr BLTU                            ; FCT : move block of memory up + vérification si il y a de la place dans la pile
                                            ; IN  : HIGHDS (cible), HIGHTR (source min), LOWTR (source max) à jour
                                            ; OUT : A,B,X modified
                                            ;       PTRTMP2 : contient le pointeur sur le dernier octet copié
        ldx HIGHDS                          ; Cible lors d'une copie de zone mémoire
        stx STREND
        ldx PTRTMP2
        stx ARYTAB
        ldx LOWTR
        ldd VARNAM                          ; Temporary storage for a variable name

initARRAY:
        std 0,x                             ; stockage du nom de la variable
        clra
        clrb
        std 2,x                             ; initialisation à 0 de la taille du tableau
        std 4,x                             ; initialisation à 0 du nombre de dimension et de l'octet de poids fort de la dimension
        staa 6,x                            ; initialisation à 0 de l'octet de poids faible de la dimension

endPTRGET:
        inx
        inx
        stx VARPNT                          ; mise à jour du pointeur de variable courant
        rts
; END OF FUNCTION CHUNK FOR PTRGET

; =============== S U B R O U T I N E =======================================
; FCT : Evaluate INDICE INTO ACC1
; IN  : le flot d'interprétation
; OUT : D=résultat de l'interprétation de l'expression

CHRGETandFRMNUM:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
; End of function CHRGETandFRMNUM

; =============== S U B R O U T I N E =======================================
; FCT : interprétre une expression de type int et retourne une valeur de type word
; ALG : /
; STX : /
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : D=résultat de l'interprétation de l'expression

jsrFRMNUMAndMKINT:
        jsr FRMNUM                          ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour
        bra entryMKINT                      ; Pour éviter de faire deux fois CHKNUM !
; End of faunction jsrFRMNUMAndMKINT

; =============== S U B R O U T I N E =======================================
; FCT : Convertit le résultat de l'évaluation d'une expression
;       du flot 'interprétration comme un octet
; ERR : FC : Fonction Incorrecte
; IN  : Le résultat d'une interprétation :
;       ACC1 doit contenir une valeur
;       NUMTYP doit contenir le flag du type du résultat de l'interprétration
; OUT : D=ACC1 contenant le résultat de l'évaluation
; OPT : /

MKINT:
        jsr CHKNUM
entryMKINT:
        ldaa ACC1+5                         ; get ACC1 sign : la donnée doit être positive
        bmi printErrorMSG_0x08_FC_FctIncorrect
        bra entryConvACC1toWord
; End of function MKIN


; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un float (ACC2) en un mot
;       D=INT(ACC1)
; ERR : Fonction incorrecte
; IN  : ACC2 set
; OUT : D=résultat de la conversion float->WORD
convACC2toWord:
doConvACC2toWord:

; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un float (ACC1) en un mot
;       D=INT(ACC1)
; ERR : Fonction incorrecte
; IN  : ACC1 set
; OUT : D=résultat de la conversion float->WORD

convACC1toWord:
        jsr CHKNUM

entryConvACC1toWord:
        tst NUMTYP                          ; NUMTYP : $00 : int , $FF : float
        beq beforeEndConvACC1toWord
doConvACC1toWord:
        ldaa ACC1
        cmpa #$90                           ; test exposant / $90
        bcs nextConvACC1toWord
        ldx #cMINUS32768                    ; TODO A ADAPTER
        jsr FCOMP2                          ; FCT : COMPARE A PACKED FLOATING POINT NUMBER POINTED TO BY (X)
                                            ;       TO AN UNPACKED FP NUMBER IN ACC1.
                                            ; IN  : X=Adresse d'un float
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       ACCB = 1   IF ACC1 > (X)
                                            ;       ACCB = $FF IF ACC1 < (X)
        bne printErrorMSG_0x08_FC_FctIncorrect

nextConvACC1toWord:
        jsr QUICK_INT                       ; FCT : effectue la fonction int sur ACC1
                                            ; IN  : ACC1 mis à jour
                                            ; OUT : ACC1=INT(ACC1)
                                            ;       B=exposant de ACC1
beforeEndConvACC1toWord:
        ldd ACC1+3

endConvACC1toWord:
        rts
; End of function convACC1toWord

; =============== S U B R O U T I N E =======================================
; FCT : traite la partie tableau de la recherche d'une variable
;       et de sa création si il n'existe pas
; IN  : le flot d'interprétation
; OUT : Variable à jour

ISARY:
        ldx DIMFLG
        pshx
        clrb                                ; set number of dimension to 0

bclIsARY:
        pshb
        ldx VARNAM                          ; Temporary storage for a variable name
        pshx
        bsr CHRGETandFRMNUM                 ; FCT : Evaluate INDICE INTO ACC1
                                            ; IN  : le flot d'interprétation
                                            ; OUT : D=résultat de l'interprétation de l'expression
        pulx
        stx VARNAM                          ; Temporary storage for a variable name
        pulb
        incb
        stab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        pula
        pulb
        ldx ACC1+3
        pshx
        pshb
        psha
        ldab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        cmpa #cBAS_SEP_ARG                  ; ','
        beq bclIsARY
        jsr CHKCLS                          ; FCT : check close parenthesis and get next char
                                            ; IN  : TXTPTR mise à jour
                                            ; OUT : X unmodified, A et B modified
        pulx
        stx DIMFLG
        ldab #$FF

nextIsARY:
        pshb
        ldx ARYTAB

bcl2IsARY:
        cpx STREND
        beq createARRAY                     ; FCT : Création de l'entête du tableau
                                            ;       00:01 : nom du tableau
                                            ;       04:04 : nombre de dimension
                                            ;       05:.. : la taille de chaque dimension +1
                                            ; IN  : X=position du futur tableau
                                            ; OUT : /
        ldd VARNAM                          ; Temporary storage for a variable name
        subd 0,x
        beq DIMARRAY_isError
        ldd 2,x
        jsr addXtoTMPPTR                    ; FCT : Ajoute l'offset B à X
                                            ; IN  : D=offset à ajouter à INDEX
                                            ; OUT : INDEX=X
                                            ;       X=D=TMPPTR=X+D

        bra bcl2IsARY

DIMARRAY_isError:
        ldab #cBAS_ERR_REDIMD               ; set code error to $12 : DD : Erreur tableau
        pula
        tsta
        beq endConvACC1toWord
        ldaa DIMFLG
        bne jmpERROR_0
        ldab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        cmpb 4,x
        beq getDimBeforCreateDimForArray

printErrorMSG0x10BSIndiceIncorrect:
        ldab #cBAS_ERR_BADSUBS
        bra jmpERROR_0
; End of function ISARY

; =============== S U B R O U T I N E =======================================

printErrorMSG_0x08_FC_FctIncorrect:
        ldab #cBAS_ERR_ILLQTY
jmpERROR_0:
        jmp ERROR
; End of function printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT : Création de l'entête du tableau
;       00:01 : nom du tableau
;       04:04 : nombre de dimension
;       05:.. : la taille de chaque dimension +1
; IN  : X=position du futur tableau
; OUT : /

createARRAY:
        pula
        tsta
        beq printErrorMSG_0x08_FC_FctIncorrect
        ldd #cBAS_BYTES_PER_VARIABLE        ; $0005
        std STRNG2                          ; Initialise la taille du tableau à 5 octets car c'est
                                            ; la taille d'une cellule contenant un float
        ldd VARNAM                          ; Temporary storage for a variable name
        std 0,x                             ; save NAME
        ldab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        stab 4,x                            ; save dimension of array
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        stx HIGHDS                          ; Cible lors d'une copie de zone mémoire

initAllDimofARRAY:
        ldab #cBAS_ARY_DIM_DEFAULT+1        ; $0B ; init one dimension to 10 + 1 by default
        clra
        tst DIMFLG
        beq nextInitAllDimofARRAY           ; si la dimension est définie alors on récupère via la pile
        pula
        pulb
        addd #$0001

nextInitAllDimofARRAY:
        std 5,x                             ; store dimension of array
        bsr UMULTARY
        std STRNG2                          ; ajuste à chaque itération la taille du tableau
        inx
        inx                                 ; Passage à la dimension suivante
        dec EOLPNTR                         ; cela sert à beaucoup de choses : op. binaires, etc.
        bne initAllDimofARRAY
        jsr addXtoTMPPTR                    ; FCT : Ajoute l'offset B à X
                                            ; IN  : D=offset à ajouter à INDEX
                                            ; OUT : INDEX=X
                                            ;       X=D=TMPPTR=X+D

        bcc testOutOfMeMBeforeCreateArray
        jmp MEMERR                          ; FCT : Point d'entrée secondaire pour la gestion d'erreur
                                            ;       il correspond à "plus de place disponible en mémoire"
                                            ; IN  : /
                                            ; OUT : A,B,X modified

testOutOfMeMBeforeCreateArray:
        jsr nextCHKMEM                      ; D=D+$3A
        subd #cBAS_OFS_STK-cBAS_BYTES_PER_VARIABLE  ; $35 : comme nextCHKMEM ajoute $3A à D alors que nous voulons soustraire
                                            ;       que la taille d'une cellule de type float = 5
        std STREND
        clra

storeTermAtEndOfArrayDesc:
        dex
        staa 5,x
        cpx INDEX
        bne storeTermAtEndOfArrayDesc
        ldx HIGHDS                          ; Cible lors d'une copie de zone mémoire
        ldaa STREND
        subd HIGHDS                         ; Cible lors d'une copie de zone mémoire
        std 2,x
        ldaa DIMFLG
        bne DIMrts

getDimBeforCreateDimForArray:
        ldab 4,x
        stab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        clra
        clrb

repeatCreateDimForArray:
        std STRNG2
        pula
        pulb
        std ACC1+3
        pshb
        psha
        subd 5,x
        bcc jmpPrintErrMsg0x010BSIndiceIncorrect
        ldd STRNG2                          ; TODO : quel drôle de code ...
        pula
        pulb
        beq untilCreateDimForArray
        bsr UMULTARY
        addd ACC1+3

untilCreateDimForArray:
        inx
        inx
        dec EOLPNTR                         ; cela sert à beaucoup de choses : op. binaires, etc.
        bne repeatCreateDimForArray

mulBy5:
        std INDEX
        lsld
        lsld
        addd INDEX
        addd #$0005
        jsr addXtoTMPPTR                    ; FCT : Ajoute l'offset B à X
                                            ; IN  : D=offset à ajouter à INDEX
                                            ; OUT : INDEX=X
                                            ;       X=D=TMPPTR=X+D

        stx VARPNT                          ; Pointer used in array building

DIMrts:
        rts
; End of function createARRAY


; =============== S U B R O U T I N E =======================================
; FCT : calcule la taille d'un tableau de dimension N
;       RESULTAT=STRNG2*X[5]
; IN  : X     =pointeur sur le descripteur d'un tableau (pour obtenir le multiplieur)
;       STRNG2=offset de départ contenant le multiplicande
; OUT : D=taille du tableau pour la dimension du tableau en cours de traitement
; RMQ : /

UMULTARY:
        ldaa #$10
        staa PTRTMP2
        ldd 5,x                             ; taille de la dimension traitée
        std SAVREGS
        clra
        clrb

bclUMULTARY:
        lsld
        bcs jmpPrintErrMsg0x010BSIndiceIncorrect
        asl STRNG2+1
        rol STRNG2
        bcc endUMULTARY
        addd SAVREGS
        bcs jmpPrintErrMsg0x010BSIndiceIncorrect

endUMULTARY:
        dec PTRTMP2
        bne bclUMULTARY
        rts

jmpPrintErrMsg0x010BSIndiceIncorrect:
        jmp printErrorMSG0x10BSIndiceIncorrect
; End of function UMULTARY

; /// BASIC - STRING
xxBASIC_STRING:

; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un octet non signé en float
; IN  : B=BYTE TO CONVERT
; OUT : ACC1=float(D) with A = 0

convUnsignedByteToACC1:
        clra                                ; Force que D soit réellement un octet !

; =============== S U B R O U T I N E =======================================
; FCT : Convert unsigned Word to Float
; IN  : D=number to convert
;       STRTYP = $00 (numérique)
; OUT : ACC1=float(D)

convUnsignedWordToACC1:
        clr NUMTYP                          ; On force le retour de la conversion comme un float
        std ACC1+1                          ; convert word to float !
        ldab #$90                           ; set exposant to 65536 = 2^16
        jmp convSignedWordToACC1

convSignedByteToACC1:
        stab ACC1+1                         ; 3 ; CONVERT (B) INTO ACC1, AS SIGNED VALUE -128 TO +127
        clr ACC1+2                          ; 6 ; TODO : POURQUOI ?
                                            ; TODO : OPTIMISATION ?
                                            ; clrb        : 2
                                            ; std ACC1+1  : 4 : par contre l'appel se fait via le reg A et non pas le REG B!
        ldab #$88                           ; set exposant to max 255 = 2^8

; =============== S U B R O U T I N E =======================================
;FCT :
;IN  :   ; FLOAT UNSIGNED VALUE IN ACC1+1,2
;        ; (B) = EXPONENT
;        ; C=0 TO MAKE VALUE NEGATIVE
;        ; C=1 TO MAKE VALUE POSITIVE
;OUT : ACC1 = FLOAT(Int)
convSignedWordToACC1:
        ldx  #ACC1
        ldaa #cTYPFLGACC1
        staa ACC1TYPFLG
        ldaa ACC1+1
        suba #$80                           ; La retenue est importante !!
        stab ACC1                           ; FLOAT UNSIGNED VALUE IN ACC1+1,2
        ldaa #$00                           ; OPT : attention ! ne pas remplacer par clra sinon la retenue sera effacé et le test effectué dans next6RompPlus ne fonctionnera PLUS !!
        tab
        std  ACC1+3
        staa ACC1EXT
        staa ACC1+5                         ; set ACC1 sign
        jmp normalizeMantBySignRomPLUS      ; NORMALIZE FAC1

; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un int signé en float.
; IN  : ACC1 : contient l'entier à convertir
;              ACC1+3,4 : contient l'entier
;              ACC1+5   : contient le signe de l'entier
;
;OUT : ACC1 = FLOAT(Int)
;      A,X : modified / B : unmodified
convSignedWordToACC1_NEW:
        ldx  #ACC1
        ldaa #cTYPFLGACC1
        bra convSignedWordToACCx

; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un int signé en float.
; IN  : ACC2 : contient l'entier à convertir
;              ACC2+3,4 : contient l'entier
;              ACC2+5   : contient le signe de l'entier
;
;OUT : ACC2 = FLOAT(Int)
;      A,X : modified / B : unmodified
convSignedWordToACC2_NEW:
        ldx  #ACC2
        ldaa #cTYPFLGACC2
convSignedWordToACCx:
        pshb                                ; sauve l'exposant
        staa 7,X                            ; set ACCxTYPFLG
        ldab #$90                           ; fixe l'exposant pour la conversion sur 16 bits (2^16)
        stab 0,X
        ldd  3,X                            ; recopie la valeur entière à convertir dans octets 1 et 2 de la mantissee
        std  1,X
        clra
        clrb
        std  3,X
        stab 6,X                            ; clear ACCxEXT
        ldaa 5,X
        coma
        asra                                ; C=1 : conversion d'un entier positif sinon négatif
        stab 5,X                            ; clear ACCXSIGN
        jsr normalizeMantBySignRomPLUS      ; NORMALIZE ACCx
        pulb
        rts

; End of function convUnsignedByteToACC1
; End of function convUnsignedWordToACC1
; End of function convSignedByteToACC1
; End of function convSignedWordToACC1

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC STR$(A) : retourne l'équivalent en string de l'expression numérique A
; STX : A$=STR$(100)
; OPT : TODO : pour accélerer : supprimer les intermédiaires ?
; BUG : /
; ALG : /
; OP  : $BE
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : une chaîne de caractères

romSTRdollar:
        jsr CHKNUM                          ; check arg (is to be numeric)
        ldx #FTAMPON                        ; Tampon pour conversion float -> STRING
        jsr FOUT1                           ; FCT : "STR$" FUNCTION ENTERS HERE,
                                            ; IN  : X=Pointeur sur le tampon de conversion Float -> String
                                            ;       ACC1=la valeur à convertir en chaine de caractères
                                            ; OUT : X=Pointeur sur le tampon de conversion Float -> String
                                            ;       A et B modified
        pulx                                ; pop the return address
        ldx #FTAMPON-1                      ; Tampon pour conversion float -> STRING
        bra STRLIT                          ; FCT : BUILD A DESCRIPTOR FOR STRING STARTING AT X
                                            ;       AND TERMINATED BY $00 OR QUOTATION MARK
                                            ;       RETURN WITH DESCRIPTOR IN A TEMPORARY
                                            ;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
                                            ; ST  : ACTIF
                                            ; IN  : X=string to create an descriptor
                                            ; OUT : A,B,X modified
; End of function romSTRdollar

; =============== S U B R O U T I N E =======================================
; FCT : GET SPACE AND MAKE DESCRIPTOR FOR STRING WHOSE ADDRESS IS IN X
;       AND WHOSE LENGTH IS IN B-REG
; IN  : X=pointer on string
;       B=taille de la chaîne à réserver
; OUT : DESCSTR mise à jour

STRINI:
        stx DSCPTR

STRSPA:
        bsr getSPACE                        ; FCT : Réserve B octets dans l'espace des chaînes de caractères
                                            ;       Effectue un garbage collector si l'espace manque
                                            ; ERR : $1A : OVERFLOW STRING
                                            ; IN  : B=nombre d'octet à réserver
                                            ; OUT : B unmodified
                                            ;       X pointeur sur le début de la zone réservée

stdESCSTR_STRSPA:
        stx DESCSTR+1
        stab DESCSTR
        rts
; End of function STRINI


; =============== S U B R O U T I N E =======================================
; FCT : DEC X AND BUILD A DESCRIPTOR FOR STRING STARTING AT X
;       AND TERMINATED BY $00 OR QUOTATION MARK
;       RETURN WITH DESCRIPTOR IN A TEMPORARY
;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
; ST  : ACTIF
; IN  : X=string to create an descriptor
; OUT : A,B,X modified

DECXbeforeSTRLIT:
        dex
; End of function DECXbeforeSTRLIT


; =============== S U B R O U T I N E =======================================
; FCT : BUILD A DESCRIPTOR FOR STRING STARTING AT X
;       AND TERMINATED BY $00 OR QUOTATION MARK
;       RETURN WITH DESCRIPTOR IN A TEMPORARY
;       AND ADDRESS OF DESCRIPTOR IN ACC1+3,4
; ST  : ACTIF
; IN  : X=string to create an descriptor
; OUT : A,B,X modified

STRLIT:
        ldaa #cBAS_SEP_STR                  ; '"'
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        staa ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire

STRLT2:
        inx
        stx STRPTR
        stx DESCSTR+1                       ; TODO BEN VOYONS
        ldab #$FF

bclSTRLIT:
        incb
        ldaa 0,x
        beq next2STRLIT
        inx
        cmpa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        beq next1STRLIT
        cmpa ENDCHR                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        bne bclSTRLIT

next1STRLIT:
        cmpa #cBAS_SEP_STR                  ; '"'
        beq next2STRLIT
        dex

next2STRLIT:
        stx STRNG2
        stab DESCSTR
        pshb
        ldd STRPTR
        subd #FTAMPON                       ; Tampon pour conversion float -> STRING
        pulb

next3STRLIT:
        bhi PUTNEW                          ; FCT : STORE DESCRIPTOR IN TEMPORARY DESCRIPTOR STACK
                                            ; THE DESCRIPTOR IS NOW IN DESCSTR
                                            ; PUT ADDRESS OF TEMP DESCRIPTOR IN ACC1+3,4
                                            ; ERR : $1E : TOO COMPLEX
                                            ; IN  : DESCSTR mise à jour
                                            ; OUT : LASTPT=TMPPT   [OLD TMPPT]
                                            ;       TMPPT=TMPT+5   [NEW TMPPT]
        bsr STRINI                          ; FCT : GET SPACE AND MAKE DESCRIPTOR FOR STRING WHOSE ADDRESS IS IN X
                                            ;       AND WHOSE LENGTH IS IN B-REG
                                            ; IN  : X=pointer on string
                                            ;       B=taille de la chaîne à réserver
                                            ; OUT : DESCSTR mise à jour
        ldx STRPTR
        jsr MOVSTR                          ; FCT : Déplace une zone mémoire dont la source est donnée par X
                                            ;       et la cible par le pointeur contenu dans FREESPC
                                            ; IN  : X=source de la zone à copier
                                            ;       B=nombre d'octet à copier
                                            ; OUT : A, X,B modified
; End of function STRLIT

; =============== S U B R O U T I N E =======================================
; FCT : STORE DESCRIPTOR IN TEMPORARY DESCRIPTOR STACK
;       THE DESCRIPTOR IS NOW IN DESCSTR
;       PUT ADDRESS OF TEMP DESCRIPTOR IN ACC1+3,4
; ERR : $1E : TOO COMPLEX
; IN  : DESCSTR mise à jour
; OUT : LASTPT=TMPPT   [OLD TMPPT]
;       TMPPT=TMPT+5   [NEW TMPPT]

PUTNEW:
        ldx TMPPT                           ; obtient le descripteur du prochain "STRING"
        cpx #TMPDESCSTK+15                  ; La pile de descripteur temporaire a une profondeur de 3 descripteurs (3 x 5 de long)
        bne nextPUTNEW

setErrorTo0x1E_STATEMENT_TOOCOMPLEX:
        ldab #cBAS_ERR_FRMCPX
jmpERROR:
        jmp ERROR

nextPUTNEW:
        ldaa DESCSTR
        staa 0,x
        ldd DESCSTR+1
        std 2,x
        ldaa #$FF                           ; le type de retour est "STRING"
        staa STRTYP                         ; $FF : type string, $00:numeric
        stx LASTPT
        stx ACC1+3                          ; ACC1+3/ACC1+4 : pointeur sur la position de la chaîne précédente
        ldab #cBAS_BYTES_PER_VARIABLE       ; $05 ; 5 octets de plus ...
        abx
        stx TMPPT                           ; Met à jour le prochain descripteur de "STRING"
        rts
; End of function PUTNEW


; =============== S U B R O U T I N E =======================================
; FCT : Réserve B octets dans l'espace des chaînes de caractères
;       Effectue un garbage collector si l'espace manque
; ERR : $1A : OVERFLOW STRING
; IN  : B=nombre d'octet à réserver
; OUT : B unmodified
;       X pointeur sur le début de la zone réservée

getSPACE:
        clr DATAFLG

bclgetSPACE:
        pshb
        clra
        std INDEX
        ldd FRETOP
        subd INDEX
        subd BOTSTK
        bcs nextgetSPACE
        addd BOTSTK
        std FRETOP
        ldx FRETOP
        inx
        stx FREESPC
        pulb
        rts

nextgetSPACE:
        ldab #cBAS_ERR_STRFULL              ; $1A : erreur OS : overflow string
        com DATAFLG
        beq jmpERROR
        bsr GARBAGE                         ; FCT : SHOVE ALL REFERENCED STRINGS AS HIGH AS POSSIBLE
                                            ;       IN MEMORY (AGAINST HIMEM), FREEING UP SPACE
                                            ;       BELOW STRING AREA DOWN TO STREND
                                            ; IN  : /
                                            ; OUT : /
        pulb
        bra bclgetSPACE
; End of function getSPACE


; =============== S U B R O U T I N E =======================================
; FCT : SHOVE ALL REFERENCED STRINGS AS HIGH AS POSSIBLE
;       IN MEMORY (AGAINST HIMEM), FREEING UP SPACE
;       BELOW STRING AREA DOWN TO STREND
; IN  : /
; OUT : /

GARBAGE:
        ldx MEMSIZ                          ; Adresse - 1 de la fin de la RAM DISPONIBLE

bclGARBAGE:
        stx FRETOP
        clra
        clrb
        std GARBTMP
        ldx BOTSTK
        stx LOWTR
        ldx #TMPDESCSTK                     ; $3146 : TODO A CORRIGER LE NOMBRE OU AJOUTER UN COMMENTAIRE

bcl1GARBAGE:
        cpx TMPPT
        beq next2GARBAGE
        bsr chkVarGARBAGE
        bra bcl1GARBAGE

next2GARBAGE:
        ldx VARTAB                          ; Fin du programme BASIC / début des variables

bcl3GARBAGE:
        cpx ARYTAB
        beq next4GARBAGE
        bsr chkSimpleVarGARBAGE
        bra bcl3GARBAGE

next4GARBAGE:
        stx HIGHDS                          ; Cible lors d'une copie de zone mémoire

bcl5GARBAGE:
        ldx HIGHDS                          ; Cible lors d'une copie de zone mémoire

bcl6GARBAGE:
        cpx STREND
        beq MOVE_HIGHEST_STR_TO_TOP
        ldd 2,x
        addd HIGHDS                         ; Cible lors d'une copie de zone mémoire
        std HIGHDS                          ; Cible lors d'une copie de zone mémoire
        ldaa 1,x
        bpl bcl5GARBAGE
        ldab 4,x
        aslb
        addb #cBAS_BYTES_PER_VARIABLE       ; $05
        abx

bcl7GARBAGE:
        cpx HIGHDS                          ; Cible lors d'une copie de zone mémoire
        beq bcl6GARBAGE
        bsr chkVarGARBAGE
        bra bcl7GARBAGE
; End of function GARBAG


; =============== S U B R O U T I N E =======================================
chkSimpleVarGARBAGE:
        ldaa 1,x
        inx
        inx
        bpl chkBumpChkVarGARBAGE
; End of function chkSimpleVarGARBAGE


; =============== S U B R O U T I N E =======================================
; FCT : Nettoyage des variables
; IN  : X=pointeur sur les variables à nettoyer
; OUT : A,B,X modified

chkVarGARBAGE:
        ldab 0,x
        beq chkBumpChkVarGARBAGE
        ldd 2,x
        subd FRETOP
        bhi chkBumpChkVarGARBAGE
        ldd 2,x
        subd LOWTR
        bls chkBumpChkVarGARBAGE
        stx GARBTMP
        ldd 2,x
        std LOWTR

chkBumpChkVarGARBAGE:
        ldab #cBAS_BYTES_PER_VARIABLE       ; $05 ; longueur du descripteur ...
        abx

endChkVarGARBAGE:
        rts
; End of function chkVarGARBAGE

MOVE_HIGHEST_STR_TO_TOP:
        ldx GARBTMP
        beq endChkVarGARBAGE
        clra
        ldab 0,x
        decb
        addd LOWTR
        std HIGHTR
        ldx FRETOP
        stx HIGHDS                          ; Cible lors d'une copie de zone mémoire
        jsr doBLTU                          ; FCT : move block of memory up
                                            ; IN  : HIGHDS (cible), HIGHTR (source min), LOWTR (source max) à jour
                                            ; OUT : A,B,X modified
        ldx GARBTMP
        ldd PTRTMP2
        std 2,x
        ldx PTRTMP2
        dex
        jmp bclGARBAGE
; END OF FUNCTION CHUNK FOR GARBAGE

; =============== S U B R O U T I N E =======================================
; FCT : Concatenate two strings
; IN  : ACC1(3:4) : pointer on string
;       expression to evaluate
; OUT : pointer

CAT:
        ldx ACC1+3
        pshx                                ; save left string descriptor
        jsr EVAL                            ; FCT : GET ELEMENT IN EXPRESSION
                                            ;       GET VALUE OF VARIABLE OR NUMBER OR NOT OR FUNCTION OR PARENTHESIS
                                            ;       AT TXTPTR, OR POINT TO STRING DESCRIPTOR IF A STRING, AND PUT IN ACC1.
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=resultat
        jsr CHKSTR
        pulx
        stx STRPTR
        ldab 0,x
        ldx ACC1+3
        addb 0,x
        bcc nextCAT

setErrorTo0x1C_StringTooLong:
        ldab #cBAS_ERR_STRLONG
        jmp ERROR

nextCAT:
        jsr STRINI                          ; FCT : GET SPACE AND MAKE DESCRIPTOR FOR STRING WHOSE ADDRESS IS IN X
                                            ;       AND WHOSE LENGTH IS IN B-REG
                                            ; IN  : X=pointer on string
                                            ;       B=taille de la chaîne à réserver
                                            ; OUT : DESCSTR mise à jour
        ldx STRPTR
        ldab 0,x
        bsr MOVSTR_IND                      ; FCT : Déplace une zone mémoire dont la source est donnée
                                            ;       indirectement par X et la cible par le pointeur contenu
                                            ;       dans FREESPC
                                            ; IN  : X=source de la zone à copier
                                            ;       B=nombre d'octet à copier
                                            ; OUT : A, X,B modified
        ldx DSCPTR
        bsr FRETMP                          ; FCT : IF STRING DESCRIPTOR WHOSE ADDRESS IS IN X IS
                                            ; ;     A TEMPORARY STRING, RELEASE IT.
                                            ; IN  : X=Address of string descriptor
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne de caractères réservée
        bsr MOVSTR                          ; FCT : Déplace une zone mémoire dont la source est donnée par X
                                            ;       et la cible par le pointeur contenu dans FREESPC
                                            ; IN  : X=source de la zone à copier
                                            ;       B=nombre d'octet à copier
                                            ; OUT : A, X,B modified
        ldx STRPTR
        bsr FRETMP                          ; FCT : IF STRING DESCRIPTOR WHOSE ADDRESS IS IN X IS
                                            ; ;     A TEMPORARY STRING, RELEASE IT.
                                            ; IN  : X=Address of string descriptor
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne de caractères réservée
        jsr PUTNEW                          ; FCT : STORE DESCRIPTOR IN TEMPORARY DESCRIPTOR STACK
                                            ; THE DESCRIPTOR IS NOW IN DESCSTR
                                            ; PUT ADDRESS OF TEMP DESCRIPTOR IN ACC1+3,4
                                            ; ERR : $1E : TOO COMPLEX
                                            ; IN  : DESCSTR mise à jour
                                            ; OUT : LASTPT=TMPPT   [OLD TMPPT]
                                            ;       TMPPT=TMPT+5   [NEW TMPPT]
        jmp testOpFRMEVL
; End of function CAT


; =============== S U B R O U T I N E =======================================
; FCT : Déplace une zone mémoire dont la source est donnée
;       indirectement par X et la cible par le pointeur contenu
;       dans FREESPC
; IN  : X=source de la zone à copier
;       B=nombre d'octet à copier
; OUT : A, X,B modified

MOVSTR_IND:
        ldx 2,x
; End of function MOVSTR_IND


; =============== S U B R O U T I N E =======================================
; FCT : Déplace une zone mémoire dont la source est donnée par X
;       et la cible par le pointeur contenu dans FREESPC
; IN  : X=source de la zone à copier
;       B=nombre d'octet à copier
; OUT : A, X,B modified

MOVSTR:
        tpa
        psha
        sts SAVREGS
        sei
        txs
        ldx FREESPC
        incb
        bra nextMOVSTR

bclMOVSTR:
        pula
        staa 0,x
        inx

nextMOVSTR:
        decb
        bne bclMOVSTR
        stx FREESPC
        lds SAVREGS
        pula
        tap
        rts
; End of function MOVSTR


; =============== S U B R O U T I N E =======================================
; FCT : Libére la zone réservée pour une chaîne de caractères
;       lors de l'interprétation du flux d'entrée
; IN  : ACC1+3 et ACC1+4 : contient le descripteur de chaîne à traiter
; OUT : X=pointeur sur la chaîne de caractères
;       B=longueur de la chaîne de caractères

FRESTR:
        jsr CHKSTR
; End of function FRESTR


; =============== S U B R O U T I N E =======================================
; FCT : Libére la zone réservée par descripteur (chaîne de caractères)
; IN  : ACC1+3 et ACC1+4 : contient le descripteur
; OUT : X=pointer
;       B=longueur de la chaîne

FREFAC:
        ldx ACC1+3
; End of function FREFAC


; =============== S U B R O U T I N E =======================================
; FCT : IF STRING DESCRIPTOR WHOSE ADDRESS IS IN X IS
;       A TEMPORARY STRING, RELEASE IT.
; IN  : X=Address of string descriptor
; OUT : X=pointer
;       B=longueur de la chaîne de caractères réservée

FRETMP:
        ldab 0,x                            ; récupère la longueur de la chaîne réservée
        bsr FRETMS                          ; FCT : RELEASE TEMPORARY DESCRIPTOR IF X = LASTPT
                                            ; IN  : X=pointeur
                                            ; OUT : si X=LASTPT alors
                                            ;         TMPPT=X et LASTP=X-5
                                            ;         A=0
                                            ;       sinon rien
        bne end1FREETMP
        ldx $07,x
        dex
        cpx FRETOP
        bne endFREETMP
        pshb
        addd FRETOP
        std FRETOP
        pulb

endFREETMP:
        inx
        rts

end1FREETMP:
        ldx $02,x
        rts
; End of function FRETMP


; =============== S U B R O U T I N E =======================================
; FCT : RELEASE TEMPORARY DESCRIPTOR IF X = LASTPT
; IN  : X=pointeur
; OUT : si X=LASTPT alors
;       TMPPT=X et LASTP=X-5
;       A=0
;       sinon rien

FRETMS:
        cpx LASTPT
        bne endFREETMPS
        stx TMPPT
        dex
        dex
        dex
        dex
        dex
        stx LASTPT
        clra

endFREETMPS:
        rts
; End of function FRETMS


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC LEN(A$) : récupère la longueur de la chaîne A$
; STX : A=LEN(A$)
; BUG : /
; ALG : /
; OP  : $BD
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : ACC1=la longueur de la chaîne A$ > 0 sous forme d'un entier

romLEN:
        bsr GETSTR                          ; FCT : POINT X TO STRING ADDRESS LOAD LENGTH INTO ACCB.
                                            ;       ENTER WITH THE STRING DESCRIPTOR IN BOTTOM TWO BYTES OF ACC1
                                            ; IN  : ACC1 : descripteur de la chaîne
                                            ; OUT : X=ACC1
                                            ;       B : length of string
                                            ;       flags à jour selon B (la longueur de la chaîne)
                                            ;       STRTYP=0 car le résultat est numérique
returnByteIntRomLEN:
        clra
returnWordIntRomLEN:
        std  ACC1+3                         ; set 16 bits value
        staa ACC1+5                         ; clr sign
        staa ACC1+2                         ; clr sign of compute ....
        staa ACC1TYPFLG                     ; set type to integer
        rts
; End of function romLEN


; =============== S U B R O U T I N E =======================================
; FCT : POINT X TO STRING ADDRESS LOAD LENGTH INTO ACCB.
;       ENTER WITH THE STRING DESCRIPTOR IN BOTTOM TWO BYTES OF ACC1
; IN  : ACC1 : descripteur de la chaîne
; OUT : X=ACC1
;       B : length of string
;       flags à jour selon B (la longueur de la chaîne)
;       STRTYP=0 car le résultat est numérique

GETSTR:
        bsr FRESTR                          ; FCT : Libére la zone réservée pour une chaîne de caractères
                                            ;       lors de l'interprétation du flux d'entrée
                                            ; IN  : ACC1+3 et ACC1+4 : contient le descripteur de chaîne à traiter
                                            ; OUT : X=pointeur sur la chaîne de caractères
                                            ;       B=longueur de la chaîne de caractères
        clr STRTYP                          ; type de la variable en cours : numerique car STRTYP=$00
        tstb                                ; Set flags according to length
        rts
; End of function GETSTR


; =============== S U B R O U T I N E =======================================
; FCT : Commande BASIC CHR$(N) : Renvoie le caractère ou
;       la commande correpondant à N
; STX : PRINT CHR$(65)
; BUG : /
; ALG : /
; OP  : $C1
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT:  /

romCHRdollar:
        jsr CONINT                          ; conversion d'une expression parenthésée de type byte

nextRomCHRdollar:
        ldab #$01
        jsr getSPACE                        ; FCT : Réserve B octets dans l'espace des chaînes de caractères
                                            ;       Effectue un garbage collector si l'espace manque
                                            ; ERR : $1A : OVERFLOW STRING
                                            ; IN  : B=nombre d'octet à réserver
                                            ; OUT : B unmodified
                                            ;       X pointeur sur le début de la zone réservée
        ldaa ACC1+4
        jsr stdESCSTR_STRSPA                ; Sauvegarde le pointeur X sur la nouvelle chaîne et la longueur B dans ACC2
        staa 0,x                            ; Sauve la valeur de l'expression dans la nouvelle chaîne

next1RomCHRdollar:
        ins
        ins                                 ; supprime l'adresse de retour

endRomCHRdollar:
        jmp PUTNEW                          ; FCT : STORE DESCRIPTOR IN TEMPORARY DESCRIPTOR STACK
                                            ; THE DESCRIPTOR IS NOW IN DESCSTR
                                            ; PUT ADDRESS OF TEMP DESCRIPTOR IN ACC1+3,4
                                            ; ERR : $1E : TOO COMPLEX
                                            ; IN  : DESCSTR mise à jour
                                            ; OUT : LASTPT=TMPPT   [OLD TMPPT]
                                            ;       TMPPT=TMPT+5   [NEW TMPPT]
; End of function romCHRdollar

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC ASC("TEST") : retourne le code ASCII du premier caractère du paramètre
;       retourne l'erreur FC si chaîne vide
; STX : A=ASC("100") retourne 49 (=ASCII de 1)
; BUG : /
; ALG : /
; OP  : $C0
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : ACC1 : code ASCII du premier caractère sous forme d'un entier

romASC:
        bsr GETSTR                          ; FCT : POINT X TO STRING ADDRESS LOAD LENGTH INTO ACCB.
                                            ;       ENTER WITH THE STRING DESCRIPTOR IN BOTTOM TWO BYTES OF ACC1
                                            ; IN  : ACC1 : descripteur de la chaîne
                                            ; OUT : X=ACC1
                                            ;       B : length of string
                                            ;       flags à jour selon B (la longueur de la chaîne)
                                            ;       STRTYP=0 car le résultat est numérique
        beq jmpPrintErrorMSg0x08_01
        ldab $00,x                          ; get first char of string
        jmp returnByteIntRomLEN

; =============== S U B R O U T I N E =======================================
; FCT : Extrait les n premiers caractères d'une chaîne de caractères
; STX : A$=LEFT$(B$,3)
; ALG : /
; ST  : ACTIF
; OP  : $C2
; IN  : le flot d'interprétation
; OUT : un descripteur de chaîne de caractères

romLEFTdollar:
        bsr SUBSTRING_SETUP                 ; FCT : COMMON SETUP ROUTINE FOR LEFT$, RIGHT$, MID$:
                                            ;       REQUIRE ")"; POP RETURN ADRS, GET DESCRIPTOR
                                            ;       ADDRESS, GET 1ST PARAMETER OF COMMAND
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=DSCPTR
                                            ;       B=Longueur de la chaîne
                                            ;       A=Longueur de la chaîne
        clra

nextRomLEFTdollar:
        cmpb $00,x
        bls next1RomLEFTdollar
        ldab $00,x
        clra

next1RomLEFTdollar:
        pshb
        psha
        jsr STRSPA
        ldx DSCPTR
        bsr FRETMP                          ; FCT : IF STRING DESCRIPTOR WHOSE ADDRESS IS IN X IS
                                            ;       A TEMPORARY STRING, RELEASE IT.
                                            ; IN  : X=Address of string descriptor
                                            ; OUT : X=pointer
                                            ;       B=longueur de la chaîne de caractères réservée
        pulb
        abx
        pulb
        jsr MOVSTR                          ; FCT : Déplace une zone mémoire dont la source est donnée par X
                                            ;       et la cible par le pointeur contenu dans FREESPC
                                            ; IN  : X=source de la zone à copier
                                            ;       B=nombre d'octet à copier
                                            ; OUT : A, X,B modified
        bra endRomCHRdollar
; End of function romLEFTdollar


; =============== S U B R O U T I N E =======================================
; FCT : Extrait les n dernières caractères d'une chaîne
; STX : A$=RIGHT$(B$,3)
; ALG : /
; ST  : ACTIF
; OP  : $C3
; IN  : le flot d'interprétation
; OUT : un descripteur de chaîne de caractères

romRIGHTdollar:
        bsr SUBSTRING_SETUP                 ; FCT : COMMON SETUP ROUTINE FOR LEFT$, RIGHT$, MID$:
                                            ;       REQUIRE ")"; POP RETURN ADRS, GET DESCRIPTOR
                                            ;       ADDRESS, GET 1ST PARAMETER OF COMMAND
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=DSCPTR
                                            ;       B=Longueur de la chaîne
                                            ;       A=Longueur de la chaîne
        ldaa $00,x
        sba
        bra nextRomLEFTdollar
; End of function romRIGHTdollar


; =============== S U B R O U T I N E =======================================
; FCT : Extrait de la chaine c,à partir de la position n1, n2 caractères
; STX : A$=MID$(c,N1,N2)
; ALG : /
; ST  : ACTIF
; OP  : $C4
; IN  : le flot d'interprétation
; OUT : un descripteur de chaîne de caractères

romMIDdollar:
        ldab #$FF
        stab ACC1+4
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        cmpa #cBAS_FCT_CLOSE                ; ')'
        beq nextRomMIDdollar
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"

nextRomMIDdollar:
        bsr SUBSTRING_SETUP                 ; FCT : COMMON SETUP ROUTINE FOR LEFT$, RIGHT$, MID$:
                                            ;       REQUIRE ")"; POP RETURN ADRS, GET DESCRIPTOR
                                            ;       ADDRESS, GET 1ST PARAMETER OF COMMAND
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=DSCPTR
                                            ;       B=Longueur de la chaîne
                                            ;       A=Longueur de la chaîne
        beq jmpPrintErrorMSg0x08_01
        clrb
        deca
        cmpa $00,x
        bcc next1RomLEFTdollar
        tab
        subb 0,x
        negb
        cmpb ACC1+4
        bls next1RomLEFTdollar
        ldab ACC1+4
        bra next1RomLEFTdollar
; End of function romMIDdollar


; =============== S U B R O U T I N E =======================================
; FCT : COMMON SETUP ROUTINE FOR LEFT$, RIGHT$, MID$:
;       REQUIRE ")"; POP RETURN ADRS, GET DESCRIPTOR
;       ADDRESS, GET 1ST PARAMETER OF COMMAND
; IN  : le flot d'interprétation
; OUT : X=DSCPTR
;       B=Longueur de la chaîne
;       A=Longueur de la chaîne

SUBSTRING_SETUP:
        jsr CHKCLS                          ; FCT : check close parenthesis and get next char
                                            ; IN  : TXTPTR mise à jour
                                            ; OUT : X unmodified, A et B modified
        tsx
getPtrSUBSTRING_SETUP:
        ldd 5,x
        std DSCPTR
setAdrReturnSUBSTRING_SETUP:
        ldd 0,x
        std 5,x
adjustStackSUBSTRING_SETUP:
        pulx
        pulx
getLengthSUBSTRING_SETUP:
        pula
returnPtrSUBSTRING_SETUP:
        ldx DSCPTR
returnLengthSUBSTRING_SETUP:
        tab
        rts
; End of function SUBSTRING_SETUP

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR GETBYT

jmpPrintErrorMSg0x08_01:
        jmp printErrorMSG_0x08_FC_FctIncorrect
; END OF FUNCTION CHUNK FOR GETBYT

; =============== S U B R O U T I N E =======================================
; FCT: SCAN TO NEXT CHARACTER AND CONVERT EXPRESSION
;      TO SINGLE BYTE IN B-REG
; IN : Le flot d'interprétation
; OUT: B=byte converted from expression
;      A=next char after expression

GETBYTC:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
; End of function GETBYTC

; =============== S U B R O U T I N E =======================================
; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
;       CONVERT IT TO SINGLE BYTE IN B-REG
; ERR : FC : fonction incorrecte
; IN  : le flot d'interprétation
;       A = le premier caractère lu dans le flot d'interprétation
; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
;       A=dernier octet lu dans le flot d'interprétation

GETBYT:
        jsr FRMNUM
                                            ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour
                                            ; TODO : OPTIM : FRNUM teste déjà la "numéracité" du nombre pourquoi le refaire via JSR MKINT ?
CONINT:
        jsr MKINT                           ; FCT : Convertit le résultat de l'évaluation d'une expression
                                            ;       du flot d'interprétration comme un octet
                                            ; ERR : FC : Fonction Incorrecte
                                            ; IN  : Le résultat d'une interprétation :
                                            ;       ACC1 doit contenir une valeur
                                            ;       NUMTYP doit contenir le flag du type du résultat de l'interprétration
                                            ; OUT : D=ACC1 contenant le résultat de l'évaluation
        ldaa ACC1+3
        bne jmpPrintErrorMSg0x08_01
        ldab ACC1+4
        jmp CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
; End of function GETBYT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC VAL("X") : retourne l'équivalent numérique d'une chaîne de caractères contenant des chiffres
; STX : A=VAL("100")
; BUG : /
; ALG : /
; OP  : $BF
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : ACC1 : représentation numérique de l'entrée sous forme d'un float

romVAL:
        jsr GETSTR                          ; FCT : POINT X TO STRING ADDRESS LOAD LENGTH INTO ACCB.
                                            ;       ENTER WITH THE STRING DESCRIPTOR IN BOTTOM TWO BYTES OF ACC1
                                            ; IN  : ACC1 : descripteur de la chaîne
                                            ; OUT : X=ACC1
                                            ;       B : length of string
                                            ;       flags à jour selon B (la longueur de la chaîne)
                                            ;       STRTYP=0 car le résultat est numérique
        bne nextRomVAL
        ldx #ACC1
        jmp ZEROFAC                         ; X=pointeur sur une zone mémoire de type float étendu

nextRomVAL:
        jsr addRegBToTMPPTR                 ; FCT : INDEX=X et TMPPTR=X+B
                                            ; IN  : B=offset sur 8 bits
                                            ;       X=pointeur
                                            ; OUT : INDEX=X
                                            ;       X=D=TMPPTR=X+D
        ldaa 0,x
        psha                                ; Sauvegarde du dernier caractere de la chaîne
        clr 0,x                             ; Remplacement de celui-ci par un $00 (fin de chaîne)
        ldx TXTPTR
        stx STRNG2                          ; Sauvegarde du TXTPTR
        ldx INDEX
        stx TXTPTR                          ; Pointe sur le début de la chaîne
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        jsr FIN                             ; FCT : Float IN : parse a number
                                            ;       NUMBER INPUT IS LEFT IN FAC.
                                            ;       AT ENTRY [TXTPTR] POINTS TO THE FIRST CHARACTER IN A TEXT BUFFER.
                                            ;       THE FIRST CHARACTER IS ALSO IN ACCA. FIN PACKS THE DIGITS
                                            ;       INTO THE FAC AS AN INTEGER AND KEEPS TRACK OF WHERE THE
                                            ;       DECIMAL POINT IS. [DPTFLG] TELL WHETHER A DP HAS BEEN
                                            ;       SEEN. [DECCNT] IS THE NUMBER OF DIGITS AFTER THE DP.
                                            ;       AT THE END [DECCNT] AND THE EXPONENT ARE USED TO
                                            ;       DETERMINE HOW MANY TIMES TO MULTIPLY OR DIVIDE BY TEN
                                            ;       TO GET THE CORRECT NUMBER.
                                            ; IN  : C=1 : The first character is numeric
                                            ;       C=0 : The first character is not numeric
                                            ;       A=premier caractère à convertir
                                            ; OUT : ACC1
        pula                                ; récupération du dernier caractère de la chaîne
        ldx TMPPTR
        staa 0,x                            ; repositionne celui-ci au bon endroit

next1RomVAL:
        ldx STRNG2                          ; Restauration de TXTPTR
        stx TXTPTR
        rts
; End of function romVAL

; =============== S U B R O U T I N E =======================================
; FCT : Lit un caractère provenant du clavier
; OP  : $C7
; ST  : ACTIF
; IN  : /
; OUT : Retourne une chaîne de caractère

romGETAdollar:
        ldaa CHARKBD                        ; WAS A KEY DOWN IN THE BREAK CHECK ?
        bne nextRomGETAdollar
        jsr OS_POLCA                        ; FCT : polling keyboard
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche actionnée
                                            ;       X,B not modified

nextRomGETAdollar:
        clr CHARKBD
        staa ACC1+4
        beq next1RomGETAdollar
        jmp nextRomCHRdollar

next1RomGETAdollar:
        staa DESCSTR
        jmp next1RomCHRdollar
; End of function romGETAdollar

; =============== S U B R O U T I N E =======================================
; FCT : parse 2 arguments séparés par une virgule
;       1er argument : word 2eme Arg : byte
; IN  : /
; OUT : LINUM contient la valeur du premier argument
;       B     contient la valeur du deuxième argument

get2params:
        bsr getArg                          ; FCT : récupère un word dans le flot d'inteprétation
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=WORD from ARGUMENT
                                            ;       ACC1+3 et ACC1+4 contiennent aussi l'expression convertie de type word
        stx LINUM
; End of function get2params


; =============== S U B R O U T I N E =======================================
; FCT : Retourne la valeur de l'expression après la
;       virgule contenue dans le flot d'interprétation
; IN  : Le flot d'interprétation
; OUT : B=la valeur de l'expression au format "BYTE"

getByteAfterComma:
        jsr CHKCOM
        bra GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
; End of function getByteAfterComma

; =============== S U B R O U T I N E =======================================
; FCT : récupère un word dans le flot d'inteprétation
; IN  : le flot d'interprétation
; OUT : X=WORD from ARGUMENT
;       ACC1+3 et ACC1+4 contiennent aussi l'expression convertie de type word

getArg:
        jsr FRMNUM                          ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour

convIntGetArg:
        ldaa ACC1+5                         ; get ACC1 sign
        bmi jmpPrintErrorMSg0x08_01         ; is négative ? yes then error
isIntGetArg:
        ldaa ACC1TYPFLG
        bne endGetArg
conv2IntGetArg:
        ldaa ACC1
        cmpa #$90
        bhi jmpPrintErrorMSg0x08_01
        jsr QUICK_INT                       ; FCT : effectue la fonction int sur ACC1
                                            ; IN  : ACC1 mis à jour
                                            ; OUT : ACC1=INT(ACC1)
                                            ;       B=exposant de ACC1
endGetArg:
        ldx ACC1+3
        rts
; End of function getArg

; /// BASIC - MATHEMATIQUE - FLOTTANT & TRIGONOMETRIE
xxBASIC_MATH:

; ---------------------------------------------------------------------------
;----- float stocké en mode compressé : le bit 7 du 4ème octet de la mantisse (=high) indique le signe
cMINUS32768:            dc.b $90,$80,$00,$00,$00 ; -32768
cNEGONE:                dc.b $81,$80,$00,$00,$00 ; -1
cNEGHLF:                dc.b $80,$80,$00,$00,$00 ; -0.5
cONEdivFOUR:            dc.b $7F,$00,$00,$00,$00 ; +0.25
cONEdivTWO:             dc.b $80,$00,$00,$00,$00 ; +0.5
cLOG2:                  dc.b $80,$31,$72,$17,$F8 ; LOG(2) = LN(2) ! Terminologie anglo-saxonne vs française
cSQRHLF:                dc.b $80,$35,$04,$F3,$34 ; SQR(0.5)
cSQRTWO:                dc.b $81,$35,$04,$F3,$34 ; SQR(2)
cONEdivLN2:             dc.b $81,$38,$AA,$3B,$29 ; 1/LN(2)
; ---- début : garder l'ordre des chiffres 0 à 9
cZERO:                  dc.b $00,$00,$00,$00,$00 ; 0
cONE:                   dc.b $81,$00,$00,$00,$00 ; 1
cTWO:                   dc.b $82,$00,$00,$00,$00 ; 2
THREE:                  dc.b $82,$40,$00,$00,$00 ; 3
cFOUR:                  dc.b $83,$00,$00,$00,$00 ; 4
cFIVE:                  dc.b $83,$20,$00,$00,$00 ; 5
cSIX:                   dc.b $83,$40,$00,$00,$00 ; 6
cSEVEN:                 dc.b $83,$60,$00,$00,$00 ; 7
cEIGHT:                 dc.b $84,$00,$00,$00,$00 ; 8
cNINE:                  dc.b $84,$10,$00,$00,$00 ; 9
; ---- fin : garder l'ordre des chiffres 0 à 9
cTEN:                   dc.b $84,$20,$00,$00,$00 ; 10
c255                    dc.b $88,$7F,$00,$00,$00 ; 255
c256                    dc.b $89,$00,$00,$00,$00 ; 256
cCENT_MILLIONS:         dc.b $9B,$3E,$BC,$1F,$FD ; 100 000 000
cUN_MILLIARD_MOINS_1:   dc.b $9E,$6E,$6B,$27,$FD ; 1 000 000 000 000 -1
cUN_MILLIARD:           dc.b $9E,$6E,$6B,$28,$00 ; 1 000 000 000 000
;----------------
cONEdivTWOPI:           dc.b $7E,$22,$F9,$83,$72 ; constante pour optimisation pour la fonction sinus
cPIdivTWO:              dc.b $81,$49,$0F,$DA,$A2
cPI:                    dc.b $82,$49,$0F,$DA,$9E ; TODO : $A2 ou $9E ? valeur en provenance d'ORIC !! 23/10/2020
cTWOPI:                 dc.b $83,$49,$0F,$DA,$A2

;----------------
cRNDSEED:               dc.b $40,$E6,$4D,$AB     ;

;----------------
tabPuiss10:             dc.b $FA,$0A,$1F,$00     ;
                        dc.b $00,$98,$96,$80     ;
                        dc.b $FF,$F0,$BD,$C0     ;
                        dc.b $00,$01,$86,$A0     ;
                        dc.b $FF,$FF,$D8,$F0     ;
                        dc.b $00,$00,$03,$E8     ;
                        dc.b $FF,$FF,$FF,$9C     ;
                        dc.b $00,$00,$00,$0A     ;
                        dc.b $FF,$FF,$FF,$FF     ;
;----------------
tabParamEXP:            dc.b 7
                        dc.b $71,$34,$58,$3E,$56 ;
                        dc.b $74,$16,$7E,$B3,$1B ;
                        dc.b $77,$2F,$EE,$E3,$85 ;
                        dc.b $7A,$1D,$84,$1C,$2A ;
                        dc.b $7C,$63,$59,$58,$0A ;
                        dc.b $7E,$75,$FD,$E7,$C6 ;
                        dc.b $80,$31,$72,$18,$10 ;
                        dc.b $81,$00,$00,$00,$00 ;
;----------------
tabParamLOG:            dc.b 3
                        dc.b $7F,$5E,$56,$CB,$79 ;
                        dc.b $80,$13,$9B, $B,$64 ;
                        dc.b $80,$76,$38,$93,$16 ;
                        dc.b $82,$38,$AA,$3B,$20 ;
;----------------
tabParamSIN:            dc.b 5
                        dc.b $84,$E6,$1A,$2D,$1B ;
                        dc.b $86,$28,$07,$FB,$F8 ;
                        dc.b $87,$99,$68,$89,$01 ;
                        dc.b $87,$23,$35,$DF,$E1 ;
                        dc.b $86,$A5,$5D,$E7,$28 ;
                        dc.b $83,$49,$0F,$DA,$A2 ;

; ---------------------------------------------------------------------------


; =============== S U B R O U T I N E =======================================
; FCT : Renvoie la valeur de la constante PI - COMMANDE BASIC PI
; OP  : $XX
; ST  : ACTIF
; IN  : /
; OUT : ACC1=la valeur de la constante PI

romPI:
        ldx #cPI
        jmp fixTypeMOVFM                    ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
; End of function romPI


; =============== S U B R O U T I N E =======================================
; FCT : Renvoie la valeur de la constante 2*PI - COMMANDE BASIC TWOPI
; OP  : $XX
; ST  : ACTIF
; IN  : /
; OUT : ACC1=la valeur de la constante PI

romTWOPI:
        ldx #cTWOPI
        jmp fixTypeMOVFM                    ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
; End of function romTWOPI


; =============== S U B R O U T I N E =======================================
; FCT : additionne 0.5 à ACC1
; STX : /
; IN  : ACC1 à jour
; OUT : ACC1=ACC1+0.5

add1div2toACC1:
        ldx #cONEdivTWO
        bra FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
; End of function add1div2toACC1

; =============== S U B R O U T I N E =========FIN==============================

; FCT : Soustrait de ACC1 le nombre réel pointé par X
; STX : /
; ST  : ACTIF
; IN  : ACC1 à jour
;       X=pointeur sur un réel
; OUT : ACC1=FLOAT(PTR X) - ACC1

FSUB:
        jsr CONUPK                          ; FONCTION CONUPK
                                            ; FCT : Recopie le nombre pointé par X dans ACC2
                                            ; IN  : X: pointeur sur une constante
                                            ; OUT : ACC2 contient la constante pointée par (X)
                                            ;       A = Exposant du nombre pointé par X
        ldab ACC1
; End of function FSUB

; =============== S U B R O U T I N E =======================================
; FCT : Subtract ACC2 to ACC1
; STX : /
; ALG : /
; ST  : ACTIF
; IN  : ACC1 and ACC2 set
;       if A = 0 then ACC1=0
;       if B = 0 : do move ACC1 to ACC2 / B <> 0 : do operation
; OUT : ACC1=ACC1-ACC2

romMINUS:
        com ACC1+5                          ; inverse ACC1 sign
        com PRODSIGN
        tst ACC1TYPFLG                      ; si ACC1 est du type float nous effectuons l'addition
        bne romPLUS
intRomMINUS:
        pshb                                ; sauvegarde de l'exposant de ACC1 car romPLUS en a besoin
        ldd ACC1+3
        coma
        comb
        addd #$0001
        std ACC1+3                          ; inversion en complément de deux  pour effectuer l'addition
                                            ; en toute simplicité
        pulb                                ; récupération de l'exposant de ACC1 car romPLUS en a besoin
        bra romPLUS
; End of function romMINUS

; ACCx=ACCx+3,ACC+4,ACCx+5 avec ACCx+5 = signe : $00 (positif) ou $FF (négatif)
; si A=[0;65535] et B=[0;65535]
; alors
; si
;    sign(A) = sign(B) alors ACC1+ACC2 & ACC1+5=ACC1+5 et overflow si ABS(ACC1+ACC2) > 65535
;    sign(A) <> sign(B) alors
;         -A+B : Si A > B alors res=abs(A)-ABS(B))  avec le signe - sinon res=ABS(B) - ABS(A) avec le signe +
;         A+(-B):  Si A > B alors res= abs(A)-ABS(B) avec le signe + sinon res=ABS(B) - ABS(A) avec le signe -

signedIntRomPLUS:
doSignedIntRomPLUS:
        ldd  ACC1+3
        addd ACC2+3
        std  ACC1+3                         ; sauvegarde du résultat de l'addition
                                            ; le drapeau C contient l'overflow de l'addition
manageSignRomPLUS:
        ldaa ACC1+5
        tab                                 ; sauvegarde intermédiaire du signe du nombre contenu dans ACC1
        adca ACC2+5
        staa ACC1+2                         ; sauve le signe du résultat final
        cmpb ACC2+5                         ; Si SIGN(ACC1)<>SIGN(ACC2) alors pas d'overflow
        bne  beforeEndSignedIntRomPLUS
        cmpb ACC1+2                         ; Si (SIGN(ACC1)=SIGN(ACC2))=SIGN(ACC1+ACC2) alors pas d'overflow
        beq  beforeEndSignedIntRomPLUS
        jmp  jmpPrintErrorMSg0x0A_OVERFLOW
beforeEndSignedIntRomPLUS:
        staa ACC1+5                         ; sauvegarde du signe du résultat
endSignedIntRomPLUS:
        rts
; =============== S U B R O U T I N E =======================================
; FCT : Add constant to ACC1
; STX : /
; ALG : /
; ST  : ACTIF
; IN  : X=pointer on constant
; OUT : ACC1=ACC1 + constant given by X
;

FADD:
        jsr CONUPK                          ; FONCTION CONUPK
                                            ; FCT : Recopie le nombre de TYPE FLOAT pointé par X dans ACC2
                                            ; IN  : X: pointeur sur une constante
                                            ; OUT : ACC2 contient la constante pointée par (X)
                                            ;       A = Exposant du nombre pointé par X
        ldab ACC1

; End of function FADD

; =============== S U B R O U T I N E =======================================
; FCT : Add ACC2 to ACC1
; STX : /
; ALG : /
; ST  : ACTIF
; IN  : ACC1 and ACC2 set
;       A = 0 then ACC1=0
;       B = 0 : do move ACC1 to ACC2 / B <> 0 : do operation
; OUT : ACC1=ACC1+ACC2
; ALG :
;  + ajustement des exposants DE ACC1 et ACC2
;  + addition des mantisses de ACC1 et ACC2
;  + normalisation du résultat de l'addition

romPLUS:
        tstb
        bne intOrFloatRomPLUS
        jmp MOVA2A1ext       ; TODO MODIFIER LE CODE DE LA PROCEDURE !!!
                                            ; FCT : Recopie ACC2 étendu dans ACC1
                                            ; ST  : ACTIF
                                            ; IN  : ACC2 set
                                            ; OUT : ACC1=ACC2
intOrFloatRomPLUS:
        ldaa ACC1TYPFLG                     ; 3/2
        adda ACC2TYPFLG                     ; 3/2
        bcs next1RomPLUS                    ; 3/2 ; SI CARRY est à '1' alors somme de deux float
        beq signedIntRomPLUS                ; 3/2 ; SI = $00 alors somme de deux entiers
        bpl cnvFlt2RomPLUS                  ; 3/2 ; SI = $7F alors conversion de int en Float de ACC2 sinon de ACC1
        jsr convSignedWordToACC1_NEW        ; n/3
        bra next0RomPLUS                    ; 3/2
cnvFlt2RomPLUS:
        jsr convSignedWordToACC2_NEW        ; n/3
                                            ; Calcul de pénalités suite à la prise en compte des entiers
                                            ; pour 2 float     : pénalités de  9 cycles
                                            ; pour 2 integer   : pénalités de 12 cycles
                                            ; pour int + float : pénalités de 15 cycles + TODO + conversion d'un int en float
                                            ; pour float + int : pénalités de 18 cycles + TODO + conversion d'un int en float
                                            ; ==> 17 octets au pire

next0RomPLUS:
        ldaa #$FF
        staa NUMTYP                         ; Le résultat du calcul intermédiaire est obligatoirement un float
                                            ; régle explicite : un calcul d'un entier avec un float donnera toujours un float ...
;= ====== CODE ORIGINEL
next1RomPLUS:
        ldx #ACC2                           ; Par défaut, ACC2 doit être justifié
        ldaa ACC2                           ; Récupération de l'exposant de ACC2

; = ==== ADDITION DE ACC1 AVEC ACC2

doRomPLUS:
adjustMantByExpRomPLUS:                     ; XXX - POINT D'ENTREE
        tab                                 ; sauvegarde de l'exposant de ACC2
        beq endZeroFacRomPLUS               ; si EXPOSANT de ACC2 = 0 donc ACC1=ACC1(+0) !
        subb ACC1                           ; B=EXPOSANT de ACC2 - EXPOSANT DE ACC1
        beq doShiftByteRomPLUS
        bmi rollingShiftByteRomPLUS         ; si < 0 alors ACC1 > ACC2 donc pas de justification de la mantisse de ACC1 mais plutôt de ACC2
        staa ACC1                           ; sauve EXPOSANT de ACC2 dans EXPOSANT de ACC1
        ldaa ACC2+5
        staa ACC1+5                         ; sauve SIGNE de ACC2 dans SIGNE de ACC1
        ldx #ACC1                           ; ACC1 doit être justifié
        negb

rollingShiftByteRomPLUS:                    ; optimisation : le rolling shift s'effectue par octet puis par bit
        cmpb #$F8                           ; $F8 : borne inférieure du rolling shift par octet
        ble doShiftByteRomPLUS              ; Si =< borne alors on shift par octet

rollingShiftBitRomPLUS:
        clra
        lsr 1,x
        jsr FADD_ROLSHF                     ; FCT : Effectue un rolling shift sur le float pointé par X
                                            ; IN  : X=pointe sur une zone contenant un float
                                            ;       A=?
                                            ;       B=le nombre de décalage en négatif B <= 0
                                            ;       C=le bit précédent à propager
                                            ; OUT : X, A,B modified
        bra testProdSignROMPLUS

doShiftByteRomPLUS:
        jsr SHIFTR                          ; FCT : Effectue un décalage sur octet puis sur bit
                                            ; IN  : B : ?
                                            ;       X : pointeur sur l'accumulateur à traiter
                                            ; OUT : A,B,X modified
        clc

testProdSignROMPLUS:
        ldab PRODSIGN                       ; Si ACC1 et ACC2 ont le même signe alors addition de leur mantisse
                                            ; sinon nous effectuons la soustraction
        bpl addMantisseRomPLUS

negMantisseByXRomPLUS:                      ; ACC1 et ACC2 n'ont pas le même signe alors on inverse la mantisse de l'accumulateur
                                            ; impactée par la justification des exposants
        com 1,x                             ; inverse mantisse de l'accumulateur indiqué par X
        com 2,x
        com 3,x
        com 4,x
        coma                                ; ajuste A
        adca #$00

; = ==== ADDITION DES MANTISSES DE ACC1 ET ACC2
addMantisseRomPLUS:
        staa ACC1EXT
        ldaa ACC1+4
        adca ACC2+4
        staa ACC1+4
        ldaa ACC1+3
        adca ACC2+3
        staa ACC1+3
        ldaa ACC1+2
        adca ACC2+2
        staa ACC1+2
        ldaa ACC1+1
        adca ACC2+1
        staa ACC1+1

; = ==== NORMALISATION DE ACC1
        ldx #ACC1                           ; Suite à la prise en compte de l'ajout des entiers,
                                            ; nous avons "variabilisé" certaines parties du code
        tba                                 ; A=produit de l'opération
        bpl loc_F019                        ; ?

; =============== S U B R O U T I N E =======================================
; FCT : justification de la mantisse selon le signe de ACCx
;       permet aussi de convertir un nombre entier signed si :
;         - l'exposant est correctement positionné : $88 pour un byte, $90 pour un word
;         - la valeur doit être positionnée en ACCx+1 et ACCx+2
;         - le signe du nombre est correctement positionné
;         - C=1 indique un nombre positif sinon négatif
; IN  : X pointe sur une zone de type float étendu (ACC1,ACC2)
;       l'exposant du nombre float est déjà bien positionné
;       C=1 : conversion d'un nombre positif sinon conversion d'un nombre négatif
; OUT : la mantisse du nombre pointé par X est justifié
normalizeMantBySignRomPLUS:                 ; XXX2 - POINT D'ENTREE
        bcs normalizeMantRomPlus            ; NORMALIZE ACCx
        bsr invAllMantACCx                  ; Complémenent à deux de la zone float

normalizeMantRomPlus:                       ; XXX1 - POINT D'ENTREE
        clrb                                ; décale la mantisse vers la gauche (au minimum 0 fois au maximum 5 fois)

bclnormalizeMantRomPlus:                    ; decalage par octet
        ldaa 1,X
        bne isJustifBitByBitRomPLUS         ; si poids fort de la mantisse est non nul alors décalage par bit
        ldaa 2,X
        staa 1,X
        ldaa 3,X
        staa 2,X
        ldaa 4,X
        staa 3,X
        ldaa 6,X                            ; get extension of ACCx
        staa 4,X
        clr 6,X                             ; new valure for extension of ACCx
        addb #$08
        cmpb #$28
        blt bclnormalizeMantRomPlus         ; a-t-on décalé 5 fois ? non alors alors on décale la mantisse vers la gauche
                                            ; TODO : OPTIMISATION : LDAB #$05 ... decb bne bclnormalizeMantRomPlus ?

ZEROFAC:                                    ; X=pointeur sur une zone mémoire de type float étendu
        clra                                ; en fait le nombre est nul ...

ZEROFAC1:
        staa 0,X                            ; EXPOSANT of float : this number is 0 !

ZEROFAC2:
        staa 5,X                            ; SIGN of float = positif float !

endZeroFacRomPLUS:
        rts

; =============== S U B R O U T I N E =======================================
; FCT : justification de la mantisse du float étendu pointé par X
; IN  : X : pointeur sur un float étendu
; OUT : Float justifié
justifBitByBitRomPLUS:
        incb
        asl 6,X                             ; rotation de l'extension du float traité
        rol 4,X                             ; décalage de la mantisse du float traité
        rol 3,X
        rol 2,X
        rol 1,X

isJustifBitByBitRomPLUS:
        bpl justifBitByBitRomPLUS           ; Si toujours pas justifié alors on continue

adjustExpJustifBitbyBitRomPlus:
        ldaa 0,X
        sba
        staa 0,X                            ; Sauvegarde de l'exposant
        bls ZEROFAC                         ; X=pointeur sur une zone mémoire de type float étendu
                                            ; Si le nombre de décalage (sba) est supérieur à celui prévu
                                            ; alors le nombre = 0 ! => perte de precision extrême
        bra loc_F01B

; La partie la plus obscure du code pour traiter la justification de la mantisse

loc_F019:
        bcs shiftRightMantByBitRomPLUS
loc_F01B:
        asl 6,X                             ; Récupère dans C le signe du résultat
        ldaa #$00
        staa 6,X
        bra loc_F035                        ; le drapeau C est important (asl 6,X)

shiftRightMantByBitRomPLUS:
        inc 0,X                             ; Incrémenter l'exposant
        beq jmpPrintErrorMSg0x0A_OVERFLOW   ; Si exposant=0 alors overflow
        ror 1,X                             ; Décalage d'un bit vers la droite de la mantisse
        ror 2,X
        ror 3,X
        ror 4,X

loc_F035:
        bcc endRomPLUS                      ; Si la retenue = 0 alors on a terminé
        bsr adjustLowAndHighMantACCx
        beq shiftRightMantByBitRomPLUS

endRomPLUS:
        rts

; =============== S U B R O U T I N E =======================================
invAllMantACCx:
        com 5,X                             ; inverse signe de ACCx

; =============== S U B R O U T I N E =======================================
invMantACCx:                                ; XXX3 - POINT D'ENTREE
        com 1,X                             ; inverse mantisse de ACC1
        com 2,X
        com 3,X
        com 4,X

; =============== S U B R O U T I N E =======================================
adjustLowAndHighMantACCx:
        psha                                ; 3,1
        pshb                                ; 3,1
        ldd 3,X                             ; 4,2
        addd #$0001                         ; 4,3
        std 3,X                             ; 5,2 ==> 15 cycles, 8 octets
        bne popadjustLowAndHighMantACCx     ; 3,2
        ldd 1,X                             ; 4,2
        addd #$0001                         ; 4,3
        std 1,X                             ; 5,2
popadjustLowAndHighMantACCx:
        pulb                                ; 4,1
        pula                                ; 4,1
endadjustLowAndHighMantACCx:                ; ===> 43 cycles, 20 octets au lieu de 25 cycles; 12 octets
        rts
; End of function invAllMantACCx
; End of function invMantACCx
; End of function adjustLowAndHighMantACCx
; End of function romPLUS

jmpPrintErrorMSg0x0A_OVERFLOW:
        ldab #cBAS_ERR_OVERFLOW
        jmp ERROR

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC LOG(X) : retourne le logarithme NATUREL (ou NEPERIEN) de X
; ALG : LN(F*2^N)=(N+LOG2(F))*LN(2)
;   approximation par polynome sur l'intervalle [0;1]
;   Si N=1/2 alors LN(F*2^N) = LN (F*SQR(2))
;                = (-0.5+LOG2(F))*LN(2)
; STX : A=LOG(10) : retourne 2.30258509
; OP  : $B7
; ST  : ACTIF
; IN  : ACC1 > 0
; OUT : ACC1=LOG(ACC1)

romLOG:
        tst ACC1TYPFLG
        bne nextRomLOG
convParamInt2FloatRomLOG:
        jsr convSignedWordToACC1_NEW
nextRomLOG:
        jsr subSIGN                         ; FCT : retourne le signe du nombre réel contenu dans ACC1
                                            ; IN  : /
                                            ; OUT : B=$01 si ACC1 > 0
                                            ;       B=$00 si ACC1 = 0
                                            ;       B=$FF si ACC1 < 0
        bgt next1RomLOG
        jmp printErrorMSG_0x08_FC_FctIncorrect
; ---------------------------------------------------------------------------
; CALCULATE (F-SQR(.5))/(F+SQR(.5))
; ((F + SQR(1/2))/SQR(2)) - 1
;
;F - SQR(1/2)   F + SQR(1/2)
;------------ = ------------ - 1
;F + SQR(1/2)     SQR(2)
;
;Soit t =  (X+SRQ(1/2))/(SQR(2))    - 1
;(poly_log(t) - 0.5) * ln(2)
;
next1RomLOG:
        ldx #cSQRHLF                        ; Pointer on SQR(0,5)
        ldaa ACC1
        suba #$80                           ; remove BIAS
        psha                                ; save
        ldaa #$80                           ; Result is ACC1 in range[0.5,1]
        staa ACC1
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
        ldx #cSQRTWO                        ; SQR(2)
        jsr FDIV
        ldx #cONE
        jsr FSUB                            ; FCT : Soustrait de ACC1 le nombre réel pointé par   X
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 à jour
                                            ;       X=pointeur sur un réel
                                            ; OUT : ACC1=FLOAT(PTR X) - ACC1
        ldx #tabParamLOG
        jsr subMapApproximation             ; FCT : applique la serie de taylor pointée  par X
                                            ; IN  : X=pointeur sur les paramètres de la  série de taylor
                                            ; OUT : ACC1=POLY(ACC1)
        ldx #cNEGHLF                        ; Ajoute -0,5
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X

ADDBtoACC1:
        jsr SAVEACC1toFLTTMP1
        pulb
        jsr convSignedByteToACC1            ; CONVERT (B) INTO ACC1, AS SIGNED VALUE -128 TO +127
        ldx #FLTTMP1
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
mulACC1byLog2:
        ldx #cLOG2                          ; LOG(2) = LN(2) ! Terminologie anglosaxonne vs française
        jmp FMULT
; End of function romLOG


; =============== S U B R O U T I N E =======================================
; FCT : Multiplication de deux entiers signés
; IN  : ACC1 et ACC2 contiennent les deux entiers signés à multiplier
; OUT : ACC1=ACC1*ACC2
;
intRomMULT:
        LDD  ACC1+3
        STD  ACC2+1

        CLR ACC1+1
        LDAA ACC2+4
        MUL
        STD ACC1+3                          ; ACC1 = xx 0 xx (AL*BL)

        LDD  ACC2+3                         ; D = AL BH
        MUL                                 ; D = AL *BH
        ADDB ACC1+3
        ADCA #$00
        STD  ACC1+2                         ; ACC1 = xx 0 16*AL*BH+HI(AL*BL) LO(AL*BL)


        LDAA  ACC2+1
        LDAB  ACC2+4                        ; D=AH BL
        MUL                                 ; D=AH*BL
        ADDD ACC1+2                         ; D=AL*BH + AH *BL
        STD ACC1+2                          ; ACC1 = xx 0 (AH*BL+AL*BH)*16+HI(AL*BL) LO(AL*BL)
        BCC nextIntRomMULT
        INC ACC1+1                          ; ACC1 = xx 1 (AH*BL+AL*BH)*16+HI(AL*BL) LO(AL*BL)

nextIntRomMULT:
        LDAA ACC2+1
        LDAB ACC2+3
        MUL                                 ; AH*BH
        ADDD ACC1+1                         ; D = (AL*BL) + HI( (AH*BL+AL*BH)*16+HI(AL*BL))
        STD ACC1+1                          ; ACC1 = xx 256*(AH*BH)+(AH*BL+AL*BH)*16 + AL*BL
        beq endIntRomMULT
        jmp jmpPrintErrorMSg0x0A_OVERFLOW
endIntRomMULT:
        LDAA ACC1+5
        EORA ACC2+5
        STAA ACC1+5                         ; signe de ACC1
        rts

; =============== S U B R O U T I N E =======================================
; FCT : set ACC2 with constant pointed by X and multiply ACC1 by ACC2
; IN  : X=pointer of constant
; OUT : ACC1=ACC1*ACC2
;

FMULT:

        jsr CONUPK                          ; FONCTION CONUPK
                                            ; FCT : Recopie le nombre pointé par X dans ACC2
                                            ; IN  : X: pointeur sur une constante
                                            ; OUT : ACC2 contient la constante pointée par (X)
                                            ;       A = Exposant du nombre pointé par X
        ldab ACC1
; End of function FMULT

; =============== S U B R O U T I N E =======================================
; FCT : multiply ACC1 by ACC2
; ALG : /
; ST  : ACTIF
; IN  : ACC1 set
;       Z=1 alors fin car *0 ==> 0 !
; OUT : ACC1=ACC1*ACC2

romMULT:
        beq endIntRomMULT

intOrFloatRomMULT:
        tab                                 ; Save exposant of ACCC??
        ldaa ACC1TYPFLG                     ; 3/2
        adda ACC2TYPFLG                     ; 3/2
        bcs romMULT1                        ; 3/2 ; SI CARRY est à '1' alors somme de deux float
        beq intRomMULT                      ; 3/2 ; SI = $00 alors somme de deux entiers
        bpl next0RomMULT                    ; 3/2 ; SI = $7F alors conversion de int en Float de ACC2 sinon de ACC1
        jsr convSignedWordToACC1_NEW        ; n/3
        bra next00RomMULT                   ; 3/2
next0RomMULT:
        jsr convSignedWordToACC2_NEW        ; n/3
                                            ; Calcul de pénalités suite à la prise en compte des entiers
                                            ; pour 2 float     : pénalités de  9 cycles
                                            ; pour 2 integer   : pénalités de 12 cycles
                                            ; pour int + float : pénalités de 15 cycles + TODO + conversion d'un int en float
                                            ; pour float + int : pénalités de 18 cycles + TODO + conversion d'un int en float
                                            ; ==> 17 octets au pire

next00RomMULT:
        ldaa #$FF
        staa NUMTYP                         ; Le résultat du calcul intermédiaire est obligatoirement un float
                                            ; régle explicite : un calcul d'un entier avec un float donnera toujours un float ...

romMULT1:
        tba                                 ; get exposant of ACC2
        jsr MULDIV                          ; FCT : FIX UP THE EXPONENTS
                                            ; IN  : A=Exposant du nombre flottant
                                            ; OUT : Si A=$00 alors retourne ACC1=0
                                            ;       sinon fixe le signe de la mantisse du résultat
                                            ; ERR : $0A : overflow error

initTFRomMULT:
        ldaa #$00                           ; TODO : initialise à 0 le résultat ; 2+4*3=14 cycles /10 octets
        staa TMPFLT                         ; TODO : OPT 1 : clra+staa = 2+3*4=14 cyles / 9 octets
        staa TMPFLT+1                       ; TODO : OPT 2 : clr mem 6*4=24 cycles / 12 octets
        staa TMPFLT+2                       ; TODO : OPT 3 : clra clrb std = 2 + 2 + 2*4 = 12 cycles / 8 octets
        staa TMPFLT+3

MULT_FACOV:
        ldab ACC1+4
        bsr MLTPLY                          ; FCT : Multiply ACC2 by B and add result to TMPFLT
                                            ; IN  : B=nombre à multiplier
                                            ; OUT : TMPFLT = TMPFLT + ACC2 * B

MULT_FACLO:
        ldab ACC1+3
        bsr MLTPLY                          ; FCT : Multiply ACC2 by B and add result to TMPFLT
                                            ; IN  : B=nombre à multiplier
                                            ; OUT : TMPFLT = TMPFLT + ACC2 * B

MULT_FACMO:
        ldab ACC1+2
        bsr MLTPLY                          ; FCT : Multiply ACC2 by B and add result to TMPFLT
                                            ; IN  : B=nombre à multiplier
                                            ; OUT : TMPFLT = TMPFLT + ACC2 * B

MULT_1:
        ldab ACC1+1
        bsr nextMLTPLY                      ; FCT : do Multiply ACC2 by B and add result to TMPFLT
                                            ; IN  : B=nombre à multiplier
                                            ; OUT : TMPFLT = TMPFLT + ACC2 * B
MULT_2:                                     ; TODO : OPTIMISATION : le rendre inline et on gagne 11 cycles et on perd 5 octets
        jsr MVTFACC1                        ; FCT : sauve TMPFLT dans ACC1
                                            ; IN  : TMPLT is set
                                            ; OUT : ACC1=TMPFLT
MULT_1_1:
        ldx #ACC1
        jmp normalizeMantRomPlus
; End of function romMULT

; =============== S U B R O U T I N E =======================================
; FCT : Effectue un décalage sur octet sur TMPFLT
; IN  : B : le multiplieur
; OUT : A,B,X modified

SHIFT_TMPFT:
        ldx #TMPFLT-1

SHIFT_byX:
        ldaa 4,x
        staa ACC1EXT
        ldaa 3,x
        staa 4,x
        ldaa 2,x
        staa 3,x
        ldaa 1,x
        staa 2,x
        ldaa ACC1JUSTIF
        staa 1,x

; =============== S U B R O U T I N E =======================================
; FCT : Effectue un décalage sur octet puis sur bit
; IN  : B : ?
;       X : pointeur sur l'accumulateur à traiter
; OUT : A,B,X modified

SHIFTR:
        addb #$08
        ble SHIFT_byX
        ldaa ACC1EXT
        subb #$08
        beq endFADD_ROLSHF

nextSHIFTR:
        asr 1,x                             ; obtient la valeur du signe afin de compléter la mantisse lors du décalage

; =============== S U B R O U T I N E =======================================
; FCT : Effectue un rolling shift sur le float pointé par X
; IN  : X=pointe sur une zone contenant un float
;       A=?
;       B=le nombre de décalage en négatif B <= 0
;       C=le bit précédent à propager
; OUT : X, A,B modified

FADD_ROLSHF:
        ror 2,x
        ror 3,x
        ror 4,x
        rora                                ; utilité ?
        incb
        bne nextSHIFTR
endFADD_ROLSHF:
        rts
; End of function FADD_ROLSHF
; End of function SHIFTR
; End of function SHIFT_TMPFT



; =============== S U B R O U T I N E =======================================
; FCT : Multiply ACC2 by B and add result to TMPFLT
; IN  : B=nombre à multiplier
; OUT : TMPFLT = TMPFLT + ACC2 * B

MLTPLY:
        beq SHIFT_TMPFT  ; SHIFT FPA2 ONE BYTE TO RIGHT
; End of function MLTPLY


; =============== S U B R O U T I N E =======================================
; FCT : do Multiply ACC2 by B and add result to TMPFLT
; IN  : B=nombre à multiplier
; OUT : TMPFLT = TMPFLT + ACC2 * B

nextMLTPLY:
        sec

bcl1MLTPLY:
        ldaa TMPFLT
        rorb
        beq endromMULT
        bcc loc_F14D
        ldaa TMPFLT+3
        adda ACC2+4
        staa TMPFLT+3
        ldaa TMPFLT+2
        adca ACC2+3
        staa TMPFLT+2
        ldaa TMPFLT+1
        adca ACC2+2
        staa TMPFLT+1
        ldaa TMPFLT
        adca ACC2+1

loc_F14D:                                   ; TODO : remplacer l'étiquette
        rora
        staa TMPFLT
        ror TMPFLT+1
        ror TMPFLT+2
        ror TMPFLT+3
        ror ACC1EXT
        clc
        bra bcl1MLTPLY

endromMULT:
        rts
; End of function nextMLTPLY


; =============== S U B R O U T I N E =======================================
; FONCTION CONUPK
; FCT : Recopie le nombre de type FLOAT pointé par X dans ACC2
; IN  : X: pointeur sur une constante
; OUT : ACC2 contient la constante pointée par (X)
;       A = Exposant du nombre pointé par X
CONUPK:
        ldd 1,x
        staa ACC2+5
        oraa #$80
        std ACC2+1
        ldab ACC2+5
        eorb ACC1+5                         ; modify ACC1 sign
        stab PRODSIGN
        ldd 3,x
        std ACC2+3
        ldaa #cTYPFLGACC2                   ; ACC2 est un float
        staa ACC2TYPFLG
        ldaa 0,x                            ; A : exposant du float pointé par X : utilisé en dehors du traitement !
        staa ACC2
        rts
; End of function CONUPK


; =============== S U B R O U T I N E =======================================
; FCT : FIX UP THE EXPONENTS
; IN  : A=Exposant du nombre flottant
; OUT : Si A=$00 alors retourne ACC1=0
;       sinon fixe le signe de la mantisse du résultat
; ERR : $0A : overflow error

MULDIV:
        tsta
        beq popReturnStackMULDIV
        adda ACC1
        rora
        rola
        bvc popReturnStackMULDIV            ; BRANCH IF EXPONENT TOO LARGE OR SMAL
        adda #$80
        staa ACC1
        bne saveResMantissaSignMULDIV
        ldx #ACC1
        jmp ZEROFAC2

saveResMantissaSignMULDIV:
        ldaa PRODSIGN
        staa ACC1+5                         ; set ACC1 sign
        rts

popReturnStackMULDIV:
        pula
        pula

setZeroOrErr0x0A_OverFlow:
        bmi jmpPrintErr0x0A_OVERFLOW
        ldx #ACC1
        jmp ZEROFAC

jmpPrintErr0x0A_OVERFLOW:
        jmp jmpPrintErrorMSg0x0A_OVERFLOW
; End of function MULDIV


; =============== S U B R O U T I N E =======================================
; FCT : Multiplie ACC1 par 10
; ALG : ACC2=ACC1 puis ACC1 * 4 puis ACC1=ACC1*4+ACC2 = 5* ACC1 puis (5*ACC1)*2
; IN  : ACC1 est à jour
; OUT : ACC1=ACC1*10

MUL10:
        jsr moveACC1toACC2                  ; FCT : move ACC1 to ACC2
                                            ; IN  : ACC1
                                            ; OUT : ACC2=ACC1
                                            ;       X,D modified
                                            ;       D=ACC1 et ACC1+1
                                            ;       P modified
        beq endMUL10
        adda #$02                           ; ACC1 = ACC1 * 4 = EXPOSANT de ACC1 + 2 !
        bcs jmpPrintErr0x0A_OVERFLOW
        clr PRODSIGN                        ; ACC1 et ACC2 sont de même signe (heureusement)
        ldx #ACC1                           ; Impact de l'ajout du traitement des entiers
        jsr doRomPLUS                       ; ACC1=(ACC1*4) + ACC1 = ACC1 * 5
        inc ACC1                            ; ACC1=ACC1*2 = EXPOSANT de ACC1 + 1
        beq jmpPrintErr0x0A_OVERFLOW

endMUL10:
        rts
; End of function MUL10

; =============== S U B R O U T I N E =======================================
; FCT : Divise ACC1 par 10
; IN  : ACC1 : float to divide by 10
; OUT : ACC1=ACC1/10
; OPT : TODO : / ==> * (1/10) ?

divBy10:
        jsr moveACC1toACC2                  ; FCT : move ACC1 to ACC2
                                            ; IN  : ACC1
                                            ; OUT : ACC2=ACC1
                                            ;       X,D modified
                                            ;       D=ACC1 et ACC1+1
                                            ;       P modified
        psha                                ; save exponent of ACC1for later
        clr PRODSIGN                        ; ACC1 et ACC2 ont le même signe
        ldx #cTEN
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
        pula                                ; get exponent of ACC1
        bra romDIV                          ; FCT : divide ACC1 by ACC2
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 and ACC2 set
                                            ;       Z=1 si exp(ACC2) = 0 sinon Z=0
                                            ;       A=Exposant de ACC1
                                            ; OUT : ACC1=ACC1/ACC2
                                            ; ERR : $0A : overflow error
                                            ;       $14 : divide by 0

errorDivideByZero:
        ldab #cBAS_ERR_ZERODIV
        jmp ERROR

; =============== S U B R O U T I N E =======================================
; FCT : effectue la division  de ACC1 by PTR(X)
; IN  : X=pointeur sur un nombre flottant
; OUT : ACC1=ACC1/PTR(X)

FDIV:
        bsr CONUPK                          ; FONCTION CONUPK
                                            ; FCT : Recopie le nombre pointé par X dans ACC2
                                            ; IN  : X: pointeur sur une constante
                                            ; OUT : ACC2 contient la constante pointée par (X)
                                            ;       A = Exposant du nombre pointé par X
        ldab ACC1

; =============== S U B R O U T I N E =======================================
; FCT : divide ACC1 by ACC2
; STX : /
; ALG : /
; ST  : ACTIF
; IN  : ACC1 and ACC2 set
;       Z=1 si exp(ACC2) = 0 sinon Z=0
;       A=Exposant de ACC1
; OUT : ACC1=ACC1/ACC2
; ERR : $0A : overflow error
;       $14 : divide by 0

romDIV:
        beq errorDivideByZero
        ldab #cTYPFLGACC1
        stab ACC1TYPFLG                     ; La division sera toujours un FLOAT
        neg ACC1
        bsr MULDIV                          ; FCT : FIX UP THE EXPONENTS
                                            ; IN  : A=Exposant du nombre flottant
                                            ; OUT : Si A=$00 alors retourne ACC1=0
                                            ;       sinon fixe le signe de la mantisse du résultat
                                            ; ERR : $0A : overflow error
        inc ACC1
        beq jmpPrintErr0x0A_OVERFLOW
        ldx #TMPFLT
        ldab #$04
        stab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        ldab #$01
bclromDIV:
        ldaa ACC1+1
        cmpa ACC2+1
        bne bcl2romDIV
        ldaa ACC1+2
        cmpa ACC2+2
        bne bcl2romDIV
        ldaa ACC1+3
        cmpa ACC2+3
        bne bcl2romDIV
        ldaa ACC1+4
        cmpa ACC2+4
        bne bcl2romDIV
        sec
bcl2romDIV:
        tpa
        rolb
        bcc next3romDIV
        stab $00,x
        inx
        dec EOLPNTR                         ; cela sert à beaucoup de choses : op. binaires, etc.
        bmi next7romDIV
        beq next6romDIV
        ldab #$01
next3romDIV:
        tap
        bcs next5romDIV
bcl4romDIV:
        asl ACC2+4
        rol ACC2+3
        rol ACC2+2
        rol ACC2+1
        bcs bcl2romDIV
        bmi bclromDIV
        bra bcl2romDIV

next5romDIV:
        ldaa ACC2+4
        suba ACC1+4
        staa ACC2+4
        ldaa ACC2+3
        sbca ACC1+3
        staa ACC2+3
        ldaa ACC2+2
        sbca ACC1+2
        staa ACC2+2
        ldaa ACC2+1
        sbca ACC1+1
        staa ACC2+1
        bra bcl4romDIV

next6romDIV:
        ldab #$40
        bra next3romDIV

next7romDIV:
        rorb
        rorb
        rorb
        stab ACC1EXT
        bsr MVTFACC1                        ; FCT : sauve TMPFLT dans ACC1
                                            ; IN  : TMPLT is set
                                            ; OUT : ACC1=TMPFLT;
DBGromDIV:
        ldx #ACC1
        jmp normalizeMantRomPlus

; End of function divBy10
; End of function FDIV
; End of function romDIV


; =============== S U B R O U T I N E =======================================
; FCT : sauve TMPFLT dans ACC1
; IN  : TMPFLT is set
; OUT : ACC1=TMPFLT

MVTFACC1:
        ldx TMPFLT
        stx ACC1+1
        ldx TMPFLT+2
        stx ACC1+3
        rts
; End of function MVTFACC1


; =============== S U B R O U T I N E =======================================
; FCT : MOVE float memory to ACC1
;       Déplace 5 octets (float compressé) dans ACC1 en mode float décompressé
; IN  : X=FLOAT (5 octets)
; OUT : ACC1=EXTENDED(X)
;       N ou Z ou C = ? : ?, V=0
;       A unmodified, B and X modified
fixTypeMOVFM:
        ldab #$FF
        stab NUMTYP                         ; set variable as float

; =============== S U B R O U T I N E =======================================
; FCT : MOVE memory to ACC1
;       Déplace 5 octets (float compressé) dans ACC1 en mode float décompressé
; IN  : X=FLOAT (5 octets
; OUT : ACC1=EXTENDED(X)
;       N=1 si EXP(ACC1) = 0 <==> ACC1=0
;       A,B and X modified
; OPT : Attention à l'ordre des mises à jour des données. Il faut toujours
;       terminer par la sauvegarde de l'exposant car c'est utilisé par d'autres
;       fonctions (telles que divby10) pour avoir le drapeua de nullité de ACC1
MOVFM:
        ldd 1,x                             ; get High byte Mantisse
        staa ACC1+5                         ; ACC1+5
        oraa #$80
        std ACC1+1                          ; ACC1+$80 ACC1+2
        ldd 3,x                             ;
        std ACC1+3                          ; ACC1+1+$80 ACC1+2 ACC1EXT=0 ACC1+3 ACC1+4
        clra
        staa ACC1EXT                        ; ACC1+1+$80 ACC1+2 ACC1EXT=0 ACC1+3 ACC1+4 ACC1 ACC1EXT
        ldab #cTYPFLGACC1
        stab ACC1TYPFLG                     ; fixe le type de la valeur copiée : float dans ACC1
        ldab 0,x
        stab ACC1                           ; ACC1+1+$80 ACC1+2 ACC1EXT=0 ACC1+3 ACC1+4 ACC1
        rts
; End of function MOVFM

; =============== S U B R O U T I N E =======================================
; FCT : MOVE memory to ACC1
;       Déplace 5 octets d'un entier codé 0xXX 0xXX SIGNE 0xVALUE_HIGH 0xVALUE_LOW
; IN  : X=pointeur sur un entier signé (5 octets)
; OUT : ACC1=entier

MOVIM2A1:
        ldd  3,X
        std  ACC1+3
        ldaa 2,X                            ; get sign of integer
        staa ACC1+5
        clr  ACC1TYPFLG
        rts
; End of function MOVIM2A1

; =============== S U B R O U T I N E =======================================
; FCT : MOVE memory to ACC2
;       Déplace 5 octets d'un entier codé 0xXX 0xXX SIGNE 0xVALUE_HIGH 0xVALUE_LOW
; IN  : X=pointeur sur un entier signé (5 octets)
; OUT : ACC2=entier

MOVIM2A2:
        ldd  3,X
        std  ACC2+3
        ldaa 2,X                            ; get sign of integer
        staa ACC2+5
        clr  ACC2TYPFLG
        rts
; End of function MOVIM2A2


; =============== S U B R O U T I N E =======================================

SAVEACC1toFLTTMP2:
         ldx #FLTTMP2
         bra MOVMF                          ; move ACC1 to memory (by X)
; End of function SAVEACC1toFLTTMP2

; =============== S U B R O U T I N E =======================================
SAVEACC1toFLTTMP1:
        ldx #FLTTMP1
        bra MOVMF
; End of function SAVEACC1toFLTTMP1

saveCC1byFORPNTByType:
        tst ACC1TYPFLG
        bne saveACC1byFORPNT
        jmp beforeMOVIA1toM

; =============== S U B R O U T I N E =======================================
saveACC1byFORPNT:
        ldx FORPNT                          ; TODO : use pointer
; =============== S U B R O U T I N E =======================================
; FCT : Déplace ACC1 de type float dans une zone mémoire pointée par X
; IN  : X : pointeur sur une zone mémoire de type float
; OUT : B et X unmodified
MOVMF:
        ldaa ACC1                           ; move ACC1 to memory (by X)
        staa 0,x
        ldaa ACC1+5                         ; get ACC1 sign
        oraa #$7F                           ; forcer les bits non significatifs à 1
        anda ACC1+1                         ; positionner b7 signe et le reste selon ACC1+1
        staa 1,x
        ldaa ACC1+2
        staa 2,x
        ldaa ACC1+3
        staa 3,x
        ldaa ACC1+4
        staa 4,x
        rts
; End of function MOVMF
; End of function saveACC1byFORPNT

; =============== S U B R O U T I N E =======================================
; FCT  : Déplace ACC1 de type integer dans une zone mémoire pointée par X
; IN   : ACC1
; OUT  : X unmodified
; TODO : faire un stockage sur 3 octets
beforeMOVIA1toM:
        ldx FORPNT                          ; TODO : use pointer
; =============== S U B R O U T I N E =======================================
; FCT  : Déplace ACC1 de type integer dans une zone mémoire pointée par X
;        codé en 0xXX 0xXX SIGNE 0xVALUE_HIGH 0xVALUE_LOW
; IN   : X : pointeur sur une zone mémoire de type integer (5 octets)
; OUT  : X unmodified
; TODO : faire un stockage sur 3 octets
MOVIA1toM:
        ldaa ACC1+5
        staa 2,X                            ; set sign of integer
        ldd  ACC1+3
        std  3,X                            ; set value complement'2
        rts
; End of function MOVIA1toM
; end of beforeMOVIA1toM:



; =============== S U B R O U T I N E =======================================
; FCT : Recopie ACC2 étendu dans ACC1 étendu
; ST  : ACTIF
; IN  : ACC2 set
; OUT : ACC1=ACC2

MOVA2A1ext:
        ldaa ACC2+5
; End of function MOVA2A1ext


; =============== S U B R O U T I N E =======================================
; FCT : recopie ACC2 dans ACC1
; OP  : /
; ST  : ACTIF
; IN  : A = SIGNE de ACC1
; OUT : X and A modified
; OPT : /

MOVA2A1:
        staa ACC1+5                         ; set ACC1 sign
        ldx ACC2
        stx ACC1
        clr ACC1EXT
        ldx ACC2+2
        stx ACC1+2
        ldx ACC2+3
        stx ACC1+3
        ldaa ACC2TYPFLG
        beq endMOVA2A1
        ldaa #cTYPFLGACC1
endMOVA2A1:
        staa ACC1TYPFLG
        rts
; End of function MOVA2A1


; =============== S U B R O U T I N E =======================================
; FCT : move ACC1 to ACC2
; IN  : /
; OUT : X,D modified
;       D=ACC1 et ACC1+1
;       C=0 si ACC1<>0 sinon C=1
; OPT : TODO : n'utiliser que le registre D mais A doit refléter l'attendu : l'exposant de ACC1 !

moveACC1toACC2:
        ldd ACC1
        std ACC2
        ldx ACC1+2
        stx ACC2+2
        ldx ACC1+4
        stx ACC2+4
        ldab ACC1TYPFLG
        beq endmoveACC1toACC2
        ldab #cTYPFLGACC2
endmoveACC1toACC2:
        stab ACC2TYPFLG
        tsta
        rts
; End of function moveACC1toACC2


; =============== S U B R O U T I N E =======================================
; FCT : retourne le signe du nombre réel contenu dans ACC1
; IN  : /
; OUT : B=$01 si ACC1 > 0
;       B=$00 si ACC1 = 0
;       B=$FF si ACC1 < 0

subSIGN:
        ldab ACC1                           ; get exposant de ACC1
        beq endSubSIGN                      ; si = 0 alors ACC1=0 donc B=0

nextSubSIGN:
        ldab ACC1+5                         ; get ACC1 sign ; 3,2

next1SubSIGN:
        rolb                                ; 2,1
        ldab #$FF                           ; 2,2
        bcs endSubSIGN                      ; 3,2
        negb                                ; 2,1      ==> 12 cycles / 8 octets

endSubSIGN:
        rts
; End of function subSIGN


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC SGN : retourne le signe de l'expression
; STX : A=SGN(-12)  : retourne -1
;       B=SGN(0)    : retourne 0
;       C=SGN(14.3) : retourne 1
; OP  : $B1
; BUG : /
; OPT : la fonction a été réécrite par rapport à la V1.0 ... nettement plus rapide
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : ACC1 avec le signe de l'expression au format entier si l'expression est typée "entier" sinon au format float

romSGN:
        tst ACC1TYPFLG
        beq doIntRomSGN
doFloatIntRomSGN
        ldx #cZERO
        ldab ACC1
        beq endRomSGN
        ldx #cNEGONE
        ldab ACC1+5                         ; get ACC1 sign
isNegRomSGN:
        bmi endRomSGN
posRomSGN:
        ldx #cONE
endRomSGN:
        jmp MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
doIntRomSGN:
        ldab #$00                           ; by default ACC1=0 => SGN(ACC1) = 0
        ldaa ACC1
        beq  endIntRomSGN

nextIngRomSGN:
        incb                                ; SGN(ACC1) = 1 car nous supposons que ACC1 > 0
        ldaa ACC1+5                         ;
        bpl  endIntRomSGN
        jmp  romTRUE                        ; appel de TRUE car TRUE = -1 !
endIntRomSGN:
        jmp  returnByteIntRomLEN

; End of function romSGN


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC ABS(X) : retourne la valeur absolue d'un nombre de type float
; STX : A=ABS(-5.4) retourne 5.4 au format float / A#=ABS(-5) retourne 5 au format entier
; OP  : $B3
; ST  : ACTIF
; IN  : /
; OUT : ACC1=ABS(ACC1) avec le type dépendant du paramètre

romABS:
        tst ACC1TYPFLG
        bne beforeEndRomABS
intRomABS:
        tst ACC1+5
        beq endRomABS                       ; le nombre entier est déjà positif ?
        ldd ACC1+3
        comb
        coma
        addd #$0001
        std ACC1+3                          ; complement à deux de l'entier négatif
beforeEndRomABS:
        clr ACC1+5                          ; set ACC1 sign to positive
endRomABS
        rts
; End of function romABS


; =============== S U B R O U T I N E =======================================
; FCT : COMPARE A PACKED FLOATING POINT NUMBER OR INTEGER POINTED BY (X)
;       TO AN UNPACKED FP NUMBER OR SIGNED INTEGER IN ACC1.
;       ACC1 give the type of numeric to compare.
;       IF the type of (X) and ACC1 is different then result is incorrect
; IN  : X=Adresse d'un float ou d'un entier
; OUT : B = 0   IF ACC1 = (X)
;       B = 1   IF ACC1 > (X)
;       B = $FF IF ACC1 < (X)
;       A modified
IorFCOMP2:
        tst ACC1TYPFLG
        bne FCOMP2
ICOMP2:
        ldab #$01                           ; par défaut ACC1 > X
tstSignICOMP2:
        ldaa ACC1+2                         ; get sign of integer
        cmpa  2,X                           ; compare with other integer
        bhi  before0EndICOMP2               ; Si A >M alors A est le plus petit ! B = -1 (=$FF)
        bne  endICOMP2                      ; Si A <>M alors A est le plus grand ! B = 1
nextICOMMP2:
        ldd ACC1+3
        subd 3,X
        beq  endICOMP2                      ; Egalité : B=0
        bhi  beforeEndICOMP2                ; Si > alors B=1 sinon -1
before0EndICOMP2:
        ldab #$FF
        rts
beforeEndICOMP2:
        ldab #$01
endICOMP2:
        rts

;  End of function IorFCOMP2


; =============== S U B R O U T I N E =======================================
; FCT : COMPARE A PACKED FLOATING POINT NUMBER POINTED BY (X)
;       TO AN UNPACKED FP NUMBER IN ACC1.
; IN  : X=Adresse d'un float
; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
;       ACCB = 1   IF ACC1 > (X)
;       ACCB = $FF IF ACC1 < (X)

FCOMP2:
        ldab 0,x
        beq subSIGN                         ; FCT : retourne le signe du nombre réel contenu dans ACC1
                                            ; IN  : /
                                            ; OUT : B=$01 si ACC1 > 0
                                            ;       B=$00 si ACC1 = 0
                                            ;       B=$FF si ACC1 < 0
        ldab 1,x
        eorb ACC1+5                         ; test ACC1 sign
        bmi nextSubSIGN
; End of function FCOMP2


; =============== S U B R O U T I N E =======================================
; FCT : compare deux float : ACC1 avec le float et un float en mémoire pointé par X
; IN  : X=Adresse d'un float
;       ACC1=float to compare with float pointed by X
; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
;       B = 1   IF ACC1 > (X)
;       B = $FF IF ACC1 < (X)

SUB_FCOMP:
        ldab ACC1
        cmpb 0,x
        bne loc_F306
        ldab 1,x
        orab #$7F
        andb ACC1+1
        cmpb 1,x
        bne loc_F306
        ldab ACC1+2
        cmpb 2,x
        bne loc_F306
        ldab ACC1+3
        cmpb 3,x
        bne loc_F306
        ldab ACC1+4
        subb 4,x
        bne loc_F306
        rts

loc_F306:
        rorb
        eorb ACC1+5                         ; test ACC1 sign
        jmp next1SubSIGN
; End of function SUB_FCOMP


; =============== S U B R O U T I N E =======================================
; FCT : effectue la fonction int sur ACC1
;
; IN  : ACC1 mis à jour et < 2 milliard
; OUT : ACC1=INT(ACC1)
;       B=exposant de ACC1
QUICK_INT:
        ldx #ACC1                           ; Ajout suite prise en compte des entiers
        ldab ACC1                           ; get exposant of ACC1
        beq setMantisseACC1byB              ; FCT : met à jour ACC1 avec B
                                            ; IN  : B=valeur à stocker dans ACC1
                                            ; OUT : ACC1[1..4]=B
        subb #$A0                           ; B=le nombre de décalage à effectuer et on obtient aussi
                                            ; la valeur du bit à utiliser lors du décalage de la mantisse
        ldaa ACC1+5                         ; get ACC1 sign
        bpl nextQUICK_INT

invMantisseQUICK_INT:
        com ACC1JUSTIF
        jsr invMantACCx

nextQUICK_INT:
        cmpb #$F8
        bgt next1QUICK_INT
        jsr SHIFTR                          ; FCT : Effectue un décalage sur octet puis sur bit
                                            ; IN  : B : le nombre de décalage à effectuer pour retrouver un exposant nul : TODO : est-ce vrai ?
                                            ;       X : pointeur sur l'accumulateur à traiter
                                            ; OUT : A,B,X modified
        clr ACC1JUSTIF
        rts

next1QUICK_INT:
        clr ACC1JUSTIF
        ldaa ACC1+5                         ; get ACC1 sign
        rola
        ror ACC1+1                          ; fix the sign of mantisse
        jmp FADD_ROLSHF                     ; FCT : Effectue un rolling shift sur le float pointé par X
                                            ; IN  : X=pointe sur une zone contenant un float
                                            ;       A=?
                                            ;       B=le nombre de décalage en négatif B <= 0
                                            ;       C=le bit précédent à propager
                                            ; OUT : X, A,B modified
; End of function QUICK_INT


; =============== S U B R O U T I N E =======================================
; FCT : conversion d'un entier signé vers un float
; IN  : ACC1+3,ACC1+4:entier ACC1+5 : signe de l'entier
;       ACC1TYPFLG doit contenir le type final "FLOAT"
;       B=exposant
; OUT : ACC1 contient la conversion en float l'entier
;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^')
convIntToFloat:
        stab ACC1EXT
        ldaa #cTYPFLGACC1                   ; Le type de retour est un float dans ACC1
        staa ACC1TYPFLG
        ldaa ACC1+5                         ; get ACC1 sign
        stab ACC1+5                         ; set ACC1 sign
        suba #$80                           ; C=sign of ACC1
        ldaa #$A0                           ; Permet de justifier un entier sur 2 milliard ...
        staa ACC1                           ; set exposant
        ldaa ACC1+4                         ; get poids faible de la mantisse
        staa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
                                            ; ===> est utilisée uniquement pour la fonction puissance '^' !
        ldx  #ACC1                          ; Nécessaire depuis l'ajout des entiers
        jmp normalizeMantBySignRomPLUS      ; NORMALIZE FAC1 : justifier la mantisse selon l'exposant et la valeur de C
; End of function convIntToFloat


jmpPrintErr0x0A_OVERFLOW_2:
        jmp jmpPrintErrorMSg0x0A_OVERFLOW

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
; STX : A=INT(5.25) : retourne 5
; OP  : $B2
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : ACC1 avec la partie entière de l'expression
;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' ou EXP)

romINT:
        ldab ACC1TYPFLG
        beq  endsetMantisseACC1byB          ; Si c'est déjà un entier on ne fait rien
doRomINT:
        ldab ACC1                           ; Test de l'exposant
        cmpb #$91                           ; nombre > 65535 ?
        bcc jmpPrintErr0x0A_OVERFLOW_2      ; oui alors errreur type OVERFLOW
        clrb
        stab ACC1TYPFLG                     ; le type de retour est un entier
        jmp QUICK_INT                       ; FCT : effectue la fonction int sur ACC1
                                            ; IN  : ACC1 mis à jour
                                            ; OUT : ACC1+3,4=INT(ACC1)
                                            ;       B=exposant de ACC1 : TODO ???
; End of function romINT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC FLOAT(X) : retourne sous forme de float l'expression
; STX : A=FLOAT(5) : retourne 5.00
; OP  : $xx
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : ACC1 contient la conversion de l'expression en float

romFLOAT:
        ldab ACC1TYPFLG
        bne  endsetMantisseACC1byB          ; Si c'est déjà un float on ne fait rien

doRomFLOAT:
        ldab #cTYPFLGACC1                   ; Le type de retour est un float dans ACC1
        stab ACC1TYPFLG
        clr  ACC1+3
        clr  ACC1+4                         ; la conversion string -> int laisse des mauvaises valeurs dans ACC1+3 et ACC1+4
        ldaa ACC1+5                         ; get ACC1 sign
        suba #$80                           ; C=sign of ACC1
        ldx  #ACC1                          ; Nécessaire depuis l'ajout des entiers
        jmp normalizeMantBySignRomPLUS      ; NORMALIZE FAC1 : justifier la mantisse selon l'exposant et la valeur de C
; End of function romFLOAT


; =============== S U B R O U T I N E =======================================
; FCT : met à jour ACC1 avec B
; IN  : B=valeur à stocker dans ACC1
; OUT : ACC1[1..4]=B

setMantisseACC1byB:
        stab ACC1+1
        stab ACC1+2
        stab ACC1+3
        stab ACC1+4

endsetMantisseACC1byB:
        rts
; End of function setMantisseACC1byB

;----------------------------------------------------------------------------
HEXGET:
        ldx  #$0000
        stx  TMP_HEX
        beq  HX_GETCHAR

HG_INIT_BCL:
        ldab #$03                           ; 4 bits à convertir ...
        asla
        asla
        asla
        asla

HX_BCL:
        asla
        rol TMP_HEX+1
        rol TMP_HEX
        bcc HX_INC_COUNTER_BCL
        jmp jmpPrintErrorMSg0x0A_OVERFLOW

HX_INC_COUNTER_BCL:
        decb
        bpl HX_BCL

HX_GETCHAR:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #$80                           ; Est supérieur à 80 ?
        bcc  F_HEX_GET                      ; Oui alors fin
        oraa #$80                           ; Add $80 to A
        eora #$B0                           ; Transforme ASCII -> Number : $30 -> $00
        cmpa #$A                            ; Est < à $0A
        bcs  HG_INIT_BCL
        adca #$88                           ; Sinon ce sont les lettres de la notation hexadecimal
        cmpa #$FA                           ; Est-ce que c'est le domaine [A-F] ?
        bcc  HG_INIT_BCL

F_HEX_GET:
        ldd  TMP_HEX
        jmp  convUnsignedWordToACC1

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR FIN
; pour la partie exposant d'un nombre flottant

addDigitToNumber:
        ldab LOWTR                          ; effectue NUMBER=NUMBER*10+(A-$30)
        aslb                                ; 2
        aslb                                ; 2
        addb LOWTR                          ; 3
        aslb                                ; 2 ; LOWTR=LOWTR*10 !
        suba #$30                           ; 2 ;'0'
        aba                                 ; 2 ; 13 cycles pour LOWTR=LOWTR*10+A
        staa LOWTR
        bra getNextNumberFIN
; END OF FUNCTION CHUNK FOR FIN


; =============== S U B R O U T I N E =======================================
; FCT : Float IN : parse a number
;       NUMBER INPUT IS LEFT IN ACC1.
;       AT ENTRY [TXTPTR] POINTS TO THE FIRST CHARACTER IN A TEXT BUFFER.
;       THE FIRST CHARACTER IS ALSO IN ACCA. FIN PACKS THE DIGITS
;       INTO THE FAC AS AN INTEGER AND KEEPS TRACK OF WHERE THE
;       DECIMAL POINT IS. [DPTFLG] TELL WHETHER A DP HAS BEEN
;       SEEN. [DECCNT] IS THE NUMBER OF DIGITS AFTER THE DP.
;       AT THE END [DECCNT] AND THE EXPONENT ARE USED TO
;       DETERMINE HOW MANY TIMES TO MULTIPLY OR DIVIDE BY TEN
;       TO GET THE CORRECT NUMBER.
; IN  : C=1 : The first character is numeric
;       C=0 : The first character is not numeric
;       A=premier caractère à convertir
; OUT : ACC1

FIN:

initFIN:
        ldx #$0000
        stx ACC1
        stx ACC1+2
        stx ACC1+4
        stx ACC1SGNFLG                      ; ATTENTION : initialise ACC1SGNFLG (voulu) et ACC1JUSTIF (pas voulu) !
        stx LOWTR                           ; LOWTR     : valeur de l'exposant
                                            ; LOWTR+1   : signe de l'exposant : $00:positif,$FF:négatif
        stx PTRTMP2                         ; PTRTMP2   : Nombre de chiffre après la virgule
                                            ; PTRTMP2+1 : partie décimale     : $00: pas de partie décimale,$FF:partie décimale
        stx MEMINT                          ; initialize temporary convert area of integer
        stx MEMINT+2
        stx MEMINT+3                        ; chevauchement pour optimiation (initialisation 5 octets)
        bcs FINDG1                          ; Si C=1 alors A contient un chiffre

isHexaFIN:
        cmpa #cBAS_ID_HEX                   ; '#'
        beq HEXGET

isMinusFIN:
        cmpa #cMATH_MINUS                   ; '-'
        bne isPlusFIN
        com ACC1SGNFLG                      ; FLAG DU SIGNE DE L'ACC1 EN COURS DE CONVERSION STRING -> FLOAT (fonction FIN)
        bra getNextCharFIN

isPlusFIN:
        cmpa #cMATH_PLUS                    ; '+'
        bne isDotFIN

getNextCharFIN:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bcs FINDG1

isDotFIN:
        cmpa #cMATH_SEP_FLT                 ; '.'
        beq treatDecFIN

isExpFIN:
        cmpa #$45                           ; 'E'
        bne FINE
getSignExpFIN:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bcs addDigitToNumber
        cmpa #cBAS_TOKEN_MINUS
        beq setSignExp_GetNextDigitFIN
        cmpa #cMATH_MINUS                   ; '-'
        beq setSignExp_GetNextDigitFIN
        cmpa #cBAS_TOKEN_PLUS
        beq getNextNumberFIN
        cmpa #cMATH_PLUS                    ; '+'
        beq getNextNumberFIN
        bra endOfNumberFIN

setSignExp_GetNextDigitFIN:
        com LOWTR+1

getNextNumberFIN:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bcs addDigitToNumber

endOfNumberFIN:
        tst LOWTR+1                         ; test du signe de l'exposant
        beq FINE
        neg LOWTR                           ; Si négatif alors changer le signe de l'exposant
        bra FINE

treatDecFIN:
        com PTRTMP2+1                       ; Il y a une partie décimale !
        bne getNextCharFIN


; --- Finalisation de la conversion
;    -- Si il y a une partie décimale (PTRTMP2+1 <>0)
;    --    Ajustement de ACC1 selon le nombre de décimale
;    --    puis si nécessaire effectue la négation de ACC1 car tout est traité en positif !
;    -- Sinon
;    --    Si pas overflow (MEMINT+2=0) alors ACC1=INT et NUMTYP=integer
FINE:
        ldaa LOWTR                          ; prendre l'exposant (base 10)
        suba PTRTMP2                        ; moins le nombre de chiffre après la virgule
        staa LOWTR                          ; comme exposant base 10
        beq FINQNG                          ; si l'exposant est nul alors on termine
        bpl FINMUL                          ; sinon on ajuste ACC1 : si >0 alors *10 sinon /10

FINDIV:
        jsr divBy10                         ; FCT : Divise ACC1 par 10
                                            ; IN  :
                                            ; OUT : ACC1=ACC1/10
        inc LOWTR
        bne FINDIV
        bra FINQNG

FINMUL:
        jsr MUL10                           ; FCT : Multiplie ACC1 par 10
                                            ; ALG : ACC2=ACC1 puis ACC1 * 4 puis ACC1=ACC1*4+ACC2 = 5* ACC1 puis (5*ACC1)*2
                                            ; IN  : ACC1 est à jour
                                            ; OUT : ACC1=ACC1*10
        dec LOWTR
        bne FINMUL

FINQNG:
        ldaa PTRTMP2                        ; Y-a-t-il une partie décimale ?
        bne FINQNG2                         ; Oui alors gestion d'un float
        ldaa PTRTMP2+1
        bne FINQNG2
        jmp intFING                         ; Il faut restituer un entier dans ACC1
FINQNG2:
        ldaa ACC1SGNFLG                     ; FLAG DU SIGNE DE L'ACC1 EN COURS DE CONVERSION STRING -> FLOAT (fonction FIN)
        bpl endFIN
        jmp doNEG                           ; FCT : routine NEG(X) : retourne l'opposé de ACC1
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : ACC1=NEG(ACC1)
;
; --- récupération de la partie entière et/ou décimale !
;
FINDG1:

        psha
        ldab PTRTMP2                        ; Subtilité : est-ce qu'il y avait une partie décimale dans le nombre ...
        subb PTRTMP2+1                      ; si oui alors on incremente le nombre de décimale
        stab PTRTMP2
        bne suiteFINDG1
        jsr addInt                          ; convert string to int
        pula
        psha
suiteFINDG1:
        jsr MUL10                           ; FCT : Multiplie ACC1 par 10
                                            ; ALG : ACC2=ACC1 puis ACC1 * 4 puis ACC1=ACC1*4+ACC2 = 5* ACC1 puis (5*ACC1)*2
                                            ; IN  : ACC1 est à jour
                                            ; OUT : ACC1=ACC1*10
        ldx #cZERO                          ; conv int to float by array
        pula
        suba #$30                           ; '0'
        tab                                 ; 2  ; Compute offset = a * 5
        asla                                ; 2
        asla                                ; 2
        aba                                 ; 2
        tab                                 ; 2
        abx                                 ; 2
DBGFIN:
        jsr FADD                            ; add float to ACC1
        jmp getNextCharFIN

endFIN:
        rts

; -- Gestion des entiers lors de la conversion string to int
; les entiers sont stockés en complément à deux sur 17 bits
intFING:
        tst MEMINT+2                        ; si il y a eu un oveflow durant la conversion des entiers alors on retourne un float
        bne FINQNG2
        staa NUMTYP                         ; set to integer type
        staa ACC1TYPFLG                     ; the value of an expression is an integer
        staa ACC1+5                         ; set by default sign to positif
        ldd MEMINT
        tst ACC1SGNFLG
        beq next1IntFING
nextIntFING:
        dec ACC1+5                          ; set sign to negatif
        comb
        coma
        addd #$0001                         ; set number to integer complement 2
next1IntFING:
        std ACC1+3                          ; store int value
endIntFING:
        rts



addInt:
        suba #$30                           ; 2
        staa MEMINT+4                       ; 4  ; save digit = A -$30 with $30='0' ASCII !
        ldd MEMINT                          ; 5  ; make MEMINT*10 + (A-$30)
        asld                                ; 3  ; D=2 * MEMINT
        bcs overflowAddInt                  ; 3
        asld                                ; 3  ; D=D*2 = 4 * MEM INt
        bcs overflowAddInt                  ; 3
        addd MEMINT                         ; 6  ; D=8 * MEMINT + 2 * MEMINT
        bcs overflowAddInt                  ; 3
        asld                                ; 3  ; D=D*2 = 8 * MEMINT
        bcs overflowAddInt                  ; 3
        addd MEMINT+3                       ; 6
        bcs overflowAddInt                  ; 3
        std MEMINT                          ; 4  ; MEMINT = MEMINT * 10 + (A-$30)
        rts                                 ; TOTAL : 51 cycles

overflowAddInt:
        inc MEMINT+2
        rts


; End of function FIN

; =============== S U B R O U T I N E =======================================
; FCT : Imprime IN puis le numéro de ligne donnée par CURLIN
; OPT : /
; IN  : CURLIN à jour
; OUT : /
printIN:
        ldx #(aIN)
        ldab 0,x
        inx
        jsr bclOUTTX
        ldd CURLIN
; End of function printIN


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le nombre non signé contenu dans D
; IN  : D : le nombre non signé à afficher
; OPT : oui. A été réécrit pour être plus rapide
; IN  : D : 0 à 65536 ( entier non relatif )
; OUT : A,B,X modified
;       ACC1 détruit
ULIPTR:
        clr ACC1+5                          ; pour éviter les effets de bords lors des précédents calculs,
                                            ; on force le nombre à afficher à être positif

; =============== S U B R O U T I N E =======================================
; FCT : Imprime le nombre signé contenu dans D
; IN  : D : le nombre signé (complément à deux) à afficher
; OPT : oui. A été réécrit pour être plus rapide
; IN  : D : 0 à 65536 ( entier non relatif )
; OUT : A,B,X modified
;       ACC1 détruit
LIPTR:
        tst ACC1+5
        beq doXLIPTR
        comb                                ; conversion d'un nombre signé négatif codé complément à 2 en binaire
        coma
        addd #$0001
doXLIPTR:
        std ACC1                            ; save word to convert
        jsr bcdConvert
        jmp bclOUTTX

; =============== S U B R O U T I N E =======================================
; FCT : Convertit un entier stocké dans ACC1 en sa répresentation décimale
; IN  : ACC1 : le nombre à afficher
; OPT : oui. A été réécrit pour être plus rapide
; OUT : B : longueur de la conversion
;       X : position du premier caractère significatif (padleft)
;       TAMPON : position du premier caractère non significatif
;       A and ACC1 modified
bcdConvert:
        sei
        sts  SAVREGS
        lds  #FTAMPON+1
entryBcdConvert:
        ldaa #$20
        staa ACC1+2                         ; curDigit
        ldx  #(bcdTable+28)
        ldaa #$04
        staa ACC1+3
loopBcdConvert:
        ldd ACC1
        subd 0,x
        bcs trialclc
        std ACC1
        sec
        bra triallower
trialclc:
        clc
triallower:
        rol ACC1+2
        dex
        dex
        bcc loopBcdConvert
        ldaa ACC1+2
        oraa #$30
        psha
        ins
        ins
        ldaa #$10
        staa ACC1+2
        dec ACC1+3
        bne loopBcdConvert

finalizeBCDConvert:
        tsx
        dex
        lds SAVREGS
        cli
        ldaa ACC1+1
        oraa #$30
        staa 0,X                            ; Finalisation de la conversion
        clr  1,X                            ; caractère $00 de fin de chaîne

initSkipZeroBCDConvert:
        ldab #$06
        ldx #(FTAMPON)

skipZeroBCDConvert:
        decb
        inx
        ldaa 0,x
        cmpa #$30
        beq skipZeroBCDConvert
        tstb
        bne suite1111
        dex
suite1111:
        incb

manageSign:
        ldaa #cMATH_MINUS
        tst ACC1+5
        bpl endBCDConvert
        dex
        incb
        staa 0,X
endBCDConvert:
; reste le cas de 0 !!

        rts

bcdTable   dc.w 10,20,40,80,100,200,400,800,1000,2000,4000,8000,10000,20000,40000


; =============== S U B R O U T I N E =======================================
; FCT : CONVERT (ACC1) TO STRING STARTING AT STACK
; IN  : ACC1 à jour
; OUT : X=Pointeur sur le tampon de conversion Float -> String

FOUT:
        ldaa ACC1TYPFLG
        bne FOUT0                           ; le type de ACC1 est-il un float (valeur <> 0) ?
        ldd ACC1+3                          ; non alors nous appelons la routine LIPTR
        jmp LIPTR
FOUT0:
        ldx #(FTAMPON+1)                    ; Tampon pour conversion float -> STRING

; =============== S U B R O U T I N E =======================================
; FCT : "STR$" FUNCTION ENTERS HERE,
; IN  : X=Pointeur sur le tampon de conversion Float -> String
;       ACC1=la valeur à convertir en chaine de caractères
; OUT : X=Pointeur sur le tampon de conversion Float -> String
;       A et B modified

FOUT1:
printSignMantFOUT1:
        ldaa #cOS_SPACE                     ; ' ' ; fixe le signe de la conversion (blanc ou -)
        ldab ACC1+5                         ; get ACC1 sign
        bpl nextFOUT1
        ldaa #cMATH_MINUS                   ; '-'

nextFOUT1:
        staa 0,x
        staa ACC1+5                         ; Pourquoi ? garde fou ?
        stx STRNG2
        inx

isZeroFOUT1:
        ldaa #$30                           ; Charge '0' par défaut
        ldab ACC1                           ; Load Exposant of ACC1
        bne next1FOUT1
        jmp storeLastCharFOUT1

next1FOUT1:
        clra
        cmpb #$80                           ; TODO ??
        bhi next2FOUT1                      ; Si exposant of ACC1 > 0x80
        ldx #cUN_MILLIARD                   ; multiplication par 1 milliard
        jsr FMULT                           ; FCT : set ACC2 with constant pointed by X and multiply ACC1 by ACC2
                                            ; IN  : X=pointer of constant
                                            ; OUT : ACC1=ACC1*ACC2
        ldaa #$F7                           ; TODO ??

next2FOUT1:
        staa PTRTMP2

bcl3FOUT1:
        ldx #cUN_MILLIARD_MOINS_1           ; compare avec 1 MILLIARD - 1
        jsr SUB_FCOMP                       ; FCT : compare deux float : ACC1 avec le float et un float en mémoire pointé par X
                                            ; IN  : X=Adresse d'un float
                                            ;       ACC1=float to compare with float pointed by X
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       B = 1   IF ACC1 > (X)
                                            ;       B = $FF IF ACC1 < (X)
        bgt divBy10FOUT1

bcl4FOUT1:
        ldx #cCENT_MILLIONS
        jsr SUB_FCOMP                       ; FCT : compare deux float : ACC1 avec le float et un float en mémoire pointé par X
                                            ; IN  : X=Adresse d'un float
                                            ;       ACC1=float to compare with float pointed by X
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       B = 1   IF ACC1 > (X)
                                            ;       B = $FF IF ACC1 < (X)
        bgt next6FOUT1

multiplyBy10FOUT1:
        jsr MUL10                           ; FCT : Multiplie ACC1 par 10
                                            ; ALG : ACC2=ACC1 puis ACC1 * 4 puis ACC1=ACC1*4+ACC2 = 5* ACC1 puis (5*ACC1)*2
                                            ; IN  : ACC1 est à jour
                                            ; OUT : ACC1=ACC1*10
        dec PTRTMP2
        bra bcl4FOUT1

divBy10FOUT1:
        jsr divBy10                         ; FCT : Divise ACC1 par 10
                                            ; IN  :
                                            ; OUT : ACC1=ACC1/10
        inc PTRTMP2
        bra bcl3FOUT1

next6FOUT1:
        jsr add1div2toACC1                  ; FCT : additionne 0.5 à ACC1
                                            ; STX : /
                                            ; IN  : ACC1 à jour
                                            ; OUT : ACC1=ACC1+0.5
        jsr QUICK_INT                       ; FCT : effectue la fonction int sur ACC1
                                            ; IN  : ACC1 mis à jour
                                            ; OUT : ACC1=INT(ACC1)
                                            ;       B=exposant de ACC1
        ldab #$01
        ldaa PTRTMP2
        adda #$0A
        bmi next7FOUT1
        cmpa #$0B
        bcc next7FOUT1
        deca
        tab
        ldaa #$02

next7FOUT1:
        deca
        deca
        staa LOWTR
        stab PTRTMP2
        bgt next9FOUT1

printDotFOUT1:
        ldx STRNG2
        ldaa #cMATH_SEP_FLT                 ; '.'
        inx
        staa 0,x
        tstb
        beq next8FOUT
        ldaa #$30
        inx
        staa 0,x

next8FOUT:
        stx STRNG2

next9FOUT1:
        ldx #tabPuiss10
        ldab #$80

bcl10FOUT1:
        ldaa ACC1+4
        adda 3,x
        staa ACC1+4
        ldaa ACC1+3
        adca 2,x
        staa ACC1+3
        ldaa ACC1+2
        adca 1,x
        staa ACC1+2
        ldaa ACC1+1
        adca 0,x
        staa ACC1+1
        incb
        rorb
        rolb
        bvc bcl10FOUT1
        bcc next11FOUT1
        subb #$B
        negb

next11FOUT1:
        addb #$2F                           ; TODO : ?
        inx
        inx
        inx
        inx
        stx VARPNT                          ; Pointer used in array building

writeNextCharFOUT1:
        ldx STRNG2
        inx
        tba
        anda #$7F
        staa 0,x
        dec PTRTMP2                         ; TODO ??
        bne next12FOUT1

writeSepFloatFOUT1:
        ldaa #cMATH_SEP_FLT                 ; '.'
        inx
        staa 0,x

next12FOUT1:
        stx STRNG2
        ldx VARPNT                          ; Pointer used in array building
        comb
        andb #$80
        cpx #(tabPuiss10+9*4)               ; Est-ce la fin du tableau tabPuiss10 ?
        bne bcl10FOUT1
        ldx STRNG2

bcl13FOUT1:
        ldaa 0,x
        dex
        cmpa #$30                           ; '0'
        beq bcl13FOUT1
        cmpa #cMATH_SEP_FLT                 ; '.'
        beq next14FOUT1
        inx

next14FOUT1:
        ldaa #cMATH_PLUS                    ; '+'
        ldab LOWTR
        beq endStringBy0FOUT1
        bpl next15FOUT1
        ldaa #cMATH_MINUS                   ; '-'
        negb

next15FOUT1:
        staa 2,x
        ldaa #$45                           ; 'E'
        staa 1,x
        ldaa #$2F

bcl16FOUT1:
        inca
        subb #$0A
        bcc bcl16FOUT1
        addb #$3A                           ; TODO : ?
        staa 3,x
        stab 4,x
        clr 5,x
        bra returnPtrResFOUT1

storeLastCharFOUT1:
        staa 0,x

endStringBy0FOUT1:
        clr 1,x

returnPtrResFOUT1:
        ldx #(FTAMPON+1)                    ; Tampon pour conversion float -> STRING

endFOUT1:
        rts
; End of function FOUT1
; End of function FOUT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC SQR(X) : retourne la racine carrée de X
; STX : A=SQR(4) : retourne 2
; OP  : $B6
; ST  : ACTIF
; IN  : résultat de l'évaluation de l'expression numérique passée en paramètre
; OUT : ACC1=SQR(X)

romSQR:
        jsr moveACC1toACC2                  ; FCT : move ACC1 to ACC2
                                            ; IN  : ACC1
                                            ; OUT : ACC2=ACC1
                                            ;       X,D modified
                                            ;       D=ACC1 et ACC1+1
                                            ;       P modified
        ldx #cONEdivTWO
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
; End of function romSQR

setOneToACC1:


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC ^ : retourne X^Y
;       ATTENTION : actuellement l'opération ne s'effectue que sur des float ...
;       Hormis 0^n ou n^0, si X et/ou Y est un entier alors erreur de type TYPMISMATCH
; ALG : N.B. 0^0=1
;   FIRST CHECK IF Y=0. IF SO, THE RESULT IS 1.
;   NEXT CHECK IF X=0. IF SO THE RESULT IS 0.
;   THEN CHECK IF X.GT.0. IF NOT CHECK THAT Y IS AN INTEGER.
;   IF SO, NEGATE X, SO THAT LOG DOESN'T GIVE FCERR.
;   IF X IS NEGATIVE AND Y IS ODD, NEGATE THE RESULT
;   RETURNED BY EXP.
;   TO COMPUTE THE RESULT USE X^Y=EXP((Y*LOG(X)).
; STX : A=2^3: retourne 8
; OP  : $B1
; ST  : ACTIF
; IN  : A=exposant de ACC2 (=X)
;       B=exposant de ACC1 (=Y)
;       ACC1=Y
;       ACC2=X
;       C=1 ==> Y=0
; OUT : ACC1=ACC2^ACC1

FPWRT:
        bne FPWRT0                          ; Y = 0 ? oui alors ACC1=X^0=1

returnOneFPWRT:
        ldx #cONE
        jmp MOVFM                           ; FCT : MOVE memory to ACC1

FPWRT0:
        tsta                                ; X = 0 ?
        bne doFPWRT                         ; non alors calcul
        ldaa ACC1+5                         ; sign(Y)
        bpl FPWRT1                          ; si Y > 0 alors ACC1=0^X=0 avec X>0
        jmp errorDivideByZero               ; sinon erreur !

FPWRT1:
        ldx #cZERO
        jmp MOVFM

doFPWRT:
        tst ACC1TYPFLG
        bne next1RPWRT
        jmp errTypMisMatchRomLET
next1RPWRT:
        tst ACC2TYPFLG
        bne next2RPWRT
        jmp errTypMisMatchRomLET
next2RPWRT:

        ldx #FLTTMP3
        jsr MOVMF                           ; move ACC1 to memory (by pointer X)
        clrb
        ldaa ACC2+5                         ; A=SGN(X of X^Y)
        bpl FPWRT2                          ; Si > 0
        jsr romINT                          ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                                            ; STX : A=INT(5.25) : retourne 5
                                            ; OP  : $B2
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : ACC1 avec la partie entière  de l'expression
                                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' ou EXP)
        jsr convIntToFloat
        ldx #FLTTMP3
        ldaa ACC2+5
        jsr SUB_FCOMP                       ; FCT : compare deux float : ACC1 avec le float et un float en mémoire pointé par X
                                            ; IN  : X=Adresse d'un float
                                            ;       ACC1=float to compare with float pointed by X
                                            ; OUT : ZERO FLAG SET AND B = 0, IF EQUAL
                                            ;       B = 1   IF ACC1 > (X)
                                            ;       B = $FF IF ACC1 < (X)
        bne FPWRT2
        coma
        ldab CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire

FPWRT2:
        jsr MOVA2A1                         ; FCT : recopie ACC2 dans ACC1
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : A = SIGNE de ACC1
                                            ; OUT : X et A modified
        pshb
        jsr romLOG                          ; FCT : COMMANDE BASIC  LOG(X) : retourne le logarithme NATUREL (ou NEPERIEN) de X
                                            ; ALG : LN(F*2^N)=(N+LOG2(F))*LN(2)
                                            ;       approximation par polynome sur l'intervalle [0;1]
                                            ;       Si N=1/2 alors LN(F*2^N) = LN (F*SQR(2))
                                            ;                    = (-0.5+LOG2(F))*LN(2)
                                            ; STX : A=LOG(10) : retourne 2.30258509
                                            ; OP  : $B7
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 > 0
                                            ; OUT : ACC1=LOG(ACC1)
        ldx #FLTTMP3
        jsr FMULT                           ; multiply ACC1 by LOG(X)
        bsr romEXP                          ; FCT : COMMANDE BASIC EXP(X) : retourne l'exponentiel de X
                                            ; ALG : FIRST SAVE THE ORIGINAL ARGUMENT AND MULTIPLY THE FAC BY
                                            ;       LOG2(E). THE RESULT IS USED TO DETERMINE IF OVERFLOW
                                            ;       WILL OCCUR SINCE EXP(X)=2^(X*LOG2(E)) WHERE
                                            ;       LOG2(E)=LOG(E) BASE 2. THEN SAVE THE INTEGER PART OF
                                            ;       THIS TO SCALE THE ANSWER AT THE END. SINCE
                                            ;       2^Y=2^INT(Y)*2^(Y-INT(Y)) AND 2^INT(Y) IS EASY TO COMPUTE.
                                            ;       NOW COMPUTE 2^(X*LOG2(E)-INT(X*LOG2(E)) BY
                                            ;       P(LN(2)*(INT(X*LOG2(E))+1)-X) WHERE P IS AN APPROXIMATION
                                            ;       POLYNOMIAL. THE RESULT IS THEN SCALED BY THE POWER OF 2
                                            ;       PREVIOUSLY SAVED.
                                            ; STX : A=EXP(10) : retourne 22026.4658
                                            ; OP  : $B8
                                            ; ST  : ACTIF
                                            ; IN  : ACC1
                                            ; OUT : ACC1=EXP(ACC1)
        pula                                ; est-ce pair ?
        rora
        bcc endFOUT1                        ; c'est le rts le plus accessible ...

; =============== S U B R O U T I N E =======================================
; FCT : routine NEG(X) : retourne l'opposé de ACC1 : traite les float et les entiers
; STX : /
; OP  : /
; ST  : ACTIF
; IN  : /
; OUT : ACC1=NEG(ACC1)

doNEG:
        ldaa ACC1
        beq endDoNEG
        com ACC1+5                          ; inverse ACC1 sign
        tst ACC1TYPFLG                      ; si float alors on sort
        bne endDoNEG
        ldd ACC1+3                          ; sinon complement à 2 du nombre
        comb
        coma
        addd #$0001
        std ACC1+3
endDoNEG:
        rts
; End of function doNEG
; End of function FPWRT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC EXP(X) : retourne l'exponentiel de
; ALG : FIRST SAVE THE ORIGINAL ARGUMENT AND MULTIPLY THE FAC BY
;   LOG2(E). THE RESULT IS USED TO DETERMINE IF OVERFLOW
;   WILL OCCUR SINCE EXP(X)=2^(X*LOG2(E)) WHERE
;   LOG2(E)=LOG(E) BASE 2. THEN SAVE THE INTEGER PART OF
;   THIS TO SCALE THE ANSWER AT THE END. SINCE
;   2^Y=2^INT(Y)*2^(Y-INT(Y)) AND 2^INT(Y) IS EASY TO COMPUTE.
;   NOW COMPUTE 2^(X*LOG2(E)-INT(X*LOG2(E)) BY
;   P(LN(2)*(INT(X*LOG2(E))+1)-X) WHERE P IS AN APPROXIMATION
;   POLYNOMIAL. THE RESULT IS THEN SCALED BY THE POWER OF 2
;   PREVIOUSLY SAVED.
; STX : A=EXP(10) : retourne 22026.4658
; OP  : $B8
; ST  : ACTIF
; IN  : ACC1
; OUT : ACC1=EXP(ACC1)

romEXP:
        ldx #cONEdivLN2                     ; optimisation : on considére que la multiplication est plus rapide que la division
        jsr FMULT
        jsr SAVEACC1toFLTTMP1
        ldaa ACC1
        cmpa #$88                           ; la valeur maximale admissible pour l'exposant de ACC1 est 88 : EXP(88) = 1.65163623E+38
        bcs next1RomEXP

nextRomEXP:
                                            ; IF sign(mantissa of ACC1) IS POSITIVE THEN 'OV'erflow ERROR
                                            ; IF sign(mantissa of ACC1) IS NEGATIVE THEN ACCA1 = 0
        ldaa ACC1+5                         ; get ACC1 sign
        coma
        jmp setZeroOrErr0x0A_OverFlow

next1RomEXP:
        jsr romINT                          ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                                            ; STX : A=INT(5.25) : retourne 5
                                            ; OP  : $B2
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : ACC1 avec la partie entière  de l'expression
                                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' ou EXP)
        jsr convIntToFloat
        ldaa CHARAC                         ; sert à tout : stockage d'un caractère, de valeur pour opération binaire
        adda #$81                           ; TODO : ??
        beq nextRomEXP                      ; sort en erreur
        deca
        psha
        ldx #FLTTMP1
        jsr FSUB                            ; FCT : Soustrait de ACC1 le nombre réel pointé par X
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 à jour
                                            ;       X=pointeur sur un réel
                                            ; OUT : ACC1=FLOAT(PTR X) - ACC1
        ldx #tabParamEXP
        bsr saveXBeforeDoPOLYNOMIAL
        clr PRODSIGN
        pula
        jmp MULDIV                          ; FCT : FIX UP THE EXPONENTS
                                            ; IN  : A=Exposant du nombre flottant
                                            ; OUT : Si A=$00 alors retourne ACC1=0
                                            ;       sinon fixe le signe de la mantisse du résultat
                                            ; ERR : $0A : overflow error
; End of function romEXP

; =============== S U B R O U T I N E =======================================
; FCT : applique la serie de taylor pointée par X
; IN  : X=pointeur sur les paramètres de la série de taylor
; OUT : ACC1=POLY(ACC1)

subMapApproximation:
        stx STRNG2
        jsr SAVEACC1toFLTTMP1
        jsr FMULT
        bsr doPOLYNOMIAL                    ; FCT : Calcule la série de taylor
                                            ; IN  : X=pointeur sur les paramètres de la série de taylor
                                            ; OUT : ACC1=POLY(ACC1)
        ldx #FLTTMP1
        jmp FMULT                           ; FCT : set ACC2 with constant pointed by X and multiply ACC1 by ACC2
                                            ; IN  : X=pointer of constant
                                            ; OUT : ACC1=ACC1*ACC2
; End of function subMapApproximation

; =============== S U B R O U T I N E =======================================
saveXBeforeDoPOLYNOMIAL:
        stx STRNG2
; End of function saveXBeforeDoPOLYNOMIAL


; =============== S U B R O U T I N E =======================================
; FCT : Calcule la série de taylor
; IN  : X=pointeur sur les paramètres de la série de taylor <== TODO A CORRIGER L'AFFIRMATION
; OUT : ACC1=POLY(ACC1)

doPOLYNOMIAL:
        jsr SAVEACC1toFLTTMP2
        ldx STRNG2
        ldab 0,x
        stab NBLOOP
        inx
        stx STRNG2

bclDoPOLYNOMIAL:
        jsr FMULT
        ldx STRNG2
        ldab #cBAS_BYTES_PER_VARIABLE       ; $05
        abx
        stx STRNG2
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
        ldx #FLTTMP2
        dec NBLOOP
        bne bclDoPOLYNOMIAL
        rts
; End of function doPOLYNOMIAL


; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC RND : retourne une valeur pseudo-aléatoire entre 1 et n
; STX : PRINT RND(15) retourne 5
; OP  : $B5
; ST  : ACTIF
; IN  : /
; OUT : ACC1=nombre pseudo-aléatoire entre 1 et n

romRND:
        jsr subSIGN                         ; FCT : retourne le signe du nombre réel contenu dans ACC1
                                            ; IN  : /
                                            ; OUT : B=$01 si ACC1 > 0
                                            ;       B=$00 si ACC1 = 0
                                            ;       B=$FF si ACC1 < 0
        bmi doRND
        beq getENTROPYbeforeDoRND
        jsr romINT                          ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                                            ; STX : A=INT(5.25) : retourne 5
                                            ; OP  : $B2
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : ACC1 avec la partie entière de l'expression
                                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' OU EXP)
        jsr convIntToFloat
        jsr SAVEACC1toFLTTMP1
        bsr getENTROPYbeforeDoRND
        ldx #FLTTMP1
        jsr FMULT
        ldx #cONE
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
        jsr romINT                          ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                                            ; STX : A=INT(5.25) : retourne 5
                                            ; OP  : $B2
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : ACC1 avec la partie entière  de l'expression
                                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^' ou EXP)
        jmp convIntToFloat
; End of function romRND

; =============== S U B R O U T I N E =======================================
getENTROPYbeforeDoRND:
        ldx ENTROPY
        stx ACC1+1
        ldx ENTROPY+2
        stx ACC1+3

doRND:
        ldx cRNDSEED
        stx ACC2+1
        ldx cRNDSEED+2
        stx ACC2+3
        jsr initTFRomMULT
        ldd DESCSTR+2                       ; ldd TMPFLT1+2         ; SEL aléatoire !!
        addd #$658B
        std ENTROPY+2
        std ACC1+3
        ldd DESCSTR                         ; ldd TMPFLT1           ; SEL aléatoire !!
        adcb #$B0
        adca #$05
        std ENTROPY
        std ACC1+1
        clr ACC1+5                          ; get ACC1 sign
        ldaa #$80
        staa ACC1
        ldaa TMPFLT+2
        staa ACC1EXT
        ldx #ACC1
        jmp normalizeMantRomPlus
; End of function getENTROPYbeforeDoRND

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC SIN(X) : retourne le sinus de X
; ALG : COS(X)=SIN(X+PI/2)
; STX : A=COS(3.14) : retourne -0.999998732
; OP  : $BA
; ST  : ACTIF
; IN  : ACC1
; OUT : ACC1=COS(ACC1)

romCOS:
        ldx #cPIdivTWO
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
; End of function romCOS

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC SIN(X) : retourne le sinus de X
; ALG : approximation
; STX : A=SIN(3.14/2) : retourne 0.999999683 et A=SIN(PI/2) donne 1
; OP  : $B9
; ST  : ACTIF
; IN  : ACC1
; OUT : ACC1=SIN(ACC1)

romSIN:
        ;jsr moveACC1toACC2                 ; FCT : move ACC1 to ACC2
                                            ; IN  : ACC1
                                            ; OUT : ACC2=ACC1
                                            ;       X,D modified
                                            ;       D=ACC1 et ACC1+1
                                            ;       P modified
        ;ldx #cTWOPI
        ;ldab ACC2+5
        ;jsr next1DivByX
        ;ldab ACC2+5      ; OPT
        ;stab PRODSIGN    ; OPT
        ldx #cONEdivTWOPI ; OPT
        jsr FMULT         ; OPT: ACC1=ACC1*(1/2*PI)=ACC1/(2*PI)
        jsr moveACC1toACC2                  ; FCT : move ACC1 to ACC2
                                            ; IN  : ACC1
                                            ; OUT : ACCC2=ACC1
                                            ;       X,D modified
                                            ;       D=ACC1 et ACC1+1
                                            ;       P modified
        jsr romINT                          ; FCT : COMMANDE BASIC INT(X) : retourne la partie entière de l'expression
                                            ; STX : A=INT(5.25) : retourne 5
                                            ; OP  : $B2
                                            ; ST  : ACTIF
                                            ; IN  : le flot à interpréter
                                            ; OUT : ACC1 avec la partie entière de l'expression
                                            ;       CHARAC contient le poid faible de la mantisse (est utilisée par la fonction '^')
        stab ACC1EXT
        ldaa ACC1+5
        stab ACC1+5
        suba #$80
        ldaa #$A0 ; ' '
        staa ACC1
        ldaa ACC1+4      ; TODO : cela sert à quelque chose ?
        ldx  #ACC1
        jsr normalizeMantBySignRomPLUS            ; NORMALIZE FAC1

        ;jsr convSignedWordToACC1_NEW        ; FCT : conversion d'un int signé en float.
                                            ; IN  : ACC1 : contient l'entier à convertir
                                            ;              ACC1+3,4 : contient l'entier
                                            ;              ACC1+5   : contient le signe de l'entier
                                            ;
;OUT : ACC1 = FLOAT(Int)
;      A,X : modified / B : unmodified
        clr PRODSIGN
        ldaa ACC2                           ; TODO get exponent of ACC2 : ==
        ldab ACC1                           ; TODO get exponent of ACC1 : ==
        jsr romMINUS                        ; FCT : Subtract ACC2 to ACC1
                                            ; STX : /
                                            ; ALG : ?
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 and ACC2 set
                                            ;       A=?
                                            ;       B=?
                                            ; OUT : ACC1=ACC1-ACC2
        ldx #cONEdivFOUR
        jsr FSUB                            ; FCT : Soustrait de ACC1 le nombre réel pointé par X
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : ACC1 à jour
                                            ;       X=pointeur sur un réel
                                            ; OUT : ACC1=FLOAT(PTR X) - ACC1
        ldaa ACC1+5                         ; get ACC1 sign
        psha
        bpl bclRomSIN
        jsr add1div2toACC1                  ; FCT : additionne 0.5 à ACC1
                                            ; STX : /
                                            ; IN  : ACC1 à jour
                                            ; OUT : ACC1=ACC1+0.5
        ldaa ACC1+5                         ; get ACC1 sign
        bmi next1RomSIN
        com CPRMASK
bclRomSIN:

        jsr doNEG                           ; FCT : routine NEG(X) : retourne l'opposé de ACC1
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : ACC1=NEG(ACC1)
next1RomSIN:
        ldx #cONEdivFOUR
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given by X
        pula
        tsta
        bpl next2RomSIN
        jsr doNEG                           ; FCT : routine NEG(X) : retourne l'opposé de ACC1
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : ACC1=NEG(ACC1)
next2RomSIN:
        ldx #tabParamSIN
        jmp subMapApproximation             ; FCT : applique la serie de taylor pointée par X
                                            ; IN  : X=pointeur sur les paramètres de la série de taylor
                                            ; OUT : ACC1=POLY(ACC1)
; End of function romSIN

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC TAN(X) : retourne la tangente de X
; ALG : TAN(X)=SIN(X)/COS(X)
; STX : A=TAN(3.14/3) : retourne 1.72992922
; OP  : $BB
; ST  : ACTIF
; IN  : ACC1
; OUT : ACC1=TAN(ACC1)
;TODO : jsrclRomSIN_romTAN : optimisation ?

romTAN:
        jsr SAVEACC1toFLTTMP1
        clr CPRMASK                         ; CLEAR THE MASK OF COMPARISON (<=>)
        bsr romSIN                          ; FCT : COMMANDE BASIC SIN(X) : retourne le sinus de X
                                            ; ALG : approximation
                                            ; STX : A=SIN(3.14/2) : retourne 0.999999683
                                            ; OP  : $B9
                                            ; ST  : ACTIF
                                            ; IN  : ACC1
                                            ; OUT : ACC1=SIN(ACC1)
        ldx #FLTTMP3
        jsr MOVMF                           ; move ACC1 to memory (by X)
        ldx #FLTTMP1
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
        clr ACC1+5                          ; set ACC1 sign to positive
        ldaa CPRMASK                        ; Masque de comparaison
        bsr jsrBclRomSIN_romTAN
        ldx #FLTTMP3
        jmp FDIV

jsrBclRomSIN_romTAN:                        ; TODO : OPTIMISATION ?
        psha
        bra bclRomSIN
; End of function romTAN


; /// BASIC - MATHEMATIQUE - ENTIER

; =============== S U B R O U T I N E =======================================
; FCT : multiplication de deux entiers signés
; IN  : ACC1 et ACC2 à jour
; OUT : ACC1=ACC1*ACC2
; Domaine de validité des entiers de -32767 à 32767 : 0 - 7FFFF / 8000 - FFFF
;int_mul:
;    rts

; =============== S U B R O U T I N E =======================================
; FCT : division de deux entiers signés
; IN  : ACC1 et ACC2 à jour
; OUT : ACC1=ACC1/ACC2
;int_div:
;    rts

; /// BASIC - MEMOIRE
xxBASIC_MEM:

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC PEEK(X) : récupère la valeur de l'octet à l'adresse X
; STX : A=PEEK(12000)
; ALG : /
; OP  : $BC
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : ACC1=la valeur pointée par X sous forme d'un entier

romPEEK:
        jsr convIntGetArg                   ; get Argument : convet it into WORD (reg X)
        ldab 0,x                            ; "peek" value from X
        jmp returnByteIntRomLEN
; End of function romPEEK


; =============== S U B R O U T I N E =======================================
; FCT : CMD BASIC POKE : initialise l'octet à l'adresse A avec B
; STX : POKE A,B
; OP  : $92
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : A,B,X modified

romPOKE:
        jsr get2params                      ; FCT : parse 2 arguments séparés par une virgule
                                            ;       1 er argument : word 2 eme Arg : byte
                                            ; IN  : /
                                            ; OUT : LINUM contient la valeur du premier argument
                                            ;       B : contient la valeur du deuxième argument
        ldx LINUM
        stab $00,x
        rts
; End of function romPOKE

; =============== S U B R O U T I N E =======================================
; FCT : Donne la taille mémoire disponible - COMMANDE BASIC MEM
; OP  : $D7
; ST  : ACTIF
; IN  : /
; OUT : ACC1=taille mémoire disponible

romMEM:
        sts SAVREGS
        ldd SAVREGS
        subd STREND
        jmp convUnsignedWordToACC1
; End of function romMEM

; =============== S U B R O U T I N E =======================================
; FCT : Exécute un sous programme assembleur
; STX : EXEC : exécute l'appel au sous-programme assembleur
;       EXEC 25000
;       EXEC exécute le sous programme initialisé préalablement par EXEC XXXX
; OP  : $9F
; ST  : ACTIF
; DBG : NON
; IN  : le flot d'interprétation
;       A=0 si pas d'argument à interpréter
; OUT : /

romEXEC:
        beq doRomEXEC
        jsr getArg                          ; FCT : récupère un word dans le flot d'inteprétation
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=WORD from ARGUMENT
                                            ;       ACC1+3 et ACC1+4 contiennent aussi l'expression convertie de type word
        stx pEXEC

doRomEXEC:
        ldx pEXEC
        jmp 0,x
; End of function romEXEC


; =============== S U B R O U T I N E =======================================
; FCT : Donne le pointeur sur la variable donnée en paramètre
;       Il faut que la variable existe sinon message d'erreur
; STX : B=VARPTR(A)
; OP  : $C6
; ST  : ACTIF
; IN  : le flot d'interprétation contenant (A[$,%])
; OUT : ACC1=Le pointeur sur la mémoire contenant la valeur de la variable

romVARPTR:
        ldx STREND
        pshx
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        jsr CHKCLS                          ; FCT : check close parenthesis and get next char
                                            ; IN  : TXTPTR mise à jour
                                            ; OUT : X unmodified, A et B modified
        stx INDEX
        pulx
        clra
        staa  STRTYP                        ; On force le retour de la fonction comme numérique
        ldd INDEX                           ; get Pointer
        cpx STREND
        beq endRomVARPTR
        jmp printErrorMSG_0x08_FC_FctIncorrect

endRomVARPTR:
        jmp convUnsignedWordToACC1          ; FCT : Convert Word to Float
                                            ; IN  : D=number to convert
                                            ; OUT : ACC1=float(D)
; End of function romVARPTR

; /// BASIC - DEBUG
; =============== S U B R O U T I N E =======================================
; FCT : Passe en mode debug
; STX : TRON
; OP  : $??
; ST  : ACTIF
; IN  : /
; OUT : /
; OPT : TODO : si on fait NEW le mode DEBUG n'est pas reinitialisé
;       TODO : remplacer ldaa #$FF par coma ?

romTRON:
        ldaa #$FF
        bra doRomTROFF

; =============== S U B R O U T I N E =======================================
; FCT : Supprime le mode debug
; STX : TROFF
; OP  : $??
; ST  : ACTIF
; IN  : /
; OUT : /

romTROFF:
        clra
doRomTROFF:
        staa fTRACE
        rts
; End of function romTRON
; End of function romTROFF

; /// BASIC - EDITION - SAISIE

; =============== S U B R O U T I N E =======================================
; FCT : Fixe le pas de l'incrémenation automatique du numéro de ligne
;       Si =0 alors l'autoincrémentation est supprimé
; STX : AUTO LINE_NUMBER
; OP  : $??
; ST  : WIP
; IN  : le flot à interpréter
; OUT : AUTOINC à jour avec la valeur de [LINE NUMBER]

romAUTO:
        jsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir<
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        ldd LINUM
        std AUTOINC
endRomAUTO:
        rts                                 ; TODO : jmp INTERPRETATION ?
; End of function romAUTO

; =============== S U B R O U T I N E =======================================
; FCT : renomme des lignes de programme basic
; STX : RENUM [LINE NUMBER FR DEBUT]-[LINE NUMBER FIN]
; OP  : $??
; ST  : WIP
; IN  : le flot à interpréter
; OUT : /
RENUOO:
   jmp setError0x02_SYNTAXERROR             ; TODO XX A RECHANGER BACK TO BASIC WARM START

romRENUM:
   ldx VARTAB

;START PASS ONE
;BUILD TABLE OF LINE NUMBERS FOLLOWING
;THE SOURCE PROGRAN IN MEMORY
;EACH ENTRY CONSISTS OF FOUR BYTES
;THE FIRST TWO ARE THE OLD LINE NO. IN BCD
;THE NEXT TWO ARE THE NEW LINE NO. IN BCD
;
RENUMF:
    ; TODO XX CALL ERASE POINTER BASICS : pour libérer de la place ...
    ; TODO XX Il faudra ajouter un test entre TXTAB et VARTAB
RENUMO:
        stx TEMP3                           ; POINTER TO END OF LINE NUMBER TABLE
        clra                                ; INIT LINE NO COUNTER
        staa MSLINE
        staa LSLINE
        ldx TXTAB                           ; POINT TO SOURCE START
RENUM1:
        ldd 2,X                             ; Obtient la valeur du numéro de ligne
        ldx 0,X                             ; Obtient la position de la prochaine ligne
        beq RENUM4
        stx TEMP2                           ; SAVE SOURCE POINTER
        ldx TEMP3                           ; GET LINE NO. TABLE POINTER
        std 0,X                             ; Sauvegarde du numéro de ligne en cours
        inx                                 ; BUMP THE POINTER
        inx                                 ; AND AGAIN
        ldd MSLINE
        addd #10                            ; Ajoute le pas d'incrémentation par défaut
        std MSLINE
        std 0,X                             ; Sauvegarde le nouveau numéro de ligne après la renumérotation
        inx                                 ; BUMP END OF TABLE POINTER
        inx                                 ;
        stx TEMP3                           ; SAVE IT
        ldx TEMP2                           ; LOAD NEXT LINE TO PARSE
        BRA RENUM1

;
;START PASS TWO                             ; parse les n lignes du programme
;
RENUM4:
        ldx TEMP3                           ; todo POURQUOI ?
        dex
        dex
        dex
        dex
        stx TEMP3

RENUM41:
        ldx TXTAB

;
;REPLACE BCD LINE NUMBER
;
RENU45:
        ldd 0,X                             ; is End of Line (TODO End Of Program ?)
        beq RENUOO
        ldd 2,X                             ; GET NUMBER OF LINE
        std TEMP1                           ; SAVE NUMBER OF LINE : used by searchNewNumber
        stx TEMP2                           ; SAVE PTR ON CURRENT LINE  : used by founding next line

RENUM5:
        jsr searchNewNumber                 ; Get pointer of the new number of line

RENUM61:
        ldd 2,X                             ; GET NEW LINE FROM ARRAY OF TRANSLATION
        ldx TEMP2                           ; GET PTR ON CURRENT LINE
        std 2,X                             ; SAVE NEW LINE INTO LINE

initParseStatementRENUM:
        ldab #$03
        abx                                 ; 5 cycles : 3 octets
        stx TXTPTR

parseStatementRENUM:

        jsr SKIP11_RENUM                    ; SKIP BLANK CHAR
        beq EOF_RENUM                       ; IF END OF LINE THEN NEXT LINE OR END OF PROGRAM

isGotoOrGosub:
        cmpa #cBAS_TOKEN_GOTO
        beq GOXX_RENUM
        cmpa #cBAS_TOKEN_GOSUB
        beq GOXX_RENUM
        cmpa #cBAS_TOKEN_RESTORE
        beq GOXX_RENUM

isThenOrElse:
        cmpa #cBAS_TOKEN_THEN
        beq THEN_RENUM
        cmpa #cBAS_TOKEN_ELSE
        bne parseStatementRENUM

; =============== THEN / ELSE
; IF x THEN [{GOTO/GOSUB} y / y] [else [{GOTO/GOSUB} y / y]
THEN_RENUM:
        jsr SKIPSP_RENUM
        beq EOF_RENUM
        bmi isGOXX_THEN_RENUM               ; is an opcode ? yes then jump
        jsr returnNUM                       ; is a NUMBER ?
        bcs next1GOXX_RENUM
isGOXX_THEN_RENUM:
        cmpa #cBAS_TOKEN_GOTO
        beq GOXX_RENUM
        cmpa #cBAS_TOKEN_GOSUB
        BNE EOF_RENUM
        jsr REMN                            ; FCT : skip to end of line
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of line
                                            ;       A,B modified

; =============== GOTO / GOSUB

GOXX_RENUM:
        jsr SKIPSP_RENUM                    ; SKIP SPACE
        beq EOF_RENUM
        jsr returnNUM                       ; is a NUMBER ?
        bcc EOF_RENUM
next1GOXX_RENUM:
        ldx TXTPTR
        stx TEMP4                           ; save. Used to save the new line number; TODO : CELA SERT-IL ? oui ...
        jsr LINGET                          ; get number (line number)
        std TEMP1                           ; Save line number
GOXX_RENUM_1:
        jsr searchNewNumber
GOXX_RENUM_2:
        ldd 2,X                             ; get new Number Line from Old Number line
        std ACC1                            ; save word to convert
        jsr bcdConvert                      ; FCT : Convertit un entier stocké dans ACC1 en sa répresentation décimale
                                            ; IN  : ACC1 : le nombre à afficher
                                            ; OPT : oui. A été réécrit pour être plus rapide
                                            ; OUT : B : longueur de la convertion
                                            ;       X : position du premier caractère significatif (padleft)
                                            ;       TAMPON : position du premier caractère non significatif
                                            ;       A and ACC1 modified
        jsr copyTampon

EOF_RENUM:
        ldx TEMP2
        ldx 0,X                             ; GET BEGIN OF NEXT LINE -- UTILITE DE LA SAUVEGARDE DU POINTEUR DE DEPRRT DE LIGNE (TMEP2)
        BRA RENU45

; ----------------------------------------------
copyTampon:
        sei
        sts SAVREGS
        txs
        ldx TEMP4
bclCopyTampon:
        pula
        tsta
        beq nextCopyTampon
        staa 0,X
        inx
        bra bclCopyTampon
nextCopyTampon:
        lds SAVREGS
        cli
        rts


; ----------------------------------------------
searchNewNumber:
        ldx VARTAB
bclSearchNewNumber:
        ldd  0,X                            ; Get ieme item from array of translation
        subd TEMP1
        beq endSearchNewNumber
        bhs errorSearchNewNumber
        ldab #$04
        abx                                 ; 5 cycles : 3 octets
        cpx TEMP3
        bls bclSearchNewNumber
errorSearchNewNumber:
        ldab #cBAS_ERR_UNDEFLINE
        jmp ERROR
endSearchNewNumber:
        rts

; ----------------------------------------------

SKIPSP_RENUM:
SKIP11_RENUM:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #$20
        beq SKIP11_RENUM
SKIP2_RENUM:
        tsta
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Supprime des lignes de programme basic entre début et fin
; STX : DEL [LINE NUMBER FR DEBUT]-[LINE NUMBER FIN]
; OP  : $??
; ST  : WIP
; IN  : le flot à interpréter
; OUT : /
; OPT : finaliser le développement (contrôle des paramètres)

NRANGE:
        jmp setError0x02_SYNTAXERROR

romDEL:
        beq NRANGE                          ; bad..no range parms.

getParamRomDEL:
        jsr LINGET                          ; get first param
        jsr FNDLIN                          ; find line
        bcs NRANGE
        stx BEGIN_RANGE
        jsr  CHRGOT                         ; get input character
        beq  endRomDEL                      ; none skip ahead
        cmpa #cBAS_TOKEN_MINUS              ; check for '-' token
        bne  NRANGE
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        jsr LINGET                          ; get second param
        jsr FNDLIN                          ; find line
        bcs NRANGE
        stx END_RANGE
moveMemRomDEL:                              ; TO_DO A optimiser
        ldx END_RANGE
        ldx 0,x                             ; obtient le pointeur de la ligne suivante
        ldd 0,x                             ; Si valeur = $0000 alors fin de programme en initialisant correctement la fin de programme
        bne doMoveMemRomDEL
        ldx BEGIN_RANGE
        std 0,x
        bra finalizeDoMoveMemRomDEL
doMoveMemRomDEL:                            ; Recopie de END_RANGE - DEBUT_VAR to BEGIN_RANGE
        sei
        sts SAVREGS
        stx NEW_RANGE                       ; Calcul du delta de mémoire à déplacer (pointeurs)
        ldd VARTAB
        subd NEW_RANGE
        addd BEGIN_RANGE
        std NEW_RANGE                       ; Borne d'arrêt de copie
        txs                                 ; SOURCE
        ldx BEGIN_RANGE                     ; CIBLE
bclDoMoveMemRomDEL:
        pula
        staa 0,x
        inx
        cpx NEW_RANGE
        bne bclDoMoveMemRomDEL
        lds SAVREGS
        cli
        stx VARTAB
finalizeDoMoveMemRomDEL:
        jsr SETPTRS                         ; Reconstruire les liens du programme basic
endRomDEL:
        jmp INTERPRETATION
; End of function romDEL


;/// OS - Divers
xxOS_DIVERS:

; =============== S U B R O U T I N E =======================================
; FCT : Point d'entrée pour la réinitialisation
; ST  : ACTIF
; IN  : /
; OUT : /²

vectRESET:
        ldaa #$FF
        staa DDR1                           ; Port 1 en sortie
        ldaa #$01
        staa DDR2                           ; Port 2, bit 0 en sortie les autres en entrée
        ldaa #$01
        staa PORT2                          ; Port I/O soit pour RS232 soit pour K7
COLDorWARNRESET:
        ldaa fCOLDWARN
        cmpa #cOS_WARN                      ; 'U'
        bne doHardReset

doColdWarn:
        ldx pCOLD
        ldaa 0,x
        deca
        bne doHardReset
        jmp 0,x

; =============== S U B R O U T I N E =======================================
; FCT : Effectue diverses initialisations systèmes :
;   - mode texte 40 colonnes
;   - la zone mémoire entre $0080 et $0100
;   - la zone vecteur CPU
;   - pile système
;   - saisie utilisateur
;   - Hook
;   - Basic
;   - Ecran
;   Puis imprime la banniére MICROSOFT
;   ENFIN entre dans la boucle d'interprétation du BASIC
; IN  : /
; OUT : A,X modified
doHardReset:
        lds #areaStackByDefault             ; Set STACK to $4800
        jsr GR_initVideoMode40

OS_initializeMEMORY_LOWRAM:
        ldx #cCPU_BEGIN_RAM                 ; pointer to 0x0080

bclOS_initializeMEMORY:
        clr 0,x                             ; met à zéro la zone du MC6803 de $80 à $FF
        inx
        cpx #(cCPU_END_RAM+1)
        bne bclOS_initializeMEMORY

OS_initializeMEMORY_MAINRAM:
        ldx #(cBEGIN_RAM-1)
bcl1OS_initializeMEMORY:
        inx                                 ; Recherche de la fin de la RAM disponible
        ldaa 2,x
        com 2,x
        ldab 2,x
        clr 2,x
        coma
        cba
        beq bcl1OS_initializeMEMORY
        stx ADRENDMEM                       ; Adresse de la fin de mémoire (à l'initialisation sans extension mémoire vaut 0x4FFE)
        stx MEMSIZ                          ; Adresse - 1 de la fin de la RAM DISPONIBLE
        stx FRETOP

allocString:
        ldd FRETOP
        subd #cBAS_AREA_STR_DEFAULT         ; $64
        std BOTSTK

initStack:
        lds BOTSTK

copyRoutineOS_GetChar:
        ldx #lgRoutineOS_GetChar
        ldd #CHRGET                         ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        bsr OS_copyMEM                      ; FCT : Copie la zone mémoire pointée par X
                                            ;       (le premier octet contient le nombre d'octets
                                            ;       à copier) dans celle pointée par D
                                            ; IN  : X=SOURCE
                                            ;       D=CIBLE
                                            ; OUT : A,B,X modified

InitVectorAndRam:
        ldx #lgTabInitVectorAndMem          ; TODO initialise la zone RAM $3024 à $3054
        ldd #vectSCI
        bsr OS_copyMEM                      ; FCT : Copie la zone mémoire pointée par X
                                            ;       (le premier octet contient le nombre d'octets
                                            ;       à copier) dans celle pointée par D
                                            ; IN  : X=SOURCE
                                            ;       D=CIBLE
                                            ; OUT : A,B,X modified
        com strPARSE_PTR_LINE_NEXT          ; Pré initialise à une valeur différente 0 (sinon la routine CHEAD ne fonctionne pas)

setBeginPrg:
        ldx #beginPrg
        stx TXTAB                           ; début du programme basic

initPTRBASIC:
        jsr doRomNEW                        ; FCT : Effectue l'action de la commande BASIC NEW
                                            ; IN  : /
                                            ; OUT : X=TXTAB+2=début du programme + 2

clearSCREEN:
        jsr OS_InitGraphAndKbd              ; FCT : Mode text 32x16, efface l'écran, autorepeat non autorisé,
                                            ;       Initialise le pointeur sur les tableaux de conversions ASCII du clavier
                                            ;       Initialise les couleurs du fond et d'encre de l'écran
                                            ; IN  : /
                                            ; OUT : A,B,X modified

printBAN:
        ldx #aMicrocolorBasic               ; "MICROCOLOR BASIC 3.48",$D,"(C) 1982-2023 MICRO$OFT",$D
        ldab 0,x
        inx
        jsr bclOUTTX

initWARM:
        ldaa #cOS_WARN
        staa fCOLDWARN

jmpINTERPRET:
        jmp INTERPRETATION                  ; FCT : INTERPRETATION
                                            ; IN  : /
                                            ; OUT : /
; End of function OS_initializeMEMORY
; End of function vectRESET

; =============== S U B R O U T I N E =======================================
; FCT : Copie la zone mémoire pointée par X
;       (le premier octet contient le nombre d'octets
;       à copier) dans celle pointée par D
; IN  : X=SOURCE
;       D=CIBLE
; OUT : A,B,X modified

OS_copyMEM:
        std PTRTMP2
        ldab 0,x                            ; récupération de la longueur de la copie à effectuer

bclOS_CopyMEM:
        inx

next1OS_CopyMEM:
        ldaa 0,x                            ; Recopie une zone mémoire de la zone X dans la zone pointée par PTRTMP2
                                            ; X=pointeur sur la zone de départ
                                            ; B=longueur à copier
        stx LOWTR
        ldx PTRTMP2
        staa 0,x
        inx
        stx PTRTMP2
        ldx LOWTR
        decb
        bne bclOS_CopyMEM
        rts
; End of function OS_copyMEM


; =============== S U B R O U T I N E =======================================
; FCT : point d'entrée par défaut du redémarrage à froid

OS_entryCOLD:
        nop
; End of function OS_entryCOLD


; =============== S U B R O U T I N E =======================================
; FCT : effectue le travail :
;       1 - intialisation divers pointeurs
;       2 - effacement de l'écran
;       3 - entre dans la boucle d'interprétation BASIC
; STX : /
; ALG : /
; OP  : /
; ST  : ACTIF
; IN  : /
; OUT : /

OS_initCOLD:
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        jsr reInitPointeur                  ; FCT : Initialisation de certains pointeurs, pile et données BASIC
                                            ; IN  : /
                                            ; OUT : S=Initialisé à sa position de départ
                                            ;       A=0
                                            ;       OLDTXT=0, SUBFLG=0,DEVCUR=0 (SCREEN),TMPPT=$3241
                                            ;       Le retour de l'appelant se fait par popx + jmp x
                                            ;       suite à l'initialisation de la pile (S)
        jsr initScreen
        bra jmpINTERPRET                    ; TODO : Et pourquoi pas directement jmp INTERPRETATION ?
; End of function OS_initCOLD

;----------------
lgRoutineOS_GetChar:   dc.b (endOS_GetChar-OS_getChar)  ; $E

; =============== S U B R O U T I N E =======================================
; FCT : définition du code assemnbleur qui sera stocké en mémoire et qui
;       sert à récupérer un caractère dans le flot d'interprétation
OS_getChar:
        inc TXTPTR+1
        bne nextOS_GetChar
        inc TXTPTR
nextOS_GetChar:
        ldaa.w DDR1
        jmp subGetNextChar                  ; FCT : Test du type de caractère
                                            ; IN  : A=caractère à tester
                                            ; OUT : ET CARRY IF NUMERIC - RETURN WITH
                                            ;       ZERO FLAG SET IF A = 0 OR $3A(:) - END
                                            ;       OF BASIC LINE OR SUB LINE
                                            ; End of function getChar
endOS_GetChar:
; End of function OS_GetChar

; =============== S U B R O U T I N E =======================================
; FCT : Test du type de caractère
; IN  : A=caractère à tester
; OUT : ET CARRY IF NUMERIC - RETURN WITH
;       ZERO FLAG SET IF A = 0 OR $3A(:) - END
;       OF BASIC LINE OR SUB LINE

subGetNextChar:
        cmpa #cBAS_SEP                      ; ':'
        bcc endSubGetNextChar
        cmpa #cOS_SPACE                     ; ' '
        bne returnNUM
        jmp CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
returnNUM:
        suba #$30 ; '0'
        suba #$D0
endSubGetNextChar:
        rts
; End of function subGetNextChar

; ---------------------------------------------------------------------------
; DEBUT ZONE DE VALEURS D'INITIALISATION DE LA RAM $3024 à $3054
; ---------------------------------------------------------------------------

lgTabInitVectorAndMem:    dc.b $31 ; TODO - ( fin_TabInitVectorAndMem-debut_TabInitVectorAndMem);$31
debut_TabInitVectorAndMem:
tabInitVector:
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
; ---------------------------------------------------------------------------
        rti
        dc.b     0
        dc.b     0
;----------------

vect_USR_defaut:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; ---------------------------------------------------------------------------
VAL_ENTROPY_RND:    dc.b $4F,$C7,$52,$59    ; Valeur utilisée pour initialiser la séquence de génération de nombre pseudo aléatoire
;----------------
; Valeur d'initialisation par défaut de certaines zones mémoires
; situées entre $3XXX et $3YYYY
;----------------
VAL_DEFAULT_DIVERS:
        dc.b $FF                                  ; valeur par défaut KEYB_INVVIDEO
        dc.w $045E                                ; valeur pour une tempo ? TODO : CELA SERT-IL ?
        dc.w printErrorMSG_0x08_FC_FctIncorrect   ; valeur par défaut pour pEXEC
        dc.w OS_entryCOLD                         ; valeur par défaut pour pCOLD
        dc.w $0081                                ; valeur par défaut pour BAUDRATE_PRT
        dc.w $0001                                ; valeur par défaut pour TEMPO_PRT
        dc.b $10                                  ; valeur par défaut pour MARGIN_PRT
        dc.b $70                                  ; valeur par défaut pour ACTIVE_PRT
        dc.b $84                                  ; valeur par défaut pour XMAX_PRT
        dc.b $00                                  ; valeur par défaut pour CURX_PRT
        dc.b $01                                  ; valeur par défaut pour CURWAITCLIGNOTEMENT
        dc.b $18                                  ; valeur par défaut pour K7
        dc.b $1A                                  ; valeur par défaut pour K7
        dc.b $0B                                  ; valeur par défaut pour K7
        dc.w $0080                                ; valeur par défaut pour K7 (pour synchronisation)
fin_TabInitVectorAndMem:
; ---------------------------------------------------------------------------
; TODO : FIN ZONE DE VALEURS D'INITIALISATION DE LA RAM $30XX à $30YY
; ---------------------------------------------------------------------------

;----------------
aMicrocolorBasic:   dc.b 47,"MICROCOLOR BASIC 3.48",$D,"(C) 1982-2023 MICRO$OFT",$D,0

MEM_FREE: ;
;xxOS_FREE_MEM ds 5219+24-6-169-2-13-1+1+2+5+2-22+3-9-1-30-4+8-41-19-1-4-(22+6+10)-(54)-(30+7-10)-(22-3)-(73)-1-2-2+3-1+1-74-1+3-3+6-1-2-4-2-4+1-2-2+3+3-11+1-(43+1+1+13+20)+11-14-1-22-20-(19)-(26+4+7)-(22)-(1-2)-4+3+(12+9+38)+(12-4-1)-6-24-(83)-(39+23+2-2+13+6-3-1+12+2+3-5)-518+430-215; =3999
;xxOS_FREE_MEM ds 3999+5-1-2+182+4+8+2-3+1-3-30-25-24-9-3-2+9-29+2-10+2-6+1-5+3+1-1+1+5-2-39-2-2+1-2-3-3-6-4-2-2-1+4-2-7+46-1-64-9-5-2-3+5+1-47-2-8-2+1+1+2+5+2-11-1-12-28-2-30-4-11+4-9-23+5-2+2+2
;xxOS_FREE_MEM ds 3800-2-33-15-1-2-7-9+5-16-10-13-4-12-9-1-3-9-41+30-1+18-(269+114+30+24-4+10-15+1-3+5+5)+9-15-20-20-19-4-4-1+4-2-6-5-3-1-2-21-20-6+4-1+1-7-4-2-20+1-2-3-1-2+2-75-6-42-8-2-1-4-3-2
;xxOS_FREE_MEM ds 2916-2-2-9-5+9-13-21-2-2-2-1+1+2-2-2-3-4+6-4-6-5+29-15-1-2-7-15+1-19-15-3-4+2-19-23-4-3-1-1-13
xxOS_FREE_MEM ds 2736-1+13-6-8-2+2-17-17-17-4-8+23+23-6-16-9-4-22-3-6-1-1-12-9-11-8-30-2-18-2+4+4-2-4-86

; ===========================================================================
; /// EDITION
; ===========================================================================
xxEDITOR:

; =============== S U B R O U T I N E ======================================

j_setError0x02_SYNTAXERROR:
        jmp setError0x02_SYNTAXERROR
; End of function j_setError0x02_SYNTAXERROR


; =============== S U B R O U T I N E =======================================
; FCT : commande basic EDIT pour editer une ligne donnée
; STX : EDIT n
; OP  : $AA
; ST  : ACTIF
; IN  : /
; OUT : /

romEDIT:
        clr strPARSE_POS
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        jsr LINGET                          ; FCT : Obtient un numéro de ligne dans le flux d'entrée
                                            ; IN  : le flot à interpréter via CHRGET
                                            ;       A=contient le premier chiffre à convertir
                                            ; OUT : LINUM = numéro de ligne obtenu en première position
                                            ;       dans le flot à interpréter
        jsr FNDLIN                          ; FCT : FNDLIN SEARCHES THE PROGRAM TEXT FOR THE LINE
                                            ;       WHOSE NUMBER IS PASSED IN "LINUM".
                                            ;       THERE ARE TWO POSSIBLE RETURNS:
                                            ;
                                            ;       1) CARRY SET.
                                            ;          LOWTR POINTS TO THE LINK FIELD IN THE LINE
                                            ;          WHICH IS THE ONE SEARCHED FOR.
                                            ;
                                            ;       2) CARRY NOT SET.
                                            ;          LINE NOT FOUND. [LOWTR] POINTS TO THE LINE IN THE
                                            ;          PROGRAM GREATER THAN THE ONE SOUGHT AFTER.
                                            ; IN  : /
                                            ; OUT : C=1 : Ligne trouvée
                                            ;       X=Position en mémoire de la ligne trouvée
        pshx
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        bne j_setError0x02_SYNTAXERROR
        pulx
        clr strPARSE_POS                    ; Pourquoi une deuxième fois ?
        ldaa #cOS_DEV_BUFFER
        staa DEVNU                          ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        ldd 0,x
        beq j_setError0x02_SYNTAXERROR
        ldd 2,x
        subd LINUM
        bhi j_setError0x02_SYNTAXERROR      ; dépassement de capacité ?
        ldd 2,x
        pshx                                ; Sauvegarde du numéro de ligne
        jsr ULIPTR                          ; FCT : Imprime le nombre non signé contenu dans D
                                            ; IN  : D : le nombre non signé à afficher
                                            ; OPT : oui. A été réécrit pour être plus rapide
                                            ; IN  : D : 0 à 65536 ( entier non relatif )
                                            ; OUT : A,B,X modified
                                            ;       ACC1 détruit
        pulx                                ; Récupération du numéro de ligne
        inx                                 ; 3
        inx                                 ; 3
        inx                                 ; 3
        inx                                 ; 3 = 12 cycles
        stx INDEX                           ; X pointe sur la première instruction à afficher
        clr fEDITLINE_SEP                   ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM

printSPACE:
        ldaa #cOS_SPACE                     ; ' '
        bra bcl1DoEDITLINE

bclDoEDITLINE_PRINT_PT_EXCL:
        ldaa #cEDT_UNKNOWN                  ; '!'  ; Affiche un ! dans le cas d'un opcode > $C8 : TODO : changer le nombe $C8

bcl1DoEDITLINE:
        ldx INDEX
        anda #$7F

bcl2DoEDITLINE:
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif séxlectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        ldaa 0,x
        inx
        tsta
        beq ED_EditLine                     ; FCT : début de la partie édition en mode ligne
                                            ; IN  : strPARSE_BUFFER contient un texte à éditer
                                            ; OUT : En fin d'édition retourne à l'Interprèteur
                                            ;       Si touche BREAK activée alors on ne  fait rien
                                            ;          et entre dans la boucle principale d'interprétation du BASIC
                                            ;       Sinon entre dans la boucle secondaire d'interprétation du BASIC
        ldab fEDITLINE_SEP                  ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM

isDoubleGuillemet:
        cmpa #cBAS_SEP_STR                  ; '"'
        bne next3DoEDITLINE
        eorb #$01
        stab fEDITLINE_SEP                  ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM

next3DoEDITLINE:
        cmpa #cBAS_SEP ; ':'
        bne next4DoEDITLINE
        bitb #$01
        bne next4DoEDITLINE
        andb #$FD
        stab fEDITLINE_SEP                  ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM

next4DoEDITLINE:
        tsta
        bpl bcl2DoEDITLINE
        tstb
        bne bcl2DoEDITLINE
        cmpa #cBAS_TOKEN_DATA               ; $85 : Opcode DATA
        bne next5DoEDITLINE
        orab #$02

next5DoEDITLINE:
        cmpa #cBAS_TOKEN_REM                ; $83 : Opcode REM
        bne next6DoEDITLINE
        orab #$04

next6DoEDITLINE:
        stab fEDITLINE_SEP                  ; en mode édition ligne ou LIST, l'opcode lu est un ", un :, un DATA, un REM
        cmpa #cBAS_TOKEN_ALL_MAX            ; TODO $E6 : numéro max des opcodes BASIC
        bhi bclDoEDITLINE_PRINT_PT_EXCL
        jsr BAS_searchTextBASIC             ; FCT : Recherche la position du nom de la commande
                                            ;       BASIC associée au code BASIC.
                                            ; IN  : A=code de la fonction BASIC A>= $80
                                            ;       X=position dans le source BASIC
                                            ; OUT : X=position en rom du texte du code BASIC recherché

bcl7DoEDITLINE:
        ldaa 0,x
        bmi bcl1DoEDITLINE
        inx
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        bra bcl7DoEDITLINE
; End of function romEDIT

; =============== S U B R O U T I N E =======================================
; FCT : début de la partie édition en mode ligne
; IN  : strPARSE_BUFFER contient un texte à éditer
; OUT : En fin d'édition retourne à l'Interprèteur
;       Si touche BREAK activée alors on ne fait rien
;          et entre dans la boucle principale d'interprétation du BASIC
;       Sinon entre dans la boucle secondaire d'interprétation du BASIC

ED_EditLine:
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante

AddCR:
        ldx #strPARSE_BUFFER                ; strPARSE_BUFFER contient la ligne à éditer
        ldab strPARSE_POS
        abx
        ldaa #cOS_CR
        staa 0,x
        clrb

entryEditLine:
        ldx #strPARSE_BUFFER

echoLine:
        jsr ED_echoLine                     ; FCT : Imprime à l'écran une ligne terminée par CR pointée par X
                                            ;       Le curseur d'édition est à la première position du texte édité
                                            ; IN  : X=Le tampon à afficher
                                            ;       B=le début du tampon à afficher
                                            ; OUT : A,B,X modified
                                            ; RMQ : La gestion du curseur est calamiteuse :
                                            ;       pourquoi réimprimer les caractères déjà affichés
                                            ;       au début de la procédure pour imprimer le curseur
                                            ;       en début de ligne ou du fait d'une ligne BASIC multiligne ?
                                            ;       ===> TODO : une nouvelle optimisation en vue

waitCmdUserAndDoIt:
        jsr ED_Manage                       ; FCT : gére le mode édition ligne d'une ligne basic
                                            ; IN  : /
                                            ; OUT : C=0:no hit key 'BREAK'
                                            ;       C=1:hit key 'BREAK'
        bcs doBREAK
        ldx #$00FF
        stx CURLIN
        jsr ED_finalyzestrPARSE_BUFFER      ; FCT : Permet de reinitialiser diverses variables liées
                                            ;       au tampon clavier lors de l'édition en mode ligne
                                            ;       Ajoute un 0 en fin de tampon de saisie
                                            ;       Effectue un CR à l'écran
                                            ; IN  : /
                                            ; OUT : X=pointeur sur la zone tampon de saisie
                                            ;       A,B modidied

callInterpret:
        stx TXTPTR
        jmp INTERPRET

doBREAK:
        jsr OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        jmp MAIN
; End of function ED_EditLine

; =============== S U B R O U T I N E =======================================
; FCT : gére le  mode édition ligne d'une ligne basic
; IN  : /
; OUT : C=0:no hit key 'BREAK'
;       C=1:hit key 'BREAK'

ED_Manage:
        clr fFLASHCAR                       ; détermine si c'est le caractère en dessous du curseur qui doit être "flashé" (clignotement)
        clr fFLASHCUR                       ; détermine si c'est le curseur qui doit être "flashé" (clignotement)

bclEditLine:
        jsr OS_getKEY                       ; FCT : Attend une saisie utilisateur
                                            ;       gére le clignotement du curseur
                                            ; IN  : /
                                            ; OUT : A=la touche actionnée
isBREAK:
        cmpa #cKB_BREAK
        beq manageBREAK
isRIGHT:
        cmpa #cKB_RIGHT
        beq manageARROWRIGHT
isLEFT:
        cmpa #cKB_LEFT
        beq manageCTRLQ_BS                  ; FCT : DEL
isDOWN:
        cmpa #cKB_DOWN
        beq manageCTRLW_SUPPR
isCTRLESPACE:
        cmpa #cKB_CTRL_ESPACE
        beq manageCTRLSPACE_AUTOREPEAT_OFF
isSHIFTESPACE
        cmpa #cKB_SHIFT_ESPACE
        beq manageSHIFTSPACE_AUTOREPEAT_ON
isENTER:
        cmpa #cKB_ENTER
        beq manageENTER
        tsta
        bpl ED_manage_next
        tst CTRLKBD                         ; =$00 : hit normal keyb or hit shift, $FF = hit CTRL,
        beq ED_manage_next
        jsr BAS_searchTextBASIC             ; FCT : Recherche la position du nom de la commande
                                            ;       BASIC associée au code BASIC.
                                            ; IN  : A=code de la fonction BASIC A>= $80
                                            ;       X=position dans le source BASIC
                                            ; OUT : X=position en rom du texte du code BASIC recherché
        bsr ED_insTextInEditLine            ; FCT : Affiche une chaîne à la position du curseur dans le tampon de ligne
                                            ; IN  : X=position du texte à ajouter au tampon d'édition de ligne
                                            ;       B=Nombre de caractères déjà insérés dans le tampon d'édition
                                            ; OUT : X=nouvelle position dans le tampon de ligne
        bra bclEditLine

manageCTRLSPACE_AUTOREPEAT_OFF:
        clr fAUTOREPEATKBD                  ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        bra bclEditLine

manageSHIFTSPACE_AUTOREPEAT_ON:
        ldaa #$FF
        staa fAUTOREPEATKBD                 ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        bra bclEditLine

ED_manage_next:
        cmpa #cKB_ESPACE                    ; $20 ; ' '
        bcs bclEditLine
        bsr ED_insCharIntoBuffer            ; FCT : Insére le caractère A dans le tampon d'édition
                                            ; IN  : B=Nombre de caractères déjà insérés dans le tampon d'édition
                                            ;       A=caractère à insérer
                                            ; OUT : A,B,X modified
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        bra bclEditLine

manageENTER:
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        bne manageENTER                     ; boucle tant qu'on n'a pas rencont‚ le Carriage Return
        clr fAUTOREPEATKBD                  ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        clc
        rts

manageBREAK:
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        bne manageBREAK
        sec
        rts

manageARROWRIGHT:
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        bra bclEditLine

manageCTRLQ_BS:
        bsr ED_EchoChWithCursAndDecPosCur   ; FCT : DEL
        bra bclEditLine

manageCTRLW_SUPPR:
        bsr ED_SUPPR_EDITLINE               ; FCT : Permet de supprimer le caractère en dessous du curseur d'édition du curseur
                                            ; IN  : B=Nombre de caractères déjà saisis dans le tampon
                                            ;       X=Pointeur du texte à éditeur à la position du curseur à l'écran
                                            ; OUT : X unmodified
                                            ;       B unmodified
        bra bclEditLine
; End of function ED_Manage


; =============== S U B R O U T I N E =======================================
; FCT : Affiche une chaîne à la position du curseur dans le tampon de ligne
; IN  : X=position du texte à ajouter au tampon d'édition de ligne
;       B=Nombre de caractères déjà insérés dans le tampon d'édition
; OUT : X=nouvelle position dans le tampon de ligne

ED_insTextInEditLine:
        ldaa 0,x
        inx
        pshx
        psha
        anda #$7F
        ldx INDEX
        bsr ED_insCharIntoBuffer            ; FCT : Insére le caractère A dans le tampon d'édition
                                            ; IN  : B=Nombre de caractères déjà insérés dans le tampon d'édition
                                            ;       A=caractère à insérer
                                            ; OUT : A,B,X modified
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        stx INDEX
        pula
        pulx
        tsta
        bpl ED_insTextInEditLine            ; FCT : Affiche une chaîne à la position du curseur dans le tampon de ligne
                                            ; IN  : X=position du texte à ajouter au tampon d'édition de ligne
                                            ;       B=Nombre de caractères déjà insérés dans le tampon d'édition
                                            ; OUT : X=nouvelle position dans le tampon de ligne
        ldx INDEX
endED_insTextInEditLine:
        rts
; End of function ED_insTextInEditLine

; =============== S U B R O U T I N E =======================================
; FCT : Insére le caractère A dans le tampon d'édition
; IN  : B=Nombre de caractères déjà insérés dans le tampon d'édition
;       A=caractère à insérer
; OUT : A,B,X modified

ED_insCharIntoBuffer:
        cmpb #$7F
        beq endED_insTextInEditLine ; beq endED_insChar
        psha
        pshb
        ldx #strPARSE_BUFFER
        inc strPARSE_POS
        bpl nextED_insChar
        dec strPARSE_POS
        dex
        incb

nextED_insChar:
        tba
        suba strPARSE_POS
        nega
        ldab strPARSE_POS
        abx
        tsta
        beq next2ED_insChar

bcl1ED_insChar:
        dex
        ldab 0,x
        stab 1,x
        deca
        bne bcl1ED_insChar

next2ED_insChar:
        pulb
        pula
        staa 0,x
        jmp ED_echoLine                     ; FCT : Imprime à l'écran une ligne terminée par CR pointée par X
                                            ;       Le curseur d'édition est à la première position du texte édité
                                            ; IN  : X=Le tampon à afficher
                                            ;       B=le début du tampon à afficher
                                            ; OUT : A,B,X modified
                                            ; RMQ : La gestion du curseur est calamiteuse :
                                            ;       pourquoi réimprimer les caractères déjà affichés
                                            ;       au début de la procédure pour imprimer le curseur
                                            ;       en début de ligne ou du fait d'une ligne BASIC multiligne ?
                                            ;       ===> TODO : une nouvelle optimisation en vue

; End of function ED_insCharIntoBuffer

; =============== S U B R O U T I N E =======================================
; FCT : affiche sur le device courant un caractère
;       pointée par X et ne fait rien quand rencontre $0D
; IN  : X=pointeur sur le caractère à afficher
;       B=position du caractère à afficher dans le tampon pointé par X
; OUT : Si A = $0D  : A=0x0D, B et X non modifié
;       Si A <> $0D : A=quelconque B=B+1, X=X+1
;       B=B+1
;       X=X+1

ED_echoCharWithoutCursor:
        ldaa 0,x
        cmpa #cOS_CR
        beq endPprintCharAndInc_X_B
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        incb
        inx

endPprintCharAndInc_X_B:
        rts
; End of function ED_echoCharWithoutCursor


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère pointé par X puis
;       décremente de 1 la position du curseur à l'écran
;       décremente de 1 aussi le pointeur X et B
; IN  : B=Position du curseur dans le tampon de ligne
;       X=Position du tampon de ligne
; OUT : B=B-1
;       X=X-1

ED_EchoChWithCursAndDecPosCur:
        tstb
        beq endED_EchoChar_EDITLINE
        ldaa 0,x
        cmpa #cOS_CR
        bne ED_EchoChar_EDITLINE_next
        ldaa #cOS_SPACE                     ; ' '

ED_EchoChar_EDITLINE_next:
        jsr ED_PrintAndDecCur               ; FCT : Imprime le caractère A puis le curseur courant est décrementé d'une position
                                            ; IN  : A=Caractère à imprimer
                                            ; OUT : X unmodified
        decb
        dex

endED_EchoChar_EDITLINE:
        rts
; End of function ED_EchoChWithCursAndDecPosCur


; =============== S U B R O U T I N E =======================================
; FCT : Permet de supprimer le caractère en dessous du curseur d'édition du curseur
; IN  : B=Nombre de caractères déjà saisies dans le tampon
;       X=Pointeur du texte à éditeur à la position du curseur à l'écran
; OUT : X unmodified
;       B unmodified

ED_SUPPR_EDITLINE:
        cmpb strPARSE_POS
        beq endSUPPR_EDITLINE
        pshx
        dex

bclSUPPR_EDITLINE:
        inx
        ldaa 1,x
        staa 0,x
        cmpa #cOS_CR
        bne bclSUPPR_EDITLINE
        pulx
        dec strPARSE_POS
        jsr ED_echoLine                     ; FCT : Imprime à l'écran une ligne terminée par CR pointée par X
                                            ;       Le curseur d'édition est à la première position du texte édité
                                            ; IN  : X=Le tampon à afficher
                                            ;       B=le début du tampon à afficher
                                            ; OUT : A,B,X modified
                                            ; RMQ : La gestion du curseur est calamiteuse :
                                            ;       pourquoi réimprimer les caractères déjà affichés
                                            ;       au début de la procédure pour imprimer le curseur
                                            ;       en début de ligne ou du fait d'une ligne BASIC multiligne ?
                                            ;       ===> TODO : une nouvelle optimisation en vue

endSUPPR_EDITLINE:
        rts
; End of function ED_SUPPR_EDITLINE


; =============== S U B R O U T I N E =======================================
; FCT : Imprime à l'écran une ligne terminée par CR pointée par X
;       Le curseur d'édition est à la première position du texte édité
; IN  : X=Le tampon à afficher
;       B=le début du tampon à afficher
; OUT : A,B,X modified
; RMQ : La gestion du curseur est calamiteuse :
;       pourquoi réimprimer les caractères déjà affichés
;       au début de la procédure pour imprimer le curseur
;       en début de ligne ou du fait d'une ligne BASIC multiligne ?
;       ===> TODO : une nouvelle optimisation en vue

ED_echoLine:
        stx INDEX

bclED_echoLine:
        bsr ED_echoCharWithoutCursor        ; FCT : affiche sur le device courant un caractère
                                            ;       pointée par X et ne fait rien quand rencontre $0D
                                            ; IN  : X=pointeur sur le caractère à afficher
                                            ;       B=position du caractère à afficher dans le tampon pointé par X
                                            ; OUT : Si A = $0D  : A=0xD
                                            ;       Si A <> $0D : A=quelconque B=B+1, X=X+1
                                            ;       B=B+1
                                            ;       X=X+1
        bne bclED_echoLine

bcl1ED_echoLine:
        cpx INDEX
        beq endED_echoLine
        bsr ED_EchoChWithCursAndDecPosCur   ; FCT : Imprime le caractère pointé par X puis
                                            ;       décremente de 1 la position du curseur à l'écran
                                            ;       décremente de 1 aussi le pointeur X  et B
                                            ; IN  : B=Position du curseur dans le tampon de ligne
                                            ;       X=Position du tampon de ligne
                                            ; OUT : B=B-1
                                            ;       X=X-1
        bra bcl1ED_echoLine

endED_echoLine:
        rts
; End of function ED_echoLine

; =============== S U B R O U T I N E =======================================
; FCT : Permet de reinitialiser diverses variables liées
;       au tampon clavier lors de l'édition en mode ligne
;       Ajoute un 0 en fin de tampon de saisie
;       Effectue un CR à l'écran
; IN  : /
; OUT : X=pointeur sur la zone tampon de saisie
;       A,B modidied

ED_finalyzestrPARSE_BUFFER:
        clr CHARKBD
        ldx #strPARSE_BUFFER
        ldab strPARSE_POS
        abx
        ;clra                                ; TODO : euh cela sert à quelque chose ? tpa p==> a  et on fait clr a juste avant ?
        ;tpa
        ;psha
        jsr OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        clr 0,x
        ldx #(strPARSE_BUFFER-1)
        ;pula
        ;tap
        rts
; End of function ED_finalyzestrPARSE_BUFFER

; =============== S U B R O U T I N E =======================================
; FCT : Affiche le caractère A à la position X=CURAD(Y,X)
; IN  : A=CHAR TO PRINT
; OUT : A, B unmodified ; X modified

ED_printAtCURPOS:
        ldx CURAD_YX
        psha
        pshb
        jsr OS_PRINT                        ; FCT : Imprime le caractère A dans la mémoire vidéo
                                            ; IN  : A=CODE ASCII à imprimer ou couleur pixel
                                            ;       A=[32..127] et [128-255]
                                            ;       X=POS(Y,X)
                                            ; OUT : A, B, X modified
        pulb
        pula
        rts
; End of function ED_printAtCURPOS


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère A puis le curseur courant est décrementé d'une position
; IN  : A=Caractère à imprimer
; OUT : X unmodified

ED_PrintAndDecCur:
        pshx
        bsr ED_printAtCURPOS                ; FCT : Affiche le caractère A à la position X=CURAD(Y,X)
                                            ; IN  : A=CHAR TO PRINT
                                            ; OUT : A, B unmodified ; X modified
        jsr GR_decCursor                    ; FCT : décremente de 1 la position X,Y donnée par le registre X
                                            ; IN  : X=La position (X,Y)
                                            ; OUT : X=X-1 en position (X,Y)
                                            ;       A et B not modified
        stx CURAD_YX
        pulx
        rts
; End of function ED_PrintAndDecCur


; ===========================================================================
; /// I/O
; ===========================================================================
xxIO:

; ===========================================================================
; /// I/O - CLAVIER
; ===========================================================================
xxIO_KEYBOARD:

tabScanCode:        dc.w TABNOR
                dc.w TABCON
                dc.w TABSHF
                dc.w TABCON

;--------------------
; -- NORMAL : permet de générer les caractères ASCII
;--------------------
TABNOR:
 dc.b cKB_NULL     ,cKB_ARROBASE,cKB_Q      ,cKB_B      ,cKB_C      ,cKB_D      ,cKB_E      ,cKB_F
 dc.b cKB_G        ,cKB_H       ,cKB_I      ,cKB_J      ,cKB_K      ,cKB_L      ,cKB_DIVIDE ,cKB_N
 dc.b cKB_O        ,cKB_P       ,cKB_A      ,cKB_R      ,cKB_S      ,cKB_T      ,cKB_U      ,cKB_V
 dc.b cKB_Z        ,cKB_X       ,cKB_Y      ,cKB_W      ,cKB_NULL   ,cKB_NULL   ,cKB_NULL   ,cKB_ENTER
 dc.b cKB_ESPACE   ,cKB_0       ,cKB_1      ,cKB_2      ,cKB_3      ,cKB_4      ,cKB_5      ,cKB_6
 dc.b cKB_7        ,cKB_8       ,cKB_9      ,cKB_2POINT ,cKB_M      ,cKB_comma  ,cKB_minus  ,cKB_dot
 dc.b cKB_SEMICOLON,cKB_NULL    ,cKB_NULL   ,cKB_BREAK  ,cKB_LEFT   ,cKB_DOWN   ,cKB_RIGHT  ,cKB_UP

;--------------------
; -- CTRL : permet de générer soit les caractères de contrôle (CLRLINE, CLRSCREEN, BACKSPACE, etc.) soit les opcodes des commandes basic
;--------------------
TABCON:
 dc.b cKB_NULL       , cKB_CTRL_ARROBASE, cKB_CTRL_Q, cKB_CTRL_B     , cKB_CTRL_C, cKB_CTRL_D    , cKB_CTRL_E     , cKB_CTRL_F
 dc.b cKB_CTRL_G     , cKB_CTRL_H       , cKB_CTRL_I, cKB_CTRL_J     , cKB_CTRL_K, cKB_CTRL_L    , cKB_CTRL_DIVIDE, cKB_CTRL_N
 dc.b cKB_CTRL_O     , cKB_CTRL_P       , cKB_CTRL_A, cKB_CTRL_R     , cKB_CTRL_S, cKB_CTRL_T    , cKB_CTRL_U     , cKB_CTRL_V
 dc.b cKB_CTRL_Z     , cKB_CTRL_X       , cKB_CTRL_Y, cKB_CTRL_W     , cKB_NULL  , cKB_NULL      , cKB_NULL       , cKB_ENTER
 dc.b cKB_CTRL_ESPACE, cKB_CTRL_0       , cKB_CTRL_1, cKB_CTRL_2     , cKB_CTRL_3, cKB_CTRL_4    , cKB_CTRL_5     , cKB_CTRL_6
 dc.b cKB_CTRL_7     , cKB_CTRL_8       , cKB_CTRL_9, cKB_CTRL_2POINT, cKB_CTRL_M, cKB_CTRL_comma, cKB_CTRL_minus , cKB_CTRL_dot
 dc.b $B6            , cKB_NULL         , cKB_NULL  , cKB_BREAK      , cKB_LEFT  , cKB_DOWN      , cKB_RIGHT      , cKB_UP

;--------------------
; -- SHIFT : permet de générer les caractères semi-graphiques
;--------------------
TABSHF:
 dc.b cKB_NULL           , cKB_SHIFT_ARROBASE, cKB_SHIFT_Q, cKB_SHIFT_B     , cKB_SHIFT_C, cKB_SHIFT_D  , cKB_SHIFT_E     , cKB_SHIFT_F
 dc.b cKB_SHIFT_G        , cKB_SHIFT_H       , cKB_SHIFT_I, cKB_SHIFT_J     , cKB_SHIFT_K, cKB_SHIFT_L  , cKB_SHIFT_DIVIDE, cKB_SHIFT_N
 dc.b cKB_SHIFT_O        , cKB_SHIFT_P       , cKB_SHIFT_A, cKB_SHIFT_R     , cKB_SHIFT_S, cKB_SHIFT_T  , cKB_SHIFT_U     , cKB_SHIFT_V
 dc.b cKB_SHIFT_Z        , cKB_SHIFT_X       , cKB_SHIFT_Y, cKB_SHIFT_W     , cKB_NULL   , cKB_NULL     , cKB_NULL        , cKB_SHIFT_ENTER
 dc.b cKB_SHIFT_ESPACE   , cKB_SHIFT_0       , cKB_SHIFT_1, cKB_SHIFT_2     , cKB_SHIFT_3, cKB_SHIFT_4  , cKB_SHIFT_5     , cKB_SHIFT_6
 dc.b cKB_SHIFT_7        , cKB_SHIFT_8       , cKB_SHIFT_9, cKB_SHIFT_2POINT, cKB_SHIFT_M, cKB_SHIFT_inf, cKB_SHIFT_egal  , cKB_SHIFT_sup
 dc.b cKB_SHIFT_SEMICOLON, cKB_NULL          , cKB_NULL   , cKB_BREAK       , cKB_LEFT   , cKB_DOWN     , cKB_RIGHT       , cKB_UP

; =============== S U B R O U T I N E =======================================
; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR INKBD

jsrClearScreen:
        jsr GR_CLRSCR                   ; FCT : GR_CLRSCR : efface l'écran selon le mode donné par TECRAN
                                        ; IN  : /
                                        ; OUT : /
; END OF FUNCTION CHUNK FOR INKBD

; =============== S U B R O U T I N E =======================================
; FCT : Attend une saisie utilisateur
;       gére les touches spécifiques
;       BREAK  : sort du programme !
;       CTRL+A : effacement de la saisie en cours
;       CTRL+L : effacement de l'écran
;       CTRL+Q : effacement d'un caractère
;       RETURN : fin de la saisie utilisateur
; IN  : /
; OUT : X=pointeur sur la tampon clavier -1 contenant la saisie utilisateur
;       C=0 : saisie utilisateur
;       C=1 : saisie d'une touche de contrôle

INKBD:

bclINKBD:
        ldab #$01
        ldx #strPARSE_BUFFER

entryINKBD:
        clr CHARKBD
bcl1INKBD:
        jsr OS_getKeyWithoutHook            ; FCT : Attend qu'une touche soit pressée et l'affiche
                                            ;       gére le clignotement
                                            ;       Si espace alors imprime un espace
                                            ; HOOK: OUI
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche pressée
                                            ;       B, X unmodified
debugINKBD:
        tst DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        bne isCR_INKBD
        tsta
        bpl isCTRLL_INKBD
        tst CTRLKBD                         ; =$00 : hit normal keyb or hit shift, $FF = hit CTRL,
        beq isCTRLL_INKBD
        jsr BAS_searchTextBASIC             ; FCT : Recherche la position du nom de la commande
                                            ;       BASIC associée au code BASIC.
                                            ; IN  : A=code de la fonction BASIC A>= $80
                                            ;       X=position dans le source BASIC
                                            ; OUT : X=position en rom du texte du code BASIC recherché

bcl2INKBD:
        ldaa 0,x
        inx
        pshx
        psha
        anda #$7F
        ldx INDEX
        bsr INKBD_echoInput                 ; FCT : vérifie que nous n'avons pas dépassé la taille du tampon clavier ($80)
                                            ;       et stocke le caractère lu dans le tampon et l'imprime sur le device en cours
                                            ; IN  : B=position dans le tampon clavier
                                            ;       A=caractère lu du clavier (ASCII)
                                            ;       X=pointeur sur le tampon clavier
                                            ; OUT : B=B+1
                                            ;       X=X+1
        stx INDEX
        pula
        pulx
        tsta
        bpl bcl2INKBD
        ldx INDEX
        bra bcl1INKBD

isCTRLL_INKBD:
        cmpa #cKB_CTRL_L                    ; $0C : est-ce une demande d'effacement d'écran ?
        beq jsrClearScreen

isCTRLQ_INKBD:
        cmpa #cOS_BS                        ; $08 : est-ce Back SPACE ?
        bne isCTRLA_INKBD

doCTRLQ_INKBD:
        decb
        beq bclINKBD
        dex
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        bra bcl1INKBD

isCTRLA_INKBD:
        cmpa #cKB_CTRL_A                    ; $15 ; est-ce une demande de nettoyage complet de la saisie utilisateur ?
        bne isBRK_INKBD

doCTRLA_INKBD:
        decb
        beq bclINKBD
        ldaa #cOS_BS                        ; $08 : backspace
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        bra doCTRLA_INKBD

isBRK_INKBD:
        cmpa #cKB_BREAK
        bne isCR_INKBD
        sec
        clr AUTOINC
        clr AUTOINC+1
        clr strPARSE_POS
        bra next10INKBD
        ;sec
        ;beq next10INKBD
isCR_INKBD:
        cmpa #cOS_CR
        bne next11INKBD

doCR_INKBD:
        clra

next10INKBD:
        tpa
        psha
        jsr OS_printCR                      ; FCT : effectue un retour à la ligne
                                            ; IN  : /
                                            ; OUT : A modified
        clr 0,x
        ldx #strPARSE_BUFFER-1
        pula
        tap

endINKBD:
        rts

next11INKBD:
        cmpa #$20 ; ' '
        bcs bcl1INKBD
        bsr INKBD_echoInput                 ; FCT : vérifie que  nous n'avons pas dépassé la taille du tampon clavier ($80)
                                            ;       et stocke le caractère lu dans le tampon et l'imprime sur le device en cours
                                            ; IN  : B=position dans le tampon clavier
                                            ;       A=caractère lu du clavier (ASCII)
                                            ;       X=pointeur sur le tampon clavier
                                            ; OUT : B=B+1
                                            ;       X=X+1
        bra bcl1INKBD
; End of function INKBD


; =============== S U B R O U T I N E =======================================
; FCT : vérifie que nous n'avons pas dépassé la taille du tampon clavier ($80)
;       et stocke le caractère lu dans le tampon et l'imprime sur le device en cours
; IN  : B=position dans le tampon clavier
;       A=caractère lu du clavier (ASCII)
;       X=pointeur sur le tampon clavier
; OUT : B=B+1
;       X=X+1

INKBD_echoInput:
        cmpb #$80
        bcc endINKBD
        staa 0,x
        inx
        incb
        jmp OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
; End of function INKBD_echoInput

; =============== S U B R O U T I N E =======================================
; FCT : Gére le clignotement du curseur
; IN  : /
; OUT : A,B,X modified

manageCURCLIGNOTEMENT:
        dec CURWAITCLIGNOTEMENT
        bne OS_doTempo0x45E                 ; FCT : une tempo fixe de $45E x K microsecondes
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X modified
        ldaa COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        eora #$0F
        staa COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        oraa #$80
        psha
        jsr OS_printCHARAtCurrentPos        ; FCT : Imprime le caractère A
                                            ; IN  : A=char to print
                                            ; OUT : A unmodified
        pula
        ldab #$16
        anda #$0F
        beq nextManageCURCLIGNOTEMENT
        ldab #$58

nextManageCURCLIGNOTEMENT:
        stab CURWAITCLIGNOTEMENT

; =============== S U B R O U T I N E =======================================
; FCT : une tempo fixe de $45E x K microsecondes
; ST  : ACTIF
; IN  : /
; OUT : X modified

OS_doTempo0x45E:
        ldx #$045E
bclTempo:
        dex
        bne bclTempo
        rts
; End of function OS_doTempo0x45E
; End of function manageCURCLIGNOTEMENT


; =============== S U B R O U T I N E =======================================
; FCT : Attend qu'une touche soit pressée et l'affiche
;       gére le clignotement
;       Si espace alors imprime un espace : TODO 02/07/2021 ?
; HOOK: OUI
; IN  : /
; OUT : A=code ascii de la touche pressée
;       B, X unmodified

OS_getKeyWithoutHook:

OS_getKey:
        pshx
        pshb

waitGetKEY_OS:
        bsr manageCURCLIGNOTEMENT           ; FCT : Gére le clignotement du curseur
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        bsr OS_POLCA                        ; FCT : polling keyboard
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche actionnée
                                            ;       X,B not modified
        beq waitGetKEY_OS
        psha
        ldaa #cOS_SPACE
        ldx CURAD_YX
        jsr OS_PRINT
        pula
        pulb
        pulx
        rts
; End of function OS_getKeyWithoutHook

; =============== S U B R O U T I N E =======================================
; FCT : gére le clignotement du curseur
; IN  : /
; OUT : A,B,X unmodified

OS_manageCURSOR:
        pshx
        dec CURWAITCLIGNOTEMENT
        bne endManageCURSORT_TEMPO
        psha
        ldaa 0,x
        cmpa #cOS_CR
        bne nextManageCURSOR
        ldaa #cOS_SPACE

nextManageCURSOR:
        com fFLASHCAR
        beq next1ManageCURSOR
        ldaa #$80
        com fFLASHCUR
        beq next1ManageCURSOR
        ldaa COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        oraa #$8F

next1ManageCURSOR:
        jsr ED_printAtCURPOS                ; FCT : Affiche le caractère A à la position X=CURAD(Y,X)
                                            ; IN  : A=CHAR TO PRINT
                                            ; OUT : A, B unmodified ; X modified
        ldaa #$5B ; '['
        staa CURWAITCLIGNOTEMENT
        pula
        pulx
        rts

endManageCURSORT_TEMPO:
        ldx #$0100

bclEndManageCURSORT_TEMPO:
        dex
        bne bclEndManageCURSORT_TEMPO
        pulx
        rts
; End of function OS_manageCURSOR

; =============== S U B R O U T I N E =======================================
; FCT : Attend une saisie utilisateur
;       gére le clignotement du curseur
; IN  : /
; OUT : A=la touche actionnée

OS_getKEY:
        jsr OS_manageCURSOR                 ; FCT : gére le clignotement du curseur
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        jsr OS_POLCA                        ; FCT : polling keyboard
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche actionnée
                                            ;       X,B not modified
        beq OS_getKEY                       ; FCT : Attend une saisie utilisateur
                                            ;       gére le clignotement du curseur
                                            ; IN  : /
                                            ; OUT : A=la touche actionnée
        rts
; End of function OS_getKEY


; =============== S U B R O U T I N E =======================================
; FCT : détermine si on a appuyé sur les touches de contrôles
;       et une autre touche
; IN  : /
; OUT : A=0 : CTRL is pressed
;       A<>0 : other key pressed

getKeyPressed:
        clra
        bsr isKeyPressedCTRL                ; FCT : Est-ce que la touche CTRL est actionnée ?
                                            ; IN  : /
                                            ; OUT : A=$00 : non A=$FF : oui
        bne OS_POLCA                        ; FCT : polling keyboard
                                            ; IN  : /
                                            ; OUT : A=code ascii de la touche actionnée
                                            ;       X,B not modified
        bsr isKeypressed_getColKBD          ; FCT : Est-ce qu'une touche normal (hors shift/ctrl) est actionnée ?
                                            ; IN  : B=rangée du clavier à activer
                                            ; OUT : A=Colonne activée quand une touche est pressée
        inca
        beq endPOLCA
; End of function getKeyPressed



; =============== S U B R O U T I N E =======================================
; FCT : polling keyboard
; IN  : /
; OUT : A=code ascii de la touche actionnée
;       X,B not modified

OS_POLCA:
        pshx
        pshb
        jsr initKBD                         ; FCT : initialise l'autorepeat et le tampon de
                                            ;       caractère à $FF
                                            ; IN  : /
                                            ; OUT : A modified
        bsr KBD_polling                     ; FCT : scanne le clavier à la recherche de touche actionnée
                                            ;       Un mécanisme d'anti rebond est programmé
                                            ; IN  : /
                                            ; OUT : A=0 : aucune touche actionnée
                                            ;       A<>0 : la derniere touche détectée
                                            ;       B= : touche CTRL ou SHIFT actionnée
        tsta
        beq nextPOLCA
        jsr KBD_CONV_MATRIX_TO_ASCII        ; FCT : Permet de donner le code équivalent ASCII (ou pas) de la touche actionnée
                                            ;       à partir d'un des tableaux de conversion choisi par le registre B
                                            ; IN  : B=0: TOUCHE
                                            ;       B=1: CTRL+TOUCHE
                                            ;       B=2: SHIFT+TOUCHE
                                            ;       B=3: CTRL+TOUCHE
                                            ; OUT : Le code fonction du tableau de conversion

nextPOLCA:
        tsta
        pulb
        pulx

endPOLCA:
        rts
; End of function OS_POLCA


; =============== S U B R O U T I N E =======================================
; FCT : scanne le clavier à la recherche de touche actionnée
;       Un mécanisme d'anti rebond est programmé
; IN  : /
; OUT : A=0  : aucune touche actionnée
;       A<>0 : la derniere touche détectée
;       B=   : touche CTRL ou SHIFT actionnée

KBD_polling:
initKBD_polling:
        ldx #(ROLTB-1)
        clrb
        decb
        stab $09,x                          ; initialise NUMRGKBD à $FF

bclPollingKEYB:
        rolb
        bcc end1PollingKEYB
        inc NUMRGKBD                        ; numéro de ligne en cas de scanning : 0->7
        bsr isKeypressed_setColKBD          ; FCT : obtient la colonne du clavier lors d'une frappe
                                            ;       pour une colonne/rangée du clavier donnée
                                            ; IN  : B=numéro de  rangée du clavier activée
                                            ; OUT : A=colonne activée quand une touche est pressée
        pshb
        tab
        inx                                 ; obtient l'adresse de la prochaine zone de stockage du caractère
        eora $00,x                          ; A=A XOR FF
                                            ; A=A AND FF
                                            ; MEM(X) = COL
                                            ; 0000 0001 XOR 1111 1111 = 1111 1110
                                            ; 1111 1110 AND 1111 1111 = 1111 1110
        anda $00,x
        stab $00,x
        pulb
        tsta
        sec
        beq bclPollingKEYB
        psha

antiRebondPollingKEYB:
        bsr KBD_TEMPO_0X45E                 ; FCT : Effectue une tempo de $45E x X secondes
                                            ; IN  : /
                                            ; OUT : /
        bsr isKeypressed_getColKBD          ; FCT : Est-ce qu'une touche normal (hors shift/ctrl) est actionnée ?
                                            ; IN  : B=rangée du clavier à activer
                                            ; OUT : A=Colonne activée quand une touche est pressée
        cmpa $00,x
        pula
        bne end1PollingKEYB
        ldab #$F8

bcl1PollingKEYB:
        addb #$08
        lsra
        bcc bcl1PollingKEYB
        addb NUMRGKBD                       ; numéro de ligne en cas de scanning : 0->7
        incb
        pshb
        clrb

isCTRLSHIFTPressed:
        ldaa #$FE
        bsr isKeyPressedCTRL                ; FCT : Est-ce que la touche CTRL est actionnée ?
                                            ; IN  : /
                                            ; OUT : A=$00 : non A=$FF : oui
        beq nextPollingKEYB
        incb

nextPollingKEYB:
        bsr isKeyPressedSHIFT               ; FCT : Est-ce que la touche SHIFT est actionnée ?
                                            ; IN  : /
                                            ; OUT : A=$00 : non A=$FF : oui

        beq endPollingKEYB
        incb
        incb

endPollingKEYB:
        pula
        rts

end1PollingKEYB:
        clra
        rts
; End of function KBD_polling


; =============== S U B R O U T I N E =======================================
; FCT : Est-ce que la touche SHIFT est actionnée ?
; IN  : /
; OUT : A=$00 : non A=$FF : oui

isKeyPressedSHIFT:
        ldaa #$7F
; End of function isKeyPressedSHIFT


; =============== S U B R O U T I N E =======================================
; FCT : Est-ce que la touche CTRL est actionnée ?
; IN  : A=??
; OUT : A=$00 : non A=$FF : oui

isKeyPressedCTRL:
        staa.w PORT1
        ldaa.w PORT2                        ; Port I/O soit pour RS232 soit pour K7
        coma
        anda #$02
        beq endIsKeyPressedCTRL
        ldaa #$FF                           ; Pourquoi pas coma ?

endIsKeyPressedCTRL:
        rts
; End of function isKeyPressedCTRL


; =============== S U B R O U T I N E =======================================
; FCT : obtient la colonne du clavier lors d'une frappe
;       pour une colonne/rangée du clavier donnée
; IN  : B=numéro de rangée du clavier activée
; OUT : A=colonne activée quand une touche est pressée

isKeypressed_setColKBD:
        stab.w PORT1
; End of function isKeypressed_setColKBD


; =============== S U B R O U T I N E =======================================
; FCT : Est-ce qu'une touche normal (hors shift/ctrl) est actionnée ?
; IN  : B=rangée du clavier à activer
; OUT : A=Colonne activée quand une touche est pressée

isKeypressed_getColKBD:
        ldaa IO_COL_KBD                     ; pour une rangée activée du clavier, indique par un 0 la touche du clavier activée
                                            ; est utilisé aussi pour le son !
        oraa #$C0                           ; $C0:1100 0000
        pshb
        comb                                ; $7C : 0111 1100
                                            ; B=$7F : 0111 1111 : 1000 0000
                                            ; B=$FE : 1111 1110 : 0000 0001
        bitb #$7C
        beq endISKeyPressed_getColKBD
        ldab.w PORT2                        ; ldab PORT2 ; TODO Bien mysterieux
        bitb #$02
        bne endISKeyPressed_getColKBD
        adda #$40

endISKeyPressed_getColKBD:
        pulb
        rts
; End of function isKeypressed_getColKBD


; =============== S U B R O U T I N E =======================================
; FCT : initialise l'autorepeat et le tampon de
;       caractère à $FF
; IN  : /
; OUT : A modified

initKBD:
        tst fAUTOREPEATKBD                  ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        beq endManageAUTOREPEAT
        ldaa fAUTOREPEATKBD                 ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        deca
        staa fAUTOREPEATKBD                 ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        cmpa #$B0 ; '°'
        bne endManageAUTOREPEAT
        ldaa #$FF
        staa fAUTOREPEATKBD                 ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition
        ldx #ROLTB                          ; Mémorisation de la dernière touche entrée
        ldab #$08
        ldaa #$FF

bclManageAUTOREPEAT:
        staa 0,x
        inx
        decb
        bne bclManageAUTOREPEAT

endManageAUTOREPEAT:
        rts
; End of function initKBD


; =============== S U B R O U T I N E =======================================
; FCT : Effectue une tempo de $45E x X secondes
; IN  : /
; OUT : /

KBD_TEMPO_0X45E:
        pshx
        ldx #$45E

bclKBD_TEMPO_0X45E:
        dex
        bne bclKBD_TEMPO_0X45E
        pulx
        rts
; End of function KBD_TEMPO_0X45E


; =============== S U B R O U T I N E =======================================
; FCT : Permet de donner le code équivalent ASCII (ou pas) de la touche actionnée
;       à partir d'un des tableaux de conversion choisi par le registre B
; IN  : B=0: TOUCHE
;       B=1: CTRL+TOUCHE
;       B=2: SHIFT+TOUCHE
;       B=3: CTRL+TOUCHE
; OUT : Le code fonction du tableau de conversion
;       CTRLKBD à jour

KBD_CONV_MATRIX_TO_ASCII:
        pshb                                ; save function keyb : none / CTRL / SHIFT
        asrb
        ldab #$00
        bcc nextKBD_CONV_MATRIX_TO_ASCII
        decb

nextKBD_CONV_MATRIX_TO_ASCII:
        stab CTRLKBD                        ; =$00 : hit normal keyb or hit shift, $FF = hit CTRL,
        pulb
        pshb
        ldx TABADKBD                        ; pointeur sur les tableaux de conversion KEYB -> ASCII
        aslb
        abx
        ldx 0,x
        tab
        abx
        ldaa 0,x
        pulb
        pshb
        tstb
        bne next1KBD_CONV_MATRIX_TO_ASCII
        psha
        adda #$BF
        cmpa #$1A
        pula
        bcc next1KBD_CONV_MATRIX_TO_ASCII
        tst KEYB_INVVIDEO                   ; Indicateur pour INVERSE VIDEO pour l'écran et
                                            ; majuscule/minuscule pour imprimante (toggle entre $00 et $FF)
        bne next1KBD_CONV_MATRIX_TO_ASCII
        adda #$20 ; ' '

next1KBD_CONV_MATRIX_TO_ASCII:
        pulb
        pshb
        bitb #$02
        beq next2KBD_CONV_MATRIX_TO_ASCII
treatShiftKeyKBD_CONV_MATRIX_TO_ASCII:
        psha
        adda #$80
        cmpa #$20 ; ' '
        pula
        bcc next2KBD_CONV_MATRIX_TO_ASCII
        ldab COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        andb #$70
        aba

; Gestion CTRL-0 (couleur cyclique du curseur) / SHIFT-0 (inverse video)
next2KBD_CONV_MATRIX_TO_ASCII:
        cmpa #cKB_CTRL_0                    ; cKB_CTRL_0=cKB_SHIFT_0=$30 : '0'
        pulb                                ; get function keyb : none, shift,ctrl
        bne rtsKBD_CONV_MATRIX_TO_ASCII
        asrb
        bcc next3KBD_CONV_MATRIX_TO_ASCII

cycleColorKBD_CONV_MATRIX_TO_ASCII:
        ldaa COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        adda #$10
        staa COLOR_CARGRA                   ; Code couleur cyclique pour les caractères graphiques via CTRL+0
        clra

next3KBD_CONV_MATRIX_TO_ASCII:
        tstb
        beq rtsKBD_CONV_MATRIX_TO_ASCII

toggleInvVideoKBD_CONV_MATRIX_TO_ASCII:
        com KEYB_INVVIDEO
        clra

rtsKBD_CONV_MATRIX_TO_ASCII:
        rts
; End of function KBD_CONV_MATRIX_TO_ASCII


; ===========================================================================
; /// I/O - GRAPHISMES
; ===========================================================================
xxIO_SCREEN:

; ---------------------------------------------------------------------------
;----------------
;; MAT +    PAT : 40 colonnes mode long (R1,R2,R3)
;; $81=TGS,$10=00 0 1 0 0 0 0
;         0  : 625 lignes / 50Hz
;         0  : NOT INTERLACED
;         0  : HOR RESYNC DISABLED
;         0  : VERT RESYNC DISABLED
;         1  : Type SYNC OUT
;         0  : SERVICE ROW Y=0
;         00 : 40 CHAR/ROW MODE, LONG CHAR CODE (3 bytes) with PAT7
;; $82=MAT,$28=0 0 10 1 000
;         000 MARGE NOIRE
;         0   PAS DE CURSEUR
;         10  CURSEUR FIXE SOULIGNE
;         1   I SIGNAL AU NIVEAU HAUT DURANT LA PERIODE DE MARGE
;         0   PAS DE ZOOM
;; $83=PAT,$67=0 1 10 0 1 1 1
;   bit 7 0   40 CHAR/ROW MODE, LONG CODE with TGS7 and TGS6
;         1   FLASHING ENABLE
;         10  CHARACTER MARK (INSERT MODE)
;         0   CONCEAL DISABLE
;         1   LOWER BULK ENABLED
;         1   UPPER BULK ENABLED
;   bit 0 1   SERVICE ROW ENABLED
;; $84=DOR,$13=0 001 0011
;         0011 : ALPHA UDS SLICES IN BLOCK 3
;         001  : SEMI GRAPHIC UDS SLICES IN BLOCK 2 and 3
;         0    : QUADRICHROME SLICES FROM BLOCK 6 et 7 : TODO ?? A corriger et à reporter sur la V1 et V2
;; $87=ROR,$08=000 01000
;         010000 : ORIGIN ROW = 8
;         000    : Displayed Page Memory starts from block 0

VDP_40_TGS EQU (cVDP_TGS_625+cVDP_TGS_NO_INTERLACE+cVDP_TGS_NO_HOR_RESYNC+cVDP_TGS_NO_HOR_RESYNC+cVDP_TGS_NO_VER_RESYNC+cVDP_TGS_SYNC_OUT_COMP+cVDP_TGS_NO_SERVICE_ROW+cVDP_TGS_MODE_40_LONG)
VDP_40_MAT EQU (cVDP_MAT_NO_DBL_HEIGHT+cVDP_MAT_NO_CURSOR_DISP+cVDP_MAT_MD_CURS_FLS_CPL+cVDP_MAT_MARG_INS+cVDP_BLACK)
VDP_40_PAT EQU (cVDP_PAT_MODE_80_LONG+cVDP_PAT_FLASH_EN+cVDP_PAT_INS_MODE_CHAR_MARK+cVDP_PAT_NO_CONCEAL_EN+cVDP_PAT_DW_BULK_EN+cVDP_PAT_UP_BULK_EN+cVDP_PAT_SERVICE_ROW_EN)
;VDP_40_DOR EQU (cVDP_DOR_HI_INS_HI+(cVDP_WHITE*16)+cVDP_DOR_HI_INS_LO+cVDP_GREEN)

tabEF9345_MODE40:
    dc.b VDP_40_TGS, cVDP_CMD_IND+cVDP_REG_TGS ; 0 : $10,$81
    dc.b VDP_40_MAT, cVDP_CMD_IND+cVDP_REG_MAT ; 2 : $28,$82
    dc.b VDP_40_PAT, cVDP_CMD_IND+cVDP_REG_PAT ; 4 : $67,$83
    dc.b $13       , cVDP_CMD_IND+cVDP_REG_DOR ; 6 : $13,$84
    dc.b $08       , cVDP_CMD_IND+cVDP_REG_ROR ; 8 : $08,$87

; ---------------------------------------------------------------------------
;----------------
; MAT + PAT : 80 colonnes mode long (R1,R2,R3)
;; $81=TGS,$D0=11 0 1  0 0 0 0
;         0  : 625 lignes / 50Hz
;         0  : NOT INTERLACED
;         0  : HOR RESYNC DISABLED
;         0  : VERT RESYNC DISABLED
;         1  : SYNC OUT (composite sync)
;         0  : SERVICE ROW Y=0
;         11 : 80 CHAR/ROW MODE, LONG CHAR CODE (1.5 bytes) with PAT7 set to 0
;; $82=MAT,$28=0 0 10 1 000
;         000 MARGE NOIRE
;         0   PAS DE CURSEUR
;         10  CURSEUR FIXE SOULIGNE
;         1   I SIGNAL AU NIVEAU HAUT DURANT LA PERIODE DE MARGE
;         0   PAS DE ZOOM
;; $83=PAT,$67=0    1 10 0 1 1 1
;   bit 7 0   80 CHAR/ROW MODE, LONG CODE with TGS7 and TGS6
;         1   FLASHING ENABLE
;         10  CHARACTER MARK (INSERT MODE)
;         0   CONCEAL DISABLE
;         1   LOWER BULK ENABLED
;         1   UPPER BULK ENABLED
;   bit 0 1   SERVICE ROW ENABLED
;; $84=DOR,$FA=1 111 1 010
;         1 010 : insert / Color C0 = VERT
;         1 111 : insert / Color C1 = BLANC
;
;; $87=ROR,$08=000 01000
;         010000 : ORIGIN ROW = 8
;         000    : Displayed Page Memory starts from block 0

VDP_HIR_NOR_TGS EQU (cVDP_TGS_625+cVDP_TGS_NO_INTERLACE+cVDP_TGS_NO_HOR_RESYNC+cVDP_TGS_NO_HOR_RESYNC+cVDP_TGS_NO_VER_RESYNC+cVDP_TGS_SYNC_OUT_COMP+cVDP_TGS_NO_SERVICE_ROW+cVDP_TGS_MODE_80_LONG)
VDP_HIR_NOR_MAT EQU (cVDP_MAT_NO_DBL_HEIGHT+cVDP_MAT_NO_CURSOR_DISP+cVDP_MAT_MD_CURS_FLS_CPL+cVDP_MAT_MARG_INS+cVDP_BLACK)
VDP_HIR_NOR_PAT EQU (cVDP_PAT_MODE_80_LONG+cVDP_PAT_FLASH_EN+cVDP_PAT_INS_MODE_CHAR_MARK+cVDP_PAT_NO_CONCEAL_EN+cVDP_PAT_DW_BULK_EN+cVDP_PAT_UP_BULK_EN+cVDP_PAT_SERVICE_ROW_EN)
VDP_HIR_NOR_DOR EQU (cVDP_DOR_HI_INS_HI+(cVDP_WHITE*16)+cVDP_DOR_HI_INS_LO+cVDP_GREEN)

tabEF9345_HIRES_NOR:
    dc.b VDP_HIR_NOR_TGS, cVDP_CMD_IND+cVDP_REG_TGS   ; 0 : $D0,$81
    dc.b VDP_HIR_NOR_MAT, cVDP_CMD_IND+cVDP_REG_MAT   ; 2 : $28,$82
    dc.b VDP_HIR_NOR_PAT, cVDP_CMD_IND+cVDP_REG_PAT   ; 4 : $67,$83
    dc.b VDP_HIR_NOR_DOR, cVDP_CMD_IND+cVDP_REG_DOR   ; 6 : $FA,$84
    dc.b $08            , cVDP_CMD_IND+cVDP_REG_ROR   ; 8 : $08,$87

; ---------------------------------------------------------------------------
; Tableau de conversion pour les couleurs
tabEF9345_COLOR:  dc.b $F0,$B0,$80,$90,$A0,$E0,$D0,$C0


; =============== S U B R O U T I N E =======================================
; FCT : test if EF9345 is ready
; IN  : /
; OUT : A,B,X unmodified
; OPT : TODO : INLINE DE GR_NOP_EF9345 pour aller plus vite ... mais on, perd de la place

GR_isEF9345ready:
        psha
        ldaa #$80

bclGR_isEF9345ready:
        tst EF9345_R0
        bpl endGR_isEF9345ready
        deca
        bne bclGR_isEF9345ready
        bsr GR_NOP_EF9345                   ; FCT : exécute on EF9345 a No OPeration
                                            ; IN  : /
                                            ; OUT : A modified

endGR_isEF9345ready:
        pula
        rts
; End of function GR_isEF9345ready


; =============== S U B R O U T I N E =======================================
; FCT : Permet de paramètrer les registres TGS,MAT,PAT,DOR,ROR
; IN  : X=pointeur sur paramétrage pour EF9345
; OUT : A,B,X modified

GR_progEF9345:
        ldab #$05                           ; Par défaut écrit 6 données

bclGR_progEF9345:
        bsr GR_isEF9345ready                ; B=nb octet à écrire (R1,EXEC) X = position du paramétrage
        ldaa 0,x
        staa EF9345_R1
        ldaa 1,x
        staa EF9345_EXEC
        inx
        inx
        decb
        bne bclGR_progEF9345                ; B=nb octet à écrire (R1,EXEC) X = position du paramétrage
        jmp GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
; End of function GR_progEF9345


; =============== S U B R O U T I N E =======================================
; FCT : Permet d'initialiser le mode 40 colonnes 24 bits
;   Par défaut, le découpage mémoire s'effectue de
;   la façon suivante :
;    RAM VIDEO : 8ko : $2000 soit 8192 octets
;    mode 40 col :  40x25 = 1000 octets, ligne de service 24 octets
;    $0000 - $03FF : C : caractères
;    $0400 - $07FF : B : attributs
;    $0800 - $0AFF : A : couleurs
;    $0B00 - $1FFF : TODO
; IN  : /
; OUT : A,B,X modified

GR_initVideoMode40:
        ldx #tabEF9345_MODE40               ; Init en mode 40 (puis on régle plus loin dans la ROM les marges pour faire 32 col)
        bsr GR_progEF9345                   ; FCT : Permet de paramètrer les registres TGS,MAT,PAT,DOR,ROR
                                            ; IN  : X=pointeur sur paramétrage pour EF9345
                                            ; OUT : A,B,X modified

GR_initRegEF9345:
        clra
        clrb
        staa EF9345_R1                      ; R1=C =$00=0 0000000 DONT_CARE CODE CARACTERE
        staa EF9345_R3                      ; R3=A =$00=0 000 0 000 : no reverse black foreground no flash black background
        std EF9345_R6                       ; R6=MP=$0000 = service row
        inca
        staa EF9345_R2                      ; R2:B =$01=0000 0 0 0 1 : 1 mode insert
        staa EF9345_EXEC                    ; $01=KRF:0000 0 00 1 : KRF/WRITE/00/Pointer inc

GR_initVRAM_InitVIDEO_mode40:
        bsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        clra
        std EF9345_R6                       ; R6-R7=$0000 : MP
        incb
        std EF9345_R4                       ; R4-R5=$00-01 : AP : 0000 0000-0000 0001
        ldaa #(cVDP_CMD_MVT+cVDP_COPY_MVP_TO_AP+cVDP_STOP_EOB) ; $F5
                                            ; $F5=MVT:1111 01 01 : MVT/MP->AP/stop at end of buffer
                                            ; ==> fill 40 bytes
        staa EF9345_EXEC
        bsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified

GR_initvRAM_0x0800_0x1FFF:
        ldd #$0800
        std EF9345_R6                       ; R6-R7 = $0800 : MP : 0000 1000-000 0000
        ldaa #(cVDP_CMD_MVT+cVDP_COPY_AP_TO_MVP+cVDP_STOP_NO) ; #$FA
                                            ; $FA=1111 10 10 : cmd : 1111 MVT (move triple buffer)
                                            ;              ss  : 10 = source AP destination MP
                                            ;              aa  : 10 = no stop
                                            ; AP is already setting to 0x28 ?
        staa EF9345_EXEC

GR_setTempoInitVideo40:
        ldx #$0A00

bclGR_initVideoMode40:
        dex
        bne bclGR_initVideoMode40
; End of function GR_initVideoMode40


; =============== S U B R O U T I N E =======================================
; FCT : exécute on EF9345 a No OPeration
; IN  : /
; OUT : A modified

GR_NOP_EF9345:
        ldaa #(cVDP_CMD_NOP-1)              ; TODO Cela devrait être $91 et non pas $90 !
        staa EF9345_EXEC
        rts
; End of function GR_NOP_EF9345

; =============== S U B R O U T I N E =======================================
; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
; IN  : X=POS(Y,X)
; OUT : A and B unmodified
;       X=POS(Y,X)
; DBG : TODO : Enlever psha/pshb/pula/pulb ...

GR_setR6_MP:
        psha
        pshb
        bsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        bsr GR_computeMP_EF9345             ; FCT : calcule la position compatible EF9345 à partir
                                            ;       des coordonnées logiques fournies via le registre X
                                            ;       Rappel : Ligne 0 : numéro de ligne = 0
                                            ;                Ligne >=1  numéro de ligne  + 7
                                            ; IN  : X=(Y,X) position de l'écran logique
                                            ; OUT : D=(Y,X) position (X,Y) dans EF9345
                                            ;       X unmodified
        std EF9345_R6
        pulb
        pula
        rts
; End of function GR_setR6_MP


; =============== S U B R O U T I N E =======================================
; FCT : set value of R4 (AP)
; IN  : X=(Y,X) position de l'écran logique
; OUT : D modified
;       X unmodified

GR_setR4_EF9345:
        bsr GR_computeMP_EF9345             ; FCT : calcule la position compatible EF9345 à partir
                                            ;       des coordonnées logiques fournies via le registre X
                                            ;       Rappel : Ligne 0 : numéro de ligne = 0
                                            ;                Ligne >=1  numéro de ligne  + 7
                                            ; IN  : X=(Y,X) position de l'écran logique
                                            ; OUT : D=(Y,X) position (X,Y) dans EF9345
                                            ;       X unmodified
        std EF9345_R4
        rts
; End of function GR_setR4_EF9345


; =============== S U B R O U T I N E =======================================
; FCT : calcule la position compatible EF9345 à partir
;       des coordonnées logiques fournies via le registre X
;       Rappel : Ligne 0 : numéro de ligne = 0
;                Ligne >=1  numéro de ligne + 7
; IN  : X=(Y,X) position de l'écran logique
; OUT : D=(Y,X) position (X,Y) dans EF9345
;       X unmodified

GR_computeMP_EF9345:
        pshx                                ; si on avait eu l'opcode TXD ...
        pula                                ; Coordonnée Y
        pulb                                ; Coordonnée X
entryGR_computeMP_EF9345:
        addd SCR_MARGEXY
        tsta
        beq nextGR_computeMP_EF9345
        adda #$07                           ; ajoute 7 si le numéro de ligne > 0 (ah ! La joie du EF9345 ...)

nextGR_computeMP_EF9345:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne endGR_computeMP_EF9345
        lsrb                                ; B=B/2 : numéro de  colonne / 2 car mode 80 colonnes
        bcc endGR_computeMP_EF9345
        addb #$80                           ; B=B+$80 si colonne impaire

endGR_computeMP_EF9345:
        rts
; End of function GR_computeMP_EF9345


; =============== S U B R O U T I N E =======================================
; FCT : Lit le caractère à la position (Y,X) et retourne espace
;       si attribut sinon le code ASCII du caractère
; ST  : ACTIF
; IN  : X=POS(Y,X)
; OUT : A=$20 si ATTRIBUT
;       sinon CODE ASCII si A>$20 et A<=$7F
;       sinon CODE SEMI GRAPHIQUE si A>=$80
;       X unmodified

GR_readASCII:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne READ_ASCII_EF9345LoRes
        jmp GR_readASCIIHires               ; FCT : Read CHAR + ATTRIBUT MODE 80 COL 12 bits
                                            ; IN  : X=POS(Y,X) de l'octet à lire
                                            ; OUT : A=$20 si attribut sinon le code ASCII

READ_ASCII_EF9345LoRes:
        bsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldaa #(cVDP_CMD_KRF+cVDP_RD+cVDP_NO_INC)
                                            ; 0x08 : 0000/1/00/0:KRF/READ/null/No Inc pointer
        staa EF9345_EXEC                    ; Lit la mémoire en  position POS(Y,X)

getColorLoRes:
        ldab EF9345_R3                      ; READ A : code couleur xCCCyFFF avec CCC : couleur du caractère
                                            ;                                  et FFF : couleur du fond
                                            ;                                  et x   : mode inverse video (=1 oui)
                                            ;                                  et y   : clignotement du caractère

getAttribLoRes:
        ldaa EF9345_R2                      ; READ B : attribut
        bmi next1READ_ASCII_EF9345LoRes     ; est-ce que l'attribut correspond à un caractère semi-graphique ?
                                            ; Si oui alors saut (car BIT 7 = 1)

getCharLoRes:
        ldaa EF9345_R1                      ; READ C : caractère
        andb #$80                           ; $80: 1000 000 : mode inverse video activé ?
        beq nextREAD_ASCII_EF99345LoRes
        adda #$20 ; ' '

nextREAD_ASCII_EF99345LoRes:
        rts

; ---------------------------------------------------------------------------
; -- En entrée
; A = attribut : jeu de caractères L  M H i
;       avec i : bit d'inscrutation
;            H : double hauteur
;            M : bit de masqage
;            L : double largeur
; B = code couleur : xFFFyCCC

next1READ_ASCII_EF9345LoRes:
        anda #$01                           ; =1 inscrustation autorisé
        bne next2READ_ASCII_EF9345LoRes
        clrb

next2READ_ASCII_EF9345LoRes:
        pshx
        ldx #tabEF9345_COLOR
        andb #$70                           ; $70=$01110000 : ne garder que la couleur du fond
                                            ; si mode inscrustation activée
        asrb
        asrb
        asrb
        asrb                                ; B=00000FFF
        abx                                 ; X=tabEF9345_COLOR[couleur du fond]
        ldaa EF9345_R1                      ; récupération du caractére
        anda #$DF                           ; A AND $DF=1101 1111 - Annulation du 6éme bit
        oraa 0,x                            ; A= A OR tabEF935_COLOR[couleur de fond]
                                            ; note : le quartet inférieur de A garde sa valeur
                                            ; seul le quartet supérieur de A est mis à jour par
                                            ; le OR du fait des valeurs du tableau
        pulx
        rts
; End of function GR_readASCII


; =============== S U B R O U T I N E =======================================
; FCT : Efface l'écran
; IN  : B=code couleur sur [$XX, xx, yy, zz, ] / TODO
; OUT : A,B,X modified

GR_CLRSCR_2:
        tba
        bsr GR_computeParamColorEF9345      ; FCT : compute param (A=R1,B=R2,C=R3) for COLOR given by A
                                            ; IN  : A=code ascii
                                            ; OUT : A, B modified ; X unmodified
        ldx HOME_YX                         ; il faut bien commencer à un endroit ...

bclGR_CLRSCR_2:
        jsr GR_clearLine                    ; FCT : Efface la ligne à la position (X,Y) donnée par le registre X.
                                            ;       Les registres R1 et R3 doivent être initialisés à la bonne valeur
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(X,Y) de départ
                                            ; OUT : A,B modified
                                            ;       X unmodified
        pshx                                ; opération  : Y=Y+1 et X=(Y+1,X)
        pula
        inca                                ; Y=Y+1
        psha
        pulx
        cmpa SCR_LGY                        ; Nous avons atteint le nombre de lignes maximale ?
        bne bclGR_CLRSCR_2                  ; non alors on boucle
        rts
; End of function GR_CLRSCR


; =============== S U B R O U T I N E =======================================
; FCT : compute param (A=R1,B=R2,C=R3) for COLOR given by A
; IN  : A=code ascii
; OUT : A, B modified
;       X unmodified

GR_computeParamColorEF9345:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne GR_computeParamColorEF9345LoRes
        jmp GR_treatHICHAR_HIRES            ; FCT : Imprime caractère plein si mod $F sinon espace
                                            ; IN  : A=caractère dont l'intervalle est 0x80-0xFF
                                            ; OUT : A et B modified
; ---------------------------------------------------------------------------
;A=x CCC cccc avec x    : dont'care
;                  CCC  : code couleur
;                  cccc : code du caractère semi-graphique

GR_computeParamColorEF9345LoRes:
        tab
        anda #$F                            ; keep low nibble : on récupère code semi-graphique (pavé de 2x2 pixels)
        oraa #$20 ; ' '                     ; $20 : 0 01000 00 : don't care/Nø de tampon/Nø du caractère
                                            ; dans le tampon de redéfinition des caractères (compatibilité
                                            ; avec les ALICE de première génération)
        staa EF9345_R1                      ; stockage dans R1 du caractère à afficher
        pshx

computeColorForSemiGraph:
        ldx #tabColor
        andb #$70                           ; $70:0 111 0000 : ne garder que le code couleur pour le caractère ....
        lsrb
        lsrb
        lsrb
        lsrb
        abx

setModeGraAndColor:                         ; Bichrome mode
        ldab #(cVDP_GPRIME11+cVDP_NO_DBL_WIDTH+cVDP_NO_CONCEAL+cVDP_NO_DBL_HEIGHT+cVDP_INSERT)
                                            ; B=$B1 : 1011 0 0 0 1 / G'11 _ _ _ incrustation
        ldaa 0,x                            ; récupération du code de couleur en table
        bne setR3R2
        ldaa #$30                           ; TODO : $30=constante; $A=$30=0 011 / 0 000
        andb #$FE                           ; B=$B1 AND $FE = $B0 = 1011 0 0 0 0 / G'11 _ _ _ pas d'incrustation

setR3R2:
        staa EF9345_R3                      ; set color background and foreground
        stab EF9345_R2                      ; set mode semi-graphic
        pulx
        rts
; End of function GR_computeParamColorEF9345

; ---------------------------------------------------------------------------
; Code couleur
; $20 : vert  $30 : jaune $40 : bleu   $10 : rouge
; $70 : blanc $60 : cyan  $50 : violet $00 : orange
tabColor:   dc.b cVDP_GREEN*16,cVDP_YELLOW*16,cVDP_BLUE*16,cVDP_RED*16,cVDP_WHITE*16,cVDP_CYAN*16,cVDP_MAGENTA*16,cVDP_ORANGE
;TODO : tabColor: dc.b cVDP_RED*16,cVDP_GREEN*16,cVDP_YELLOW*16,cVDP_BLUE*16,cVDP_MAGENTA*16,cVDP_CYAN*16,cVDP_WHITE*16,cVDP_ORANGE

; CLS 0 : noir         INK 0 : noir
; CLS 1 : vert         INK 1 : rouge
; CLS 2 : jaune        INK 2 : vert
; CLS 3 : bleu         INK 3 : jaune
; CLS 4 : rouge        INK 4 : bleu
; CLS 5 : blanc        INK 5 : magenta
; CLS 6 : cyan         INK 6 : cyan
; CLS 7 : magenta      INK 7 : blanc
; CLS 8 : orange



; =============== S U B R O U T I N E =======================================
; FCT : Initialise les caractères semi-graphiques
;       identiques à ceux du premier ALICE à base de MC6847
;       car ceux de EF9345 ne sont pas les mêmes !
; IN  : /
; OUT : A,B,X modified

GR_initCarSemiGraph:
        ldaa #(cVDP_CMD_OCT+cVDP_WR+cVDP_USE_AUX+cVDP_NO_INC)
                                            ; $34(0011 0 1 0 0) : OCT/Write/AuxiliaryPtr/null/NoInc
        staa EF9345_R0
        ldx #tab9345SLICE

bclGR_initCarSemiGraph:
        ldd 0,x
        pshx
        bsr GR_initSLICE                    ; FCT : Initialise les SLICE en mémoire vidéo selon le registre D
                                            ; IN  : D=valeur du slice
                                            ; OUT : A,B,X modified
        pulx
        inx
        inx
        cpx #(tab9345SLICE+8)
        bne bclGR_initCarSemiGraph
        rts
; End of function GR_initCarSemiGraph


; =============== S U B R O U T I N E =======================================
; FCT : Initialise les SLICE en mémoire vidéo selon le registre D
; IN  : D=valeur du slice
; OUT : A,B,X modified

GR_initSLICE:
        pshb
        ldab #$C0                           ; R4:$C0 : 11 0 00000 => dont_care/Z2/C6-C2
        std EF9345_R4                       ; init AuxilliaryPointer
        pula
        ldx #(tab9345SLICE+1)

bclGR_initSLICE:
        ldab 0,x
        psha
        bsr GR_createOneSLICE               ; FCT : valeurs à stocker par colonne (définition 2 col x 5 lignes)
                                            ; IN  : A=valeur de la colonne gauche
                                            ;       B=valeur de la colonne droite
                                            ; OUT : A,B modified
        pula
        ldab EF9345_R5
        andb #$C3                           ; 0xC3 : 1100 0011
        incb
        stab EF9345_R5
        inx
        inx
        cmpb #$C4                           ; TODO : ?
        bne bclGR_initSLICE
        rts
; End of function GR_initSLICE


; =============== S U B R O U T I N E =======================================
; FCT : valeurs à stocker par colonne (définition 2 col x 5 lignes)
; IN  : A=valeur de la colonne gauche
;       B=valeur de la colonne droite
; OUT : A,B modified

GR_createOneSLICE:
        pshb
        bsr doGR_CreateOneSLICE
        pula

doGR_CreateOneSLICE:
        ldab #$05

bclGR_CreateOneSLICE:
        pshb
        staa EF9345_R9                      ; R9 : DATA to store private MEM video
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        ldab EF9345_R5                      ; compute next slice
        addb #$04
        stab EF9345_R5
        pulb
        decb
        bne bclGR_CreateOneSLICE
        rts
; End of function createOneSLICE

; ---------------------------------------------------------------------------
tab9345SLICE:   dc.b    $08,$00         ; 0
                dc.b    $09,$F0         ; 2
                dc.b    $0A,$0F         ; 4
                dc.b    $0B,$FF         ; 6

; =============== S U B R O U T I N E =======================================
; FCT : Exécute un scrolling vers le haut de l'écran
;       La dernière ligne de l'écran est effacée
; ALG : Déplacement le ligne L+1 vers la ligne L via EF9345
; IN  : /
; OUT : A et B unmodified
;       X modified

GR_scrollUp:
        psha
        pshb
        ldx HOME_YX                         ; Position de l'écran en haut à gauche =(0,0)

bclGR_scrollUp:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        pshx                                ; quel bordel pour faire +1 sur la position de ligne !
        pula                                ; TODO : peut-on optimiser ?
        inca
        psha
        pulx
        psha
        jsr GR_setR4_EF9345                 ; FCT : set value of R4 (AP)
                                            ; IN  : X=(Y,X) position de l'écran logique
                                            ; OUT : D modified
                                            ; X unmodified
        ldab #(cVDP_CMD_MVT+cVDP_COPY_AP_TO_MVP+cVDP_STOP_EOB)
                                            ; EXEC CMD $F9 = 1111 10 01 :
                                            ;            (1111) MVT
                                            ;            (11) copy AP -> MP
                                            ;            (01) stop at the end of buffer
        stab EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        pula
        inca
        cmpa SCR_LGY                        ; Taille max en pixel pour Y
        bne bclGR_scrollUp
        stx CURAD_YX

clearOneLine:
        bsr GR_clearLineByMode              ; FCT : Efface la ligne courante selon le mode graphique en courss
                                            ; IN  : X=POS(Y,X) position de la ligne à effacer
                                            ; OUT : A,B,X modified
        pulb
        pula
        rts
; End of function GR_scrollUp


; =============== S U B R O U T I N E =======================================
; FCT : Efface la ligne courante selon le mode graphique en cours
; IN  : X=POS(Y,X) position de la ligne à effacer
; OUT : A,B,X modified

GR_clearLineByMode:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne GR_clearLineLORES
GR_clearLineHIRES:
        ldaa ATTRIBUTE_HIRES                ; contient l'attribut du caractère en mode haute résolution
                                            ; Par défaut contient $00 (mode inversion) sinon $88.
                                            ; C'est un nibble donc l'attribut doit être répété 2
                                            ; fois dans l'octet (car colonne paire/impaire !)
                                            ; Sinon cela fait des effets sympas
        staa EF9345_R3
        ldaa #cOS_SPACE                     ; $20 ; ' '
        staa EF9345_R1
        bra GR_clearLine                    ; FCT : Efface une ligne en mode haute résolution
                                            ; IN  : /
                                            ; OUT : A,B,X modified

GR_clearLineLORES:
        ldaa ColorBG_SCR_LINE               ; Couleur du fond de la ligne insérée suite au scrolling de l'écran
        staa EF9345_R3                      ; DATA (A)
        ldaa #cVDP_INSERT                   ; Définition des attributs : mode insert
        staa EF9345_R2                      ; DATA (B)
        ldaa #cOS_PLEIN                     ; $7F : caractère plein
        staa EF9345_R1                      ; DATA (C)

; =============== S U B R O U T I N E =======================================
; FCT : Efface la ligne à la position (X,Y) donnée par le registre X.
;       Les registres R1,R2 et R3 doivent être initialisés à la bonne valeur
;       pour effectuer l'effacement
;       R1 et R3 sont utilisés par le mode 80 colonnes
;       R1,R2 et R3 sont utilisés par le mode 40 colonnes
; ST  : ACTIF
; IN  : X=POS(X,Y) de départ
; OUT : A,B modified
;       X unmodified

GR_clearLine:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldab SCR_XMAX                       ; longueur d'un écran
        ldaa #cVDP_CMD_KRF+cVDP_WR+cVDP_INC ; $01 : 0000 0 00 1 : KRF (40 COL / 24 bits) write IncPtr
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne bclGR_clearLine
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_INC ; $51 : 0101 0 00 1 : KRL (80 COL / 12 bits) write IncPtr

bclGR_clearLine:                            ; TODO : mise en inline de GR_writeKRx
        jsr GR_writeKRx                     ; FCT : Store A,B,C(R3,R2,R1) to MP (R6,R7) + increment Y
                                            ; IN  : /
                                            ; OUT : A modified
        decb
        bne bclGR_clearLine

endGR_clearLine:
        rts
; End of function GR_clearLine
; End of function GR_clearLineByMode


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère A dans la mémoire vidéo
; IN  : A=CODE ASCII à imprimer ou couleur pixel
;       A=[32..127] et [128-255]
;       X=POS(Y,X)
; OUT : A, B modified
;       X unmodified

OS_PRINT:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne OS_PRINTLoRes
        jmp GR_printHiRes                   ; FCT : écrit en mémoire vidéo le caractère A en position X(YX)
                                            ; IN  : A: le caractère à écrire
                                            ;       range : 0x00-0x1F : ne fait rien (pas d'affichage)
                                            ;               0x20-0x7F : caractère ASCII
                                            ;              0x80-0xFF : ?
                                            ;       X: la position(Y,X) où écrire le caractère
                                            ; OUT : A,B modified

OS_PRINTLoRes:
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        cmpa #$20 ; ' '
        bcs  endGR_clearLine                ; Si A < $20 alors on ne fait rien !
        cmpa #$80
        bcs nextPRINTASCIILoRes             ; Si A < $80 alors c'est un caractère imprimable sinon  c'est un caractère semi graphique

printSemiGraficLoRes:
        jsr GR_computeParamColorEF9345LoRes
                                            ; FCT : compute param (A=R1,B=R2,C=R3) for COLOR given by A
                                            ; IN  : A=code ascii
                                            ; OUT : A, B modified
                                            ; X unmodified
        bra next2PRINTLoRes

nextPRINTASCIILoRes:
        ldab #(cVDP_G0+cVDP_NO_DBL_WIDTH+cVDP_NO_CONCEAL+cVDP_NO_DBL_HEIGHT+cVDP_INSERT)
                                            ; B=$01:0000 0001 : mode G0/no dbl width/no conceal/no double height/insert
        stab EF9345_R2
        ldab ColorFGBG_CAR                  ; Couleur de fond et d'écriture du caractère !
        cmpa #$60 ; '`'
        bmi next1PRINTLoRes
        orab #$80
        suba #$20 ; ' '

next1PRINTLoRes:
        stab EF9345_R3                      ; Couleur : x FFF y CCC
        staa EF9345_R1                      ; character

next2PRINTLoRes:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldaa #cVDP_CMD_KRF+cVDP_WR+cVDP_INC ; $01 : 0000 0 00 1 : KRF (40 COL / 24 bits) write IncPtr
; End of function OS_PRINT

; =============== S U B R O U T I N E =======================================
; FCT : Store A,B,C(R3,R2,R1) to MP (R6,R7)+ increment de X
; IN  : A=commande EF9345 à exécuter : KRF,KRL, etc.
; OUT : A modified

GR_writeKRx:
        staa EF9345_EXEC
        jmp GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
; End of function GR_writeKRx

; =============== S U B R O U T I N E =======================================
; FCT : Initialise la couleur de fond et d'encre par défaut
;       en mode LOW RESOLUTION
; IN  : /
; OUT : A modified

GR_initColorLoRes:
        ldaa #(cVDP_GREEN*16)+cVDP_GREEN    ; $22 : 0 010 0 010 : NO_NEGATIVE / C1=GREEN / NO_FLASH / C0=GREEN
        staa ColorBG_SCR_LINE               ; Couleur du fond de la ligne insérée suite au scrolling de l'écran
        ldaa #(cVDP_BLACK*16)+cVDP_GREEN    ; $02
        staa ColorFGBG_CAR                  ; Couleur de fond et d'écriture du caractère !
        ldaa #(cVDP_GREEN*64)+cVDP_PLEIN_LO ; $8F ==> $80:vert,$90:jaune,$A0:bleu,$B0:rouge,$C0:blanc;$D0:cyan;$E0:violet;$F0:orange
        staa ColorCLS
        rts
; End of function GR_initColorLoRes


; =============== S U B R O U T I N E =======================================
; FCT : Initialise les couleurs de l'écran, du caractère
;       affiché‚ en mode HIGH RESOLUTION pour la partie ASSEMBLEUR
; IN  : /
; OUT : A modified
; ST  : TODO : à supprimer

GR_initColorASS:
        ldaa #(cVDP_BLUE*16)+cVDP_BLUE      ; $44 : 0 100 / 0 100 : NO_NEGATIVE / C1=BLUE / NO_FLASH / C0=BLUE
        staa ColorBG_SCR_LINE               ; Couleur du fond de la ligne insérée suite au scrolling de l'écran
        ldaa #(cVDP_WHITE*16)+cVDP_BLUE     ; $74
        staa ColorFGBG_CAR                  ; Couleur de fond et d'écriture du caractère !
        ldaa #(cVDP_BLUE*40)+cVDP_PLEIN_LO  ; $AF : $80:vert,$90:jaune,$A0:bleu,$B0:rouge,$C0:blanc;$D0:cyan;$E0:violet;$F0:orange
        staa ColorCLS                       ; Couleur pour effacer l'écran
        rts
; End of function GR_initColorASM

; =============== S U B R O U T I N E =======================================
; FCT : Mode text 32x16, efface l'écran, autorepeat non autorisé,
;       Initialise le pointeur sur les tableaux de conversions ASCII du clavier
;       Initialise les couleurs du fond et d'encre de l'écran
; IN  : /
; OUT : A,B,X modified

OS_InitGraphAndKbd:
        ldaa #cVDP_MODE_32x16
        staa TECRAN                         ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        clr fAUTOREPEATKBD                  ; =0:no autorepeat;<>0:AUTOREPEAT ON et est décrementée
                                            ; d'1 unité à chaque répétition

initPTRTABCONVASCII:
        ldx #tabScanCode
        stx TABADKBD                        ; pointeur sur les tableaux de conversion KEYB -> ASCII

initScreen:
        jsr GR_initColorLoRes               ; FCT : Initialise la couleur de fond et d'encre par défaut
                                            ;       en mode LOW RESOLUTION
                                            ; IN  : /
                                            ; OUT : A modified

isLowOrHighRes:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        bne next1InitScreenSetMode40

setEF9345toHires:
        jsr GR_initVIDEOMode80
        bra next2InitScreen

next1InitScreenSetMode40:
        jsr GR_initVideoMode40
        jsr GR_initCarSemiGraph

next2InitScreen:
        jsr GR_initParamByMode              ; FCT : Initialisation des variables du basic utilisées pour la gestion de l'écran
                                            ; IN  : TECRAN à jour
                                            ; OUT : X,A,B modified
        jmp GR_CLRSCR                           ; FCT : GR_CLRSCR : efface l'écran selon le mode donné par TECRAN
                                            ; IN  : /
                                            ; OUT : /
; End of function OS_InitGraphAndKbd

; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère A
; IN  : A=char to print
; OUT : A modified

OS_printCHARAtCurrentPos:
        ldx CURAD_YX
        jmp OS_PRINT

; =============== S U B R O U T I N E =======================================
; FCT : Obtient le code couleur du fond du caractère
; IN  : X=POS(Y,X)
; OUT : A=unmodified
;       B=0 si caractère lu est un attribut ou un caractère
;       sinon le code caractère AND $70 (0111 0000)
; OPT : enlever le psha et pula ?

GR_getBackColor:
        psha
        jsr GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
        tab
        bpl endGR_getBackColor
        andb #$70
        SKIP1                               ; TODO opcode BRN ! Permet de ne pas exécuter le CLRB suivant !

endGR_getBackColor:
        clrb
        pula
        rts
; End of function GR_getBackColor


; =============== S U B R O U T I N E =======================================
; FCT : Lit la zone mémoire pointée par X pour récupèrer
;       la couleur, l'attribut et le caractère
; IN  : X=POS(Y,X)
; OUT : A=0 si code ASCII lu sinon valeur du caractère semi-graphique

GR_getCharSemiGraphFromXY:
        jsr GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
        tsta
        bmi endGR_getCharSemiGraphFromXY
        clra

endGR_getCharSemiGraphFromXY:
        rts
; End of function GR_getCharSemiGraphFromXY


; =============== S U B R O U T I N E =======================================
; FCT : Lecture de la donnée à la position X=POS(Y,X)
; IN  : X=POS(Y,X)
; OUT : A=Code ASCII ou $20 si ATTRIBUT ou CODE SEMI GRAPHIQUE
;       N=1 si A=CODE SEMI GRAPHIQUE

GR_readScreenAtXY:
        jsr GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
        ;ldab #$FF                          ; TODO : A supprimer ?
        tsta
        rts
; End of function GR_readScreenAtXY


; =============== S U B R O U T I N E =======================================
; FCT : Lit le caractère (ASCII, ATTRIBUT, SEMI-GRAPHIQUE) à la position (Y,X)
;       EST UTILISEE DANS LE CAS OU ON RECHERCHE LE CODE COULEUR
; IN  : X=POS(Y,X)
; OUT : A=(le code ascii ou $20 SI ATTRIBUT ou CODE SEMI GRAPHIQUE) lu à la position (Y,X)
;       B=(le code ascii ou $20 SI ATTRIBUT ou CODE SEMI GRAPHIQUE) / 2 lu à la position (Y,X)

GR_readAttribAtXY:
        jsr GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
        tab
        lsrb
        rts
; End of function GR_readScreenAtXY


; =============== S U B R O U T I N E =======================================
; FCT : Lit le caractère en mémoire vidéo à la position (0,0)
; IN  : /
; ST  : ACTIF
; OUT : X modified
;       A=$20 si attribut sinon code ASCII du caractère lu

GR_readScreenAtHOME:
        ldx HOME_YX                         ; Position de l'écran en haut à gauche =(0,0)
        jmp GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
; End of function GR_readScreenAtHOME


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère A à la position (0,0) de l'écran
; IN  : A=caractère à imprimer
; OUT : A,B modified
;       X unmodified

GR_printCharAtHOME:
        pshx                                ; TODO : Pourquoi sauvegarder x ?
        ldx HOME_YX                         ; Position de l'écran en haut à gauche =(0,0)
        jsr OS_PRINT
        pulx
        rts
; End of function GR_printCharAtHOME

; =============== S U B R O U T I N E =======================================
; FCT : Incrémente de 1 la position du curseur à l'écran
;       et effectue un défilement vers le haut si nécessaire
; IN  : X=pos(Y,X)
; OUT : X=pos(Y,X+1) + scrollup si nécessaire

GR_incXScrollUp:
        bsr GR_incCursor                    ; FCT : Gestion du curseur physique : Incrémente de 1 la position horizontale
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : X=POS(Y,X+1)
                                            ;       A,B unmodified
        bne endGR_incXScrollUp
        jmp GR_scrollUp                     ; FCT : Appel la routine de SCROLLING de l'écran
                                            ; IN  : /
                                            ; OUT : A et B unmodified
                                            ;       X modified

endGR_incXScrollUp:
        rts
; End of function GR_incXScrollUp


; =============== S U B R O U T I N E =======================================
; FCT : Gestion du curseur physique : Incrémente de 1 la position horizontale
; IN  : X=POS(Y,X)
; OUT : X=POS(Y,X+1)
;       A,B unmodified

GR_incCursor:
        psha
        pshb
        pshx
        pula
        pulb
        incb
        cmpb SCR_LGX                        ; taille max sur X en mode 32, 40 ou 80 colonnes
        bne pushDpopX
        ldab HOME_YX+1                      ; Position de l'écran en haut à gauche =(0,0)
        inca
        cmpa SCR_LGY                        ; Taille max en pixel pour Y
        bne pushDpopX
        bra popD
; End of function GR_incCursor


; =============== S U B R O U T I N E =======================================
; FCT : décremente de 1 la position X,Y donnée par le registre X
; IN  : X=La position (X,Y)
; OUT : X=X-1 en position (X,Y)
;       A et B not modified

GR_decCursor:
        psha
        pshb
        pshx
        pula
        pulb
        cmpb HOME_YX+1                      ; Position de l'écran en haut à gauche =(0,0)
        bne dodecX_EF9345
        ldab SCR_LGX                        ; taille max sur X en mode 32, 40 ou 80 colonnes
        cmpa HOME_YX                        ; Position de l'écran en haut à gauche =(0,0)
        bne dodecYdecX_EF9345
        ldab HOME_YX+1                      ; Position de l'écran en haut à gauche =(0,0)

dodecYdecX_EF9345:
        deca

dodecX_EF9345:
        decb

pushDpopX:
        pshb
        psha
        pulx

popD:
        pulb
        pula
        rts
; End of function GR_decCursor


; =============== S U B R O U T I N E =======================================
; FCT : vérifie que la valeur de D est bien contenue dans l'intervalle
;       d'un affichage via PRINT @
;       au minimum : 0
;       au maximum : dépend de l'écran 32*16 ou 40*25 ou 80*25
; IN  : D=Position du curseur en nombre de caractère
;       et non pas en position (X,Y)
; OUT : Met à jour CURAD_YX
;       D=CURAD_YX=nouvelle position imposée par D

GR_verifyParam_AT:
        pshx
        ldx #$0000

bclGR_verifyParam_AT:
        subd SCR_OFSY                       ; OFFSET A AJOUTER POUR ALLER A LA LIGNE SUIVANTE POUR UN MEME X
        bmi nextGR_verifyParam_AT
        inx
        bra bclGR_verifyParam_AT

nextGR_verifyParam_AT:
        addd SCR_OFSY                       ; OFFSET A AJOUTER POUR ALLER A LA LIGNE SUIVANTE POUR UN MEME X
        pshx
        pula
        pula
        pulx
        adda HOME_YX                        ; Position de l'écran en haut à gauche =(0,0)
        cmpa SCR_LGY                        ; Taille max en pixel pour Y
        bcc jmpErrorMsg_0X08
        addb HOME_YX+1                      ; Position de l'écran en haut à gauche =(0,0)
        std CURAD_YX
        rts

jmpErrorMsg_0X08:
        jmp printErrorMSG_0x08_FC_FctIncorrect
; End of function GR_verifyParam_AT


; =============== S U B R O U T I N E =======================================
; FCT : Initialisation des variables du basic utilisées pour la gestion de l'écran
; IN  : TECRAN à jour
; OUT : X,A,B modified

GR_initParamByMode:
        ldx #tabINITPRM_SCR
        ldab TECRAN                         ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        ldaa #$0A
        mul
        abx
        ldab #$0A

bclGR_InitParamByMode:
        ldaa 0,x
        psha
        inx
        decb
        bne bclGR_InitParamByMode
        ldab #$0A
        ldx #SCR_LGY

bcl2GR_InitParamByMode:
        pula
        staa 0,x
        inx
        decb
        bne bcl2GR_InitParamByMode

setCurAtHomeGR_InitParamByMode:
        ldx #$0000
        stx HOME_YX                         ; Position de l'écran en haut à gauche =(0,0)
        rts
; End of function GR_initParamByMode

; ---------------------------------------------------------------------------
; paramétrage des modes écrans
; 1ere ligne : 80x25
; 2eme ligne : 40x25
; 3eme ligne : 32x16
; Les données sont à l'envers de leur stockage !
;=====================================================================
;MARGE_DROITE, MARGE_GAUCHE,PIX_XMAX, PIX_YMAX,OFSLINHI,OFSLINLOW,XMIN,YMIN,XMAX,YMAX
;=====================================================================
;        160     ,      125
;$40,$10,$A0     ,       $7D,    $50,    0,    0,    0, $50, $19
;=====================================================================
;        80      ,       50
;$10,$10,$50     ,       $32,    $28,    0,    0,    0, $28, $19
;=====================================================================
;         64     ,       32
;$10,$10,$40     ,       $20,    $20,    0,    4,    4, $20, $10
;---------------------------------------------------
tabINITPRM_SCR:
        dc.b $40,$10,$A0,$7D,$50,$00,$00,$00,$50,$19
        dc.b $10,$10,$50,$32,$28,$00,$00,$00,$28,$19
        dc.b $10,$10,$40,$20,$20,$00,$04,$04,$20,$10
;----------------

; =============== S U B R O U T I N E =======================================
; FCT : écrit en mémoire vidéo le caractère A en position X(YX) en mode bichrome
; IN  : A: le caractère à écrire
;       range : 0x00-0x1F : ne fait rien (pas d'affichage)
;               0x20-0x7F : caractère ASCII
;               0x80-0xFF : ?
;       X: la position(Y,X) où écrire le caractère
; OUT : A,B modified
; STA : TODO !!


GR_PRINTBiChrome:
        rts

; =============== S U B R O U T I N E =======================================
; FCT : écrit en mémoire vidéo le caractère A en position X(YX en mode quadrichrome
; IN  : A: le caractère à écrire
;       range : 0x00-0x1F : ne fait rien (pas d'affichage)
;               0x20-0x7F : caractère ASCII
;               0x80-0xFF : ?
;       X: la position(Y,X) où écrire le caractère
; OUT : A,B modified

GR_PRINTQuadri:
isCharQuadri:
        cmpa #$20 ; ' '
        bcs endGR_PRINTQuadri
        cmpa #$80
        bcc endGR_PRINTQuadri

next1GR_PRINTQuadri:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldab #cVDP_CMD_KRF+cVDP_WR+cVDP_INC ; $01 : 0000 0 00 1 : KRF (40 COL / 24 bits) write IncPtr
        stab EF9345_R0                      ; set command to KRL
        ldab QUAD_BLK
        orab #$C1                           ; 11 BLK x x 1 : avec BLK : numéro de bloc (page mémoire géré EF9345)
        stab EF9345_R2                      ; (B)
        ldab QUAD_PAL                       ; set COLOR palette
        stab EF9345_R3                      ;  (A)
        staa EF9345_R1+$08                  ; set char and do action (C)

endGR_PRINTQuadri:
        rts
; End of function GR_PRINTQuadri


; =============== S U B R O U T I N E =======================================
; FCT : Initialise le EF9345 pour le mode 80 caractères en mode normal
;       Reconfiguration des registres + Reinitialisation des zones mémoires
; IN  : /
; OUT : A,B,X modified

GR_initVIDEOMode80:
        ldx #tabEF9345_HIRES_NOR

nextGR_initVIDEOMode80:
        jsr GR_progEF9345                   ; FCT : Permet de paramètrer les registres TGS,MAT,PAT,DOR,ROR
                                            ; IN  : X=pointeur sur paramétrage pour EF9345
                                            ; OUT : A,B,X modified
        ldaa #$80 ;#cOS_PLEIN                     ; $7F : caractère plein TODO
        staa EF9345_R1                      ; = CARACTERE (C)
        ldaa ATTRIBUTE_HIRES                ; contient l'attribut du caractère en mode haute résolution
                                            ; Par défaut contient $00 (mode inversion) sinon $88.
                                            ; C'est un nibble donc l'attribut doit être répété 2
                                            ; fois dans l'octet (car colonne paire/impaire !)
                                            ; Sinon cela fait des effets sympas
        staa EF9345_R3                      ; = ATTRIBUTS (A)
        ldd #$0000
        std EF9345_R6
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_NO_INC  ; $50 : 0101/1/00/0 : KRL/WRITE/null/NO INC PTR
        staa EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        eorb #$80                           ; B=$80 !
        stab EF9345_RF                      ; Met à jour R7 avec $80 ==> R6R7=$0080
        clrb
        jmp GR_initVRAM_InitVIDEO_mode40
; End of function GR_initVIDEOMode80


; =============== S U B R O U T I N E =======================================
; FCT : Read CHAR + ATTRIBUT MODE 80 COL 12 bits
; IN  : X=POS(Y,X) de l'octet à lire
; OUT : A=$20 si attribut sinon le code ASCII

GR_readASCIIHires:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldaa #cVDP_CMD_KRL+cVDP_RD+cVDP_NO_INC  ; $58 : 0101/1/00/0 : KRL/READ/null/NO INC PTR
        staa EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        ldaa EF9345_R1
        bpl endGR_readASCIIHires
        ldaa #$20                           ; ' '

endGR_readASCIIHires:
        rts
; End of function GR_readASCIIHires

; =============== S U B R O U T I N E =======================================
; FCT : Imprime caractère plein si mod $F sinon espace
; IN  : A=caractère dont l'intervalle est 0x80-0xFF
; OUT : A et B modified

GR_treatHICHAR_HIRES:
        ldab #cOS_SPACE                     ; ' ' ; espace
        anda #$0F
        bne nextGR_treatHICHAR_HIRES
        ldab #cOS_PLEIN                     ; $7F ; caractère plein

nextGR_treatHICHAR_HIRES:
        ldaa ATTRIBUTE_HIRES
        staa EF9345_R3                      ; set attibute
        stab EF9345_R1                      ; set char
        rts
; End of function GR_treatHICHAR_HIRES

; =============== S U B R O U T I N E =======================================
; FCT : écrit en mémoire vidéo le caractère A en position X(YX)
; IN  : A: le caractère à écrire
;       range : 0x00-0x1F : ne fait rien (pas d'affichage)
;               0x20-0x7F : caractère ASCII
;               0x80-0xFF : ?
;       X: la position(Y,X) où écrire le caractère
; OUT : A,B modified

GR_printHiRes:

isCharPrinting:
        cmpa #$20 ; ' '
        bcs endGR_printHiRes

setPOSXYGR_printHiRes:                      ; Position inhabituel afin d'effectuer un seul GR_isEF9345ready
                                            ; car déja effectué par GR_setR6_MP !
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
is0x80_0xFF_GR_printHiRes:
        cmpa #$80
        bcs nextGR_printHiRes


        jsr GR_treatHICHAR_HIRES            ; FCT : Imprime caractère plein si mod $F sinon espace
                                            ; IN  : A=caractère dont l'intervalle est 0x80-0xFF
                                            ; OUT : A et B modified
        bra next1GR_printHiRes

nextGR_printHiRes:
        ldab ATTRIBUTE_HIRES                ; contient l'attribut du caractère en mode haute résolution
                                            ; Par défaut contient $00 (mode inversion) sinon $88.
                                            ; C'est un nibble donc l'attribut doit être répété 2
                                            ; fois dans l'octet (car colonne paire/impaire !)
                                            ; Sinon cela fait des effets sympas
        stab EF9345_R3
        staa EF9345_R1

next1GR_printHiRes:
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_INC ; $51 : 0101 0 00 1 : KRL (80 COL / 12 bits) write IncPtr
        staa EF9345_EXEC

endGR_printHiRes:
        rts
; End of function GR_printHiRes

; =============== S U B R O U T I N E =======================================
; FCT : Allume le pixel dont la position est donnée par X.
; IN  : X=(X div 2,Y div 5) position du pixel à traiter !
;       RDPIX_EF9345 contient le masque du bit à allumer
; OUT : A,B,X modified

GR_setPixelHires:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)

readPixelBlock:
        ldaa #cVDP_CMD_KRL+cVDP_RD+cVDP_NO_INC  ; $58 : 0101/1/00/0 : KRL/READ/null/NO INC PTR
                                            ; le résultat de trouvera dans R1=C et R3=A
        staa EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        ldd RDPIX_EF9345                    ; Lit le masque du pixel à modifier :        format: sm00 0 0A2A1/A0C6C5C4C3C2C1C0
        lsld                                ; C=BIT[15] OF D = bit de signe (l'attendu est 1)  : m000 0A2A1A0/C6C5C4C3C2C1C0 0 C=[s]
        rorb                                ; B[7] = C_EF9345[7]] : bit de mode mosaique       : m000 0A2A1A0/ sC6C5C4C3C2C1C0 C=[0]
        asla                                ; C=B[0] ==> A = 0000A2A1A00                       : 0000A2A1A0 0/ sC6C5C4C3C2C1C0 C=[m]
        adca #$00                           ;                                                  : 0000A2A1A0 m/ sC6C5C4C3C2C1C0 C=[m]
        anda #$0F                           ; ne garde que les 4 bits de poids faibles : est-ce nécessaire ? TODO
        stab EF9345_R1                      ; C=R1=[ 1C6C5C4C3C2C1C0]
        ldab EF9345_R3                      ; Get A_EF9345 = code couleur (binaire 0/1)
        tst EF9345_R7                       ; récupère la parité en X : paire ou impaire ?
        bmi nextGR_setPixelHires            ; si impaire alors saut
        asla                                ; le but est de mettre le bit de couleur en A[0] ou A[4] correctement ...
        asla
        asla
        asla
        andb #$0F
        bra next1GR_setPixelHires

nextGR_setPixelHires:
        andb #$F0

next1GR_setPixelHires:
        aba
        staa EF9345_R3                      ; met à jour le code couleur  (binaire : 0 ou 1) !
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_NO_INC  ; $50 : 0101/1/00/0 : KRL/WRITE/null/NO INC PTR
        staa EF9345_EXEC
        rts
; End of function GR_setPixelHires


; =============== S U B R O U T I N E =======================================
; FCT : Lit la couleur de la position d'un pixel en mode haute résolution
; IN  : X=Position Y,X selon le mode semi graphique = (Y div 5, X div 2)
;       D=Position Y,X selon la matrice 5x2 du pixel recherché
; OUT : D=La valeur des pixels (0,1) contenus dans la matrice 5x2
;       au format sm0000A2A1/A0C6C5C4C3C2C1C0

GR_readColorHires:
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldaa #cVDP_CMD_KRL+cVDP_RD+cVDP_NO_INC  ; $58 : 0101/1/00/0 : KRL/READ/null/NO INC PTR
        staa EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        ldaa EF9345_R3                      ; read nibble A (EF9345)
        tst EF9345_R7                       ; Test la parité de X dans R7 car les pixels A3,A2,A1
                                            ; ne sont pas au même endroit dans R3 !
        bmi nextGR_readColorHires
        anda #$F0                           ; nous sommes en colonne paire donc on décale de 4 vers la droite
                                            ; pour récupèrer 0000 A3A2A1D avec D : couleur active
        lsra
        lsra
        lsra
        lsra
        bra next1GR_readColorHires

nextGR_readColorHires:
        anda #$0F                           ; nous sommes en colonne impaire alors on efface le nibble de poids fort

next1GR_readColorHires:
        ldab EF9345_R1                      ; on récupère les données concernant les pixels C6 à C0 !
        lsra                                ; nous récupérons le bit D (code couleur : 0=couleur de l'encre/1=couleur de la marge)
        bcc next2GR_readColorHires
        adda #$80                           ; nous indiquons que la couleur de la pixel est celui de la marge

next2GR_readColorHires:
        aslb                                ; On récupère le bit 7 indiquant un caractère semi-graphique ou pas
        rora                                ; on propage ce bit dans A (pixel A3,A2,A1) puis le bit 0 dans C
        rorb                                ; on propage le bit 0 de A dans B
        std RDPIX_EF9345                    ; et on stocke dans RDPIX_EF9345 la valeur sm0000A2A1/A0C6C5C4C3C2C1C0
        rts
; End of function GR_readColorHires


; =============== S U B R O U T I N E =======================================
; FCT : Applique le masque de recherche de pixel sur la valeur lue
;       (matrice 5x2)
; IN  : /
; OUT : D=0 si pixel eteint sinon <> 0 pour pixel allumé

GR_convPixelToXY:
        ldd RDPIX_EF9345
        anda MSKPIX_EF9345                  ; Masque du pixel recherché en mode HIRES
        bne endGR_convPixelToXY
        andb MSKPIX_EF9345+1                ; Masque du pixel recherché en mode HIRES
endGR_convPixelToXY:
        rts
; End of function GR_convPixelToXY


; =============== S U B R O U T I N E =======================================
; FCT : retourne la position du pixel en mode semi-graphique
;   Le pixel est contenu dans une zone de 2 colonnes de 5 rangées
;   C0 C1
;   C2 C3
;   C4 C5
;   C6 A1
;   A2 A3
; IN  : A=Y mod 5 c'est à dire le numéro de ligne dans la matrice 5x2 de pixels
;       B=Parité de X
; OUT : MSKPIX_EF9345=D=La position du pixel recherché selon (Y=A,X=B) dans la matrice 5x2
;       X=ptr(tabXY2Pixel)

GR_convXY2NumPixel:
        asla                                ; A=(Y mod 5) * 2
        aba                                 ; A=(Y mod 5) * 2 + (0 ou 1)
        ldx #tabXY2Pixel
        tab                                 ; B=(Y mod 5) * 2 + (0 ou 1)
        aslb                                ; B=((Y mod 5)* 2 + (0 ou 1))*2
        abx
        ldd 0,x
        std MSKPIX_EF9345                   ; Masque du pixel recherché en mode HIRES
        rts
; End of function GR_convXY2NumPixel

; ---------------------------------------------------------------------------
; Tableau de conversion pour obtenir la position
; du pixel recherché dans la matrice 5 lignes x 2 colonnes en mode HIRES.
; La matrice des pixels est :
; C0 C1 avec Cx stocké dans R1 de EF9345
; C2 C3 avec Ax stocké dans R3 de EF9345
; C4 C5
; C6 A1
; A2 A3
tabXY2Pixel:dc.b  $00,$01  ; C0 L1
            dc.b  $00,$02  ; C1 L1
            dc.b  $00,$04  ; C2 L2
            dc.b  $00,$08  ; C3 L2
            dc.b  $00,$10  ; C4 L3
            dc.b  $00,$20  ; C5 L3
            dc.b  $00,$40  ; C6 L4
            dc.b  $00,$80  ; A1 L4
            dc.b  $01,$00  ; A2 L5
            dc.b  $02,$00  ; A3 L5

jmpPrintErrorMSg0x08_FC:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT : effectue l'interprétation de l'expression (X,Y
; IN  : le flot d'interprétation
; OUT : X=POS(X div 2,Y div 5)
;       D=La valeur des pixels (0,1) contenus dans la matrice 5x2
;       au format sm0000A2A1/A0C6C5C4C3C2C1C0
;       Cette valeur est stockée dans RDPIX_EF9345.
;       MSKPIX_EF9345 est mise à jour : masque d'accés au pixel (X,Y)
;       RDPIX_EF9345  est mise à jour : valeur du pixel lu en POS(X,Y)

checkOPNBeforeGR_getPixelHiRes:
        jsr CHKOPN
; End of function checkOPNBeforeGR_getPixelHiRes


; =============== S U B R O U T I N E =======================================
; FCT : récupère les paramètres X et Y dans le flot d'interprétation
;       et retourne dans D l'état des pixels dans une matrice 2 col x 5 lig
;       résolution en modes HIRES : 160  x 125
;       X=0-159 et Y=0-124
; IN  : /
; OUT : D=La valeur des pixels (0,1) contenus dans la matrice 5x2
;       au format sm0000A2A1/A0C6C5C4C3C2C1C0
;       Cette valeur est stockée dans RDPIX_EF9345.
;       X=POS(X div 2,Y div 5)
;       MSKPIX_EF9345 est mise à jour : masque d'accés au pixel (X,Y)
;       RDPIX_EF9345  est mise à jour : valeur du pixel lu en POS(X,Y)
; ERR : $08 : FC

GR_getPixelHiRes:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        tst REL_HIRES
        beq suite1
        addb CUR_POSX
suite1:
        cmpb SCR_XMAX_PIX                   ; Taille max en pixel pour X
        bcc jmpPrintErrorMSg0x08_FC
        stab CUR_POSX
        clra
        lsrb                                ; B=X/2
        adca #$00
        psha                                ; sauvegarde si c'est une colonne paire(=0) ou impaire(=1)
        stab POINT_YX_HIRES+1               ; stocke la valeur de X div 2

getY_POINT:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        tst REL_HIRES
        beq suite2
        addb CUR_POSY
suite2:
        cmpb SCR_YMAX_PIX                   ; Taille max en pixel pour Y
        bcc jmpPrintErrorMSg0x08_FC
        stab CUR_POSY
        clra
findLineMod5:                               ; Mode HIRES : mode semi-graphique avec résolution 160x125
        inca                                ; par contre X=[0;79] et Y=[0;24]
        subb #$05
        bpl findLineMod5
        deca
        addb #$05
        staa POINT_YX_HIRES                 ; stocke la valeur Y div 5
        tba                                 ; Y mod 5
        pulb                                ; récupère la parité de X
        jsr GR_convXY2NumPixel              ; FCT : retourne la position du pixel en mode semi-graphique
                                            ;       Le pixel est contenu dans une zone de 2 colonnes de 5 rangées
                                            ;       C0 C1
                                            ;       C2 C3
                                            ;       C4 C5
                                            ;       C6 A1
                                            ;       A2 A3
                                            ; IN  : A=Y mod 5 c'est à dire le numéro de ligne dans la matrice 5x2 de pixels
                                            ;       B=Parité de X
                                            ; OUT : MSKPIX_EF9345=D=La position du pixel recherché selon (Y=A,X=B) dans la matrice 5x2
                                            ;       X=ptr(tabXY2Pixel)
        ldx POINT_YX_HIRES
        jmp GR_readColorHires               ; FCT : Lit la couleur de la position d'un pixel en mode haute résolution
                                            ; IN  : X=Position Y,X selon le mode semigraphique = (Y div 5, X div 2)
                                            ;       D=Position Y,X selon la matrice 5x2 du pixel recherché
                                            ; OUT : D=La valeur des pixels (0,1) contenus dans la matrice 5x2
                                            ;       au format sm0000A2A1/A0C6C5C4C3C2C1C0
; End of function GR_getPixelHiRes

jmpPrErrorMsg_0x08_FctIncorrect_1:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC SET : pour allumer un point ou définir les couleurs
;       du mode HIRES
;   2 utilisations
;   1ère : LORES
;   CLS0:SET(X,Y,C) avec X=[0;63 ou 79] si mode 32 ou 40 colonnes
;   2ème : HIRES
;   CLS80:
;   SET* C0,C1,C2 avec C0: couleur marge [0;7],
;                      C1: couleur intensité [0..7],
;                      C2: couleur demi-intensité [0..7]
;   SET (X,Y,C) avec C=[0,1,2] (marge, intensité, demi-intensité)
; OP  : $9B
; IN  : le flot d'interprétation
; OUT : A,B,X modified

romSET:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        beq doRomSETHiRes

getXYParamDoRomSETLoRes:
        jsr OS_getXYLoRes                   ; FCT : Parse l'expression du type X,Y dans le flot d'interprétation
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ADRMEM_XY à jour
                                            ;       A,B,X modified
        pshx                                ; sauvegarde X=POS(Y/2,X/2)

doRomSETLoRes:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        pulx                                ; récupère POS(Y/2,X/2)
        cmpb #$08                           ; Est-ce que B=code couleur > 8 ?

isInf0x09:                                  ; Oui alors Erreur !
        bhi jmpPrErrorMsg_0x08_FctIncorrect_1
        decb

isEq0x00:
        bmi nextdoRomSETLoRes
        ldaa #$10                           ; TODO : D=B*16 : euh ... 4 * LSL = 8 cycles / LDA + MUL : 12 cycles
        mul                                 ; permet de calculer le code couleur à ajouter
                                            ; au caractère semi graphique pour simuler le pixel
                                            ; en LORES
        bra next1doRomSETLoRes

; ---------------------------------------------------------------------------
; entrées : B=$FF si code couleur = 0
;           B=$00 à $60 pas pas de $10 si code couleur =[1;7]
;
; Pourquoi lire deux fois la même zone mémoire ?
; Afin de gérer le code couleur = $00 qui est une
; recopie de l'attribut en position (X mod 2, Y Mod 2)
; le mode semi-graphique fait chuter la résolution de moitié
; Donc :
; X=[0..63],Y:[0..40] devient un écran de 32x20 contenant des pavés de 2x2 pixels avec 2 couleurs définissables

nextdoRomSETLoRes:
        jsr GR_getBackColor                 ; FCT : Obtient le code couleur du fond du caractère
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=unmodified
                                            ;       B=0 si caractère lu est un attribut ou un caractère
                                            ;       sinon le code caractère AND $70 (0111 0000)

next1doRomSETLoRes:
        stab EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
        jsr GR_getCharSemiGraphFromXY       ; FCT : Lit la zone mémoire  pointée  par X pour récupèrer
                                            ;       la couleur, l'attribut et le caractère
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=0 si code ASCII lu sinon valeur du caractère semi-graphique

computeCharAndColorSemiGraph:
        anda #$0F                           ; nous gardons que le caractère graphique
        oraa ADRMEM_XY                      ; nous ajoutons le pixel à allumer
        oraa EOLPNTR                        ; cela sert à beaucoup de choses : op. binaires, etc.
                                            ; nous ajoutons la couleur

enddoRomSETLoRes:
        oraa #$80                           ; bit7=1 : caractère semi-graphique
        jmp OS_PRINT                        ; FCT : Stocke à la position X=POS(Y,X) le caractère A
                                            ; IN  : A=caractère à afficher
                                            ;       X=POS (Y,X) du caractère à afficher
                                            ; OUT : A,B,X modified

doRomSETHiRes:
        jsr GR_getPixelHiRes                ; FCT : effectue l'interprétation de l'expression (X,Y
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=POS(X div 2,Y div 5)
                                            ;       D=La valeur des pixels (0,1) contenus dans la matrice 5x2
                                            ;       au format sm0000A2A1/A0C6C5C4C3C2C1C0
                                            ;       Cette valeur est stockée dans RDPIX_EF9345.
                                            ;       MSKPIX_EF9345 est mise à jour : masque d'accés au pixel (X,Y)
                                            ;       RDPIX_EF9345  est mise à jour : valeur du pixel lu en POS(X,Y)
        pshx                                ; sauvegarde X div 2 ,Y div 5
getColor:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        pulx                                ; récupère X,Y
        cmpb #$03                           ; < 3 ?
        bcc jmpPrErrorMsg_0x08_FctIncorrect_1     ; non alors erreur !
nextdoRomSETHires:
        tstb
        beq nextdoRomRESETHiRes             ; code couleur=marge ? Oui alors on eteint le point via RESET !
        ldaa RDPIX_EF9345                   ; récupération de la valeur de la zone 2x5 contenant le pixel demandé
        bmi next1doRomSETHiRes
        clr RDPIX_EF9345+1
        ldaa #$80

next1doRomSETHiRes:
        anda #$BF
        decb
        beq next2doRomSETHiRes
        oraa #$40

next2doRomSETHiRes:
        staa RDPIX_EF9345
        ldab RDPIX_EF9345+1
        oraa MSKPIX_EF9345                  ; Masque du pixel recherché en mode HIRES
        orab MSKPIX_EF9345+1                ; Masque du pixel recherché en mode HIRES
        std  RDPIX_EF9345
        jmp GR_setPixelHires                ; FCT : Allume le pixel dont la position est donnée par X
                                            ; IN  : X=(X div 2,Y div 5) position du pixel à traiter !
                                            ;       RDPIX_EF9345 contient le masque du bit à allumer
                                            ;       RDPIX_EF9345 contient le masque du bit à allumer
                                            ; OUT : A,B,X modified

; End of function doRomSET

; =============== S U B R O U T I N E =======================================
; FCT : éteint un pixel en mode LORES et HIRES
; STX : RESET (X,Y)
; OP  : $9C
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : /
romRESET:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        beq doRomRESETHiRes

doRomRESETLoRes:
        jsr OS_getXYLoRes                   ; FCT : Parse l'expression du type X,Y dans le flot d'interprétation
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ADRMEM_XY a jour
                                            ;       A,B,X modified
        jsr GR_readASCII                    ; FCT : Lit le caractère à la position (Y,X) et retourne espace
                                            ;       si attribut sinon le code ASCII du caractère
                                            ; ST  : ACTIF
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=$20 si ATTRIBUT
                                            ;       sinon CODE ASCII si A>$20 et A<=$7F
                                            ;       sinon CODE SEMI GRAPHIQUE si A>=$80
                                            ;       X unmodified
        bpl enddoRomSETLoRes                ; si c'est un caractère autre que semi-graphique alors on éteint tout car A=0 !
        com ADRMEM_XY                       ; sinon on éteint le pixel demandé !
        anda ADRMEM_XY                      ; ADRMEM_XY Position dans le pavé 2x2 de pixels en LOWRES
        jmp OS_PRINT                        ; FCT : Stocke à la position X=POS(Y,X) le caractère A
                                            ; IN  : A=caractère à afficher
                                            ;       X=POS (Y,X) du caractère à afficher
                                            ; OUT : A,B,X modified

doRomRESETHiRes:
        jsr GR_getPixelHiRes                ; FCT : récupère les paramètres X et Y dans le flot d'interprétation
                                            ;       et retourne dans D l'état des pixels dans une matrice 2 col x 5 lig
                                            ;       résolution en modes HIRES : 160  x 125
                                            ;       X=0-159 et Y=0-124
                                            ; IN  : /
                                            ; OUT : D=La valeur des pixels (0,1) contenus dans la matrice 5x2
                                            ;       au format sm0000A2A1/A0C6C5C4C3C2C1C0
                                            ;       Cette valeur est stockée dans RDPIX_EF9345.
                                            ;       X=POS(X div 2,Y div 5)
                                            ;       MSKPIX_EF9345 est mise à jour : masque d'accés au pixel (X,Y)
                                            ;       RDPIX_EF9345  est mise à jour : valeur du pixel lu en POS(X,Y)
                                            ; ERR : $08 : FC
nextdoRomRESETHiRes:
        tst RDPIX_EF9345
        bpl enddoRomRESETHiRes
        ldd  MSKPIX_EF9345                  ; 5/3
        coma                                ; 2/1
        comb                                ; 2/1
        anda RDPIX_EF9345                   ; 4/3 ; Masque du pixel recherché en mode HIRES
        andb RDPIX_EF9345+1                 ; 4/3 ; Masque du pixel recherché en mode HIRES
        std  RDPIX_EF9345                   ; 5/3 ; ===> 22 cycles / 14 cycles
        jmp GR_setPixelHires

enddoRomRESETHiRes:
        rts

; End of function doRomRESET

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC POINT(X,Y) : retourne l'état du pixel aux coordonnées (X,Y)
; STX : A=POINT(10,10)
; BUG : /
; ALG : /
; ST  : ACTIF
; OP  : $C5
; IN  : le flot d'interprétation
; OUT : ACC1 : état du pixel aux coordonnées (X,Y)
;       -1 si il y a un caractère
;       0  si il est éteint
;       Si LORES : 1 à 8 selon la couleur si allumé
;       Si HIRES : 1 à 2 si allumé
;       en HIRES :-1 (caractère),0 (éteint),1 (couleur 1=encre) ou 2 (couleur 2=marge) sous forme de word
;       en LORES :-1 (caractère),0 (éteint),1 à 8 code couleur si allumé

romPOINT:
        tst TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        beq doRomPointHiRes                 ; FCT : retourne la couleur du pixel en position (X,Y) en mode HIRES
                                            ; IN  : le flot d'interprétation contenant les paramètres sous forme (X,Y)
                                            ; OUT : retourne -1 (=$FF : caractère),0(pixel éteint),1(pixel allumé) ou 2 (couleur de la marge) sous forme de word
doRomPointLoRes:
        jsr OS_getXYLoRes                   ; FCT : Parse l'expression du type X,Y dans le flot d'interprétation
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ADRMEM_XY a jour
                                            ;       A,B,X modified
        jsr GR_readScreenAtXY               ; FCT : Lecture de la donnée à la position X=POS(Y,X)
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=Code ASCII ou $20 si ATTRIBUT ou CODE SEMI GRAPHIQUE
                                            ;       N=1 si A=CODE SEMI GRAPHIQUE
        bpl next1doRomPointLoRes
        anda ADRMEM_XY                      ; Position dans le pavé 2x2 de pixels en LOWRES
        beq nextdoRomPointLoRes
        jsr GR_readAttribAtXY               ; FCT : Lit le code ASCII à la position (Y,X)
                                            ;       EST UTILISEE DANS LE CAS OU ON RECHERCHE LE CODE COULEUR
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A=(le code ascii ou $20 SI ATTRIBUT ou CODE SEMI GRAPHIQUE) lu à la position (Y,X)
                                            ;       B=(le code ascii ou $20 SI ATTRIBUT ou CODE SEMI GRAPHIQUE) / 2 lu à la position (Y,X)
        lsrb
        lsrb
        lsrb
        andb #$07

nextdoRomPointLoRes:
        incb

next1doRomPointLoRes:
        jsr returnWordFromB                 ; FCT : Retourne un mot issu de B dans ACC1
                                            ;       range : $00 - $7F => 0000 - 007F
                                            ;               $80 - $FF => FF80 - FFFF
                                            ; IN  : B=byte to convert to signed word
                                            ; OUT : D=convInt2Word(B)
jmpIsRightParen:
        jmp CHKCLS                          ; FCT : check close parenthesis and get next char
                                            ; IN  : TXTPTR mise à jour
                                            ; OUT : X modified, A et B modified

doRomPointHiRes:
        jsr GR_getPixelHiRes                ; FCT : récupère les paramètres X et Y dans le flot d'interprétation
                                            ;       et retourne dans D l'état des pixels dans une matrice 2 col x 5 lig
                                            ;       résolution en modes  HIRES : 160 x 125
                                            ;       X=0-159 et Y=0-124
                                            ; IN  : /
                                            ; OUT : D=La valeur des pixels (0,1) contenus dans la matrice 5x2
                                            ;       Cette valeur est stockée dans RDPIX_EF9345
                                            ;       X=POS(X div 2,Y div 5)
                                            ;       MSKPIX_EF9345 est mise à jour : masque d'accés au pixel (X,Y)
                                            ;       RDPIX_EF9345  est mise à jour : valeur du pixel lu en POS(X,Y)
                                            ; ERR : $08 : FC
        ldab #$FF                           ; =$FF si la position lue contient un caractère
        tst RDPIX_EF9345
        bpl nextdoRomPointHiRes
        incb                                ; =$00 : le pixel est éteint
        pshb
        jsr GR_convPixelToXY                ; FCT : Applique le masque de recherche de pixel sur la valeur lue
                                            ;       (matrice 5x2)
                                            ; IN  : /
                                            ; OUT : D=0 si pixel eteint sinon <> 0 pour pixel allumé
        pulb
        beq nextdoRomPointHiRes
        incb                                ; =$01 : le pixel est allumé
        ldaa RDPIX_EF9345
        bita #$40                           ; Le bit [14] de RDPIX_EF9345 est-il à 1 ? oui alors c'est un pixel allumé avec la couleur de la marge ...
        beq nextdoRomPointHiRes
        incb                                ; =$02 : la couleur du bit (en fait du pavé de 5 col x 2 lignes) est celle de la marge

nextdoRomPointHiRes:
        jsr returnWordFromB                 ; FCT : Retourne un mot issu de B dans ACC1
                                            ;       range : 0x00 - 0x7F => 0000 007F
                                            ;               0x80 - 0xFF => FF80 FFFF
                                            ; IN  : B=byte to convert to signed word
                                            ; OUT : D=convInt2Word(B)
        jmp CHKCLS                          ; FCT : check close parenthesis and get next char
                                            ; IN  : TXTPTR mis à jour
                                            ; OUT : X unmodified, A et B modified

; End of function doRomPOINT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC HIRES : initialise le mode 80 colonnes
; STX : HIRES
; OP  : $9E
; ST  : WIP
; IN  : /
; OUT : /

romHIRES:
        clr REL_HIRES                       ; les coordonnées sont calculées de façon absolu
        clr CUR_POSX                        ; position du curseur en mode HIRES axe horizontal
        clr CUR_POSY                        ; position du curseur en mode HIRES axe vertical
        clr TECRAN                          ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        clr ATTRIBUTE_HIRES                 ; contient l'attribut du caractère en mode haute résolution
                                            ; Par défaut contient $00 (mode inversion) sinon $88.
                                            ; C'est un nibble donc l'attribut doit être répété 2
                                            ; fois dans l'octet (car colonne paire/impaire !)
                                            ; Sinon cela fait des effets sympas
        jsr GR_initVIDEOMode80              ; FCT : Initialise le EF9345 pour le mode 80 caractères en mode normal
                                            ;       Reconfiguration des registres + Reinitialisation des zones mémoires
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        jmp GR_initParamByMode              ; FCT : Initialisation des variables du basic utilisées pour la gestion de l'écran
                                            ; IN  : TECRAN à jour
                                            ; OUT : X,A,B modified
; End of function romHIRES

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC TEXT : initialise le mode 40 colonnes x 25 lignes
; STX : TEXT
; OP  : $9F
; ST  : ACTIF
; IN  : /
; OUT : /
romTEXT:
        ldaa #cVDP_MODE_40x25
        bra  saveAndInitLORES_TEXT
; End of function romTEXT

; =============== S U B R O U T I N E =======================================
; FCT : COMMANDE BASIC LORES : initialise le mode 32 colonnes x 16 lignes
; STX : LORES
; OP  : $A0
; ST  : ACTIF
; IN  : /
; OUT : /

romLORES:
        ldaa #cVDP_MODE_32x16
saveAndInitLORES_TEXT:
        staa TECRAN                         ; Type d'écran : 0 , 1 ,2 : 80x25, 40x25, 32x16
        jsr GR_initColorLoRes               ; FCT : Initialise la couleur de fond et d'encre par défaut
                                            ;       en mode LOW RESOLUTION
                                            ; IN  : /
                                            ; OUT : A modified
        jmp next1InitScreenSetMode40
; End of function romLORES

; =============== S U B R O U T I N E =======================================
; FCT : commande BASIC PAPER : initialise le fond de l'écran d'un écran haute résolution
;       avec la couleur donnée en paramètre
;       Il est possible de dessiner en HIRES avec deux couleurs.
;       En mode TEXT/LORES : change la couleur de la marge
; CLS 0 : noir         PAPER 0 : noir
; CLS 1 : vert         PAPER 1 : rouge
; CLS 2 : jaune        PAPER 2 : vert
; CLS 3 : bleu         PAPER 3 : jaune
; CLS 4 : rouge        PAPER 4 : bleu
; CLS 5 : blanc        PAPER 5 : magenta
; CLS 6 : cyan         PAPER 6 : cyan
; CLS 7 : magenta      PAPER 7 : blanc
; CLS 8 : orange
; STX : PAPER 4
; ALG : la couleur du fond est stockée dans le registre MAT de l'EF9345 en mode haute résolution
; OP  : $A1
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romPAPER:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
                                            ; récupération du code couleur dans le registre B

setColorRomPAPER:
        andb #$07                           ; Il y a 8 couleurs possibles !

readPreviousColorRomPaper:
        ldaa #cVDP_CMD_IND+cVDP_RD+cVDP_REG_MAT
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        staa EF9345_EXEC

writeColorRomPaper:
        ldaa EF9345_R1
        anda #$F8                           ; clear previous color
        aba                                 ; set new color
        staa EF9345_R1
        ldaa #cVDP_CMD_IND+cVDP_WR+cVDP_REG_MAT
        staa EF9345_EXEC

endRomPAPER:
        rts
; End of function romPAPER

; =============== S U B R O U T I N E =======================================
; FCT : commande BASIC INK : initialise l'encre C1 ou C2 avec le code couleur donnée en paramètre
; CLS 0 : noir         INK 0 : noir
; CLS 1 : vert         INK 1 : rouge
; CLS 2 : jaune        INK 2 : vert
; CLS 3 : bleu         INK 3 : jaune
; CLS 4 : rouge        INK 4 : bleu
; CLS 5 : blanc        INK 5 : magenta
; CLS 6 : cyan         INK 6 : cyan
; CLS 7 : magenta      INK 7 : blanc
; CLS 8 : orange
; STX : INK 4 (couleur 1 : 0 à 15) ou INK 20 (couleur 2 : 16 à 31)
; ALG : la couleur de l'encre est stockée dans le registre DOR de l'EF9345 en mode haute résolution
; OP  : $A2
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romINK:
getColorRomINK:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
doRomINK:
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        ldaa #cVDP_CMD_IND+cVDP_RD+cVDP_REG_DOR
        staa EF9345_EXEC
        ldaa EF9345_R1                      ; get current color from VDP
        cmpb #$0F
        ble setC1RomINK                     ; if lesser than 0x0F then fix color C1

setC2RomINK:
        aslb                                ; compute next color
        aslb
        aslb
        aslb
        anda #$0F                           ; cancel the previous color
        bra setCxRomINK

setC1RomINK:
        andb #$0F                           ; keep the next color
        anda #$F0                           ; cancel the previous color

setCxRomINK:
        aba                                 ; set color Cx
        staa EF9345_R1
        ldaa #cVDP_CMD_IND+cVDP_WR+cVDP_REG_DOR
        staa EF9345_EXEC

endRomINK:
        rts
; End of function romINK

; =============== S U B R O U T I N E =======================================
; FCT : Commande BASIC CURSET : positionne le curseur haute résolution à la
;       position X,Y en coordonnées absolues avec la couleur c.
;       Avec c=[0,1,2] avec 0 : couleur du fond et [1,2] : une des couleurs d'avant plan
; STX : CURSET 14,20,2
; OP  : $A4
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romCURSET:
        clr REL_HIRES
        jmp doRomSETHiRes
; End of function romCURSET

; =============== S U B R O U T I N E =======================================
; FCT : Commande BASIC CURMOV : positionne le curseur haute résolution à la
;       position X,Y relativement avec la position du curseur en utilisant la couleur c.
;       Avec c=[0,1,2] avec 0 : couleur du fond et [1,2] : une des couleurs d'avant plan
; STX : CURMOV 10,14,1
; OP  : $A5
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romCURMOV:
        sec
        rol REL_HIRES
        jmp doRomSETHiRes
; End of function romCURMOV

; =============== S U B R O U T I N E =======================================
; FCT : commande BASIC RECT : permet de tracer un rectangle avec la couleur c
;       de la position (X,Y) à la position (X1,Y1)
; STX : LINE X,Y,dX,dY,c
; OP  : $A8
; ST  : WIP
; IN  : /
; OUT : /
romRECT:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation

        stab CUR_POSX
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab CUR_POSY
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab END_POSX
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab END_POSY
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab FILL_COLOR

; X,Y,X1,Y   :  _  : X,Y,X1,Y   ==> X1,Y,X1,Y
; X1,Y,X1,Y1 :   | : X1,Y,X1,Y1 ==> X1,Y1,X1,Y1
; X,Y1,X1,Y1 :  _  : X,Y1,X1,Y1 ==> X1,Y1,X1,Y1
; X,Y,X,Y1   : |   : X,Y,X,Y1   ==> X1,Y1,X1,Y1

doRomRECT:
        ldaa CUR_POSY
        psha                                ; save Y
        ldaa CUR_POSX
        psha                                ; save X
        psha                                ; save X
        ldaa END_POSY
        psha                                ; save Y1
drawRomRECT:                                ; draw line X,Y,X1,Y
        ldaa CUR_POSY
        staa END_POSY
        jsr beforeTrtRomLINE
draw1RomRECT:                               ; draw line X1,Y,X1,Y1
        pula                                ; get Y1
        staa END_POSY
        jsr beforeTrtRomLINE
draw2RomRECT:                               ; draw line X,Y1,X1,Y1
        pula                                ; get X
        staa CUR_POSX
        jsr beforeTrtRomLINE
draw3RomRECT:                               ; draw line X,Y,X,Y1
        pula                                ; get X
        staa CUR_POSX
        staa END_POSX
        pula                                ; get Y
        staa CUR_POSY
        jmp beforeTrtRomLINE


;; X,Y,X1,Y   : Y1  :  -
;; X1,Y,X1,Y1 : X   :   |
;; X,Y1,X1,Y1 : Y   :  _
;; X,Y1,X,Y1  :     : |
;
;doRomRECT:
;        ldab CUR_POSY
;       pshb                                ; save Y
;        ldaa CUR_POSX
;       psha                                ; save X
;        ldaa END_POSY
;       psha                                ; save Y1
;drawRomRECT:                                ; draw line X,Y,X1,Y
;       stab END_POSY
;       jsr beforeTrtRomLINE
;draw1RomRECT:                               ; draw line X1,Y,X1,Y1
;       pula                                ; get Y1
;       staa END_POSY
;       ldaa END_POSX
;        staa CUR_POSX
;        jsr beforeTrtRomLINE
;draw2RomRECT:                               ; draw line X,Y1,X1,Y1
;       pula                                ; get X
;        staa CUR_POSX
;       jsr beforeTrtRomLINE
;draw3RomRECT:                               ; draw line X,Y,X,Y1
;        pula                                ; get Y
;       staa END_POSY
;       ldaa CUR_POSX
;       staa END_POSX
;       jmp beforeTrtRomLINE


; X,Y,DX,0            :  _   : DY
; X,Y,0,DY            : |    : DX
; X+DX,Y+DY,0,DY      :   |  :
; X+DX,Y+DY,DX,0      :  _



;doRomRECT:
;        ldaa END_POSX
;       psha                                ; save DX
;       psha                                ; save DX
;        ldaa END_POSY
;       psha                                ; save DY
;       psha                                ; save DY
;drawRomRECT:                                ; draw line X,Y,DX,0
;        clr END_POSY
;       jsr beforeTrtRomLINE
;draw1RomRECT:                               ; draw line X1,Y,0,DY
;       pula                                ; get DY
;       staa END_POSY
;       clr END_POSX
;        jsr beforeTrtRomLINE
;draw2RomRECT:                               ; draw line X+DX,Y+DY,0,DY
;       pulb                                ; get DY
;       ldaa CUR_POSY
;       aba
;       staa CUR_POSY                       ; save Y+DY
;        stab END_POSY
;       pulb                                ; get DX
;       ldaa CUR_POSX
;        aba
;        staa CUR_POSX                      ; save X+DX
;        clr  END_POSX
;       jsr beforeTrtRomLINE
;draw3RomRECT:                               ; draw line X+DX,Y+DY,DX,0
;        pula                                ; get DX
;       staa END_POSX
;       clr  END_POSY
;       jmp beforeTrtRomLINE

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC BOX : remplit une zone rectangulaire commençant en (X,Y)
;       et se termix²nant en (X+dX,Y+dY) avec la couleur c.
;       La zone remplie est calculée en modulo : X mod 2 et Y mod 5.
; Avec c=[0,1,2] avec 0 : couleur du fond et [1,2] : une des couleurs d'avant plan
; NOTE : PAS DE GESTION DU CLIPING !
; STX : BOX 100,100,10,20,1
; OP  : $A3
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romBOX:
        jsr getParam                        ; FCT : Récupère dans le flot d'interprétation les paramètres suivants :
                                            ;       X,Y,DX,DY,c
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : FILL_PARITE_X=X mod 1, FILL_COLOR=c, POINT_YX_HIRES+1=X/2, FILL_DX=DX, FILL_DX_SAV=DX, FILL_DY=DY
                                            ;       CUR_POSX=X, CUR_POSY=Y

controleRomBOX:
        tst FILL_DY
        beq endRomBOX
        tst FILL_DX
        beq endRomBOX

repeatRomBOX:
        ldab CUR_POSY
        ldaa #52                            ; 52 : magic number : nous remplaçons le calcul de Y div 5 par Y * 0.2
        mul                                 ; 52/256 = 0,203125 : donc l'approximation donne le bon résultat sur l'intervalle [0,63]
        staa POINT_YX_HIRES                 ; stocke Y div 5

suiteRepeatRomBOX:
        ldx POINT_YX_HIRES                  ; POINT_YX_HIRES = (Y div 5, X div 2)
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
setR1RomBox:
        ldaa #$80
        tst FILL_COLOR                      ; Si code couleur = 0 alors on éteint le pixel
        beq doSetR1RomBox
        ldaa #$FF
doSetR1RomBox:
        staa EF9345_R1                      ; $80=pixels tous éteints, $FF=pixels tous allumés
setR3RomBox:
        clra
        ldab FILL_COLOR                     ; B=$00 ou $01 ou $02
        beq doSetR3RomBox                   ;
        ldaa #$0E                           ; A=$0E
        decb                                ; B=$00 ou $01
        aba
        tst EF9345_R7
        bmi doSetR3RomBox
        asla                                ; swap des nibbles
        adca #$80
        rola
        asla
        adca #$80
        rola
doSetR3RomBox:
        staa EF9345_R3
        ldab #cVDP_CMD_KRL+cVDP_WR+cVDP_INC ; $50 : 0101/1/00/0 : KRL/WRITE/null/INC PTR
repeatXRomBOX:
        stab EF9345_EXEC
        jsr  GR_isEF9345ready               ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
        asla                                ;2 / swap nibbles
        adca #$80                           ;2
        rola                                ;2
        asla                                ;2
        adca #$80                           ;2
        rola                                ;2 : 12 cycles / 8 octets
        staa EF9345_R3
untilXRomBOX:
        dec FILL_DX
        bne repeatXRomBOX
untilRomBOX:
        dec FILL_DY
        beq endRomBOX
        ldaa CUR_POSY
        ldab #$05
        aba
        staa CUR_POSY
        ldaa FILL_DX_SAV
        staa FILL_DX
        jmp repeatRomBOX
endRomBOX:
        rts
; End of function romBOX

jmpPrintErrorMSg0x08_FC_02:
        jmp printErrorMSG_0x08_FC_FctIncorrect

;
; =============== S U B R O U T I N E =======================================
; FCT : Récupère dans le flot d'interprétation les paramètres suivants :
;       X,Y,DX,DY,c
; STX : /
; OP  : /
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : FILL_PARITE_X=X mod 1, FILL_COLOR=c, POINT_YX_HIRES+1=X/2, FILL_DX=DX, FILL_DX_SAV=DX, FILL_DY=DY
;       CUR_POSX=X, CUR_POSY=Y

getParam:

getx_getParam:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
        cmpb SCR_XMAX_PIX                   ; Taille max en pixel pour X
        bcc jmpPrintErrorMSg0x08_FC_02
        stab CUR_POSX
        clra
        lsrb                                ; B=X/2
        adca #$00
        staa FILL_PARITE_X                  ; sauvegarde si c'est une colonne paire(=0) ou impaire(=1)
        stab POINT_YX_HIRES+1               ; stocke la valeur de X div 2

getY_getParam:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        cmpb SCR_YMAX_PIX                   ; Taille max en pixel pour Y
        bcc jmpPrintErrorMSg0x08_FC_02
        stab CUR_POSY

getdX_getParam:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab FILL_DX
        stab FILL_DX_SAV

getdY_getParam:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab FILL_DY

getColor_getParam:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : /
                                            ; OUT : B=la valeur de l'expression au format "BYTE"s
        stab FILL_COLOR
endGetParam:
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC FILL : remplit une zone rectangulaire commençant en (X,Y)
;       et se terminant en (X+dX,Y+dY) avec la couleur c.
; Avec c=[0,1,2] avec 0 : couleur du fond et [1,2] : une des couleurs d'avant plan
; NOTE : PAS DE GESTION DU CLIPING !
; STX : FILL 100,100,10,20,1
; OP  : $A6
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romFILL:
        jsr getParam                        ; FCT : Récupère dans le flot d'interprétation les paramètres suivants :
                                            ;       X,Y,DX,DY,c
                                            ; STX : /
                                            ; OP  : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : FILL_PARITE_X, FILL_COLOR, POINT_YX_HIRES, FILL_DX, FILL_DX_SAV, FILL_DY
                                            ;       CUR_POSX, CUR_POSY
controleROMFILL:
        tst FILL_DY
        beq endRomBOX
        tst FILL_DX
        beq endRomBOX
repeatRomFILL:
        ldab CUR_POSY
        pshb                                ; Calcul de Y div 5 et Y mod 5
        ldaa #52                            ; 52 : magic number : nous remplaçons le calcul de Y div 5 par Y * 0.2
        mul                                 ; 52/256 = 0,203125 : donc l'approximation donne le bon résultat sur l'intervalle [0,63]
        staa POINT_YX_HIRES                 ; stocke Y div 5
        ldab #$05                           ; compute Y mod 5
        mul
        pula
        sba
        bpl suiteRepeatRomFILL
        dec POINT_YX_HIRES
        adda #$05                           ; A=Y mod 5 (utilisation par GR_convXY2NumPixel)
suiteRepeatRomFILL:
        ldx POINT_YX_HIRES                  ; POINT_YX_HIRES = (Y div 5, X div 2)
        jsr GR_setR6_MP                     ; FCT : Set MP (R6 EF9345) from logical coordinate given by X. Call GR_isEF9345ready
                                            ; IN  : X=POS(Y,X)
                                            ; OUT : A and B unmodified
                                            ;       X=POS(Y,X)
        ldab FILL_PARITE_X
        jsr GR_convXY2NumPixel              ; FCT : retourne la position du pixel en mode semi-graphique
                                            ;       Le pixel est contenu dans une zone de 2 colonnes de 5 rangées
                                            ;       C0 C1
                                            ;       C2 C3
                                            ;       C4 C5
                                            ;       C6 A1
                                            ;       A2 A3
                                            ; IN  : A=Y mod 5 c'est à dire le numéro de ligne dans la matrice 5x2 de pixels
                                            ;       B=Parité de X
                                            ; OUT : MSKPIX_EF9345=D=La position du pixel recherché selon (Y=A,X=B) dans la matrice 5x2
                                            ;       X=ptr(tabXY2Pixel)
        ldab FILL_PARITE_X                  ; Si X est impaire alors on dessine via dX1
        bne suite2repeatRomFILL
        ldab FILL_DX
        cmpb #$01                           ; Si X est paire et que dx = 1 alors on dessine via dX1 sinon via dX2
        bne  stepdX2RomFILL
suite2repeatRomFILL:
        ldd MSKPIX_EF9345
        jsr setMask
        jsr setMaskColor
        jsr setPixel
        ldaa FILL_DX
        deca
        staa FILL_DX
        cmpa #$01
        beq stepdX3RomFILL
        blt loopRomFILL
stepdX2RomFILL:
        clr FILL_PARITE_DX
        lsr FILL_DX                         ; Nous dessinons 2 pixels à la fois
        rol FILL_PARITE_DX                  ; Pour plus tard, pour dessiner le dernier pixel si nécessaire
        tst FILL_PARITE_X
        beq suitedX2ROMFILL
        dex
        dex
suitedX2ROMFILL:
        ldd  0,X
        oraa 2,X
        orab 3,X
        jsr setMask
        jsr setMaskColor
bclsuitedX2ROMFILL:
        jsr setPixel
swapNibbleX2ROMFILL:                        ; swap des nibbles
        ldaa FILL_MASK_COLOR                ; 4
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
        staa FILL_MASK_COLOR                ; 4 ==> 20 cycles / 14 octets
        ldaa MSKPIX_EF9345                  ; 4
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
        staa MSKPIX_EF9345                  ; 4 ==> 20 cycles / 14 octets
        dec  FILL_DX
        bne  bclsuitedX2ROMFILL
        tst  FILL_PARITE_DX
        beq  loopRomFILL
        bra  stepdX3RomFILL_1
stepdX3RomFILL:
        dex
        dex
stepdX3RomFILL_1:
        ldd  0,X
        jsr setMask
        jsr setPixel
loopRomFILL:
        dec FILL_DY
        beq endRomFILL
        inc CUR_POSY
        ldaa FILL_DX_SAV
        staa FILL_DX
        jmp repeatRomFILL
endRomFILL:
        rts
; End of function romFILL

;
; =============== S U B R O U T I N E =======================================
; FCT : détermine le masque d'écriture du pixel selon :
;       1 - Position impaire/paire du pixel : FILL_PARITE_X
;       2 - Code couleur : FILL_COLOR avec =0 : efface le pixel, =1 : couleur1; =2 : couleur2;
;       3 - Position impaire/paire du caractère contenant le pixel traité via le registre vidéo EF9345_R7
; STX : /
; OP  : /
; ST  : ACTIF
; IN  : D avec le masque pixel
;       FILL_PARITE_X mise à jour
;       EF9345_R7 à jour
; OUT : A, B modified
;       FILL_MASK_COLOR modified

setMask:
        tsta                                ; pour rester compatible avec SET et RESET !
        beq suiteSetMask                    ; SET et RESET utilise un masque de pixel
        asla                                ; qui n'est pas compatible avec celui attendu par
        bra suite1SetMask                   ; la commande FILL alors nous faisons des
suiteSetMask:                               ; circonvolutions pour l'utiliser !
        tstb
        bpl suite1SetMask
        asld
        lsrb
suite1SetMask:
        asla
        std MSKPIX_EF9345
        tst FILL_COLOR                      ; Si code couleur = 0 alors on éteint le pixel
        bne setComputeMaskPixel
resetComputeMaskPixel:
        coma
        comb
        stab MSKPIX_EF9345+1
setComputeMaskPixel:
        tst EF9345_R7                       ; Est-ce que nous sommes dans une position de caractère impaire ou pas ?
        bmi saveComputeMaskPixel
rollSetComputeMaskPixel:                    ; Rotation du masque (partie A de la doc EF9345, celle qui gére aussi le code couleur)
        tab                                 ;2
        rolb                                ;2
        rolb                                ;2
        rolb                                ;2
        rolb                                ;2
        aba                                 ;2 = 12 cycles pour la rotation / 9 octets
saveComputeMaskPixel:
        staa MSKPIX_EF9345
endComputeMaskPixel:
        rts
; End of function setMask

;
; =============== S U B R O U T I N E =======================================
; FCT : calcule le masque pour le code couleur en mode 80 colonnes semi-graphiques
;       1 - Position impaire/paire du pixel : FILL_PARITE_X
;       2 - Code couleur : FILL_COLOR avec =0 : efface le pixel, =1 : couleur1; =2 : couleur2;
;       3 - Position impaire/paire du caractère contenant le pixel traité : EF9345_R7
; STX : /
; OP  : /
; ST  : ACTIF
; IN  : FILL_PARITE_X, FILL_COLOR, EF9345_R7
; OUT : A, B modified
;       FILL_MASK_COLOR modified
setMaskColor:
        ldaa #$FE
        ldab FILL_COLOR
        bne setColorSetMaskColor
resetMaskColor:
        inca
        bra returnMaskColor
setColorSetMaskColor:
        decb
        beq nextSetColorSetMaskColor
        coma
nextSetColorSetMaskColor:
        tst   EF9345_R7                     ; récupère la parité en X : paire ou impaire ?
        bmi returnMaskColor
rotateColorMaskColor:
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
        asla                                ; 2
        adca #$80                           ; 2
        rola                                ; 2
returnMaskColor:
        staa FILL_MASK_COLOR
        rts
; End of function setMaskColor

;
; =============== S U B R O U T I N E =======================================
; FCT : imprime un pixel selon le masque MSKPIX_EF9345 et FILL_MASK_COLOR
; STX : /
; OP  : /
; ST  : ACTIF
; IN  : MSKPIX_EF9345 et FILL_COLOR à jour
; OUT : A, B modified

setPixel:
readKRL:
        ldaa #cVDP_CMD_KRL+cVDP_RD+cVDP_NO_INC  ; $58 : 0101/1/00/0 : KRL/READ/null/NO INC PTRor
        staa EF9345_EXEC
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
doSetPixel:
        ldaa FILL_COLOR
        deca
        beq doSetPixelColor_C0
        bpl doSetPixelColor_C1
doResetPixel:
        ldd MSKPIX_EF9345
        anda EF9345_R3
        andb EF9345_R1
        bra doResetetOrSetPixelRomFILL
doSetPixelColor_C0:
        ldd MSKPIX_EF9345
        oraa EF9345_R3
        anda FILL_MASK_COLOR
        orab EF9345_R1
        bra doResetetOrSetPixelRomFILL
doSetPixelColor_C1:
        ldd MSKPIX_EF9345
        oraa EF9345_R3
        oraa FILL_MASK_COLOR
        orab EF9345_R1
doResetetOrSetPixelRomFILL:
        stab EF9345_R1
        staa EF9345_R3
writeKRL:
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_INC ; $50 : 0101/1/00/0 : KRL/WRITE/null/INC PTR
        staa EF9345_EXEC
        jmp  GR_isEF9345ready               ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
; End of function setPixel

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC PAL : fixe la palette des caractères en mode quadrichrome
;       pas de vérficication de la cohérence de l'information fournie pour
;       positionner la palette
; STX : PAL(b)
; OP  : $XX
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romPAL:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        pshb                                ; save value

isCloseParentheseRomPAL:
        jsr CHKCLS

doRomPAL:
        pulb
        stab QUAD_PAL
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC BLK : fixe le numéro de bloc quadrichrome à utiliser (6 ou 7)
; STX : BLK(6)
; OP  : $XX
; ST  : ACTIF
; IN  : Le flot d'interprétation
; OUT : /

romBLK:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        andb #$07                           ; range from 0 to 7
        pshb                                ; save value

isCloseParentheseRomBLK:
        jsr CHKCLS

doRomBLK:
        pulb                                ; 00000 abc
        ldx #tabCnvBLK
        abx
        ldaa 0,X
        staa QUAD_BLK                       ; 00 acb 000
        rts

; Tableau de conversion du numéro de bloc en numéro de bloc attendu en mode QUADRICHROME
tabCnvBLK dc $00,$01*8,$03*8,$02*8,$04*8,$06*8,$05*8,$07*8


; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC PLOT : imprime une chaîne de caractère à la position X,Y
;       avec (X,Y)=[0,0] à [79,24] au maximum.
;        La commande peut-être utilisée suivant 3 MODES :
;           - PLOT  : mode Haute Résolution
;           - PLOTB : mode Basse Résolution en mode bichrome
;           - PLOTQ : mode Basse Résolution en mode quadrichrome
; STX : PLOT 10,10,"HELLO"
; OP  : $A7
; ST  : ACTIF
; IN  : Le flot d'interprétation avec A la valeur de l'octet qui suit la commande PLOT
; OUT : /

romPLOT:
        ldab #$FF                           ; mode Haute Résolution
        ldx  #GR_printHiRes                 ; adresse de la routine d'affichage mode Haute Résolution

isPLOTQRomPLOT:
        cmpa #$51                           ; 'Q'
        bne isPLOTBRomPLOT
        incb                                ; mode Quadrichrome
        ldx #GR_PRINTQuadri                 ; adresse de la routine d'affichage mode quadrichrome

isPLOTBRomPLOT:
        cmpa #$42                           ; 'B'
        bne nextRomPLOT
        incb                                ; mode Bichrome
        ldx #GR_PRINTBiChrome               ; adresse de la routine d'affichage en mode bichrome

nextRomPLOT:
        stab PLOT_MODE                      ; sauvegarde le mode graphique pour la fonction PLOT
                                            ; Mode graphique pour la fonction BASIC PLOT : $FF : HR, $00 : QUADRICHROME / 1 : BICHROME
        stx PLOT_JMP
        ldab #$7E                           ; Initialise la fonction de saut avec l'opcode JMP
        stab JMP_PLOT_JMP                   ;

        ; obtient X,Y
getXRomPLOT:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        cmpb SCR_LGX                        ; Taille max en pixel pour X
        bcc jmpPrintErrorMSg0x08_FC_01
        stab CUR_POSX

getYRomPLOT:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        cmpb SCR_LGY                        ; Taille max en pixel pour Y
        bcc jmpPrintErrorMSg0x08_FC_01
        stab CUR_POSY

        ; obtient le descripteur de chaine
        jsr CHKCOM
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
        jsr FRESTR                          ; FCT : Libére la zone réservée pour une chaîne de caractères
                                            ;       lors de l'interprétation du flux d'entrée
                                            ; IN  : ACC1+3 et ACC1+4 : contient le descripteur de chaîne à traiter
                                            ; OUT : X=pointeur sur la chaîne de caractères
                                            ;       B=longueur de la chaîne de caractères
        ; affichage de la chaîne
        tstb                                ; Si la chaîne à afficher est vide alors nous sortons
        beq endRomPLOT
        stab lgSTR

bclRomPLOT:
        ldaa 0,X
        inx
        pshx
        ldx CUR_POSY
        jsr JMP_PLOT_JMP
        inc CUR_POSX
        pulx
        dec lgSTR
        bne bclRomPLOT

endRomPLOT:
        rts
; End of function romPLOT

jmpPrintErrorMSg0x08_FC_01:
        jmp printErrorMSG_0x08_FC_FctIncorrect


; =============== S U B R O U T I N E =======================================
; FCT : commande BASIC LINE : permet de tracer une ligne avec la couleur c
;       de la position (X,Y) jusqu'à la position (X1,Y2)
; STX : LINE X,Y,X1,Y2,c
; OP  : $A8
; ST  : WIP
; IN  : /
; OUT : /
;; CUR_POSX, CUR_POSY
;; END_POSX, END_POXY
;; FILL_DX:                ds 1            ; Utilisée par la commande FILL
;; FILL_DY:                ds 1            ; Utilisée par la commande FILL
;; FILL_PARITE_X:          ds 1            ; Utilisée par la commande FILL
;; FILL_PARITE_DX:         ds 1            ; Utilisée par la commande FILL
;; FILL_DX_SAV:            ds 1            ; Utilisée par la commande FILL
;; FILL_COLOR:             ds 1            ; Utilisée par la commande FILL*
;; FILL_MASK_COLOR:        ds 1            ; Utilisée par la commande FILL
;; GRINCX                  ds 1
;; GRINCY                  ds 1
romLINE:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation

        stab CUR_POSX
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab CUR_POSY
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab END_POSX
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab END_POSY
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        stab FILL_COLOR

            ; int dx = x1 - x0;
            ; int incX = SGN(dx);
            ; dx = ABS(dx);
beforeTrtRomLINE:
        ldab CUR_POSX
        ldaa END_POSX
        sba
        ldab #$00
        tsta
        beq endDX
        bmi suiteDX
        incb
        bra endDX
suiteDX:
        decb
        nega                                ; dx=ABS(dx)
endDX:
        stab GRINCX
        staa FILL_DX

suiteDY:
        ; int dy = y1 - y0;
        ; int incY = SGN(dy);
        ; dy = ABS(dy);

        ldab CUR_POSY
        ldaa END_POSY
        sba
        ldab #$00
        tsta
        beq endDY
        bmi suite1DY
        incb
        bra endDY
suite1DY:
        decb
        nega                                ; dx=ABS(dx)
endDY:
        stab GRINCY
        ;anda #$7F
        staa FILL_DY

doromLINE:
testDYRomLine:
            tsta
            bne testDXRomLINE
            ;;if (dy == 0)
            ;;{
            ;;  // horizontal line
            ;;  for (int x = x0; x != x1 + incX; x += incX)
            ;;      gfx.setPixel(x, y0, c);
            ;;}
            ldab END_POSX
            addb GRINCX
            stab END_POSX
LOOPHORLINE:
            jsr setPixelLine
            ldaa CUR_POSX
            adda GRINCX
            staa CUR_POSX
            cmpa END_POSX
            bne LOOPHORLINE
            jmp endRomLINE

testDXRomLINE:
            ;;else if (dx == 0)
            ;;{
            ;;  // vertical line
            ;;  for (int y = y0; y != y1 + incY; y += incY)
            ;;      gfx.setPixel(x0, y, c);
            ;;}
            ldaa FILL_DX              ; TODO ldaa FILL_DY
            bne  OTHERLINE
            ldab END_POSY
            addb GRINCY
            stab END_POSY
LOOPVERLINE:
            jsr setPixelLine
            ldaa CUR_POSY
            adda GRINCY
            staa CUR_POSY
            cmpa END_POSY
            bne LOOPVERLINE
            jmp endRomLINE

OTHERLINE:
           ldaa FILL_DX
           cmpa FILL_DY
           blt OTHER2RomLINE
           ;;else if (dx >= dy)
           ;;{
           ;;   // more horizontal than vertical
           ;;   int slope = 2 * dy;
           ;;   int error = -dx;
           ;;   int errorInc = -2 * dx;
           ;;   int y = y0;
           ;;
           ;;   for (int x = x0; x != x1 + incX; x += incX)
           ;;   {
           ;;       gfx.setPixel(x, y, c);
           ;;       error += slope;
           ;;
           ;;       if (error >= 0)
           ;;       {
           ;;           y += incY;
           ;;           error += errorInc;
           ;;       }
           ;;   }
           ;;}
           nega
           staa GRERROR
           asla
           staa GRERRORINC
           ldaa FILL_DY
           asla
           staa GRSLOPE
           ldaa END_POSX
           adda GRINCX
           staa END_POSX
loopOTHERRomLINE:
           jsr setPixelLine
           ldaa GRERROR
           adda GRSLOPE
           staa GRERROR
           bmi suiteloopOTHERRomLINE
           ldaa CUR_POSY
           adda GRINCY
           staa CUR_POSY
           ldaa GRERROR
           adda GRERRORINC
           staa GRERROR
suiteloopOTHERRomLINE:
           ldaa CUR_POSX
           adda GRINCX
           staa CUR_POSX
           cmpa END_POSX
           bne loopOTHERRomLINE
           bra endRomLINE

OTHER2RomLINE:
            ;;else
            ;;{
            ;;  // more vertical than horizontal
            ;;  int slope = 2 * dx;
            ;;  int error = -dy;
            ;;  int errorInc = -2 * dy;
            ;;  int x = x0;
            ;;
            ;;  for (int y = y0; y != y1 + incY; y += incY)
            ;;  {
            ;;      gfx.setPixel(x, y, c);
            ;;      error += slope;
            ;;
            ;;      if (error >= 0)
            ;;      {
            ;;          x += incX;
            ;;          error += errorInc;
            ;;      }
            ;;  }
            ;;}
           ldaa FILL_DY
           nega
           staa GRERROR
           asla
           staa GRERRORINC
           ldaa FILL_DX
           asla
           staa GRSLOPE
           ldaa END_POSY
           adda GRINCY
           staa END_POSY
loopOTHER2RomLINE:
           jsr setPixelLine
           ldaa GRERROR
           adda GRSLOPE
           staa GRERROR
           bmi suiteloopOTHER2RomLINE
dbgRomLine:
           ldaa CUR_POSX
           adda GRINCX
           staa CUR_POSX
           ldaa GRERROR
           adda GRERRORINC
           staa GRERROR
suiteloopOTHER2RomLINE:
           ldaa CUR_POSY
           adda GRINCY
           staa CUR_POSY
           cmpa END_POSY
           bne loopOTHER2RomLINE

endRomLINE:
           rts
; End of function romLINE

; Tableau de paramètres permettant d'initialiser les pixel dans le registre R1 et R3 de l'EF9345
; la 1ere valeur fixe la valeur R1 : en mode 80 colonnes, on fixe le bit 7 à 1 par défaut (mode semi graphique)
; la 2ème valeur fixe la valeur du registre R3 qui contient 3 pixels et le code couleur
; F72A B C
; F72D E F
; F730
tabXY2Pixel_2:
        dc.b  $81,$00,$00  ; C0 L1 ; 0 ; 0,0 ; 1
        dc.b  $82,$00,$00  ; C1 L1 ; 1 ; 1,0 ; 2
        dc.b  $84,$00,$00  ; C2 L2 ; 2 ; 0,1 ; 4
        dc.b  $88,$00,$00  ; C3 L2 ; 3 ; 1,1 ; 8
        dc.b  $90,$00,$00  ; C4 L3 ; 4 ; 0,2 ; 16
        dc.b  $A0,$00,$00  ; C5 L3 ; 5 ; 1,2 ; 32
        dc.b  $C0,$00,$00  ; C6 L4 ; 6 ; 0,3 ; 64
        dc.b  $80,$02,$20  ; A1 L4 ; 7 ; 1,3 ; 512
        dc.b  $80,$04,$40  ; A2 L5 ; 8 ; 0,4 ; 1024
        dc.b  $80,$08,$80  ; A3 L5 ; 9 ; 1,4 ; 2048


setPixelLine:
XX_setPixel:
XX_SetY:
        ldab CUR_POSY
        clra
XX_SetY_MOD5:                               ; Mode HIRES : mode semi-graphique avec résolution 160x125
        inca                                ; par contre X=[0;79] et Y=[0;24]
        subb #$05
        bpl XX_SetY_MOD5
        deca
        addb #$05                           ; B=Y mod 5
        psha                                ; A=Y div 5

XX_convXY2NumPixel:
        ldaa CUR_POSX
        anda #$01                           ; B=parite de X
        aslb                                ; A=(Y mod 5) * 2
        aba                                 ; A=(Y mod 5) * 2 + (0 ou 1)
        ldx #tabXY2Pixel_2
        tab                                 ; B=(Y mod 5) * 2 + (0 ou 1)
        aslb                                ; B=((Y mod 5)* 2 + (0 ou 1))*2
        aba
        tab                                 ; B=((Y mod 5)* 2 + (0 ou 1))*3
        abx
        jsr GR_isEF9345ready                ; FCT : test if EF9345 is ready
                                            ; IN  : /
                                            ; OUT : A,B,X unmodified
XX_computeMP_EF9345:
        pula                                ; Get Y div 5
        ldab CUR_POSX
        lsrb                                ; X=X div 2
        addd SCR_MARGEXY
        tsta
        beq nextXX_computeMP_EF9345
        adda #$07                           ; ajoute 7 si le numéro de ligne > 0 (ah ! La joie du EF9345 ...)

nextXX_computeMP_EF9345:
        lsrb                                ; B=B/2 : numéro de colonne / 2 car mode 80 colonnes
        bcc save_R6_EF9345
        addb #$80                           ; B=B+$80 si colonne impaire
save_R6_EF9345:
        std EF9345_R6
        ldaa #cVDP_CMD_KRL+cVDP_RD+cVDP_NO_INC  ; $58 : 0101/1/00/0 : KRL/READ/null/NO INC PTR
        staa EF9345_EXEC

setPixelAndColor:
        ldaa 0,X                            ; get Pixel to set
        ldab FILL_COLOR
        beq resetCandAX
        oraa EF9345_R1                      ; A or read C (EF9345)
        staa EF9345_R1                      ; set pixel and set bit 7 to 1

setColorAndAx:
        decb                                ; le code couleur passe de [1;2] à [0;1]
setAx:
        ldaa 1,X                            ; get param for pixel A3,A2,A1 for right quartet
        tst EF9345_R7                       ; Test la parité de X afin d'initialiser correctement le code couleur
        bmi beforeSaveR3                    ; Si paire alors on fait un décalage des valeurs
        ldaa 2,X                            ; get param for pixel A3,A2,A1 for left quartet
        oraa EF9345_R3                      ; new value of A OR old valuere of A (previous color and value of pixel A3,A2, A1) from EP9345
        anda #$EF                           ; reinitialise le code couleur
        lslb
        lslb
        lslb
        lslb                                ; décalage d'un quartet à gauche de la couleur (0/1)
        bra saveR3
beforeSaveR3:
        oraa EF9345_R3                      ; new value of A OR old valuere of A (previous color and value of pixel A3,A2, A1) from EP9345
        anda #$FE                           ; sinon on initialise le bit D du quarter à droite
saveR3:
        aba                                 ; on initialise le code couleur
        staa EF9345_R3                      ; met à jour le code couleur  (binaire : 0 ou 1) !

doSetPixelAx:
        ldaa #cVDP_CMD_KRL+cVDP_WR+cVDP_NO_INC  ; $50 : 0101/1/00/0 : KRL/WRITE/null/NO INC PTR
        staa EF9345_EXEC                    ; on initialise le pixel et le code couleur
        rts

resetCandAX:
resetC:
        coma
        anda EF9345_R1                      ; reset pixel
        oraa #$80
        staa EF9345_R1                      ; set pixel and set bit 7 to 1
resetAx:
        ldaa 1,X
        tsta
        beq doSetPixelAx                    ; Si le pixel allumé ne concerne pas les pixels Ax alors on finalise l'action
        tst EF9345_R7                       ; Test la parité de X dans R7 car les pixels A3,A2,A1
                                            ; ne sont pas au même endroit dans R3 !
        bmi doResetAx                       ; Si paire alors on fait un décalage des valeurs
        ldaa 2,X
doResetAx:
        coma
        anda EF9345_R3
        staa EF9345_R3
endResetAX:
        bra doSetPixelAx

;;;;;;;;;;             setpixel(first_x,first_y,state)
;;;;;;;IN
;;;;;;; LINE_COLOR=color
;;;;;;; first_x
;;;;;;; first_y
;;;;;;;
;;;;;;; First step:
;;;;;;;  Get X mod 2, Y mod 5 from first_x
;;;;;;;  current_pixel=read_pixel from (X mod 2, Y mod 5)
;;;;;;;  mask_pixel=compute_mask_pixel from (X mod 2, Y mod 5)
;;;;;;;  si color = background color = erase pixel ==> new_pixel = current_pixel & mask_pixel
;;;;;;;  sinon
;;;;;;;       ...
;;;;;;;  put_pixel(X mod 2, Y mod 5)
;;;;;;;  INC(X mod 2)
;;;;;;;  INC(Y mod 5)

jmpPrintErrorMSg0x08_FC_04:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC CARG : permet de définir un caractère redfinissable en
;       quadrichromie haute résolution
;       avec z : le numéro de bloc 0 (bloc 6) ou 1 (bloc 7) où le caractère est redéfini
;            c : le numéro de caractère redéfini de 0 à 3 et 32 à 128 : 4 + 96 = 100
;            WWXXYYZZAABBCCDDEEFF : le code hexadécimal de la redéfinition
; STX : CARG z,c,"0F2DBDEF12569AEEFF00"
; BUG : ne vérifie pas les valeurs des différents champs
; OP  : $AB
; ST  : WIP
; IN  : Le flot d'interprétation
; OUT : /

romCARG:
        ; obtient z
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        pshb


        ; obtient c
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : /
                                            ; OUT : B=la valeur de l'expression au format "BYTE"s

                                            ; Le prochain paramètre est-il un début de chaîne ?
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #cBAS_SEP_STR
        bne jmpPrintErrorMSg0x08_FC_04

computParamEF9345RomCARG:
        ; Mise à jour de AP (auxiliary Pointer) stocké dans R4/45 de l'EF9345
        ; Calculer la valeur des registres R4/R5/R6 afin de stocker la description du caractère
        ; avec c= numero de caractère
        ; avec Z= numero de bloc : valeurs possibles  0 à 1 qui représentent les blocs mémoires vidéos 6 et 7
        ; 0000 0110 / 0000 0111 == Z3 = 0,Z2=1, Z0,Z1=[01;11]
        ; y=R4= xxxx Z2 C6C5C4C3C2
        ; x=R5= Z0Z1 YYYYYYYY C1C0 avec YYYYYYYYYY entre 0 et 9 : numéro du slice (= ligne du carctère redéfini)
        ; R6= xxZ3xxxx xxxxxxxx : ici Z3=0 car mémoire vidéo de 8 Ko
        tba                                 ; A=0  C6C5C4C3C2C1C0 / sauvegarde pour la mise à jour de R5
        lsra                                ; A=00   C6C5C4C3C2C1
        lsra                                ; A=000    C6C5C4C3C2
        oraa #$20                           ; A=001    C6C5C4C3C2 ; Met le bit 5 de R4 =Z2 à 1
        jsr GR_isEF9345ready
        staa EF9345_R4
        andb #$03                           ; ne garde que les C1 et C0
        pula                                ; récupère le numéro de bloc : 0 = Q6 ou 1 = Q7
        lsra
        rora                                ; 0000000[Z0] ==> [Z0]0000000
        oraa #$40                           ; force le bit 6 de R5 = Z1 à 1 === > [Z0]1 0000 00
        aba                                 ; ajoute C1C0 === > [Z0]1 0000 C1C0
        staa EF9345_R5
        ldaa #(cVDP_CMD_OCT+cVDP_WR+cVDP_USE_AUX+cVDP_NO_INC)
                                            ; $34(0011 0 1 0 0) : OCT/Write/AuxiliaryPtr/null/NoInc
        staa EF9345_R0

                                            ; écrit la nouvelle description du caractère dans la mémoire de l'EF9345
bclRomCARG:
                                            ; Obtient les données concernant la nième ligne du caractère
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #cBAS_SEP_STR
        beq endRomCARG
        suba #$30                           ; range $30-$4F --> $00-$1F
        cmpa #$09+1
        bcs nextRomCARG
        suba #$06+1                         ; range $11-$1F --> $0A-$0F
nextRomCARG:
        asla
        asla
        asla
        asla
        psha                                ; sauvegarde du nibble hexadécimal
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        cmpa #cBAS_SEP_STR
        beq end1RomCARG
        suba #$30
        cmpa #$09+1
        bcs next1RomCARG
        suba #$06+1

next1RomCARG:
        pulb                                ; récupération du nibble hexadécimal
        aba                                 ; fusion des nibbles hexadécimaux
        staa EF9345_R9                      ; R9 : DATA to store private MEM video
        jsr GR_isEF9345ready
        ldaa #$04                           ; incrémentation de la nieme ligne +1 du caractère
        adda EF9345_R5
        staa EF9345_R5
        bra bclRomCARG
end1RomCARG:
        pula
endRomCARG:
        jmp CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
; End of function romCARG

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WORD : permet de lister tous les mot-clés du BASIC
; STX : WORD
; BUG : ?
; OP  : $AB
; ST  : WIP
; IN  : /
; OUT : /

romWORD:
        ldx #aFOR
bclRomWORD:
        ldaa 0,x
        beq endRomWORD
        bpl nextRomWord
        anda #$7F
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        ldaa #$2C                           ; ','
nextRomWord:
        jsr OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified
        inx
        jmp bclRomWORD
endRomWORD: ldaa #$08                       ; Back space pour supprimer le dernier ',' intempestif
        jmp OS_printCHARByDevice            ; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
                                            ; IN  : A=char to print
                                            ; OUT : A modified
                                            ;       X,B unmodified


; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WORD : permet de décrementer unitairement une variable
; STX : WORD
; BUG : Ne teste pas si la variable à décrementer est vraiment du type numérique
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /

romDEC:
        ldaa #$FF
        staa flgTYPINC
        bra doRomINC

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WORD : permet d'incrémenter unitairement une variable
; STX : WORD
; BUG : Ne teste pas si la variable incrémentée est vraiment du type numérique
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /

romINC:
        clr flgTYPINC

doRomINC:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        ldaa NUMTYP                         ; $00:int, $FF : float
        bne doFloatRomINC

doIntRomINC:
        ldd 3,X
        tst flgTYPINC
        bne nextIntRomINC
        addd #$0001
        bra endIntRomINC
nextIntRomINC:
        addd #$FFFF
endIntRomINC:
        std 3,X
        rts

doFloatRomINC:
        pshx                                ; sauvegarder le pointeur de la variable pour l'action puis le stockage
        pshx
        ldx #cONE
        tst flgTYPINC
        beq nextFloatRomINC
        ldx #cNEGONE
nextFloatRomINC:
        jsr MOVFM                           ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified
        pulx
        jsr FADD                            ; FCT : Add constant to ACC1
                                            ; STX : /
                                            ; ALG : /
                                            ; ST  : ACTIF
                                            ; IN  : X=pointer on constant
                                            ; OUT : ACC1=ACC1 + constant given
        pulx
        jmp MOVMF

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WORD : permet d'échanger le contenu de deux variables
; STX : WORD
; BUG : Ne teste pas si les deux variables ne sont pas du même type
; ALG : SWAP A,B : PTR(A), B -> ACC1, A -> B, ACC1 -> B
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romSWAP:
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        stx FORPNT
        ldd 0,X
        std ACC1
        ldd 2,X
        std ACC1+2
        ldaa 4,X
        staa ACC1+4
        jsr CHKCOM
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        pshx
        ldd 0,X
        std ACC2
        ldd 2,X
        std ACC2+2
        ldaa 4,X
        staa ACC2+4
        ldx FORPNT
        ldd ACC2
        std 0,X
        ldd ACC2+2
        std 2,X
        ldaa ACC2+4
        staa 4,X
        pulx
        ldd ACC1
        std 0,X
        ldd ACC1+2
        std 2,X
        ldaa ACC1+4
        staa 4,X
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC FALSE : retourne 0 dans ACC1
; STX : WORD
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : ACCA=0 sous forme d'un entier
romFALSE:
        clrb
        jmp returnByteIntRomLEN             ; FCT : MOVE memory to ACC1
                                            ; IN  : X=FLOAT (5 bytes)
                                            ; OUT : A unmodified, B and X modified

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC TRUE
; STX : WORD
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romTRUE:
        ldaa #$FF
        staa ACC1+3
        staa ACC1+4
        staa ACC1+5                         ; -1
        inca
        staa ACC1TYPFLG                     ; return an integer
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC REPEAT
; STX : REPEAT
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romREPEAT:
        bne errRomREPEAT
        ldaa #$03
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        ldx TXTPTR
        pshx
        ldx CURLIN
        pshx
        ldaa #cBAS_TOKEN_REPEAT
        psha
        jmp NEWSTT
errRomREPEAT:
        jmp setError0x02_SYNTAXERROR

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC UNTIL - Mettre la commande UNTIL en première position d'une ligne
;       pour éviter les effets de bord avec d'autres commandes (IF ... THEN ... ELSE)
; STX : 5 A=0
;       10 REPEAT
;       20 INC A
;       30 UNTIL A=1
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romUNTIL:
        jsr FNDFOR                          ; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
                                            ; IN  : /
                                            ; OUT : A=0 : Token FOR trouvé
                                            ;       A=2 : Token GOSUB trouvé
                                            ;       V et C =0
                                            ;       Z=1 si A est null
                                            ;       N=1 si A est négatif
                                            ;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
        cmpa #(cBAS_TOKEN_REPEAT-cBAS_TOKEN_FOR)   ; Dans la pile y-a-t-il un REPEAT ?
        bne errRomUNTIL
        jsr FRMEVL                          ; Evaluation de l'expression qui suit le UNTIL
                                            ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jourx
        tsx                                 ; Récupération du pointeur sur les données de paramétrage de la boucle
        ldaa ACC1
        beq loopRomUNTIL                    ; Si l'évalution est fausse (=$00) alors on reboucle vers les instructions suivant le REPEAT

endRomUNTIL:
        ldab #$07                           ; sinon on nettoie la pile et la boucle REPEAT ... UNTIL est terminée
        abx
        txs
        rts

loopRomUNTIL:
        ldd 3,x                             ; on positionne le flot d'interprétation sur l'instruction qui suit le REPEAT
        std CURLIN
        ldd 5,x
        std TXTPTR
        pulx
        jmp NEWSTT                          ; exécution de l'instruction qui suit / TODO : pulx+jmp NEXSTT remplacé par rts ?

errRomUNTIL:
        ldab #cBAS_ERR_NOREPEAT
        jmp ERROR

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WHILE
; STX : 10 A=0
;       20 WHILE A < 10
;       30 PRINT A : INC A
;       40 WEND
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romWHILE:
        ldaa #$03                           ; Avons-nous 6 (3*2) octets de libre dans la pile ?
        jsr CHKMEM                          ; FCT : vérifie s'il y a 2*B + $3A octets libres
                                            ; IN  : B=Nombre d'octets / 2 nécessaires, STREND à jour, POINTEUR DE PILE S à jour
                                            ; OUT : D=pointeur après ajout de 2*B + $3A octets
        ldx TXTPTR                          ; Oui alors on évalue l'expression qui suit le WHILE

entryRomWHILE:
        pshx                                ; Sauvegarde de la position de l'expression associée à WHILE
        jsr FRMEVL
        ldaa ACC1
        beq endRomWHILE                     ; Si ce n'est pas égle à 0 alors nous exécutons les instructions situées entre le WHILE et WEND

loopRomWHILE:
        ldx CURLIN
        pshx
        ldaa #cBAS_TOKEN_WHILE
        psha

loop1RomWHILE:
        jmp NEWSTT                          ; Exécution de la prochaine instruction suivant while [condition]


endRomWHILE:                                ; Il faut sortir de la boucle WHILE donc on cherche le WEND associé soit sur la même ligne
                                            ; soit en première position sur une des lignes suivantes
        pulx                                ; nous sortons du while donc nous n'avons plus besoin de la position de l'expression associée à WHILE

searchWENDOnCurrentLine:
        jsr DATAN                           ; FCT : skip to end of statement ":" or null
                                            ; IN  : TXTPTR is set
                                            ; OUT : X=pointer on end of statement ":" or null
                                            ;       A,B, modified
        inx
        tsta
        beq searchWENDAtBeginningLine       ; Si fin de ligne alors on va chercher sur la ligne suivante

nextSearchWendOCurrentLine:
        ldab #cBAS_TOKEN_WEND               ; Le token WEND recherché
        jsr entryREMN                       ; token WEND sur la même ligne que le while ?
        inx
        stx TXTPTR                          ; mise à jour du pointeur sur le flot d'interprétation
        tsta
        beq end2RomWHILE                    ; Fin de la ligne donc le wend n'est pas sur la même ligne que le while
        tst 1,X                             ; Est-ce que c'est la fin du programme ?
        beq end3RomWHILE                    ; oui on sort : TODO : peut-être sortir en erreur car un while sans wend en fin de programme ...
        rts                                 ; non donc il y des instructions à la suite du WEND

searchWENDAtBeginningLine:
        ldab #cBAS_TOKEN_WEND               ; TODO (nécessaire ?) : Le token recherché

end1RomWHILE:
        cmpb 4,x                            ; on recherche le token WEND
        beq end2RomWHILE
        ldx 0,x
        bra end1RomWHILE
end2RomWHILE:                               ; Token WEND trouvé
        ldd 2,x                             ; récupération du numéro de ligne BASIC qui contient WEND
        std CURLIN
        ldx 0,x                             ; On récupère l'offset de la prochaine ligne
        dex                                 ; on soustrait d'une unité pour avoir l'octet de fin de ligne du WEND
        stx TXTPTR                          ; sauvegarde pour l'exécution à la ligne suivante ...
end3RomWHILE:
        rts


; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC WEND - La commande doit être en première position d'une ligne
;       car la fonction de recherche parcourt la premère position de chaque ligne
; STX : 10 A=0
;       20 WHILE A < 10
;       30 PRINT A : INC A
;       40 WEND
; BUG : ?
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romWEND:
        jsr FNDFOR                          ; FCT : RECHERCHE DANS LA PILE SI LE TOKEN FOR EXISTE
                                            ; IN  : /
                                            ; OUT : A=0 : Token FOR trouvé
                                            ;       A=2 : Token GOSUB trouvé
                                            ;       V et C =0
                                            ;       Z=1 si A est null
                                            ;       N=1 si A est négatif
                                            ;       X  : est le pointeur sur le paramétrage du token recheché dans la pile
        txs
        cmpa #(cBAS_TOKEN_WHILE-cBAS_TOKEN_FOR)    ; Si le premier token trouvé n'est pas WHILE alors erreur
        bne errRomWHILE
        pula                                ; le numéro de ligne du WHILE et la position de la première instruction
        pulx                                ; qui suit le WHILE
        stx CURLIN
        pulx
        stx TXTPTR
        jmp entryRomWHILE                   ; Et on exécute la condition associée au while ...

errRomWHILE:
        ldab #cBAS_ERR_NOWHILE
        jmp ERROR

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC DEF
; STX : 10 DEF FN AT(X)=X-2
; BUG : ?
; ALG :
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romDEF:
        jsr CHKFN                           ; FCT : check token FN and get next char
                                            ; IN  : TXTPTR mis à jour
                                            ; OUT : X modified, A et B modified
        jsr CHKOPN
        jsr PTRGET                          ; get VARIABLE
        stx struct_FN+1
        ;TODO jsr CHKNUM
        jsr CHKCLS
        ldab #cBAS_TOKEN_egal               ; $AF : token EQUAL
        stab struct_FN
        jsr SYNCHR                          ; FCT : UNLESS CHAR AT TXTPTR=(B), SYNTAX ERROR
                                            ; IN  : B=Opcode ou caractère à comparer
                                            ; OUT : X : not modified
                                            ;       A : le caractère suivant l'opcode ou caractère à comparer
                                            ;           si la comparaison de l'opcode est OK
        ldx TXTPTR
        stx struct_FN+3
        jmp romDATA

; =============== S U B R O U T I N E =======================================
; FCT : Command BASIC FN
; RMQ : TODO - Vérification du type /Interdire le mode direct
; STX : 10 DEF FN(X) = X-2
;       20 PRINT FN(8)
; BUG : ?
; RMQ : TODO : A RETRAVAILLER - Ajout gestion variable integer
; ALG : /
; OP  : $XX
; ST  : WIP
; IN  : /
; OUT : /
romFN:
        jsr CHKFN                           ; FCT : check token FN and get next char
                                            ; IN  : TXTPTR mis à jour
                                            ; OUT : X modified, A et B modified
        jsr PARCHK                          ; Evaluation of parameter
        ldx struct_FN+1
        jsr MOVMF                           ; Sauvegarde de l'évaluation du paramètre dans la variable définie lors de la définition
        ldx TXTPTR
        pshx
        ldx struct_FN+3                     ; Récupère le pointeur sur la définition de la fonction
        stx TXTPTR
        jsr FRMNUM                          ; FCT : EVALUATE THE EXPRESSION AT TXTPTR, LEAVING THE RESULT IN ACC1.
                                            ;       WORKS FOR BOTH STRING AND NUMERIC EXPRESSIONS.
                                            ; ALG : Utilise une pile pour stocker les calculs intermédiaires
                                            ;       X est le pointeur sur l'expression à interpréter
                                            ;       A et B contiennent les priorités des expressions en cours de traitement
                                            ; IN  : TXTPTR : pointe sur l'expression à évaluer
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
                                            ;       NUMTYP et STRTYP à jour
        pulx
        stx TXTPTR                          ; Récupération du pointeur d'évaluation du flux
        rts

; =============== S U B R O U T I N E =======================================
; FCT : Envoie un 1 sur le port imprimante
; IN  : B=1 to send printer
; OUT : X modified

OS_send0x01toPrinter:
        ldab #$01
; End of function OS_send0x01toPrinter


; =============== S U B R O U T I N E =======================================
; FCT : Envoie un bit sur le port2
; IN  : B=bit (O or 1) to send printer
; OUT : X modified

OS_send0xXXtoPrinter:
        stab PORT2                          ; Port I/O soit pour RS232 soit pour K7
        bsr .+2
        ldx BAUDRATE_PRT
        bra jmpBclTempo
; End of function OS_send0xXXtoPrinter


; =============== S U B R O U T I N E =======================================
; FCT : effectue une tempo de X µsecondes
; IN  : TEMPO_PRT doit être à jour
; OUT : /

doTEMPO:
        ldx TEMPO_PRT
jmpBclTempo:
        jmp bclTempo
; End of function doTEMPO


; =============== S U B R O U T I N E =======================================
; FCT : Imprime un caractère sur le dispositif sélectionné par DEVNU
; IN  : A=char to print
; OUT : A modified
;       X,B unmodified
;OPT  : 25/06/2021 : a été optimisé inversion des pshx/pshb
;       + appel de nextOS_printCHAR au lieu de OS_printCHAR
;       + suppression de pshx/pshb pour optimisation
;       + déplacement du code + ...

OS_printCHARByDevice:
        pshx
        pshb
        tst DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        beq screen_OS_printCHARByDevice
        bmi printer_OS_printCHARByDevice

buffer_OS_printCHARByDevice:
        ldab strPARSE_POS
        cmpb #$7F
        beq endbuffer_OS_printCHARByDevice
        ldx #strPARSE_BUFFER
        abx
        inc strPARSE_POS
        staa 0,x
endbuffer_OS_printCHARByDevice:
        pulb
        pulx
        rts

printer_OS_printCHARByDevice:
        psha                                ; sauvegarde du caractère pour utilisation ultérieur
        tab
        tpa
        psha
trapEmulateurAlice:
        sei
        tba

waitdoOS_printCHARByDevice_PRINTER:
        ldab PORT2                          ; Port I/O soit pour RS232 soit pour K7
        andb #$04
        bne waitdoOS_printCHARByDevice_PRINTER
        bsr OS_send0x01toPrinter            ; FCT : Envoie un 1 sur le port imprimante
                                            ; IN  : B=1 to send printer
                                            ; OUT : X modified
        clrb
        bsr OS_send0xXXtoPrinter            ; FCT : Envoie un bit sur le port2
                                            ; IN  : B=bit (O or 1) to send printer
                                            ; OUT : /
        ldab #$08

bcldoOS_printCHARByDevice_PRINTER:
        pshb
        clrb
        lsra
        rolb
        bsr OS_send0xXXtoPrinter            ; FCT : Envoie un bit sur le port2
                                            ; IN  : B=bit (O or 1) to send printer
                                            ; OUT : /
        pulb
        decb
        bne bcldoOS_printCHARByDevice_PRINTER
        bsr OS_send0x01toPrinter            ; FCT : Envoie un 1 sur le port imprimante
                                            ; IN  : B=1 to send printer
                                            ; OUT : X modified
trapEmulateurAlice_2:
        pula
        tap
        pula
        cmpa #cOS_CR                        ; $0D
        beq next1doOS_printCHARByDevice_PRINTER
        inc CURX_PRT
        ldab CURX_PRT
        cmpb XMAX_PRT                       ; WORD :
                                            ; Max X for cursor on PRINTER
                                            ; Position X for cursor on PRINTER
        bcs enddoOS_printCHARByDevice_PRINTER

next1doOS_printCHARByDevice_PRINTER:
        clr CURX_PRT
        bsr doTEMPO                         ; FCT : effectue une tempo de X secondes
        bsr doTEMPO                         ; FCT : effectue une tempo de X secondes

enddoOS_printCHARByDevice_PRINTER:
        pulb
        pulx
        rts

screen_OS_printCHARByDevice:
        ldx CURAD_YX

isCHR0X08_BackSpace:
        cmpa #cOS_BS                        ; $08 : backspace
        bne isCR

doCHR0X08_BS:                               ; Position de l'écran en haut à gauche =(0,0)
        cpx HOME_YX
        beq endPrintCHAR
        jsr GR_decCursor                    ; FCT : décremente de 1 la position X,Y donnée par le registre X
                                            ; IN  : X=La position (X,Y)
                                            ; OUT : X=X-1 en position (X,Y)
                                            ;       A et B not modified
        ldaa #cOS_SPACE                     ; ' '
        jsr OS_PRINT                        ; FCT : Stocke à la position X(Y,X) le caractère A
                                            ; IN  : A=caractère à afficher
                                            ;       X=POS (Y,X) du caractère à afficher
                                            ; OUT : A,B,X modified
        bra storeCurADPrintCHAR

isCR:
        cmpa #cOS_CR
        bne isSPACE

doIsCR:
        ldd CURAD_YX
        clrb
        inca
        std CURAD_YX
        cmpa SCR_LGY                        ; Taille max en pixel pour Y
        bne endPrintCHAR
        jsr GR_scrollUp                     ; FCT : Exécute un scrolling vers le haut de l'écran
                                            ;       La dernière ligne de l'écran est effacée
                                            ; ALG : Déplacement le ligne L+1 vers la ligne L via EF9345
                                            ; IN  : /
                                            ; OUT : A et B unmodified
                                            ;       X modified
nextDoIsCR:
        bra storeCurADPrintCHAR

isSPACE:
        cmpa #cOS_SPACE                     ; ' '
        bcs endPrintCHAR
        jsr OS_PRINT                        ; FCT : Stocke à la position X(Y,X) le caractère A
                                            ; IN  : A=caractère à afficher
                                            ;       X=POS (Y,X) du caractère à afficher
                                            ; OUT : A,B,X modified
        jsr GR_incXScrollUp                 ; FCT : Incrémente de 1 la position du curseur à l'écran
                                            ;       et effectue un défilement vers le haut si nécessaire
                                            ; IN  : X=pos(Y,X)
                                            ; OUT : X=pos(Y,X+1) + scrollup si nécessaire

storeCurADPrintCHAR:
        stx CURAD_YX

endPrintCHAR:
        pulb
        pulx
        rts
; End of function OS_printCHARByDevice


; =============== S U B R O U T I N E =======================================
; FCT : Initialise le paramétrage des abscisses pour le device (DEVNU=0: écran sinon imprimante)
; IN  : DEVNU Initialisé : =$00  écran sinon imprimante
; OUT : A,B,X unmodified
; OPT : /

doinitParamByMode:
        pshx
        pshb
        psha
        ldaa DEVNU                          ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        beq nextDoinitParamByMode

doInitPrinter:
        ldx MARGIN_PRT                      ; DEFAUT : MARGE GAUCHE : $10 MARGE DROITE : $70
        ldd XMAX_PRT                        ; WORD :
                                            ; Max X for cursor on PRINTER
                                            ; Position X for cursor on PRINTER
        bra next1DoinitParamByMode

nextDoinitParamByMode:
        ldab CURAD_YX+1
        ldx SCR_MARGIN                      ; défaut pour 32x16:$10=16:80x25:$10=16
        ldaa SCR_XMAX                       ; longueur d'un écran
        nop                                 ; TODO Pourquoi un NOP ?

next1DoinitParamByMode:
        stx DEVXMARGIN                      ; Marge GAUCHE/DROITE pour les tabulations
                                            ; CLS 81  : $10,$40
                                            ; CLS 40  : $10,$10
                                            ; CLS 32  : $10,$10
                                            ; PRINTER : $10,$70
        stab DEVXCURR                       ; vaut $00 à l'init
        staa DEVXMAX                        ; vaut 32,40 ou 80
        pula
        pulb
        pulx
        rts
; End of function doinitParamByMode


jmpPrErrorMsg_0x08_FctIncorrect:
        jmp printErrorMSG_0x08_FC_FctIncorrect

; =============== S U B R O U T I N E =======================================
; FCT : Parse l'expression du type X,Y dans le flot d'interprétation
; ALG : /
; STX : /
; OPT : TODO : à optimiser
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : ADRMEM_XY à jour
;       X=POS(Y/2,X/2)
;       A,B modified

OS_getXYLoRes:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        cmpb SCR_XMAX_PIX                   ; Taille max en pixel pour X
        bcc jmpPrErrorMsg_0x08_FctIncorrect
        pshb                                ; sauve le premier paramètre (X)

getY_OS_getXYLoRes:
        jsr getByteAfterComma               ; FCT : Retourne la valeur de l'expression après la
                                            ;       virgule contenue dans le flot d'interprétation
                                            ; IN  : Le flot d'interprétation
                                            ; OUT : B=la valeur de l'expression au format "BYTE"
        cmpb SCR_YMAX_PIX                   ; Taille max en pixel pour Y
        bcc jmpPrErrorMsg_0x08_FctIncorrect
        tba                                 ; A=POS(Y)
        pulb                                ; B=POS(X)
        pshb                                ; X -> S[]
        psha                                ; Y -> S[]
        asra                                ; A=POS(Y)/2
        asrb                                ; B=POS(X)/2
        addd HOME_YX                        ; Position de l'écran en haut à gauche =(0,0)
        pshb                                ; X/2,Y,X ->S[]
        psha                                ; Y/2,X/2,Y,X ->S[]
        pulx                                ; X=Y/2,X/2 ==> TDX en fait !
        pula                                ; A=POS(Y)
        pulb                                ; B=POX(X)
        anda #$01                           ; 0:Ligne paire;1:Ligne impaire
        rorb                                ; B=X/2 AND C=bit 0 of X
        rola                                ; A=Parite(Y)*2+(parité de X)
        ldab #$10                           ; B=$10
bclOS_getXYLoRes:
        lsrb
        deca
        bpl bclOS_getXYLoRes                ; ==> Tout cela pour obtenir la position du pixel
                                            ; dans un pavé 2x2 (représentation de l'écran basse résolution)
        stab ADRMEM_XY                      ; Position dans le pavé 2x2 de pixels en LOWRES
        rts
; End of function OS_getXYLoRes

; =============== S U B R O U T I N E =======================================
; FCT : Retourne un mot issu de B dans ACC1
;       range : $00 - $7F => 0000 007F
;               $80 - $FF => FF80 FFFF
; IN  : B=byte to convert to signed word
; OUT : D=convInt2Word(B)
;       ACC1=convInt2Word(B)

returnWordFromB:
        clra
        tstb
        bpl jmpReturnWord
        coma

jmpReturnWord:
        jmp convUnsignedWordToACC1          ; FCT : Convert Word to Float
                                            ; IN  : D=number to convert
                                            ; OUT : ACC1=float(D)
; End of function returnWordFromB

; ---------------------------------------------------------------------------
; FCT : Efface l'écran soit
;       - avec la couleur courante
;       - avec le code couleur fourni en paramètre [0-8]
; cls 0 : noir
; cls 1 : vert
; cls 2 : jaune
; cls 3 : bleu
; cls 4 : rouge
; cls 5 : blanc
; cls 6 : cyan
; cls 7 : magenta
; cls 8 : orange
; STX : CLS [0-8] avec [0-8] : couleur du fond d'écran
; OP  : $9D
; ST  : ACTIF
; IN  : /
; OUT : A,B,X : modified

romCLS:
        beq GR_CLRSCR                       ; FCT : GR_CLRSCR : efface l'écran selon le mode donné par TECRAN
                                            ; IN  : /
                                            ; OUT : /

getParamCLS:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        tstb
        beq nextRomCLS
        cmpb #$08
        bls computeColor
        ldab #$01                           ; On force le numéro de couleur à 1 (fond vert) si le paramètre couleur est > 8

computeColor:
        decb                                ; Pour B=1 à 8
        ldaa #$10
        mul                                 ; D = [$00;$10;$20;$30;$40;$50;$60;$70]
        orab #$0F                           ; B = [$00;$10;$20;$30;$40;$50;$60;$70] ==> [$0F;$1F;$2F;$3F;$4F;$5F;$6F;$7F]

nextRomCLS:
        orab #$80                           ; B = [$0F;$1F;$2F;$3F;$4F;$5F;$6F;$70] ==> [$8F;$9F;$AF;$BF;$CF;$DF;$EF;$FF]
        bra nextGR_CLRSCR

; =============== S U B R O U T I N E =======================================
; FCT : GR_CLRSCR : efface l'écran selon le mode donné par TECRAN
; IN  : /
; OUT : /

GR_CLRSCR:
        ldab ColorCLS
nextGR_CLRSCR:
        ldx HOME_YX                         ; Position de l'écran en haut à gauche =(0,0)

setCURAD_YXbeforCLRSCR:
        stx CURAD_YX
        jmp GR_CLRSCR_2                     ; FCT : Efface l'écran
                                            ; IN  : B=code couleur du fond de l'écran
                                            ; OUT : A,B,X modified
; End of function GR_CLRSCR

; =============== S U B R O U T I N E =======================================
; FCT : récupère le paramètre numérique suivant le @ de PRINT @
;       vérifie que le paramètre est bien dans l'intervalle
;       en nombre de caractères de l'écran.
;       Et oui ! on ne donne pas X et Y directement !
; IN  ; /
; OUT : D=CURAD_YX=nouvelle position imposée par D

gepPARAM_ARROBASE:
        jsr CHRGETandFRMNUM                 ; FCT : Evaluate INDICE INTO ACC1
                                            ; IN  : le flot d'interprétation
                                            ; OUT : D=résultat de l'interprétation de l'expression
        jmp GR_verifyParam_AT               ; FCT : vérifie que D est bien contenu dans l'intervalle
                                            ;       d'un affichage via PRINT @
                                            ;       au minimum : 0
                                            ;       au maximum : dépend de l'écran 32*16 ou 40*25 ou 80*25
                                            ; IN  : D=Position du curseur en nombre de caractère
                                            ;       et non pas en position (X,Y)
                                            ; OUT : Met à jour CURAD_YX
                                            ;       D=CURAD_YX=nouvelle position imposée par D
; End of function gepPARAM_ARROBASE

xxOS_FREE_IO_GRAPH ds 74 + 169 + 16 + 1 + 13 -2-14-14+22+17+1+1+11+45+27-1+1-4-10+4+7; 362

; ===========================================================================
; /// I/O - K7
; ===========================================================================
xxIO_K7:

; =============== S U B R O U T I N E =======================================
; FCT : TRAITE A LA FOIS CSAVE,CSAVE*
; STX : CSAVE"TITI"
;       CSAVE* T,"TOTO"
; OP  : $98
; ST  : ACTIF
; IN  : A=le prochain caractère (ou opcode)
;       Le flot à interpréter
; OUT : A,B,X modified

romCSAVE:
        ldx TXTAB                           ; début du programme basic
        stx pMEMBEGIN_K7
        ldx VARTAB                          ; Fin du programme BASIC / début des variables
        stx pMEMEND_K7
        clrb                                ; B=0: fichier basic à sauvegarder

romCSAVSE_ARRAY:
        cmpa #cBAS_TOKEN_mult               ; $B7 is star (=ARRAY) ?
        bne nextRomCSAVE

doromCSAVE_ARRAY:                           ; FCT : Traite le paramétrage de CLOAD* : chargement d'un tableau
        jsr K7_getPRMARRAY                  ; IN  : le flot d'interprétation
                                            ; OUT : /
        ldab #cK7_TYP_PRG_ARRAY

nextRomCSAVE:
        stab fFICTYP_K7                     ; Type du fichier k7 : $00:BASIC,$01 ou $04 selon la rom ? : ARRAY,$02:LANGAGE MACHINE,$05:FICHIER TEXTE DE L'EDITEUR
        ldd pMEMEND_K7
        subd pMEMBEGIN_K7
        std wSAVEorLOAD_K7                  ; Nombre d'octets à sauvegarder ou à lire
        bsr K7_writeBlockFileName           ; FCT : Ecrit le bloc de type FILENAME
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : A,B,X modified

next1RomCSAVE:
        ldx pMEMBEGIN_K7

bcl2RomCSAVE:
        stx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        ldaa #$FF
        staa LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        ldd pMEMEND_K7
        subd pTMP_K7                        ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        bls next4RomCSAVE
        tsta
        bne next3RomCSAVE
        cmpb #$FF
        beq next3RomCSAVE
        stab LG_BLK_K7                      ; Longueur du bloc lu ou écrit

next3RomCSAVE:
        bsr K7_writeBlock                   ; FCT : envoie un bloc de données de n'importe quel type sur le port K7
                                            ;       BLOC :
                                            ;         octet $55 : synchronisation
                                            ;         octet $3C : synchronisation
                                            ;         octet type de bloc : $00 pour le nom de fichier
                                            ;         octet longueur de données : $0F pour le nom de fichier
                                            ;         les données
                                            ;         octet de vérification : CHECKSUM
                                            ;         octet de fin $55      : synchronisation
                                            ; IN  : pTMP_K7 à jour
                                            ; OUT : A,B,X modified
        bra bcl2RomCSAVE

next4RomCSAVE:
        neg BLKTY_K7                        ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        clr LG_BLK_K7                       ; Longueur du bloc lu ou écrit
        bsr K7_writeBlock                   ; FCT : envoie un bloc de données de n'importe quel type sur le port K7
                                            ;       BLOC :
                                            ;         octet $55 : synchronisation
                                            ;         octet $3C : synchronisation
                                            ;         octet type de bloc : $00 pour le nom de fichier
                                            ;         octet longueur de données : $0F pour le nom de fichier
                                            ;         les données
                                            ;         octet de vérification : CHECKSUM
                                            ;         octet de fin $55      : sychronisation
                                            ; IN  : pTMP_K7 à jour
                                            ; OUT : A,B,X modified

endRomCSAVE:
        ldaa #$01
        staa PORT2                          ; Port I/O soit pour RS232 soit pour K7
        rts
; End of function romCSAVE


; =============== S U B R O U T I N E =======================================
; FCT : Ecrit le bloc de type FILENAME
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : A,B,X modified

K7_writeBlockFileName:
        jsr K7_getFileName                  ; FCT : récupère le nom du fichier dans le flot d'interprétation
                                            ;       sort en erreur s'il y a une expression après le nom du fichier
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; BUG : Ne vérifie pas que la chaîne de caractères fait 8 de long au maximum !
                                            ; IN  : le flot d'interprétation
                                            ; OUT : stockage dans une zone temporaire du nom du fichier

cpFileName_K7:
        ldx #zTMPFICNM_K7
        stx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        stx PTRTMP2                         ; utiliser pour copier le nom du fichier

initAREAUNKNOWN_K7:
        clr $09,x                           ; initialise la donnée UNKNOWN_1_K7
        clr $0A,x                           ; initialise la donnée UNKNOWN_2_K7

doCpFileName_K7:
        ldx #(sTMPBUF_K7+1)                 ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        ldab #$08
        jsr next1OS_CopyMEM                 ; Recopie une zone mémoire de la zone X dans la zone pointée par PTRTMP2
                                            ; X=pointeur sur la zone de départ
                                            ; B=longueur à copier

doWriteBLOCKFILENAME:
        clr BLKTY_K7                        ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        ldaa #$0F
        staa LG_BLK_K7                      ; Longueur du bloc lu ou écrit

writeSynchroK7:
        bsr K7_writeHeaderSynchro           ; FCT : Envoi sur le port K7 $0080 fois le caractère de synchro $55
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X,B modified

writeBLKFILENAME:
        bsr K7_writeBlock                   ; FCT : envoie un bloc de données de n'importe quel type sur le port K7
                                            ;       BLOC :
                                            ;         octet $55 : synchronisation
                                            ;         octet $3C : synchronisation
                                            ;         octet type de bloc : $00 pour le nom de fichier
                                            ;         octet longueur de données : $0F pour le nom de fichier
                                            ;         les données
                                            ;         octet de vérification : CHECKSUM
                                            ;         octet de fin $55      : synchronisation
                                            ; IN  : pTMP_K7 à jour
                                            ; OUT : A,B,X modified
        inc BLKTY_K7                        ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin

waitBLKFILENAME:
        ldx #$0000
        jsr bclTempo
; End of function K7_writeBlockFileName


; =============== S U B R O U T I N E =======================================
; FCT : Envoi sur le port K7 $0080 fois le caractère de synchro $55
; ST  : ACTIF
; IN  : /
; OUT : X,B modified

K7_writeHeaderSynchro:
        ldx NBBYTSYNCHRO_K7                 ; défaut : $0080 : nombre d'octets à $55 à envoyer sur K7 pour la synchronisation

bclWriteHeaderSynchro_K7:
        bsr K7_WRBYTE_SYNCHRO               ; FCT : Envoie le caractère  $55 de synchronisation sur le port K7
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X and A not modified
                                            ;       B modified
        dex
        bne bclWriteHeaderSynchro_K7
        rts
; End of function K7_writeHeaderSynchro


; =============== S U B R O U T I N E =======================================
; FCT : envoie un bloc de données de n'importe quel type sur le port K7
;   Un bloc est constitué de :
;     octet $55                 : synchronisation
;     octet $3C                 : synchronisation
;     octet type de bloc        : $00 pour le nom de fichier
;     octet longueur de données : $0F pour le nom de fichier
;     les données               :
;     octet de vérification     : CHECKSUM
;     octet de fin $55          ; synchronisation
; IN  : pTMP_K7 à jour
; OUT : A,B,X modified

K7_writeBlock:
        nop                                 ; Pourquoi un NOP ?
        sei
        ldab LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        stab bNB_READ_K7                    ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        ldaa LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        beq computeByteVerifBlock
        ldx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...

bclComputeByteVerifBlock:
        adda 0,x
        inx
        decb
        bne bclComputeByteVerifBlock

computeByteVerifBlock:
        adda BLKTY_K7                       ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        staa bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture

setXtoFilename:
        ldx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...

WriteVerifBlock_0x55:
        bsr K7_WRBYTE_SYNCHRO               ; FCT : Envoie le caractère $55 de synchronisation sur le port K7
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : X and A not modified
                                            ;       B modified

WriteByteSynchro:
        ldaa #cK7_SYNCHRO_02
        bsr K7_WRBYTE                       ; FCT : Ecrit un octet donné par A sur la K7
                                            ; IN  : A=octet à envoyer sur K7
                                            ; OUT : X and A not modified
                                            ;       B modified

WriteTypBlock:
        ldaa BLKTY_K7                       ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        bsr K7_WRBYTE                       ; FCT : Ecrit un octet donné par A sur la K7
                                            ; IN  : A=octet à envoyer sur K7
                                            ; OUT : X and A not modified
                                            ;       B modified

WriteLenBlock:
        ldaa LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        bsr K7_WRBYTE                       ; FCT : Ecrit un octet donné par A sur la K7
                                            ; IN  : A=octet à envoyer sur K7
                                            ; OUT : X and A not modified
                                            ;       B modified
        tsta
        beq WriteVerifBlock

WriteByteForBlock:
        ldaa 0,x
        inx
        bsr K7_WRBYTE                       ; FCT : Ecrit un octet donné par A sur la K7
                                            ; IN  : A=octet à envoyer sur K7
                                            ; OUT : X and A not modified
                                            ;       B modified
        dec bNB_READ_K7                     ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        bne WriteByteForBlock

WriteVerifBlock:
        ldaa bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture
        bsr K7_WRBYTE                       ; FCT : Ecrit un octet donné par A sur la K7
                                            ; IN  : A=octet à envoyer sur K7
                                            ; OUT : X and A not modified
                                            ;       B modified
; End of function K7_writeBlock

; =============== S U B R O U T I N E =======================================
; FCT : Envoie le caractère $55 de synchronisation sur le port K7
; ST  : ACTIF
; IN  : /
; OUT : X and A not modified
;       B modified

K7_WRBYTE_SYNCHRO:
        ldaa #cK7_SYNCHRO                    ; $55 = 'U'
; End of function K7_WRBYTE_SYNCHRO


; =============== S U B R O U T I N E =======================================
; FCT : Ecrit un octet donné par A sur la K7
; IN  : A=octet à envoyer sur K7
; OUT : X and A not modified
;       B modified

K7_WRBYTE:
trapEmulateurAlice_3:
        pshx                                ; sauvegarde de X
        psha
        psha
        ldab #$08                           ; nb de bits à envoyer sur K7

bclK7_WRBYTE:
        tsx                                 ; nous jouons avec la pile ...
        lsr 0,x                             ; on récupère un bit à envoyer sur K7
        ldx #cK7_DURATE_BIT_LOW             ; on fixe la durée d'un bit à 0 (=$23) ou à 1 (=$46)
        bcs next1K7_WRBYTE
        ldx #cK7_DURATE_BIT_HIGH

next1K7_WRBYTE:
        pshx
        ldaa #$01
        staa PORT2                          ; Port I/O soit pour RS232 soit pour K7

bcl2K7_WRBYTE:
        dex
        bne bcl2K7_WRBYTE
        clra
        staa PORT2                          ; Port I/O soit pour RS232 soit pour K7
        pulx

bcl3K7_WRBYTE:
        dex
        bne bcl3K7_WRBYTE
        decb                                ; décremente le nombre de bits restants à envoyer au lecteur de K7
        bne bclK7_WRBYTE
        pula
        pula
        pulx                                ; Au final A et X ne sont pas modifiés

endK7_WRBYTE:
        rts
; End of function K7_WRBYTE

; =============== S U B R O U T I N E =======================================
; FCT : récupère le nom du fichier dans le flot d'interprétation
;       sort en erreur s'il y a une expression après le nom du fichier
; ALG : /
; STX : /
; ST  : ACTIF
; BUG : Ne vérifie pas que la chaîne de caractères fait 8 de long au maximum !
; IN  : le flot d'interprétation
; OUT : stockage dans une zone temporaire du nom du fichier

K7_getFileName:
        bsr K7_getFilenameFromInput         ; FCT : récupère le nom du fichier dans le flot d'interprétation
                                            ; ST  : ACTIF
                                            ; BUG : Ne vérifie que la chaîne de caractères fait 8 de long  au maximum !
                                            ; IN  : le flot d'interprétation
                                            ; OUT : zTMPFICNM_K7 est initialisée avec le nom du  fichier obtenu à partir du flux d'interprétation
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq endK7_WRBYTE
        jmp setError0x02_SYNTAXERROR
; End of function K7_getFileName

; =============== S U B R O U T I N E =======================================
; FCT : récupère le nom du fichier dans le flot d'interprétation
; ST  : ACTIF
; BUG : Ne vérifie pas que la chaîne de caractères fait 8 de long  au maximum !
; IN  : le flot d'interprétation
; OUT : zTMPFICNM_K7 est initialisée avec le nom du fichier obtenu à partir du flux d'interprétation

K7_getFilenameFromInput:
        ldx #sTMPBUF_K7                     ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        clr 0,x
        ldaa #cOS_SPACE                     ; ' '
initK7FILENAMETMP:
        inx
        staa 0,x
        cpx #sTMPBUF_K7+9                   ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        bne initK7FILENAMETMP
;--- ATTENTION pour les futurs optimisations :
;-- X pointe sur la zone zTMPFICNM_K7
;-- donc pb si les zones sTMPBUF_K7 et zTMPFICNM_K7
;-- ne sont pas contigues
getFileName_GFK7:
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq endK7_WRBYTE
        jsr FRMEVL                          ; FCT : effectue l'évaluation du flux d'entrée
                                            ; IN  : le flot d'interprétation
                                            ; OUT : ACC1=result of expression (pointeur if string or value if numeric)
        jsr FRESTR                          ; FCT : Libére la zone réservée pour une chaîne de caractères
                                            ;       lors de l'interprétation du flux d'entrée
                                            ; IN  : ACC1+3 et ACC1+4 : contient le descripteur de chaîne à traiter
                                            ; OUT : X=pointeur sur la chaîne de caractère
                                            ;       B=longueur de la chaîne de caractère
setLenFileNme:
        stab sTMPBUF_K7                     ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        beq endK7_WRBYTE
        pshb                                ; sauvegarde de la longueur du nom du fichier
getptrToTmpBufK7:
        ldd #(sTMPBUF_K7+1)                 ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        std PTRTMP2
        pulb                                ; récupère la longueur du nom de fichier
        jmp next1OS_CopyMEM                 ; Recopie une zone mémoire de la zone X dans la zone pointée par PTRTMP2
                                            ; X=pointeur sur la zone de départ
                                            ; B=longueur à copier
; End of function K7_getFilenameFromInput

; =============== S U B R O U T I N E =======================================
; FCT : TRAITE A LA FOIS CLOAD,CLOAD* (pour tableau) et CLOADM (programme binaire)
; STX : CLOAD "TITI"
;       CLOAD T,"TITI"
;       CLOADM "TITI",offset
; OP  : $97
; ST  : ACTIF
; IN  : le flot à interpréter
; OUT : A,B,X modified

romCLOAD:
        cmpa #cBAS_TOKEN_mult               ; $B7 is a star ?
        bne isCLOADM
        jmp getARRAY_CLOAD                  ; FCT : Charge des données de type tableau en provenance d'1 K7
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation contenant le nom du tableau et celui du fichier
                                            ; OUT : A,B,X modified
isCLOADM:
        cmpa #$4D                           ; 'M'
        bne doCLOAD
        jmp doCLOADM
doCLOAD:
        clra                                ; on veut un bloc de type nom de fichier
        bsr readAndVerifyBlock              ; FCT : Lit un bloc sur K7 et compare le type de bloc reçu avec A
                                            ;       Si non égal  alors message d'erreur
                                            ;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
                                            ; IN  : A=Type de bloc à comparer
                                            ;       le flot d'interprétation contenant le nom du fichier
                                            ; OUT : A,B,X modified
        jsr doRomNEW                        ; FCT : Effectue l'action de la commande BASIC NEW
                                            ; IN  : /
                                            ; OUT : X=TXTAB+2=début du programme + 2
        com DEVCUR                          ; CURRENT DEVICE : $00 : SCREEN, $FF : K7
        ldd wSAVEorLOAD_K7                  ; Nombre d'octets à sauvegarder ou à lire
        addd TXTAB                          ; début du programme basic
        jsr nextCHKMEM
        ldx TXTAB                           ; début du programme basic
bclDoCLOAD:
        stx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        bsr K7_readBLOCKDATA                ; FCT : Lit un bloc de données en provenance d'une K7
                                            ; IN  : X=pointeur sur la zone de stockage des données en provenance de la K7
                                            ; OUT : A=type de dernier bloc lu
        bpl bclDoCLOAD
        stx VARTAB                          ; Fin du programme BASIC / début des variables
        ldx #(aOk)
        ldab 0,x
        inx
        jsr bclOUTTX
        jmp next3PARESELINE
; End of function romCLOAD


; =============== S U B R O U T I N E =======================================
; FCT : Lit un bloc sur K7 et compare le type de bloc reçu avec A
;       Si non égal alors message d'erreur
;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
; IN  : A=Type de bloc à comparer
;       le flot d'interprétation contenant le nom du fichier
; OUT : A,B,X modified

readAndVerifyBlock:
        psha
        bsr K7_getFileNameAndSearchIt       ; FCT : Lit un bloc de type nom de l'interface K7.
                                            ;       Si le bloc n'est pas trouvé alors erreur
                                            ;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
                                            ; BUG : Une foultitude ...
                                            ;       Pas de vérification du type de données comme nom du fichier !
                                            ;       CLOAD 3 fait partir le BASIC dans les lymbes de l'informatique
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /
        pula
        tst DUMMY_K7                        ; A quoi cela sert-il car il n'y a pas de modif. explicite de cette variable !
        bne endGetARRAYBLOCK_CLOAD
        cmpa fFICTYP_K7                     ; Type du fichier k7 : $00:BASIC,$01 ou $04 selon la rom ?:ARRAY,$02:LANGAGE MACHINE,$05:FICHIER TEXTE DE L'EDITEUR
        beq endGetARRAYBLOCK_CLOAD

printErrMSG_0X24_FM:                        ; Erreur avec un fichier !
        ldab #cBAS_ERR_K7
        jmp ERROR
; End of function readAndVerifyBlock


; =============== S U B R O U T I N E =======================================
; FCT : Lit un bloc de type nom de l'interface K7.
;       Si le bloc n'est pas trouvé alors erreur
;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
; BUG : Une foultitude ...
;       Pas de vérification du type de données comme nom du fichier !
;       CLOAD 3 fait partir le BASIC dans les lymbes de l'informatique
; IN  : le flot d'interprétation
; OUT : /

K7_getFileNameAndSearchIt:
        bsr K7_getFilenameFromInput         ; FCT : récupère le nom du fichier dans le flot d'interprétation
                                            ; ST  : ACTIF
                                            ; BUG : Ne vérifie que la chaîne de caractères fait 8 de long au maximum !
                                            ; IN  : le flot d'interprétation
                                            ; OUT : zTMPFICNM_K7 est initialisée avec le nom du  fichier obtenu à partir du flux d'interprétation
        jsr K7_searchBlockFilenameFromK7    ; FCT : Cherche le bloc de type FILENAME
                                            ;       2 points d'entrée utilisés :
                                            ;       le 1er écrit S puis F quand trouvé
                                            ;       le 2eme ecrit F quand trouvé
                                            ; NAME: CMPNA
                                            ; ST  : ACTIF
                                            ; IN  : la zone zTMPFICNM_K7 (ou sTMPBUF_K7 ?) doit être initialisée avec le nom du fichier
                                            ; OUT : A=$00 si trouvé
        bne printErrMSG_IO                  ; Input/Output ERROR !
        jmp K7_skipSYNCHRO                  ; FCT : Permet d'ignorer la séquence de synchronisation d'un programme K7
                                            ;       Celle-ci est constituée de :
                                            ;        1 - 128 octets égaux à $55=01010101b
                                            ;        2 - espace blanc de 0,5s
                                            ;        3 - 128 octets égaux à $55=01010101b
                                            ; IN  : /
                                            ; OUT : A,B,X modified

printErrMSG_IO:
        ldab #cBAS_ERR_IO                   ; '"'  ; Input/Output ERROR !
        jmp ERROR
; End of function K7_getFileNameAndSearchIt


; =============== S U B R O U T I N E =======================================
; FCT : Charge des données de type tableau en provenance d'1 K7
; ST  : ACTIF
; IN  : le flot d'interprétation contenant le nom du tableau et celui du fichier
; OUT : A,B,X modified

getARRAY_CLOAD:
        bsr K7_getPRMARRAY                  ; FCT : Traite le paramétrage de CLOAD* : chargement d'un tableau
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /

getARRAYBLOCK_CLOAD:                        ; Le bloc à lire doit être du type TABLEAU
        ldaa #cK7_TYP_PRG_ARRAY
        bsr readAndVerifyBlock              ; FCT : Lit un bloc sur K7 et compare le type de bloc reçu avec A
                                            ;       Si non égal  alors message d'erreur
                                            ;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
                                            ; IN  : A=Type de bloc à comparer
                                            ;       le flot d'interprétation contenant le nom du fichier
                                            ; OUT : A,B,X modified
        ldd pMEMEND_K7
        subd pMEMBEGIN_K7
        subd wSAVEorLOAD_K7                 ; Nombre d'octets à sauvegarder ou à lire
        bcc nextGetARRAYBLOCK_CLOAD
        jmp MEMERR                          ; FCT : Point d'entrée secondaire pour la gestion d'erreur
                                            ;       il correspond à "plus de place disponible en mémoire"
                                            ; IN  : /
                                            ; OUT : A,B,X modified

nextGetARRAYBLOCK_CLOAD:
        ldx pMEMBEGIN_K7

bclReadBLKDT_K7:
        stx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        bsr K7_readBLOCKDATA                ; FCT : Lit un bloc de données en provenance d'une K7
                                            ; IN  : X=pointeur sur la zone de stockage des données en provenance de la K7
                                            ; OUT : A=type de dernier bloc lu
        bpl bclReadBLKDT_K7

endGetARRAYBLOCK_CLOAD:
        rts
; End of function getARRAY_CLOAD


; =============== S U B R O U T I N E =======================================
; FCT : Lit un bloc de données en provenance d'une K7
; IN  : X=pointeur sur la zone de stockage des données en provenance de la K7
; OUT : A=type de dernier bloc lu

K7_readBLOCKDATA:
        jsr K7_getBlockData                 ; FCT : Lit un bloc et vérifie que le type de bloc est DATA
                                            ; IN  : X=endroit où on stocke les donnees en provenance de la K7
                                            ; OUT : A=$03:Erreur code bloc inattendu
                                            ;       A=$02:Erreur problème mémoire
                                            ;       A=$01:Erreur suite à la comparaison avec l'octet de vérification
                                            ;       A=$00:pas d'erreur
                                            ;       X=pointeur sur le dernier octet stocké (si demandée via B)

errorReadBLOCKDATA_K7:
        bne printErrMSG_IO                  ; Input/Output ERROR !
        ldaa BLKTY_K7                       ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        beq printErrMSG_IO                  ; Input/Output ERROR !
        rts
; End of function K7_readBLOCKDATA


; =============== S U B R O U T I N E =======================================
; FCT : Traite le paramétrage de CLOAD* : chargement d'un tableau
; IN  : le flot d'interprétation
; OUT : /

K7_getPRMARRAY:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1
        ldab #$01                           ; on cherche un tableau
        stab SUBFLG                         ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        jsr PTRGET                          ; FCT : Lit un nom de variable à l'aide de CHRGOT
                                            ;       et le trouve en mémoire
                                            ; IN  : TXTPTR pointe sur le premier caractère du nom
                                            ; OUT : X=VARPNT=ADRESSE DE LA VARIABLE
                                            ;       (<si non trouvé alors création d'une variable simple ou d'un
                                            ;       tableau de dim(10) initialisé à 0)
        clr SUBFLG                          ; Disable ARRAY search : =$00: ALLOW SEARCH,=$80:DISABLE SEARCH
        jsr CHKNUM
        ldd 2,x
        jsr addXtoTMPPTR                    ; FCT : Ajoute l'offset B à X
                                            ; IN  : D=offset à ajouter à INDEX
                                            ; OUT : INDEX=X
                                            ;       X=D=TMPPTR=X+D

        stx pMEMEND_K7
        ldx INDEX
        ldab 4,x
        aslb
        addb #$05
        abx
        stx pMEMBEGIN_K7
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq endGetARRAYBLOCK_CLOAD
        jmp CHKCOM
; End of function K7_getPRMARRAY

; ---------------------------------------------------------------------------
;----------------------
; CLOADM "TITI",20000
;----------------------
; START OF FUNCTION CHUNK FOR romCLOAD

doCLOADM:
        jsr CHRGET                          ; "CHRGET" USING [TXTPTR] AS THE CURRENT TEXT PNTR
                                            ; FETCHES A NEW CHARACTER INTO ACCA AFTER INCREMENTING [TXTPTR]
                                            ; AND SETS CONDITION CODES ACCORDING TO WHAT'S IN ACCA.
                                            ; NOT C= NUMERIC ("0" THRU "9")
                                            ; Z= ":" OR END-OF-LINE (A NULL)
                                            ; [ACCA] = NEW CHAR.
                                            ; [TXTPTR]=[TXTPTR]+1

readFileNameBlock_CLOADM:                   ; 2 : on veut un bloc de type langage machine
        ldaa #cK7_TYP_PRG_ASS
        bsr readAndVerifyBlock              ; FCT : Lit un bloc sur K7 et compare le type de bloc reçu avec A
                                            ;       Si non égal  alors message d'erreur
                                            ;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
                                            ; IN  : A=Type de bloc à comparer
                                            ;       le flot d'interprétation contenant le nom du fichier
                                            ; OUT : A,B,X modified

getOffset_CLOADM:                           ; Obtient l'offset de chargement si existant
        ldx #$0000                          ; initialise l'offset à 0
        jsr CHRGOT                          ; FCT : Obtient le dernier caractère lu dans le flot d'interprétation
        beq nextDoCLOADM
        jsr CHKCOM                          ; une virgule doit exister ...
        jsr getArg                          ; FCT : récupère un word dans le flot d'inteprétation
                                            ; IN  : le flot d'interprétation
                                            ; OUT : X=WORD from ARGUMENT
                                            ;       ACC1+3 et ACC1+4 contiennent aussi l'expression convertie de type word

nextDoCLOADM:
        stx INDEX                           ; stocke l'offset dans l'INDEX
        ldd wOFSLOAD_K7                     ; offset de chargement du programme, $0000 par défaut
        addd INDEX
        std pEXEC
        ldd wSAVEorLOAD_K7
        addd INDEX
        pshb
        psha
        pulx
        bra bclReadBLKDT_K7
; END OF FUNCTION CHUNK FOR romCLOAD

; =============== S U B R O U T I N E =======================================
; FCT : K7 : recherche d'un programme sur K7
; STX : SKIPF "FICHIER"
; IN  : le flot d'interprétation
; OUT : A,B,X modified
; OP  : $A0
; ST  : ACTIF

romSKIPF:
        jsr K7_getFileNameAndSearchIt       ; FCT : Lit un bloc de type nom de l'interface K7.
                                            ;       Si le bloc n'est pas trouvé alors erreur
                                            ;       Le nom du fichier est récupéré dans le flux d'entrée utilisateur
                                            ; BUG : Une foultitude ...
                                            ;       Pas de vérification du type de données comme nom du fichier !
                                            ;       CLOAD 3 fait partir le BASIC dans les lymbes de l'informatique
                                            ; IN  : le flot d'interprétation
                                            ; OUT : /
        bsr K7_searchNextBlockFileName_bcl
        bne errorReadBLOCKDATA_K7
        rts
; End of function romSKIPF


; =============== S U B R O U T I N E =======================================
; FCT : Cherche le bloc de type FILENAME
;       2 points d'entrée utilisés :
;       le 1er écrit S puis F quand trouvé
;       le 2eme ecrit F quand trouvé
; NAME: CMPNA
; ST  : ACTIF
; IN  : la zone zTMPFICNM_K7 (ou sTMPBUF_K7 ?) doit être initialisée avec le nom  du fichier
; OUT : A=$00 si trouvé

K7_searchBlockFilenameFromK7:
        ldaa CURLIN                         ; Sommes nous en mode éditeur (=$FFFF) ou en mode exécution (<>$FFFF)
        inca
        bne nextSearchHeaderFromK7          ; efface l'écran si on est en mode editeur
        jsr GR_CLRSCR                           ; FCT : GR_CLRSCR : efface l'écran selon le mode donné par TECRAN
                                            ; IN  : /
                                            ; OUT : /

printSAtHome:
        ldaa #$53                           ; 'S' ; imprime 'S' à la position(0,0)
        bsr K7_printCharOnScreen            ; FCT : Imprime obligatoirement le caractère sur l'écran
                                            ; IN  : A=caractère à imprimer
                                            ; OUT : A,B,X unmodified
        jsr OS_printESPACE                  ; Imprime autant d'espace qu'il faut pour le tab

nextSearchHeaderFromK7:
        bsr K7_getBlockFileName             ; FCT : Lit un bloc et vérifie que le type de bloc est FILENAME
                                            ; IN  : /
                                            ; OUT : A=Type de bloc lu
        oraa BLKTY_K7                       ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        bne endSearchHeaderFromK7
        clrb                                ; Initialise l'octet de la pile qui servira à stocker un delta entre le nom du fichier cherché et le bloc filename lu
        pshb

bcl1SearchHeaderFromK7:
        ldx #zTMPFICNM_K7
        abx
        ldaa 0,x
        ldx CURLIN
        inx
        bne next2SearchHeaderFromK7
        psha
        bsr K7_printCharOnScreen            ; FCT : Imprime obligatoirement le caractère sur l'écran
                                            ; IN  : A=caractère à imprimer
                                            ; OUT : A,B,X unmodified
        pula
next2SearchHeaderFromK7:
        ldx #(sTMPBUF_K7+1)                 ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
        abx
        suba 0,x
        tsx                                 ; Nous utilisons un octet de la pile pour stocker la différence octet par octet du nom du fichier cherché
        oraa 0,x
        staa 0,x
        incb
        cmpb #$08
        bne bcl1SearchHeaderFromK7
        pula
        tsta
        beq next3SearchHeaderFromK7_WriteF
        tst sTMPBUF_K7                      ; stocke :
                                            ;  - la longueur du nom du fichier (maxi 8 caractères)
                                            ;  - le nom du fichier
isFound:
        beq next3SearchHeaderFromK7_WriteF  ; Si = 0 alors trouvé donc on affiche 'F' à la position (0,0) puis on sort
        bsr K7_searchBlockFileName          ; FCT : Cherche un bloc de type FileName
                                            ;       2 point d'entrées
                                            ; IN  : /
                                            ; OUT : A=code erreur
                                            ;       $00 : trouvé
        bne endSearchHeaderFromK7
        bra K7_searchBlockFilenameFromK7    ; FCT : Cherche le bloc de type FILENAME
                                            ;       2 points d'entrées utilisés :
                                            ;        le 1er écrit S puis F quand trouvé
                                            ;        le 2eme écrit F quand trouvé
                                            ; NAME: CMPNA
                                            ; ST  : ACTIF
                                            ; IN  : la zone zTMPFICNM_K7 (ou sTMPBUF_K7 ?) doit être initialisée avec le nom du fichier
                                            ; OUT : A=$00 si trouvé

next3SearchHeaderFromK7_WriteF:
        ldaa #$46                           ; 'F' ; écrit 'F' à la position (0,0) de l'écran
        bsr K7_printCHARatHOME              ; FCT : Imprime le caractère A à la position (0,0) de l'écran vidéo
                                            ; IN  : A=code ASCII du caractère à afficher
                                            ; OUT : A,B modified, X unmodified
        clra

endSearchHeaderFromK7:
        rts
; End of function K7_searchBlockFilenameFromK7


; =============== S U B R O U T I N E =======================================
; FCT : Imprime obligatoirement le caractère sur l'écran
; IN  : A=caractère à imprimer
; OUT : B,X unmodified

K7_printCharOnScreen:
        clr DEVNU                           ; $00 : affichage sur l'écran $01 : écriture dans tampon $FF : affichage sur l'imprimante
        jmp OS_printCHARByDevice            ; FCT : OS_printCHARByDevice : émission d'un caractère soit sur imprimante soit sur l'écran
                                            ; IN  : A=caractère à imprimer
                                            ;       DEVNU mise à jour
                                            ; OUT : B, X unmodified
; End of function K7_printCharOnScreen

; =============== S U B R O U T I N E =======================================
; FCT : Cherche un bloc de type FileName
;       2 points d'entrée
; IN  : /
; OUT : A=code erreur
;       $00 : trouvé

K7_searchBlockFileName:
        jsr K7_skipSYNCHRO                  ; FCT : Permet d'ignorer la séquence de synchronisation d'un programme K7
                                            ;       Celle-ci est constituée de :
                                            ;        1 - 128 octets égaux à $55=01010101b
                                            ;        2 - espace blanc de 0,5s
                                            ;        3 - 128 octets égaux à $55=01010101b
                                            ; IN  : /
                                            ; OUT : A,B,X modified

K7_searchNextBlockFileName_bcl:
        ldaa #$FF
        tab
        bsr K7LEC                           ; FCT : lit un programme sur K7
                                            ; ALG : 1 - synchronisation avec le caractère $3C
                                            ;       2 - Lit le type de bloc
                                            ;       3 - Lit la longueur du bloc
                                            ;       4 - itére sur la longueur de bloc pour récupèrer les données si nécessaire
                                            ;       5 - Lit un octet de vérification = somme des données + type  de bloc + longueur du bloc
                                            ; ST  : ACTIF
                                            ; IN  : A:longueur du bloc à lire
                                            ;       B=0 écrit les données lues en mémoire <>0 ne les écrit pas
                                            ;       X=pointeur sur la zone de stockage des données (si la demande est faite par B)
                                            ; OUT : A=$03:Erreur code bloc inattendu
                                            ;       A=$02:Erreur problème mémoire
                                            ;       A=$01:Erreur suite à la comparaison avec l'octet de vérification
                                            ;       A=$00:pas d'erreur
                                            ;       X=pointeur sur le dernier octet stocké (si demandée via B)
        bne K7_searchBlockFileName_end
        ldaa BLKTY_K7                       ; type de bloc : $00 nom du fichier,$01 bloc de données,$FF bloc de fin
        nega
        bmi K7_searchNextBlockFileName_bcl
        deca

K7_searchBlockFileName_end:
        staa bNB_READ_K7                    ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        rts
; End of function K7_searchBlockFileName


; =============== S U B R O U T I N E =======================================
; FCT : Inverse l'affichage du caractère à la position (0,0) de l'écran vidéo
;       Si c'est un attribut alors on imprime un espace
; IN  : /
; OUT : A,B,X modified

invCHARatHome:
        jsr GR_readScreenAtHOME             ; FCT : Lit le caractère en mémoire vidéo à la position (0,0)
                                            ; IN  : /
                                            ; ST  : ACTIF
                                            ; OUT : X modified
                                            ;       A=$20 si attribut sinon code ASCII du caractère lu
        eora #$20 ; ' '
; End of function invCHARatHome


; =============== S U B R O U T I N E =======================================
; FCT : Imprime le caractère A à la position (0,0) de l'écran vidéo
; IN  : A=code ASCII du caractère à afficher
; OUT : A,B modified, X unmodified

K7_printCHARatHOME:
        ldab CURLIN
        incb
        bne endPrintCHARatHOME
        jmp GR_printCharAtHOME              ; FCT : Imprime le caractère A à la position (0,0) de l'écran
                                            ; IN  : A=caractère à imprimer
                                            ; OUT : A,B modified
                                            ;       X unmodified

endPrintCHARatHOME:
        rts
; End of function K7_printCHARatHOME


; =============== S U B R O U T I N E =======================================
; FCT : Lit un bloc et vérifie que le type de bloc est FILENAME
; IN  : /
; OUT : A=Type de bloc lu

K7_getBlockFileName:
        jsr K7_skipSYNCHRO                  ; FCT : Permet d'ignorer la séquence de synchronisation d'un programme K7
                                            ;       Celle-ci est constituée de :
                                            ;        1 - 128 octets égaux à $55=01010101b
                                            ;        2 - espace blanc de 0,5s
                                            ;        3 - 128 octets égaux à $55=01010101b
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        ldx #zTMPFICNM_K7
        stx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        ldaa #$0F                           ; Bloc de type FileName XXXXXX
        bra K7_getBlockData_0
; End of function K7_getBlockFileName

; =============== S U B R O U T I N E =======================================
; FCT : Lit un bloc et vérifie que le type de bloc est DATA
; IN  : X=endroit où on stocke les donnees en provenance de la K7
; OUT : A=$03:Erreur code bloc inattendu
;       A=$02:Erreur problème mémoire
;       A=$01:Erreur suite à la comparaison avec l'octet de vérification
;       A=$00:pas d'erreur
;       X=pointeur sur le dernier octet stocké (si demandée via B)


K7_getBlockData:
        ldaa #$FF
K7_getBlockData_0:
        clrb
; End of function K7_getBlockData


; =============== S U B R O U T I N E =======================================
; FCT : lit un programme sur K7
; ALG : 1 - synchronisation avec le caractère $3C
;       2 - Lit le type de bloc
;       3 - Lit la longueur du bloc
;       4 - itére sur la longueur de bloc pour récupèrer les données si nécessaire
;       5 - Lit un octet de vérification = somme des données + type de bloc + longueur du bloc
; ST  : ACTIF
; IN  : A:longueur du bloc à lire
;       B=0 écrit les données lues en mémoire <>0 ne les écrit pas
;       X=pointeur sur la zone de stockage des données (si la demande est faite par B)
; OUT : A=$03:Erreur code bloc inattendu
;       A=$02:Erreur problème mémoire
;       A=$01:Erreur suite à la comparaison avec l'octet de vérification
;       A=$00:pas d'erreur
;       X=pointeur sur le dernier octet stocké (si demandée via B)

K7LEC:
        psha                                ; sauvegarde la longueur du bloc à lire
        stab fSAVEDATA_K7                   ; =$00:sauve les données K7 en mémoire sinon ne les sauve pas
        nop                                 ; TODO Pourquoi un NOP ?
        sei
        bsr invCHARatHome                   ; FCT : Inverse l'affichage du caractère à la position (0,0) de l'écran vidéo
                                            ;       Si c'est un attribut alors on imprime un espace
                                            ; IN  : /
                                            ; OUT : A,B,X modified
        ldx pTMP_K7                         ; pointeur servant à tout ... FILENAME,CLOAD,CSAVE...
        clra                                ; RESET ACCA
bclK7LEC_SYNCHRO:
trapEmulateurAlice_4:                        ; Modification du code pour l'émulateur ...
        ;bsr K7_readBit                      ; FCT : Lit un bit en provenance du magnétophone
        ;                                    ; IN  : /
        ;                                    ; OUT : C=value of bit read from K7
        ;                                    ;       B modified
        ;                                    ;       A unmodified
        ;rora
        bsr K7_readByte
        nop
        cmpa #cK7_SYNCHRO_02                ; est-ce l'octet de synchronisation ($3C) ?
        bne bclK7LEC_SYNCHRO
K7LEC_TYPBLK:
        bsr K7_readByte                     ; FCT : Lit 8bits de données de la K7
                                            ; IN  : /
                                            ; OUT : A=octet lu lors de la lecture des données K7
                                            ;       B modified
        staa BLKTY_K7                       ; type de bloc : $00 nom du fichier, $01 bloc de données, $FF bloc de fin
K7LEC_LGDATA:
        bsr K7_readByte                     ; FCT : Lit 8bits de données de la K7
                                            ; IN  : /
                                            ; OUT : A=octet lu lors de la lecture des données K7
                                            ;       B modified
        staa LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        pulb                                ; récupère la longueur du bloc à lire
        cba
        bhi next4K7LEC
        adda BLKTY_K7                       ; type de bloc : $00 nom du fichier, $01 bloc de données ,$FF bloc de fin
        staa bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture
        ldaa LG_BLK_K7                      ; Longueur du bloc lu ou écrit
        staa bNB_READ_K7                    ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        beq next3K7LEC_verify
bcl1K7LEC:
        bsr K7_readByte                     ; FCT : Lit 8bits de données de la K7
                                            ; IN  : /
                                            ; OUT : A=octet lu lors de la lecture des données K7
                                            ;       B modified
issaveData:
        tst fSAVEDATA_K7                    ; =$00:sauve les données K7 en mémoire sinon ne les sauve pas
        bne next2K7LEC
        staa 0,x
        cmpa $00,x
        bne next5K7LEC
        inx
next2K7LEC:
        adda bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture
        staa bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture
        dec bNB_READ_K7                     ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        bne bcl1K7LEC
next3K7LEC_verify:
        bsr K7_readByte                     ; FCT : Lit 8bits de données de la K7
                                            ; IN  : /
                                            ; OUT : A=octet lu lors de la lecture des données K7
                                            ;       B modified
        suba bREALL_K7                      ; doit être égal à 0 pour effectuer la lecture
        beq endK7LEC
        ldaa #$01
        SKIP2                               ; NE PAS REMPLACER PAR UN bra CAR CELA DECALE LES ADRESSES TRAPEES PAR L'EMULATEUR
next4K7LEC:
        ldaa #$03
        SKIP2                               ; NE PAS REMPLACER PAR UN bra CAR CELA DECALE LES ADRESSES TRAPEES PAR L'EMULATEUR
next5K7LEC:
        ldaa #$02
endK7LEC:
        staa bNB_READ_K7                    ; compteur du nombre de données à lire : est décrementé de 1 à chaque lecture d'octet de la K7
        rts
; End of function K7LEC


; =============== S U B R O U T I N E =======================================
; FCT : Lit 8bits de données de la K7
; IN  : /
; OUT : A=octet lu lors de la lecture des données K7
;       B modified

K7_readByte:
trapEmulateurAlice_6:
        ldaa #$08
        staa bNbBitsToRDWR_K7

bclReaddByteFromK7:
        bsr K7_readBit                      ; FCT : Lit un bit en provenance du magnétophone
                                            ; IN  : /
                                            ; OUT : C=value of bit read from K7
                                            ;       B modified
                                            ;       A unmodified
        rora
        dec bNbBitsToRDWR_K7
        bne bclReaddByteFromK7
        rts
; End of function K7_readByte


; =============== S U B R O U T I N E =======================================
; FCT : Lit un bit en provenance du magnétophone
; IN  : /
; OUT : C=value of bit read from K7
;       B modified
;       A unmodified

K7_readBit:
        bsr K7_getTimeBetweenTransition     ; FCT : Permet de déterminer la valeur du bit lu en
                                            ;       se basant sur les durées de  transition bas vers haut
                                            ; IN  : /
                                            ; OUT : /
        ldab CPERTM_K7                      ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        decb                                ; Si B < CMMID_K7 alors le bit lu est un 1 sinon un 0
        cmpb CMPMID_K7                      ; $18 par défaut ;  valeur de comparaison pour déterminer si c'est un bit à 1 ou à 0
        rts
; End of function K7_readBit


; =============== S U B R O U T I N E =======================================
; FCT : Permet de déterminer la valeur du bit lu en
;       se basant sur les durées de transition bas vers haut
; IN  : /
; OUT : /

K7_getTimeBetweenTransition:
        clr CPERTM_K7                       ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        tst CBTPHA_K7                       ; flag indiquant la phase de lecture du port K7 (quelle transition HI-LO or LO-HI)
        bne K7_waitTransitionHigh_Low
; End of function K7_getTimeBetweenTransition


; =============== S U B R O U T I N E =======================================
; FCT : attend une transition du bas vers le haut en provenance du port K7
; IN  : /
; OUT : /

K7_waitTransitionLowHigh:
        bsr K7_readInput                    ; FCT : Lit l'état du port d'entrée de la K7
                                            ; IN  : /
                                            ; OUT : B=0   : bit à 0
                                            ;       B<> 0 : bit à 1
        bne K7_waitTransitionLowHigh        ; FCT : attend une transition du bas vers le haut en provenance du port K7
                                            ; IN  : /
                                            ; OUT : /
; End of function K7_waitTransitionLowHigh

; =============== S U B R O U T I N E =======================================
; FCT : Attend une transition haute sur le port K7
; IN  : /
; OUT : B<>0

K7_waitTransitionHigh:
        bsr K7_readInput                    ; FCT : Lit l'état du port d'entrée de la K7
                                            ; IN  : /
                                            ; OUT : B=0   : bit à 0
                                            ;       B<> 0 : bit à 1
        beq K7_waitTransitionHigh           ; FCT : Attend une transition haute sur le port K7
                                            ; IN  : /
                                            ; OUT : B<>0
        rts
; End of function K7_waitTransitionHigh


; =============== S U B R O U T I N E =======================================
; FCT : Lit l'état du port d'entrée de la K7
; IN  : /
; OUT : B=0   : bit à 0
;       B<> 0 : bit à 1

K7_readInput:
        inc CPERTM_K7                       ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        ldab PORT2                          ; Port I/O soit pour RS232 soit pour K7
        andb #$10                           ; 0x10=0001 0000
        rts
; End of function K7_readInput

; ---------------------------------------------------------------------------
; START OF FUNCTION CHUNK FOR K7_getTimeBetweenTransition

K7_waitTransitionHigh_Low:
        bsr K7_readInput                    ; FCT : Lit l'état du port d'entrée de la K7
                                            ; IN  : /
                                            ; OUT : B=0   : bit à 0
                                            ;       B<> 0 : bit à 1
        beq K7_waitTransitionHigh_Low
; END OF FUNCTION CHUNK FOR K7_getTimeBetweenTransition

; =============== S U B R O U T I N E =======================================
; FCT : Attend une transition basse sur le port K7
; IN  : /
; OUT : B=0

K7_waitTransitionLow:
        bsr K7_readInput                    ; FCT : Lit l'état du port d'entrée de la K7
                                            ; IN  : /
                                            ; OUT : B=0   : bit à 0
                                            ;       B<> 0 : bit à 1
        bne K7_waitTransitionLow            ; FCT : Attend une transition basse sur le port K7
                                            ; IN  : /
                                            ; OUT : B=0
        rts
; End of function K7_waitTransitionLow


; =============== S U B R O U T I N E =======================================
; FCT : Permet d'ignorer la séquence de synchronisation d'un programme K7
;       Celle-ci est constituée de :
;       1 - 128 octets égaux à $55=01010101b
;       2 - espace blanc de 0,5s
;       3 - 128 octets égaux à $55=01010101b
; IN  : /
; OUT : A,B,X modified

K7_skipSYNCHRO:
trapEmulateurAlice_7:
        nop                                 ; TODO : Pourquoi un NOP ?
        sei
        clr bNbBitsToRDWR_K7

bclReadByteFromK7:
        bsr K7_waitTransitionLowHigh        ; FCT : attend une transition du bas vers le haut en provenance du port K7
                                            ; IN  : /
                                            ; OUT : /

bcl1ReadByteFromK7:
        bsr K7_waitTransitionLow_0          ; FCT : Attend une transition basse
                                            ;       2 point d'entrées
                                            ; IN  : /
                                            ; OUT : B=0
                                            ;       bLenBit_K7=0
        bhi next4ReadByteFromK7

bcl2ReadByteFromK7:
        bsr K7_waitTransitionHigh_0         ; FCT : Attend une transition haute vers basse
                                            ; IN  : /
                                            ; OUT : B=0
                                            ;       bLenBit_K7=0
        bcs next5ReadByteFromK7
        dec bNbBitsToRDWR_K7
        ldaa bNbBitsToRDWR_K7
        cmpa #$A0 ; ' '

bcl3ReadByteFromK7:
        bne bclReadByteFromK7
        staa CBTPHA_K7                      ; flag indiquant la phase de lecture du port K7 (quelle transition HI-LO or LO-HI)
trapEmulateurAlice_8:
        rts

next4ReadByteFromK7:
        bsr K7_waitTransitionHigh_0         ; FCT : Attend une transition haute vers basse
                                            ; IN  : /
                                            ; OUT : B=0
                                            ;       bLenBit_K7=0
        bhi bcl1ReadByteFromK7

next5ReadByteFromK7:
        bsr K7_waitTransitionLow_0          ; FCT : Attend une transition basse
                                            ;       2 point d'entrées
                                            ; IN  : /
                                            ; OUT : B=0
                                            ;       bLenBit_K7=0
        bcs bcl2ReadByteFromK7
        inc bNbBitsToRDWR_K7
        ldaa bNbBitsToRDWR_K7
        suba #$60
        bra bcl3ReadByteFromK7
; End of function K7_skipSYNCHRO


; =============== S U B R O U T I N E =======================================
; FCT : Attend une transition haute vers basse
; IN  : /
; OUT : B=0
;       bLenBit_K7=0

K7_waitTransitionHigh_0:
        clr CPERTM_K7                       ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        bsr K7_waitTransitionHigh           ; FCT : Attend une transition haute sur le port K7
                                            ; IN  : /
                                            ; OUT : B<>0
        bra K7_waitTransitionLow_next
; End of function K7_waitTransitionHigh_0


; =============== S U B R O U T I N E =======================================
; FCT : Attend une transition basse
;       2 point d'entrées
; IN  : /
; OUT : B=0
;       bLenBit_K7=0

K7_waitTransitionLow_0:
        clr CPERTM_K7                       ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        bsr K7_waitTransitionLow            ; FCT : Attend une transition basse sur le port K7
                                            ; IN  : /
                                            ; OUT : B=0

K7_waitTransitionLow_next:
        ldab CPERTM_K7                      ; longueur (équivalent à un temps) d'un bit lu en provenance du port K7
        cmpb CMP0_K7                        ; $1A par défaut ;  Limite haute pour un signal à 1200 hz
        bhi K7_waitTransitionLow_end        ; Est-ce supérieur à la constante CMP0_K7 ? Oui alors saut
        cmpb CMP1_K7                        ; $0B par défaut ;  limite haute pour une fréquence  à 2400 Hz
        rts

K7_waitTransitionLow_end:
        clr bNbBitsToRDWR_K7
        rts
; End of function K7_waitTransitionLow_0

; ===========================================================================
; /// I/O - SON
; ===========================================================================
xxIO_SON:

; =============== S U B R O U T I N E =======================================
; FCT : Obtient le deuxième paramètre de la fonction SOUND
;       à partir du flot d'interprétation contenant ,XX
; IN  : le flot d'interprétation
; OUT : B=résultat de l'interprétration du deuxième paramètre

getNextParamRomSOUND:
        jsr CHKCOM
; End of function getNextParamRomSOUND


; =============== S U B R O U T I N E =======================================
; FCT : Conversion de l'expression du flux d'interprétation en octet
; ALG : /
; STX : /
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : B=résultat de l'expression

getParamRomSOUND:
        jsr GETBYT                          ; FCT : EVALUATE EXPRESSION AT TXTPTR, AND
                                            ;       CONVERT IT TO SINGLE BYTE IN B-REG
                                            ; ERR : FC : fonction incorrecte
                                            ; IN  : le flot d'interprétation
                                            ;       A = le premier caractère lu dans le flot d'interprétation
                                            ; OUT : B=la partie haute de la conversion (ACC1+3,ACC1+4)
                                            ;       A=dernier octet lu dans le flot d'interprétation
        tstb
        bne endRomSOUND
        jmp printErrorMSG_0x08_FC_FctIncorrect
; End of function getParamRomSOUND


; =============== S U B R O U T I N E =======================================
; FCT : Génére un son de hauteur n1 pendant une période n2
;       avec n1=[0..255] et n2=[0..255] : unité 7.5/100e de seconde
;       rend inutilisable le clavier car utilise la broche de
;       détection d'une touche du clavier pour générer
;       le signal carré
; STX : SOUND 10,55
; OP  : $9E
; ST  : ACTIF
; IN  : le flot d'interprétation
; OUT : A,B,X modified

romSOUND:
        bsr getParamRomSOUND                ; FCT : Conversion de l'expression du flux d'interprétation en octet
                                            ; ALG : /
                                            ; STX : /
                                            ; ST  : ACTIF
                                            ; IN  : le flot d'interprétation
                                            ; OUT : B=résultat de l'expression
        pshb
        bsr getNextParamRomSOUND            ; FCT : Obtient le deuxième paramètre de la fonction SOUND
                                            ;       à partir du flot d'interprétation contenant ,XX
                                            ; IN  : le flot d'interprétation
                                            ; OUT : B=résultat de l'interprétration du deuxième paramètre
        pula

initRomSOUND:
        psha
        pshb
        clra

bcl1RomSOUND:
        ldx CPTHOR                          ; Compteur d'horloge
        ldab CPTHOR_STATUS
        stx CPTHOR_CMP                      ; Comparateur pour le compteur d'horloge

bcl2RomSOUND:
        eora #$80
        staa IO_COL_KBD                     ; pour une rangée activée du clavier, indique par un 0 la touche du clavier activée
                                            ; est utilisé aussi pour le son !
        tsx
        ldab 1,x

bcl3RomSOUND:
        inx
        inx
        incb
        bne bcl3RomSOUND
        ldab CPTHOR_STATUS
        andb #$40
        beq bcl2RomSOUND
        tsx
        dec 0,x
        bne bcl1RomSOUND
        clra
        staa IO_COL_KBD                     ; pour une rangée activée du clavier, indique par un 0 la touche du clavier activée
                                            ; est utilisé aussi pour le son !
        pulx

endRomSOUND:
        rts
; End of function romSOUND

; ===========================================================================
; /// DIVERS - Zone libre
; ===========================================================================
xxFREE_DIVERS:
xxOS_FREE_DIVERS ds 18+12

; ===========================================================================
; /// VECTEURS
; ===========================================================================
xxVECTEURS:

;---------------- Adresse $FFF0
vectorSCI:
        dc.w vectSCI                        ; SerialCommunicationInterrupt
        dc.w vectTOF                        ; TimerOverflowInterrupt
        dc.w vectOCF                        ; OutputCompareInterruptFlag
        dc.w vectICF                        ; InputCaptureInterruptFlag
        dc.w vectIRQ1                       ; Interrupt ReQuest 1
        dc.w vectSWI                        ; SoftWare Interrupt
        dc.w vectNMI                        ; No Maskable Interrupt
vectorRESET:
        dc.w vectRESET                      ; FCT : Point d'entrée pour la réinitialisation
                                            ; ST  : ACTIF
                                            ; IN  : /
                                            ; OUT : /
        end
